// swift-tools-version: 6.0
// The swift-tools-version declares the minimum version of Swift required to build this package.

import PackageDescription

public let package = Package(
    name: "XMLInvoice",
    platforms: [
        .iOS(.v17),
        .macOS(.v14),
    ],
    products: [
        .library(name: "UBLInvoice", targets: ["UBLInvoice"]),
        .library(name: "UBLInvoiceView", targets: ["UBLInvoiceView"]),
        .library(name: "ViewPresentable", targets: ["ViewPresentable"]),
    ],
    dependencies: [
        .package(url: "https://github.com/CoreOffice/XMLCoder.git", from: "0.17.1"),
    ],
    targets: [
        .target(name: "UBLInvoice", dependencies: ["XMLCoder", "ViewPresentable"]),
        .target(name: "UBLInvoiceView", dependencies: ["UBLInvoice", "ViewPresentable"]),
        .target(name: "ViewPresentable", dependencies: []),
    ]
)
