// 
// Address.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct Address: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>?
    public var addressTypeCode: SendableWrapper<Code>?
    public var addressFormatCode: SendableWrapper<Code>?
    public var postbox: SendableWrapper<Text>?
    public var floor: SendableWrapper<Text>?
    public var room: SendableWrapper<Text>?
    public var streetName: SendableWrapper<Text>?
    public var additionalStreetName: SendableWrapper<Text>?
    public var blockName: SendableWrapper<Text>?
    public var buildingName: SendableWrapper<Text>?
    public var buildingNumber: SendableWrapper<Text>?
    public var inhouseMail: SendableWrapper<Text>?
    public var department: SendableWrapper<Text>?
    public var markAttention: SendableWrapper<Text>?
    public var markCare: SendableWrapper<Text>?
    public var plotIdentification: SendableWrapper<Text>?
    public var citySubdivisionName: SendableWrapper<Text>?
    public var cityName: SendableWrapper<Text>?
    public var postalZone: SendableWrapper<Text>?
    public var countrySubentity: SendableWrapper<Text>?
    public var countrySubentityCode: SendableWrapper<Code>?
    public var region: SendableWrapper<Text>?
    public var district: SendableWrapper<Text>?
    public var timezoneOffset: SendableWrapper<Text>?
    public var addressLine: [SendableWrapper<AddressLine>] // This array should have at least one element
    public var country: SendableWrapper<Country>?
    public var locationCoordinate: [SendableWrapper<LocationCoordinate>] // This array should have at least one element

    public init(id: SendableWrapper<Identifier>? = nil,
         addressTypeCode: SendableWrapper<Code>? = nil,
         addressFormatCode: SendableWrapper<Code>? = nil,
         postbox: SendableWrapper<Text>? = nil,
         floor: SendableWrapper<Text>? = nil,
         room: SendableWrapper<Text>? = nil,
         streetName: SendableWrapper<Text>? = nil,
         additionalStreetName: SendableWrapper<Text>? = nil,
         blockName: SendableWrapper<Text>? = nil,
         buildingName: SendableWrapper<Text>? = nil,
         buildingNumber: SendableWrapper<Text>? = nil,
         inhouseMail: SendableWrapper<Text>? = nil,
         department: SendableWrapper<Text>? = nil,
         markAttention: SendableWrapper<Text>? = nil,
         markCare: SendableWrapper<Text>? = nil,
         plotIdentification: SendableWrapper<Text>? = nil,
         citySubdivisionName: SendableWrapper<Text>? = nil,
         cityName: SendableWrapper<Text>? = nil,
         postalZone: SendableWrapper<Text>? = nil,
         countrySubentity: SendableWrapper<Text>? = nil,
         countrySubentityCode: SendableWrapper<Code>? = nil,
         region: SendableWrapper<Text>? = nil,
         district: SendableWrapper<Text>? = nil,
         timezoneOffset: SendableWrapper<Text>? = nil,
         addressLine: [SendableWrapper<AddressLine>] = [],
         country: SendableWrapper<Country>? = nil,
         locationCoordinate: [SendableWrapper<LocationCoordinate>] = []) {
        self.id = id
        self.addressTypeCode = addressTypeCode
        self.addressFormatCode = addressFormatCode
        self.postbox = postbox
        self.floor = floor
        self.room = room
        self.streetName = streetName
        self.additionalStreetName = additionalStreetName
        self.blockName = blockName
        self.buildingName = buildingName
        self.buildingNumber = buildingNumber
        self.inhouseMail = inhouseMail
        self.department = department
        self.markAttention = markAttention
        self.markCare = markCare
        self.plotIdentification = plotIdentification
        self.citySubdivisionName = citySubdivisionName
        self.cityName = cityName
        self.postalZone = postalZone
        self.countrySubentity = countrySubentity
        self.countrySubentityCode = countrySubentityCode
        self.region = region
        self.district = district
        self.timezoneOffset = timezoneOffset
        self.addressLine = addressLine
        self.country = country
        self.locationCoordinate = locationCoordinate
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case addressTypeCode = "AddressTypeCode"
        case addressFormatCode = "AddressFormatCode"
        case postbox = "Postbox"
        case floor = "Floor"
        case room = "Room"
        case streetName = "StreetName"
        case additionalStreetName = "AdditionalStreetName"
        case blockName = "BlockName"
        case buildingName = "BuildingName"
        case buildingNumber = "BuildingNumber"
        case inhouseMail = "InhouseMail"
        case department = "Department"
        case markAttention = "MarkAttention"
        case markCare = "MarkCare"
        case plotIdentification = "PlotIdentification"
        case citySubdivisionName = "CitySubdivisionName"
        case cityName = "CityName"
        case postalZone = "PostalZone"
        case countrySubentity = "CountrySubentity"
        case countrySubentityCode = "CountrySubentityCode"
        case region = "Region"
        case district = "District"
        case timezoneOffset = "TimezoneOffset"
        case addressLine = "AddressLine"
        case country = "Country"
        case locationCoordinate = "LocationCoordinate"
    }
}

extension Address: CreateEmpty {
    public nonisolated static func empty() -> Address {
        Address()
    }
}
