// 
// AllowanceCharge.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct AllowanceCharge: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>?
    public var chargeIndicator: SendableWrapper<Indicator>
    public var allowanceChargeReasonCode: SendableWrapper<Code>?
    public var allowanceChargeReason: [SendableWrapper<Text>] // This array should have at least one element
    public var multiplierFactorNumeric: SendableWrapper<Numeric>?
    public var prepaidIndicator: SendableWrapper<Indicator>?
    public var sequenceNumeric: SendableWrapper<Numeric>?
    public var amount: SendableWrapper<Amount>
    public var baseAmount: SendableWrapper<Amount>?
    public var accountingCostCode: SendableWrapper<Code>?
    public var accountingCost: SendableWrapper<Text>?
    public var perUnitAmount: SendableWrapper<Amount>?
    public var taxCategory: [SendableWrapper<TaxCategory>] // This array should have at least one element
    public var taxTotal: SendableWrapper<TaxTotal>?
    public var paymentMeans: [SendableWrapper<PaymentMeans>] // This array should have at least one element

    public init(id: SendableWrapper<Identifier>? = nil,
         chargeIndicator: SendableWrapper<Indicator> = SendableWrapper(Indicator.empty()),
         allowanceChargeReasonCode: SendableWrapper<Code>? = nil,
         allowanceChargeReason: [SendableWrapper<Text>] = [],
         multiplierFactorNumeric: SendableWrapper<Numeric>? = nil,
         prepaidIndicator: SendableWrapper<Indicator>? = nil,
         sequenceNumeric: SendableWrapper<Numeric>? = nil,
         amount: SendableWrapper<Amount> = SendableWrapper(Amount.empty()),
         baseAmount: SendableWrapper<Amount>? = nil,
         accountingCostCode: SendableWrapper<Code>? = nil,
         accountingCost: SendableWrapper<Text>? = nil,
         perUnitAmount: SendableWrapper<Amount>? = nil,
         taxCategory: [SendableWrapper<TaxCategory>] = [],
         taxTotal: SendableWrapper<TaxTotal>? = nil,
         paymentMeans: [SendableWrapper<PaymentMeans>] = []) {
        self.id = id
        self.chargeIndicator = chargeIndicator
        self.allowanceChargeReasonCode = allowanceChargeReasonCode
        self.allowanceChargeReason = allowanceChargeReason
        self.multiplierFactorNumeric = multiplierFactorNumeric
        self.prepaidIndicator = prepaidIndicator
        self.sequenceNumeric = sequenceNumeric
        self.amount = amount
        self.baseAmount = baseAmount
        self.accountingCostCode = accountingCostCode
        self.accountingCost = accountingCost
        self.perUnitAmount = perUnitAmount
        self.taxCategory = taxCategory
        self.taxTotal = taxTotal
        self.paymentMeans = paymentMeans
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case chargeIndicator = "ChargeIndicator"
        case allowanceChargeReasonCode = "AllowanceChargeReasonCode"
        case allowanceChargeReason = "AllowanceChargeReason"
        case multiplierFactorNumeric = "MultiplierFactorNumeric"
        case prepaidIndicator = "PrepaidIndicator"
        case sequenceNumeric = "SequenceNumeric"
        case amount = "Amount"
        case baseAmount = "BaseAmount"
        case accountingCostCode = "AccountingCostCode"
        case accountingCost = "AccountingCost"
        case perUnitAmount = "PerUnitAmount"
        case taxCategory = "TaxCategory"
        case taxTotal = "TaxTotal"
        case paymentMeans = "PaymentMeans"
    }
}

extension AllowanceCharge: CreateEmpty {
    public nonisolated static func empty() -> AllowanceCharge {
        AllowanceCharge()
    }
}
