// 
// Amount.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct Amount: Codable, Sendable, Hashable , DynamicNodeEncoding, DynamicNodeDecoding {
    public var value: Decimal
    public var currencyID: String?
    public var currencyCodeListVersionID: String?

    public init(value: Decimal = 0,
         currencyID: String? = nil,
         currencyCodeListVersionID: String? = nil) {
        self.value = value
        self.currencyID = currencyID
        self.currencyCodeListVersionID = currencyCodeListVersionID
    }
    
    public enum CodingKeys: String, CodingKey {
        case value = ""
        case currencyID = "currencyID"
        case currencyCodeListVersionID = "currencyCodeListVersionID"
    }

    nonisolated public static func nodeEncoding(for key: CodingKey) -> XMLEncoder.NodeEncoding {
        switch key {
        case CodingKeys.value:
           return .element
        default:
            return .attribute
        }
    }
    
    nonisolated public static func nodeDecoding(for key: CodingKey) -> XMLDecoder.NodeDecoding {
        switch key {
        case CodingKeys.value:
            return .element
        default:
            return .attribute
        }
    }}

extension Amount: CreateEmpty {
    public nonisolated static func empty() -> Amount {
        Amount()
    }
}
