// 
// Attachment.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct Attachment: Codable, Sendable, Hashable  {
    public var embeddedDocumentBinaryObject: SendableWrapper<BinaryObject>?
    public var externalReference: SendableWrapper<ExternalReference>?

    public init(embeddedDocumentBinaryObject: SendableWrapper<BinaryObject>? = nil,
         externalReference: SendableWrapper<ExternalReference>? = nil) {
        self.embeddedDocumentBinaryObject = embeddedDocumentBinaryObject
        self.externalReference = externalReference
    }
    
    public enum CodingKeys: String, CodingKey {
        case embeddedDocumentBinaryObject = "EmbeddedDocumentBinaryObject"
        case externalReference = "ExternalReference"
    }
}

extension Attachment: CreateEmpty {
    public nonisolated static func empty() -> Attachment {
        Attachment()
    }
}
