// 
// BillingReference.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct BillingReference: Codable, Sendable, Hashable  {
    public var invoiceDocumentReference: SendableWrapper<DocumentReference>?
    public var selfBilledInvoiceDocumentReference: SendableWrapper<DocumentReference>?
    public var creditNoteDocumentReference: SendableWrapper<DocumentReference>?
    public var selfBilledCreditNoteDocumentReference: SendableWrapper<DocumentReference>?
    public var debitNoteDocumentReference: SendableWrapper<DocumentReference>?
    public var reminderDocumentReference: SendableWrapper<DocumentReference>?
    public var additionalDocumentReference: SendableWrapper<DocumentReference>?
    public var billingReferenceLine: [SendableWrapper<BillingReferenceLine>] // This array should have at least one element

    public init(invoiceDocumentReference: SendableWrapper<DocumentReference>? = nil,
         selfBilledInvoiceDocumentReference: SendableWrapper<DocumentReference>? = nil,
         creditNoteDocumentReference: SendableWrapper<DocumentReference>? = nil,
         selfBilledCreditNoteDocumentReference: SendableWrapper<DocumentReference>? = nil,
         debitNoteDocumentReference: SendableWrapper<DocumentReference>? = nil,
         reminderDocumentReference: SendableWrapper<DocumentReference>? = nil,
         additionalDocumentReference: SendableWrapper<DocumentReference>? = nil,
         billingReferenceLine: [SendableWrapper<BillingReferenceLine>] = []) {
        self.invoiceDocumentReference = invoiceDocumentReference
        self.selfBilledInvoiceDocumentReference = selfBilledInvoiceDocumentReference
        self.creditNoteDocumentReference = creditNoteDocumentReference
        self.selfBilledCreditNoteDocumentReference = selfBilledCreditNoteDocumentReference
        self.debitNoteDocumentReference = debitNoteDocumentReference
        self.reminderDocumentReference = reminderDocumentReference
        self.additionalDocumentReference = additionalDocumentReference
        self.billingReferenceLine = billingReferenceLine
    }
    
    public enum CodingKeys: String, CodingKey {
        case invoiceDocumentReference = "InvoiceDocumentReference"
        case selfBilledInvoiceDocumentReference = "SelfBilledInvoiceDocumentReference"
        case creditNoteDocumentReference = "CreditNoteDocumentReference"
        case selfBilledCreditNoteDocumentReference = "SelfBilledCreditNoteDocumentReference"
        case debitNoteDocumentReference = "DebitNoteDocumentReference"
        case reminderDocumentReference = "ReminderDocumentReference"
        case additionalDocumentReference = "AdditionalDocumentReference"
        case billingReferenceLine = "BillingReferenceLine"
    }
}

extension BillingReference: CreateEmpty {
    public nonisolated static func empty() -> BillingReference {
        BillingReference()
    }
}
