// 
// BillingReferenceLine.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct BillingReferenceLine: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>
    public var amount: SendableWrapper<Amount>?
    public var allowanceCharge: [SendableWrapper<AllowanceCharge>] // This array should have at least one element

    public init(id: SendableWrapper<Identifier> = SendableWrapper(Identifier.empty()),
         amount: SendableWrapper<Amount>? = nil,
         allowanceCharge: [SendableWrapper<AllowanceCharge>] = []) {
        self.id = id
        self.amount = amount
        self.allowanceCharge = allowanceCharge
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case amount = "Amount"
        case allowanceCharge = "AllowanceCharge"
    }
}

extension BillingReferenceLine: CreateEmpty {
    public nonisolated static func empty() -> BillingReferenceLine {
        BillingReferenceLine()
    }
}
