// 
// BinaryObject.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct BinaryObject: Codable, Sendable, Hashable , DynamicNodeEncoding, DynamicNodeDecoding {
    public var value: String
    public var format: String?
    public var mimeCode: String?
    public var encodingCode: String?
    public var characterSetCode: String?
    public var uri: String?
    public var filename: String?

    public init(value: String = "",
         format: String? = nil,
         mimeCode: String? = nil,
         encodingCode: String? = nil,
         characterSetCode: String? = nil,
         uri: String? = nil,
         filename: String? = nil) {
        self.value = value
        self.format = format
        self.mimeCode = mimeCode
        self.encodingCode = encodingCode
        self.characterSetCode = characterSetCode
        self.uri = uri
        self.filename = filename
    }
    
    public enum CodingKeys: String, CodingKey {
        case value = ""
        case format = "format"
        case mimeCode = "mimeCode"
        case encodingCode = "encodingCode"
        case characterSetCode = "characterSetCode"
        case uri = "uri"
        case filename = "filename"
    }

    nonisolated public static func nodeEncoding(for key: CodingKey) -> XMLEncoder.NodeEncoding {
        switch key {
        case CodingKeys.value:
           return .element
        default:
            return .attribute
        }
    }
    
    nonisolated public static func nodeDecoding(for key: CodingKey) -> XMLDecoder.NodeDecoding {
        switch key {
        case CodingKeys.value:
            return .element
        default:
            return .attribute
        }
    }}

extension BinaryObject: CreateEmpty {
    public nonisolated static func empty() -> BinaryObject {
        BinaryObject()
    }
}
