// 
// Branch.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct Branch: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>?
    public var name: SendableWrapper<Text>?
    public var financialInstitution: SendableWrapper<FinancialInstitution>?
    public var address: SendableWrapper<Address>?

    public init(id: SendableWrapper<Identifier>? = nil,
         name: SendableWrapper<Text>? = nil,
         financialInstitution: SendableWrapper<FinancialInstitution>? = nil,
         address: SendableWrapper<Address>? = nil) {
        self.id = id
        self.name = name
        self.financialInstitution = financialInstitution
        self.address = address
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case name = "Name"
        case financialInstitution = "FinancialInstitution"
        case address = "Address"
    }
}

extension Branch: CreateEmpty {
    public nonisolated static func empty() -> Branch {
        Branch()
    }
}
