// 
// CardAccount.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct CardAccount: Codable, Sendable, Hashable  {
    public var primaryAccountNumberID: SendableWrapper<Identifier>
    public var networkID: SendableWrapper<Identifier>
    public var cardTypeCode: SendableWrapper<Code>?
    public var validityStartDate: XMLDate?
    public var expiryDate: XMLDate?
    public var issuerID: SendableWrapper<Identifier>?
    public var issueNumberID: SendableWrapper<Identifier>?
    public var cV2ID: SendableWrapper<Identifier>?
    public var cardChipCode: SendableWrapper<Code>?
    public var chipApplicationID: SendableWrapper<Identifier>?
    public var holderName: SendableWrapper<Text>?

    public init(primaryAccountNumberID: SendableWrapper<Identifier> = SendableWrapper(Identifier.empty()),
         networkID: SendableWrapper<Identifier> = SendableWrapper(Identifier.empty()),
         cardTypeCode: SendableWrapper<Code>? = nil,
         validityStartDate: XMLDate? = nil,
         expiryDate: XMLDate? = nil,
         issuerID: SendableWrapper<Identifier>? = nil,
         issueNumberID: SendableWrapper<Identifier>? = nil,
         cV2ID: SendableWrapper<Identifier>? = nil,
         cardChipCode: SendableWrapper<Code>? = nil,
         chipApplicationID: SendableWrapper<Identifier>? = nil,
         holderName: SendableWrapper<Text>? = nil) {
        self.primaryAccountNumberID = primaryAccountNumberID
        self.networkID = networkID
        self.cardTypeCode = cardTypeCode
        self.validityStartDate = validityStartDate
        self.expiryDate = expiryDate
        self.issuerID = issuerID
        self.issueNumberID = issueNumberID
        self.cV2ID = cV2ID
        self.cardChipCode = cardChipCode
        self.chipApplicationID = chipApplicationID
        self.holderName = holderName
    }
    
    public enum CodingKeys: String, CodingKey {
        case primaryAccountNumberID = "PrimaryAccountNumberID"
        case networkID = "NetworkID"
        case cardTypeCode = "CardTypeCode"
        case validityStartDate = "ValidityStartDate"
        case expiryDate = "ExpiryDate"
        case issuerID = "IssuerID"
        case issueNumberID = "IssueNumberID"
        case cV2ID = "CV2ID"
        case cardChipCode = "CardChipCode"
        case chipApplicationID = "ChipApplicationID"
        case holderName = "HolderName"
    }
}

extension CardAccount: CreateEmpty {
    public nonisolated static func empty() -> CardAccount {
        CardAccount()
    }
}
