// 
// Certificate.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct Certificate: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>
    public var certificateTypeCode: SendableWrapper<Code>
    public var certificateType: SendableWrapper<Text>
    public var remarks: [SendableWrapper<Text>] // This array should have at least one element
    public var issuerParty: SendableWrapper<Party>
    public var documentReference: [SendableWrapper<DocumentReference>] // This array should have at least one element
    public var signature: [SendableWrapper<Signature>] // This array should have at least one element

    public init(id: SendableWrapper<Identifier> = SendableWrapper(Identifier.empty()),
         certificateTypeCode: SendableWrapper<Code> = SendableWrapper(Code.empty()),
         certificateType: SendableWrapper<Text> = SendableWrapper(Text.empty()),
         remarks: [SendableWrapper<Text>] = [],
         issuerParty: SendableWrapper<Party> = SendableWrapper(Party.empty()),
         documentReference: [SendableWrapper<DocumentReference>] = [],
         signature: [SendableWrapper<Signature>] = []) {
        self.id = id
        self.certificateTypeCode = certificateTypeCode
        self.certificateType = certificateType
        self.remarks = remarks
        self.issuerParty = issuerParty
        self.documentReference = documentReference
        self.signature = signature
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case certificateTypeCode = "CertificateTypeCode"
        case certificateType = "CertificateType"
        case remarks = "Remarks"
        case issuerParty = "IssuerParty"
        case documentReference = "DocumentReference"
        case signature = "Signature"
    }
}

extension Certificate: CreateEmpty {
    public nonisolated static func empty() -> Certificate {
        Certificate()
    }
}
