// 
// Clause.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct Clause: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>?
    public var content: [SendableWrapper<Text>] // This array should have at least one element

    public init(id: SendableWrapper<Identifier>? = nil,
         content: [SendableWrapper<Text>] = []) {
        self.id = id
        self.content = content
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case content = "Content"
    }
}

extension Clause: CreateEmpty {
    public nonisolated static func empty() -> Clause {
        Clause()
    }
}
