// 
// CommodityClassification.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct CommodityClassification: Codable, Sendable, Hashable  {
    public var natureCode: SendableWrapper<Code>?
    public var cargoTypeCode: SendableWrapper<Code>?
    public var commodityCode: SendableWrapper<Code>?
    public var itemClassificationCode: SendableWrapper<Code>?

    public init(natureCode: SendableWrapper<Code>? = nil,
         cargoTypeCode: SendableWrapper<Code>? = nil,
         commodityCode: SendableWrapper<Code>? = nil,
         itemClassificationCode: SendableWrapper<Code>? = nil) {
        self.natureCode = natureCode
        self.cargoTypeCode = cargoTypeCode
        self.commodityCode = commodityCode
        self.itemClassificationCode = itemClassificationCode
    }
    
    public enum CodingKeys: String, CodingKey {
        case natureCode = "NatureCode"
        case cargoTypeCode = "CargoTypeCode"
        case commodityCode = "CommodityCode"
        case itemClassificationCode = "ItemClassificationCode"
    }
}

extension CommodityClassification: CreateEmpty {
    public nonisolated static func empty() -> CommodityClassification {
        CommodityClassification()
    }
}
