// 
// Communication.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct Communication: Codable, Sendable, Hashable  {
    public var channelCode: SendableWrapper<Code>?
    public var channel: SendableWrapper<Text>?
    public var value: SendableWrapper<Text>?

    public init(channelCode: SendableWrapper<Code>? = nil,
         channel: SendableWrapper<Text>? = nil,
         value: SendableWrapper<Text>? = nil) {
        self.channelCode = channelCode
        self.channel = channel
        self.value = value
    }
    
    public enum CodingKeys: String, CodingKey {
        case channelCode = "ChannelCode"
        case channel = "Channel"
        case value = ""
    }
}

extension Communication: CreateEmpty {
    public nonisolated static func empty() -> Communication {
        Communication()
    }
}
