// 
// Condition.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct Condition: Codable, Sendable, Hashable , DynamicNodeEncoding, DynamicNodeDecoding {
    public var attributeID: SendableWrapper<Identifier>
    public var measure: SendableWrapper<Measure>?
    public var description: [SendableWrapper<Text>] // This array should have at least one element
    public var minimumMeasure: SendableWrapper<Measure>?
    public var maximumMeasure: SendableWrapper<Measure>?
    public var value: String
    public var languageID: String?
    public var languageLocaleID: String?

    public init(attributeID: SendableWrapper<Identifier> = SendableWrapper(Identifier.empty()),
         measure: SendableWrapper<Measure>? = nil,
         description: [SendableWrapper<Text>] = [],
         minimumMeasure: SendableWrapper<Measure>? = nil,
         maximumMeasure: SendableWrapper<Measure>? = nil,
         value: String = "",
         languageID: String? = nil,
         languageLocaleID: String? = nil) {
        self.attributeID = attributeID
        self.measure = measure
        self.description = description
        self.minimumMeasure = minimumMeasure
        self.maximumMeasure = maximumMeasure
        self.value = value
        self.languageID = languageID
        self.languageLocaleID = languageLocaleID
    }
    
    public enum CodingKeys: String, CodingKey {
        case attributeID = "AttributeID"
        case measure = "Measure"
        case description = "Description"
        case minimumMeasure = "MinimumMeasure"
        case maximumMeasure = "MaximumMeasure"
        case value = ""
        case languageID = "languageID"
        case languageLocaleID = "languageLocaleID"
    }

    nonisolated public static func nodeEncoding(for key: CodingKey) -> XMLEncoder.NodeEncoding {
        switch key {
        case CodingKeys.attributeID, CodingKeys.measure, CodingKeys.description, CodingKeys.minimumMeasure, CodingKeys.maximumMeasure, CodingKeys.value:
           return .element
        default:
            return .attribute
        }
    }
    
    nonisolated public static func nodeDecoding(for key: CodingKey) -> XMLDecoder.NodeDecoding {
        switch key {
        case CodingKeys.attributeID, CodingKeys.measure, CodingKeys.description, CodingKeys.minimumMeasure, CodingKeys.maximumMeasure, CodingKeys.value:
            return .element
        default:
            return .attribute
        }
    }}

extension Condition: CreateEmpty {
    public nonisolated static func empty() -> Condition {
        Condition()
    }
}
