// 
// Consignment.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct Consignment: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>
    public var carrierAssignedID: SendableWrapper<Identifier>?
    public var consigneeAssignedID: SendableWrapper<Identifier>?
    public var consignorAssignedID: SendableWrapper<Identifier>?
    public var freightForwarderAssignedID: SendableWrapper<Identifier>?
    public var brokerAssignedID: SendableWrapper<Identifier>?
    public var contractedCarrierAssignedID: SendableWrapper<Identifier>?
    public var performingCarrierAssignedID: SendableWrapper<Identifier>?
    public var summaryDescription: [SendableWrapper<Text>] // This array should have at least one element
    public var totalInvoiceAmount: SendableWrapper<Amount>?
    public var declaredCustomsValueAmount: SendableWrapper<Amount>?
    public var tariffDescription: [SendableWrapper<Text>] // This array should have at least one element
    public var tariffCode: SendableWrapper<Code>?
    public var insurancePremiumAmount: SendableWrapper<Amount>?
    public var grossWeightMeasure: SendableWrapper<Measure>?
    public var netWeightMeasure: SendableWrapper<Measure>?
    public var netNetWeightMeasure: SendableWrapper<Measure>?
    public var chargeableWeightMeasure: SendableWrapper<Measure>?
    public var grossVolumeMeasure: SendableWrapper<Measure>?
    public var netVolumeMeasure: SendableWrapper<Measure>?
    public var loadingLengthMeasure: SendableWrapper<Measure>?
    public var remarks: [SendableWrapper<Text>] // This array should have at least one element
    public var hazardousRiskIndicator: SendableWrapper<Indicator>?
    public var animalFoodIndicator: SendableWrapper<Indicator>?
    public var humanFoodIndicator: SendableWrapper<Indicator>?
    public var livestockIndicator: SendableWrapper<Indicator>?
    public var bulkCargoIndicator: SendableWrapper<Indicator>?
    public var containerizedIndicator: SendableWrapper<Indicator>?
    public var generalCargoIndicator: SendableWrapper<Indicator>?
    public var specialSecurityIndicator: SendableWrapper<Indicator>?
    public var thirdPartyPayerIndicator: SendableWrapper<Indicator>?
    public var carrierServiceInstructions: [SendableWrapper<Text>] // This array should have at least one element
    public var customsClearanceServiceInstructions: [SendableWrapper<Text>] // This array should have at least one element
    public var forwarderServiceInstructions: [SendableWrapper<Text>] // This array should have at least one element
    public var specialServiceInstructions: [SendableWrapper<Text>] // This array should have at least one element
    public var sequenceID: SendableWrapper<Identifier>?
    public var shippingPriorityLevelCode: SendableWrapper<Code>?
    public var handlingCode: SendableWrapper<Code>?
    public var handlingInstructions: [SendableWrapper<Text>] // This array should have at least one element
    public var information: [SendableWrapper<Text>] // This array should have at least one element
    public var totalGoodsItemQuantity: SendableWrapper<Quantity>?
    public var totalTransportHandlingUnitQuantity: SendableWrapper<Quantity>?
    public var insuranceValueAmount: SendableWrapper<Amount>?
    public var declaredForCarriageValueAmount: SendableWrapper<Amount>?
    public var declaredStatisticsValueAmount: SendableWrapper<Amount>?
    public var freeOnBoardValueAmount: SendableWrapper<Amount>?
    public var specialInstructions: [SendableWrapper<Text>] // This array should have at least one element
    public var splitConsignmentIndicator: SendableWrapper<Indicator>?
    public var deliveryInstructions: [SendableWrapper<Text>] // This array should have at least one element
    public var consignmentQuantity: SendableWrapper<Quantity>?
    public var consolidatableIndicator: SendableWrapper<Indicator>?
    public var haulageInstructions: [SendableWrapper<Text>] // This array should have at least one element
    public var loadingSequenceID: SendableWrapper<Identifier>?
    public var childConsignmentQuantity: SendableWrapper<Quantity>?
    public var totalPackagesQuantity: SendableWrapper<Quantity>?
    public var consolidatedShipment: [SendableWrapper<Shipment>] // This array should have at least one element
    public var customsDeclaration: [SendableWrapper<CustomsDeclaration>] // This array should have at least one element
    public var requestedPickupTransportEvent: SendableWrapper<TransportEvent>?
    public var requestedDeliveryTransportEvent: SendableWrapper<TransportEvent>?
    public var plannedPickupTransportEvent: SendableWrapper<TransportEvent>?
    public var plannedDeliveryTransportEvent: SendableWrapper<TransportEvent>?
    public var status: [SendableWrapper<Status>] // This array should have at least one element
    public var childConsignment: [SendableWrapper<Consignment>] // This array should have at least one element
    public var consigneeParty: SendableWrapper<Party>?
    public var exporterParty: SendableWrapper<Party>?
    public var consignorParty: SendableWrapper<Party>?
    public var importerParty: SendableWrapper<Party>?
    public var carrierParty: SendableWrapper<Party>?
    public var freightForwarderParty: SendableWrapper<Party>?
    public var notifyParty: SendableWrapper<Party>?
    public var originalDespatchParty: SendableWrapper<Party>?
    public var finalDeliveryParty: SendableWrapper<Party>?
    public var performingCarrierParty: SendableWrapper<Party>?
    public var substituteCarrierParty: SendableWrapper<Party>?
    public var logisticsOperatorParty: SendableWrapper<Party>?
    public var transportAdvisorParty: SendableWrapper<Party>?
    public var hazardousItemNotificationParty: SendableWrapper<Party>?
    public var insuranceParty: SendableWrapper<Party>?
    public var mortgageHolderParty: SendableWrapper<Party>?
    public var billOfLadingHolderParty: SendableWrapper<Party>?
    public var originalDepartureCountry: SendableWrapper<Country>?
    public var finalDestinationCountry: SendableWrapper<Country>?
    public var transitCountry: [SendableWrapper<Country>] // This array should have at least one element
    public var transportContract: SendableWrapper<Contract>?
    public var transportEvent: [SendableWrapper<TransportEvent>] // This array should have at least one element
    public var originalDespatchTransportationService: SendableWrapper<TransportationService>?
    public var finalDeliveryTransportationService: SendableWrapper<TransportationService>?
    public var deliveryTerms: SendableWrapper<DeliveryTerms>?
    public var paymentTerms: SendableWrapper<PaymentTerms>?
    public var collectPaymentTerms: SendableWrapper<PaymentTerms>?
    public var disbursementPaymentTerms: SendableWrapper<PaymentTerms>?
    public var prepaidPaymentTerms: SendableWrapper<PaymentTerms>?
    public var freightAllowanceCharge: [SendableWrapper<AllowanceCharge>] // This array should have at least one element
    public var extraAllowanceCharge: [SendableWrapper<AllowanceCharge>] // This array should have at least one element
    public var mainCarriageShipmentStage: [SendableWrapper<ShipmentStage>] // This array should have at least one element
    public var preCarriageShipmentStage: [SendableWrapper<ShipmentStage>] // This array should have at least one element
    public var onCarriageShipmentStage: [SendableWrapper<ShipmentStage>] // This array should have at least one element
    public var transportHandlingUnit: [SendableWrapper<TransportHandlingUnit>] // This array should have at least one element
    public var firstArrivalPortLocation: SendableWrapper<Location>?
    public var lastExitPortLocation: SendableWrapper<Location>?

    public init(id: SendableWrapper<Identifier> = SendableWrapper(Identifier.empty()),
         carrierAssignedID: SendableWrapper<Identifier>? = nil,
         consigneeAssignedID: SendableWrapper<Identifier>? = nil,
         consignorAssignedID: SendableWrapper<Identifier>? = nil,
         freightForwarderAssignedID: SendableWrapper<Identifier>? = nil,
         brokerAssignedID: SendableWrapper<Identifier>? = nil,
         contractedCarrierAssignedID: SendableWrapper<Identifier>? = nil,
         performingCarrierAssignedID: SendableWrapper<Identifier>? = nil,
         summaryDescription: [SendableWrapper<Text>] = [],
         totalInvoiceAmount: SendableWrapper<Amount>? = nil,
         declaredCustomsValueAmount: SendableWrapper<Amount>? = nil,
         tariffDescription: [SendableWrapper<Text>] = [],
         tariffCode: SendableWrapper<Code>? = nil,
         insurancePremiumAmount: SendableWrapper<Amount>? = nil,
         grossWeightMeasure: SendableWrapper<Measure>? = nil,
         netWeightMeasure: SendableWrapper<Measure>? = nil,
         netNetWeightMeasure: SendableWrapper<Measure>? = nil,
         chargeableWeightMeasure: SendableWrapper<Measure>? = nil,
         grossVolumeMeasure: SendableWrapper<Measure>? = nil,
         netVolumeMeasure: SendableWrapper<Measure>? = nil,
         loadingLengthMeasure: SendableWrapper<Measure>? = nil,
         remarks: [SendableWrapper<Text>] = [],
         hazardousRiskIndicator: SendableWrapper<Indicator>? = nil,
         animalFoodIndicator: SendableWrapper<Indicator>? = nil,
         humanFoodIndicator: SendableWrapper<Indicator>? = nil,
         livestockIndicator: SendableWrapper<Indicator>? = nil,
         bulkCargoIndicator: SendableWrapper<Indicator>? = nil,
         containerizedIndicator: SendableWrapper<Indicator>? = nil,
         generalCargoIndicator: SendableWrapper<Indicator>? = nil,
         specialSecurityIndicator: SendableWrapper<Indicator>? = nil,
         thirdPartyPayerIndicator: SendableWrapper<Indicator>? = nil,
         carrierServiceInstructions: [SendableWrapper<Text>] = [],
         customsClearanceServiceInstructions: [SendableWrapper<Text>] = [],
         forwarderServiceInstructions: [SendableWrapper<Text>] = [],
         specialServiceInstructions: [SendableWrapper<Text>] = [],
         sequenceID: SendableWrapper<Identifier>? = nil,
         shippingPriorityLevelCode: SendableWrapper<Code>? = nil,
         handlingCode: SendableWrapper<Code>? = nil,
         handlingInstructions: [SendableWrapper<Text>] = [],
         information: [SendableWrapper<Text>] = [],
         totalGoodsItemQuantity: SendableWrapper<Quantity>? = nil,
         totalTransportHandlingUnitQuantity: SendableWrapper<Quantity>? = nil,
         insuranceValueAmount: SendableWrapper<Amount>? = nil,
         declaredForCarriageValueAmount: SendableWrapper<Amount>? = nil,
         declaredStatisticsValueAmount: SendableWrapper<Amount>? = nil,
         freeOnBoardValueAmount: SendableWrapper<Amount>? = nil,
         specialInstructions: [SendableWrapper<Text>] = [],
         splitConsignmentIndicator: SendableWrapper<Indicator>? = nil,
         deliveryInstructions: [SendableWrapper<Text>] = [],
         consignmentQuantity: SendableWrapper<Quantity>? = nil,
         consolidatableIndicator: SendableWrapper<Indicator>? = nil,
         haulageInstructions: [SendableWrapper<Text>] = [],
         loadingSequenceID: SendableWrapper<Identifier>? = nil,
         childConsignmentQuantity: SendableWrapper<Quantity>? = nil,
         totalPackagesQuantity: SendableWrapper<Quantity>? = nil,
         consolidatedShipment: [SendableWrapper<Shipment>] = [],
         customsDeclaration: [SendableWrapper<CustomsDeclaration>] = [],
         requestedPickupTransportEvent: SendableWrapper<TransportEvent>? = nil,
         requestedDeliveryTransportEvent: SendableWrapper<TransportEvent>? = nil,
         plannedPickupTransportEvent: SendableWrapper<TransportEvent>? = nil,
         plannedDeliveryTransportEvent: SendableWrapper<TransportEvent>? = nil,
         status: [SendableWrapper<Status>] = [],
         childConsignment: [SendableWrapper<Consignment>] = [],
         consigneeParty: SendableWrapper<Party>? = nil,
         exporterParty: SendableWrapper<Party>? = nil,
         consignorParty: SendableWrapper<Party>? = nil,
         importerParty: SendableWrapper<Party>? = nil,
         carrierParty: SendableWrapper<Party>? = nil,
         freightForwarderParty: SendableWrapper<Party>? = nil,
         notifyParty: SendableWrapper<Party>? = nil,
         originalDespatchParty: SendableWrapper<Party>? = nil,
         finalDeliveryParty: SendableWrapper<Party>? = nil,
         performingCarrierParty: SendableWrapper<Party>? = nil,
         substituteCarrierParty: SendableWrapper<Party>? = nil,
         logisticsOperatorParty: SendableWrapper<Party>? = nil,
         transportAdvisorParty: SendableWrapper<Party>? = nil,
         hazardousItemNotificationParty: SendableWrapper<Party>? = nil,
         insuranceParty: SendableWrapper<Party>? = nil,
         mortgageHolderParty: SendableWrapper<Party>? = nil,
         billOfLadingHolderParty: SendableWrapper<Party>? = nil,
         originalDepartureCountry: SendableWrapper<Country>? = nil,
         finalDestinationCountry: SendableWrapper<Country>? = nil,
         transitCountry: [SendableWrapper<Country>] = [],
         transportContract: SendableWrapper<Contract>? = nil,
         transportEvent: [SendableWrapper<TransportEvent>] = [],
         originalDespatchTransportationService: SendableWrapper<TransportationService>? = nil,
         finalDeliveryTransportationService: SendableWrapper<TransportationService>? = nil,
         deliveryTerms: SendableWrapper<DeliveryTerms>? = nil,
         paymentTerms: SendableWrapper<PaymentTerms>? = nil,
         collectPaymentTerms: SendableWrapper<PaymentTerms>? = nil,
         disbursementPaymentTerms: SendableWrapper<PaymentTerms>? = nil,
         prepaidPaymentTerms: SendableWrapper<PaymentTerms>? = nil,
         freightAllowanceCharge: [SendableWrapper<AllowanceCharge>] = [],
         extraAllowanceCharge: [SendableWrapper<AllowanceCharge>] = [],
         mainCarriageShipmentStage: [SendableWrapper<ShipmentStage>] = [],
         preCarriageShipmentStage: [SendableWrapper<ShipmentStage>] = [],
         onCarriageShipmentStage: [SendableWrapper<ShipmentStage>] = [],
         transportHandlingUnit: [SendableWrapper<TransportHandlingUnit>] = [],
         firstArrivalPortLocation: SendableWrapper<Location>? = nil,
         lastExitPortLocation: SendableWrapper<Location>? = nil) {
        self.id = id
        self.carrierAssignedID = carrierAssignedID
        self.consigneeAssignedID = consigneeAssignedID
        self.consignorAssignedID = consignorAssignedID
        self.freightForwarderAssignedID = freightForwarderAssignedID
        self.brokerAssignedID = brokerAssignedID
        self.contractedCarrierAssignedID = contractedCarrierAssignedID
        self.performingCarrierAssignedID = performingCarrierAssignedID
        self.summaryDescription = summaryDescription
        self.totalInvoiceAmount = totalInvoiceAmount
        self.declaredCustomsValueAmount = declaredCustomsValueAmount
        self.tariffDescription = tariffDescription
        self.tariffCode = tariffCode
        self.insurancePremiumAmount = insurancePremiumAmount
        self.grossWeightMeasure = grossWeightMeasure
        self.netWeightMeasure = netWeightMeasure
        self.netNetWeightMeasure = netNetWeightMeasure
        self.chargeableWeightMeasure = chargeableWeightMeasure
        self.grossVolumeMeasure = grossVolumeMeasure
        self.netVolumeMeasure = netVolumeMeasure
        self.loadingLengthMeasure = loadingLengthMeasure
        self.remarks = remarks
        self.hazardousRiskIndicator = hazardousRiskIndicator
        self.animalFoodIndicator = animalFoodIndicator
        self.humanFoodIndicator = humanFoodIndicator
        self.livestockIndicator = livestockIndicator
        self.bulkCargoIndicator = bulkCargoIndicator
        self.containerizedIndicator = containerizedIndicator
        self.generalCargoIndicator = generalCargoIndicator
        self.specialSecurityIndicator = specialSecurityIndicator
        self.thirdPartyPayerIndicator = thirdPartyPayerIndicator
        self.carrierServiceInstructions = carrierServiceInstructions
        self.customsClearanceServiceInstructions = customsClearanceServiceInstructions
        self.forwarderServiceInstructions = forwarderServiceInstructions
        self.specialServiceInstructions = specialServiceInstructions
        self.sequenceID = sequenceID
        self.shippingPriorityLevelCode = shippingPriorityLevelCode
        self.handlingCode = handlingCode
        self.handlingInstructions = handlingInstructions
        self.information = information
        self.totalGoodsItemQuantity = totalGoodsItemQuantity
        self.totalTransportHandlingUnitQuantity = totalTransportHandlingUnitQuantity
        self.insuranceValueAmount = insuranceValueAmount
        self.declaredForCarriageValueAmount = declaredForCarriageValueAmount
        self.declaredStatisticsValueAmount = declaredStatisticsValueAmount
        self.freeOnBoardValueAmount = freeOnBoardValueAmount
        self.specialInstructions = specialInstructions
        self.splitConsignmentIndicator = splitConsignmentIndicator
        self.deliveryInstructions = deliveryInstructions
        self.consignmentQuantity = consignmentQuantity
        self.consolidatableIndicator = consolidatableIndicator
        self.haulageInstructions = haulageInstructions
        self.loadingSequenceID = loadingSequenceID
        self.childConsignmentQuantity = childConsignmentQuantity
        self.totalPackagesQuantity = totalPackagesQuantity
        self.consolidatedShipment = consolidatedShipment
        self.customsDeclaration = customsDeclaration
        self.requestedPickupTransportEvent = requestedPickupTransportEvent
        self.requestedDeliveryTransportEvent = requestedDeliveryTransportEvent
        self.plannedPickupTransportEvent = plannedPickupTransportEvent
        self.plannedDeliveryTransportEvent = plannedDeliveryTransportEvent
        self.status = status
        self.childConsignment = childConsignment
        self.consigneeParty = consigneeParty
        self.exporterParty = exporterParty
        self.consignorParty = consignorParty
        self.importerParty = importerParty
        self.carrierParty = carrierParty
        self.freightForwarderParty = freightForwarderParty
        self.notifyParty = notifyParty
        self.originalDespatchParty = originalDespatchParty
        self.finalDeliveryParty = finalDeliveryParty
        self.performingCarrierParty = performingCarrierParty
        self.substituteCarrierParty = substituteCarrierParty
        self.logisticsOperatorParty = logisticsOperatorParty
        self.transportAdvisorParty = transportAdvisorParty
        self.hazardousItemNotificationParty = hazardousItemNotificationParty
        self.insuranceParty = insuranceParty
        self.mortgageHolderParty = mortgageHolderParty
        self.billOfLadingHolderParty = billOfLadingHolderParty
        self.originalDepartureCountry = originalDepartureCountry
        self.finalDestinationCountry = finalDestinationCountry
        self.transitCountry = transitCountry
        self.transportContract = transportContract
        self.transportEvent = transportEvent
        self.originalDespatchTransportationService = originalDespatchTransportationService
        self.finalDeliveryTransportationService = finalDeliveryTransportationService
        self.deliveryTerms = deliveryTerms
        self.paymentTerms = paymentTerms
        self.collectPaymentTerms = collectPaymentTerms
        self.disbursementPaymentTerms = disbursementPaymentTerms
        self.prepaidPaymentTerms = prepaidPaymentTerms
        self.freightAllowanceCharge = freightAllowanceCharge
        self.extraAllowanceCharge = extraAllowanceCharge
        self.mainCarriageShipmentStage = mainCarriageShipmentStage
        self.preCarriageShipmentStage = preCarriageShipmentStage
        self.onCarriageShipmentStage = onCarriageShipmentStage
        self.transportHandlingUnit = transportHandlingUnit
        self.firstArrivalPortLocation = firstArrivalPortLocation
        self.lastExitPortLocation = lastExitPortLocation
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case carrierAssignedID = "CarrierAssignedID"
        case consigneeAssignedID = "ConsigneeAssignedID"
        case consignorAssignedID = "ConsignorAssignedID"
        case freightForwarderAssignedID = "FreightForwarderAssignedID"
        case brokerAssignedID = "BrokerAssignedID"
        case contractedCarrierAssignedID = "ContractedCarrierAssignedID"
        case performingCarrierAssignedID = "PerformingCarrierAssignedID"
        case summaryDescription = "SummaryDescription"
        case totalInvoiceAmount = "TotalInvoiceAmount"
        case declaredCustomsValueAmount = "DeclaredCustomsValueAmount"
        case tariffDescription = "TariffDescription"
        case tariffCode = "TariffCode"
        case insurancePremiumAmount = "InsurancePremiumAmount"
        case grossWeightMeasure = "GrossWeightMeasure"
        case netWeightMeasure = "NetWeightMeasure"
        case netNetWeightMeasure = "NetNetWeightMeasure"
        case chargeableWeightMeasure = "ChargeableWeightMeasure"
        case grossVolumeMeasure = "GrossVolumeMeasure"
        case netVolumeMeasure = "NetVolumeMeasure"
        case loadingLengthMeasure = "LoadingLengthMeasure"
        case remarks = "Remarks"
        case hazardousRiskIndicator = "HazardousRiskIndicator"
        case animalFoodIndicator = "AnimalFoodIndicator"
        case humanFoodIndicator = "HumanFoodIndicator"
        case livestockIndicator = "LivestockIndicator"
        case bulkCargoIndicator = "BulkCargoIndicator"
        case containerizedIndicator = "ContainerizedIndicator"
        case generalCargoIndicator = "GeneralCargoIndicator"
        case specialSecurityIndicator = "SpecialSecurityIndicator"
        case thirdPartyPayerIndicator = "ThirdPartyPayerIndicator"
        case carrierServiceInstructions = "CarrierServiceInstructions"
        case customsClearanceServiceInstructions = "CustomsClearanceServiceInstructions"
        case forwarderServiceInstructions = "ForwarderServiceInstructions"
        case specialServiceInstructions = "SpecialServiceInstructions"
        case sequenceID = "SequenceID"
        case shippingPriorityLevelCode = "ShippingPriorityLevelCode"
        case handlingCode = "HandlingCode"
        case handlingInstructions = "HandlingInstructions"
        case information = "Information"
        case totalGoodsItemQuantity = "TotalGoodsItemQuantity"
        case totalTransportHandlingUnitQuantity = "TotalTransportHandlingUnitQuantity"
        case insuranceValueAmount = "InsuranceValueAmount"
        case declaredForCarriageValueAmount = "DeclaredForCarriageValueAmount"
        case declaredStatisticsValueAmount = "DeclaredStatisticsValueAmount"
        case freeOnBoardValueAmount = "FreeOnBoardValueAmount"
        case specialInstructions = "SpecialInstructions"
        case splitConsignmentIndicator = "SplitConsignmentIndicator"
        case deliveryInstructions = "DeliveryInstructions"
        case consignmentQuantity = "ConsignmentQuantity"
        case consolidatableIndicator = "ConsolidatableIndicator"
        case haulageInstructions = "HaulageInstructions"
        case loadingSequenceID = "LoadingSequenceID"
        case childConsignmentQuantity = "ChildConsignmentQuantity"
        case totalPackagesQuantity = "TotalPackagesQuantity"
        case consolidatedShipment = "ConsolidatedShipment"
        case customsDeclaration = "CustomsDeclaration"
        case requestedPickupTransportEvent = "RequestedPickupTransportEvent"
        case requestedDeliveryTransportEvent = "RequestedDeliveryTransportEvent"
        case plannedPickupTransportEvent = "PlannedPickupTransportEvent"
        case plannedDeliveryTransportEvent = "PlannedDeliveryTransportEvent"
        case status = "Status"
        case childConsignment = "ChildConsignment"
        case consigneeParty = "ConsigneeParty"
        case exporterParty = "ExporterParty"
        case consignorParty = "ConsignorParty"
        case importerParty = "ImporterParty"
        case carrierParty = "CarrierParty"
        case freightForwarderParty = "FreightForwarderParty"
        case notifyParty = "NotifyParty"
        case originalDespatchParty = "OriginalDespatchParty"
        case finalDeliveryParty = "FinalDeliveryParty"
        case performingCarrierParty = "PerformingCarrierParty"
        case substituteCarrierParty = "SubstituteCarrierParty"
        case logisticsOperatorParty = "LogisticsOperatorParty"
        case transportAdvisorParty = "TransportAdvisorParty"
        case hazardousItemNotificationParty = "HazardousItemNotificationParty"
        case insuranceParty = "InsuranceParty"
        case mortgageHolderParty = "MortgageHolderParty"
        case billOfLadingHolderParty = "BillOfLadingHolderParty"
        case originalDepartureCountry = "OriginalDepartureCountry"
        case finalDestinationCountry = "FinalDestinationCountry"
        case transitCountry = "TransitCountry"
        case transportContract = "TransportContract"
        case transportEvent = "TransportEvent"
        case originalDespatchTransportationService = "OriginalDespatchTransportationService"
        case finalDeliveryTransportationService = "FinalDeliveryTransportationService"
        case deliveryTerms = "DeliveryTerms"
        case paymentTerms = "PaymentTerms"
        case collectPaymentTerms = "CollectPaymentTerms"
        case disbursementPaymentTerms = "DisbursementPaymentTerms"
        case prepaidPaymentTerms = "PrepaidPaymentTerms"
        case freightAllowanceCharge = "FreightAllowanceCharge"
        case extraAllowanceCharge = "ExtraAllowanceCharge"
        case mainCarriageShipmentStage = "MainCarriageShipmentStage"
        case preCarriageShipmentStage = "PreCarriageShipmentStage"
        case onCarriageShipmentStage = "OnCarriageShipmentStage"
        case transportHandlingUnit = "TransportHandlingUnit"
        case firstArrivalPortLocation = "FirstArrivalPortLocation"
        case lastExitPortLocation = "LastExitPortLocation"
    }
}

extension Consignment: CreateEmpty {
    public nonisolated static func empty() -> Consignment {
        Consignment()
    }
}
