// 
// Contact.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct Contact: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>?
    public var name: SendableWrapper<Text>?
    public var telephone: SendableWrapper<Text>?
    public var telefax: SendableWrapper<Text>?
    public var electronicMail: SendableWrapper<Text>?
    public var note: [SendableWrapper<Text>] // This array should have at least one element
    public var otherCommunication: [SendableWrapper<Communication>] // This array should have at least one element

    public init(id: SendableWrapper<Identifier>? = nil,
         name: SendableWrapper<Text>? = nil,
         telephone: SendableWrapper<Text>? = nil,
         telefax: SendableWrapper<Text>? = nil,
         electronicMail: SendableWrapper<Text>? = nil,
         note: [SendableWrapper<Text>] = [],
         otherCommunication: [SendableWrapper<Communication>] = []) {
        self.id = id
        self.name = name
        self.telephone = telephone
        self.telefax = telefax
        self.electronicMail = electronicMail
        self.note = note
        self.otherCommunication = otherCommunication
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case name = "Name"
        case telephone = "Telephone"
        case telefax = "Telefax"
        case electronicMail = "ElectronicMail"
        case note = "Note"
        case otherCommunication = "OtherCommunication"
    }
}

extension Contact: CreateEmpty {
    public nonisolated static func empty() -> Contact {
        Contact()
    }
}
