// 
// Contract.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct Contract: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>?
    public var issueDate: XMLDate?
    public var issueTime: XMLDate?
    public var nominationDate: XMLDate?
    public var nominationTime: XMLDate?
    public var contractTypeCode: SendableWrapper<Code>?
    public var contractType: SendableWrapper<Text>?
    public var note: [SendableWrapper<Text>] // This array should have at least one element
    public var versionID: SendableWrapper<Identifier>?
    public var description: [SendableWrapper<Text>] // This array should have at least one element
    public var validityPeriod: SendableWrapper<Period>?
    public var contractDocumentReference: [SendableWrapper<DocumentReference>] // This array should have at least one element
    public var nominationPeriod: SendableWrapper<Period>?
    public var contractualDelivery: SendableWrapper<Delivery>?

    public init(id: SendableWrapper<Identifier>? = nil,
         issueDate: XMLDate? = nil,
         issueTime: XMLDate? = nil,
         nominationDate: XMLDate? = nil,
         nominationTime: XMLDate? = nil,
         contractTypeCode: SendableWrapper<Code>? = nil,
         contractType: SendableWrapper<Text>? = nil,
         note: [SendableWrapper<Text>] = [],
         versionID: SendableWrapper<Identifier>? = nil,
         description: [SendableWrapper<Text>] = [],
         validityPeriod: SendableWrapper<Period>? = nil,
         contractDocumentReference: [SendableWrapper<DocumentReference>] = [],
         nominationPeriod: SendableWrapper<Period>? = nil,
         contractualDelivery: SendableWrapper<Delivery>? = nil) {
        self.id = id
        self.issueDate = issueDate
        self.issueTime = issueTime
        self.nominationDate = nominationDate
        self.nominationTime = nominationTime
        self.contractTypeCode = contractTypeCode
        self.contractType = contractType
        self.note = note
        self.versionID = versionID
        self.description = description
        self.validityPeriod = validityPeriod
        self.contractDocumentReference = contractDocumentReference
        self.nominationPeriod = nominationPeriod
        self.contractualDelivery = contractualDelivery
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case issueDate = "IssueDate"
        case issueTime = "IssueTime"
        case nominationDate = "NominationDate"
        case nominationTime = "NominationTime"
        case contractTypeCode = "ContractTypeCode"
        case contractType = "ContractType"
        case note = "Note"
        case versionID = "VersionID"
        case description = "Description"
        case validityPeriod = "ValidityPeriod"
        case contractDocumentReference = "ContractDocumentReference"
        case nominationPeriod = "NominationPeriod"
        case contractualDelivery = "ContractualDelivery"
    }
}

extension Contract: CreateEmpty {
    public nonisolated static func empty() -> Contract {
        Contract()
    }
}
