// 
// CorporateRegistrationScheme.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct CorporateRegistrationScheme: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>?
    public var name: SendableWrapper<Text>?
    public var corporateRegistrationTypeCode: SendableWrapper<Code>?
    public var jurisdictionRegionAddress: [SendableWrapper<Address>] // This array should have at least one element

    public init(id: SendableWrapper<Identifier>? = nil,
         name: SendableWrapper<Text>? = nil,
         corporateRegistrationTypeCode: SendableWrapper<Code>? = nil,
         jurisdictionRegionAddress: [SendableWrapper<Address>] = []) {
        self.id = id
        self.name = name
        self.corporateRegistrationTypeCode = corporateRegistrationTypeCode
        self.jurisdictionRegionAddress = jurisdictionRegionAddress
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case name = "Name"
        case corporateRegistrationTypeCode = "CorporateRegistrationTypeCode"
        case jurisdictionRegionAddress = "JurisdictionRegionAddress"
    }
}

extension CorporateRegistrationScheme: CreateEmpty {
    public nonisolated static func empty() -> CorporateRegistrationScheme {
        CorporateRegistrationScheme()
    }
}
