// 
// Country.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct Country: Codable, Sendable, Hashable  {
    public var identificationCode: SendableWrapper<Code>?
    public var name: SendableWrapper<Text>?

    public init(identificationCode: SendableWrapper<Code>? = nil,
         name: SendableWrapper<Text>? = nil) {
        self.identificationCode = identificationCode
        self.name = name
    }
    
    public enum CodingKeys: String, CodingKey {
        case identificationCode = "IdentificationCode"
        case name = "Name"
    }
}

extension Country: CreateEmpty {
    public nonisolated static func empty() -> Country {
        Country()
    }
}
