// 
// CustomerParty.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct CustomerParty: Codable, Sendable, Hashable  {
    public var customerAssignedAccountID: SendableWrapper<Identifier>?
    public var supplierAssignedAccountID: SendableWrapper<Identifier>?
    public var additionalAccountID: [SendableWrapper<Identifier>] // This array should have at least one element
    public var party: SendableWrapper<Party>?
    public var deliveryContact: SendableWrapper<Contact>?
    public var accountingContact: SendableWrapper<Contact>?
    public var buyerContact: SendableWrapper<Contact>?

    public init(customerAssignedAccountID: SendableWrapper<Identifier>? = nil,
         supplierAssignedAccountID: SendableWrapper<Identifier>? = nil,
         additionalAccountID: [SendableWrapper<Identifier>] = [],
         party: SendableWrapper<Party>? = nil,
         deliveryContact: SendableWrapper<Contact>? = nil,
         accountingContact: SendableWrapper<Contact>? = nil,
         buyerContact: SendableWrapper<Contact>? = nil) {
        self.customerAssignedAccountID = customerAssignedAccountID
        self.supplierAssignedAccountID = supplierAssignedAccountID
        self.additionalAccountID = additionalAccountID
        self.party = party
        self.deliveryContact = deliveryContact
        self.accountingContact = accountingContact
        self.buyerContact = buyerContact
    }
    
    public enum CodingKeys: String, CodingKey {
        case customerAssignedAccountID = "CustomerAssignedAccountID"
        case supplierAssignedAccountID = "SupplierAssignedAccountID"
        case additionalAccountID = "AdditionalAccountID"
        case party = "Party"
        case deliveryContact = "DeliveryContact"
        case accountingContact = "AccountingContact"
        case buyerContact = "BuyerContact"
    }
}

extension CustomerParty: CreateEmpty {
    public nonisolated static func empty() -> CustomerParty {
        CustomerParty()
    }
}
