// 
// Delivery.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct Delivery: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>?
    public var quantity: SendableWrapper<Quantity>?
    public var minimumQuantity: SendableWrapper<Quantity>?
    public var maximumQuantity: SendableWrapper<Quantity>?
    public var actualDeliveryDate: XMLDate?
    public var actualDeliveryTime: XMLDate?
    public var latestDeliveryDate: XMLDate?
    public var latestDeliveryTime: XMLDate?
    public var releaseID: SendableWrapper<Identifier>?
    public var trackingID: SendableWrapper<Identifier>?
    public var deliveryAddress: SendableWrapper<Address>?
    public var deliveryLocation: SendableWrapper<Location>?
    public var alternativeDeliveryLocation: SendableWrapper<Location>?
    public var requestedDeliveryPeriod: SendableWrapper<Period>?
    public var promisedDeliveryPeriod: SendableWrapper<Period>?
    public var estimatedDeliveryPeriod: SendableWrapper<Period>?
    public var carrierParty: SendableWrapper<Party>?
    public var deliveryParty: SendableWrapper<Party>?
    public var notifyParty: [SendableWrapper<Party>] // This array should have at least one element
    public var despatch: SendableWrapper<Despatch>?
    public var deliveryTerms: [SendableWrapper<DeliveryTerms>] // This array should have at least one element
    public var minimumDeliveryUnit: SendableWrapper<DeliveryUnit>?
    public var maximumDeliveryUnit: SendableWrapper<DeliveryUnit>?
    public var shipment: SendableWrapper<Shipment>?

    public init(id: SendableWrapper<Identifier>? = nil,
         quantity: SendableWrapper<Quantity>? = nil,
         minimumQuantity: SendableWrapper<Quantity>? = nil,
         maximumQuantity: SendableWrapper<Quantity>? = nil,
         actualDeliveryDate: XMLDate? = nil,
         actualDeliveryTime: XMLDate? = nil,
         latestDeliveryDate: XMLDate? = nil,
         latestDeliveryTime: XMLDate? = nil,
         releaseID: SendableWrapper<Identifier>? = nil,
         trackingID: SendableWrapper<Identifier>? = nil,
         deliveryAddress: SendableWrapper<Address>? = nil,
         deliveryLocation: SendableWrapper<Location>? = nil,
         alternativeDeliveryLocation: SendableWrapper<Location>? = nil,
         requestedDeliveryPeriod: SendableWrapper<Period>? = nil,
         promisedDeliveryPeriod: SendableWrapper<Period>? = nil,
         estimatedDeliveryPeriod: SendableWrapper<Period>? = nil,
         carrierParty: SendableWrapper<Party>? = nil,
         deliveryParty: SendableWrapper<Party>? = nil,
         notifyParty: [SendableWrapper<Party>] = [],
         despatch: SendableWrapper<Despatch>? = nil,
         deliveryTerms: [SendableWrapper<DeliveryTerms>] = [],
         minimumDeliveryUnit: SendableWrapper<DeliveryUnit>? = nil,
         maximumDeliveryUnit: SendableWrapper<DeliveryUnit>? = nil,
         shipment: SendableWrapper<Shipment>? = nil) {
        self.id = id
        self.quantity = quantity
        self.minimumQuantity = minimumQuantity
        self.maximumQuantity = maximumQuantity
        self.actualDeliveryDate = actualDeliveryDate
        self.actualDeliveryTime = actualDeliveryTime
        self.latestDeliveryDate = latestDeliveryDate
        self.latestDeliveryTime = latestDeliveryTime
        self.releaseID = releaseID
        self.trackingID = trackingID
        self.deliveryAddress = deliveryAddress
        self.deliveryLocation = deliveryLocation
        self.alternativeDeliveryLocation = alternativeDeliveryLocation
        self.requestedDeliveryPeriod = requestedDeliveryPeriod
        self.promisedDeliveryPeriod = promisedDeliveryPeriod
        self.estimatedDeliveryPeriod = estimatedDeliveryPeriod
        self.carrierParty = carrierParty
        self.deliveryParty = deliveryParty
        self.notifyParty = notifyParty
        self.despatch = despatch
        self.deliveryTerms = deliveryTerms
        self.minimumDeliveryUnit = minimumDeliveryUnit
        self.maximumDeliveryUnit = maximumDeliveryUnit
        self.shipment = shipment
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case quantity = "Quantity"
        case minimumQuantity = "MinimumQuantity"
        case maximumQuantity = "MaximumQuantity"
        case actualDeliveryDate = "ActualDeliveryDate"
        case actualDeliveryTime = "ActualDeliveryTime"
        case latestDeliveryDate = "LatestDeliveryDate"
        case latestDeliveryTime = "LatestDeliveryTime"
        case releaseID = "ReleaseID"
        case trackingID = "TrackingID"
        case deliveryAddress = "DeliveryAddress"
        case deliveryLocation = "DeliveryLocation"
        case alternativeDeliveryLocation = "AlternativeDeliveryLocation"
        case requestedDeliveryPeriod = "RequestedDeliveryPeriod"
        case promisedDeliveryPeriod = "PromisedDeliveryPeriod"
        case estimatedDeliveryPeriod = "EstimatedDeliveryPeriod"
        case carrierParty = "CarrierParty"
        case deliveryParty = "DeliveryParty"
        case notifyParty = "NotifyParty"
        case despatch = "Despatch"
        case deliveryTerms = "DeliveryTerms"
        case minimumDeliveryUnit = "MinimumDeliveryUnit"
        case maximumDeliveryUnit = "MaximumDeliveryUnit"
        case shipment = "Shipment"
    }
}

extension Delivery: CreateEmpty {
    public nonisolated static func empty() -> Delivery {
        Delivery()
    }
}
