// 
// DeliveryTerms.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct DeliveryTerms: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>?
    public var specialTerms: [SendableWrapper<Text>] // This array should have at least one element
    public var lossRiskResponsibilityCode: SendableWrapper<Code>?
    public var lossRisk: [SendableWrapper<Text>] // This array should have at least one element
    public var amount: SendableWrapper<Amount>?
    public var deliveryLocation: SendableWrapper<Location>?
    public var allowanceCharge: SendableWrapper<AllowanceCharge>?

    public init(id: SendableWrapper<Identifier>? = nil,
         specialTerms: [SendableWrapper<Text>] = [],
         lossRiskResponsibilityCode: SendableWrapper<Code>? = nil,
         lossRisk: [SendableWrapper<Text>] = [],
         amount: SendableWrapper<Amount>? = nil,
         deliveryLocation: SendableWrapper<Location>? = nil,
         allowanceCharge: SendableWrapper<AllowanceCharge>? = nil) {
        self.id = id
        self.specialTerms = specialTerms
        self.lossRiskResponsibilityCode = lossRiskResponsibilityCode
        self.lossRisk = lossRisk
        self.amount = amount
        self.deliveryLocation = deliveryLocation
        self.allowanceCharge = allowanceCharge
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case specialTerms = "SpecialTerms"
        case lossRiskResponsibilityCode = "LossRiskResponsibilityCode"
        case lossRisk = "LossRisk"
        case amount = "Amount"
        case deliveryLocation = "DeliveryLocation"
        case allowanceCharge = "AllowanceCharge"
    }
}

extension DeliveryTerms: CreateEmpty {
    public nonisolated static func empty() -> DeliveryTerms {
        DeliveryTerms()
    }
}
