// 
// DeliveryUnit.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct DeliveryUnit: Codable, Sendable, Hashable  {
    public var batchQuantity: SendableWrapper<Quantity>
    public var consumerUnitQuantity: SendableWrapper<Quantity>?
    public var hazardousRiskIndicator: SendableWrapper<Indicator>?

    public init(batchQuantity: SendableWrapper<Quantity> = SendableWrapper(Quantity.empty()),
         consumerUnitQuantity: SendableWrapper<Quantity>? = nil,
         hazardousRiskIndicator: SendableWrapper<Indicator>? = nil) {
        self.batchQuantity = batchQuantity
        self.consumerUnitQuantity = consumerUnitQuantity
        self.hazardousRiskIndicator = hazardousRiskIndicator
    }
    
    public enum CodingKeys: String, CodingKey {
        case batchQuantity = "BatchQuantity"
        case consumerUnitQuantity = "ConsumerUnitQuantity"
        case hazardousRiskIndicator = "HazardousRiskIndicator"
    }
}

extension DeliveryUnit: CreateEmpty {
    public nonisolated static func empty() -> DeliveryUnit {
        DeliveryUnit()
    }
}
