// 
// DependentPriceReference.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct DependentPriceReference: Codable, Sendable, Hashable  {
    public var percent: SendableWrapper<Numeric>?
    public var locationAddress: SendableWrapper<Address>?
    public var dependentLineReference: SendableWrapper<LineReference>?

    public init(percent: SendableWrapper<Numeric>? = nil,
         locationAddress: SendableWrapper<Address>? = nil,
         dependentLineReference: SendableWrapper<LineReference>? = nil) {
        self.percent = percent
        self.locationAddress = locationAddress
        self.dependentLineReference = dependentLineReference
    }
    
    public enum CodingKeys: String, CodingKey {
        case percent = "Percent"
        case locationAddress = "LocationAddress"
        case dependentLineReference = "DependentLineReference"
    }
}

extension DependentPriceReference: CreateEmpty {
    public nonisolated static func empty() -> DependentPriceReference {
        DependentPriceReference()
    }
}
