// 
// Despatch.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct Despatch: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>?
    public var requestedDespatchDate: XMLDate?
    public var requestedDespatchTime: XMLDate?
    public var estimatedDespatchDate: XMLDate?
    public var estimatedDespatchTime: XMLDate?
    public var actualDespatchDate: XMLDate?
    public var actualDespatchTime: XMLDate?
    public var guaranteedDespatchDate: XMLDate?
    public var guaranteedDespatchTime: XMLDate?
    public var releaseID: SendableWrapper<Identifier>?
    public var instructions: [SendableWrapper<Text>] // This array should have at least one element
    public var despatchAddress: SendableWrapper<Address>?
    public var despatchLocation: SendableWrapper<Location>?
    public var despatchParty: SendableWrapper<Party>?
    public var carrierParty: SendableWrapper<Party>?
    public var notifyParty: [SendableWrapper<Party>] // This array should have at least one element
    public var contact: SendableWrapper<Contact>?
    public var estimatedDespatchPeriod: SendableWrapper<Period>?
    public var requestedDespatchPeriod: SendableWrapper<Period>?

    public init(id: SendableWrapper<Identifier>? = nil,
         requestedDespatchDate: XMLDate? = nil,
         requestedDespatchTime: XMLDate? = nil,
         estimatedDespatchDate: XMLDate? = nil,
         estimatedDespatchTime: XMLDate? = nil,
         actualDespatchDate: XMLDate? = nil,
         actualDespatchTime: XMLDate? = nil,
         guaranteedDespatchDate: XMLDate? = nil,
         guaranteedDespatchTime: XMLDate? = nil,
         releaseID: SendableWrapper<Identifier>? = nil,
         instructions: [SendableWrapper<Text>] = [],
         despatchAddress: SendableWrapper<Address>? = nil,
         despatchLocation: SendableWrapper<Location>? = nil,
         despatchParty: SendableWrapper<Party>? = nil,
         carrierParty: SendableWrapper<Party>? = nil,
         notifyParty: [SendableWrapper<Party>] = [],
         contact: SendableWrapper<Contact>? = nil,
         estimatedDespatchPeriod: SendableWrapper<Period>? = nil,
         requestedDespatchPeriod: SendableWrapper<Period>? = nil) {
        self.id = id
        self.requestedDespatchDate = requestedDespatchDate
        self.requestedDespatchTime = requestedDespatchTime
        self.estimatedDespatchDate = estimatedDespatchDate
        self.estimatedDespatchTime = estimatedDespatchTime
        self.actualDespatchDate = actualDespatchDate
        self.actualDespatchTime = actualDespatchTime
        self.guaranteedDespatchDate = guaranteedDespatchDate
        self.guaranteedDespatchTime = guaranteedDespatchTime
        self.releaseID = releaseID
        self.instructions = instructions
        self.despatchAddress = despatchAddress
        self.despatchLocation = despatchLocation
        self.despatchParty = despatchParty
        self.carrierParty = carrierParty
        self.notifyParty = notifyParty
        self.contact = contact
        self.estimatedDespatchPeriod = estimatedDespatchPeriod
        self.requestedDespatchPeriod = requestedDespatchPeriod
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case requestedDespatchDate = "RequestedDespatchDate"
        case requestedDespatchTime = "RequestedDespatchTime"
        case estimatedDespatchDate = "EstimatedDespatchDate"
        case estimatedDespatchTime = "EstimatedDespatchTime"
        case actualDespatchDate = "ActualDespatchDate"
        case actualDespatchTime = "ActualDespatchTime"
        case guaranteedDespatchDate = "GuaranteedDespatchDate"
        case guaranteedDespatchTime = "GuaranteedDespatchTime"
        case releaseID = "ReleaseID"
        case instructions = "Instructions"
        case despatchAddress = "DespatchAddress"
        case despatchLocation = "DespatchLocation"
        case despatchParty = "DespatchParty"
        case carrierParty = "CarrierParty"
        case notifyParty = "NotifyParty"
        case contact = "Contact"
        case estimatedDespatchPeriod = "EstimatedDespatchPeriod"
        case requestedDespatchPeriod = "RequestedDespatchPeriod"
    }
}

extension Despatch: CreateEmpty {
    public nonisolated static func empty() -> Despatch {
        Despatch()
    }
}
