// 
// DespatchLine.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct DespatchLine: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>
    public var uuid: SendableWrapper<Identifier>?
    public var note: [SendableWrapper<Text>] // This array should have at least one element
    public var lineStatusCode: SendableWrapper<Code>?
    public var deliveredQuantity: SendableWrapper<Quantity>?
    public var backorderQuantity: SendableWrapper<Quantity>?
    public var backorderReason: [SendableWrapper<Text>] // This array should have at least one element
    public var outstandingQuantity: SendableWrapper<Quantity>?
    public var outstandingReason: [SendableWrapper<Text>] // This array should have at least one element
    public var oversupplyQuantity: SendableWrapper<Quantity>?
    public var orderLineReference: [SendableWrapper<OrderLineReference>]
    public var documentReference: [SendableWrapper<DocumentReference>] // This array should have at least one element
    public var item: SendableWrapper<Item>
    public var shipment: [SendableWrapper<Shipment>] // This array should have at least one element

    public init(id: SendableWrapper<Identifier> = SendableWrapper(Identifier.empty()),
         uuid: SendableWrapper<Identifier>? = nil,
         note: [SendableWrapper<Text>] = [],
         lineStatusCode: SendableWrapper<Code>? = nil,
         deliveredQuantity: SendableWrapper<Quantity>? = nil,
         backorderQuantity: SendableWrapper<Quantity>? = nil,
         backorderReason: [SendableWrapper<Text>] = [],
         outstandingQuantity: SendableWrapper<Quantity>? = nil,
         outstandingReason: [SendableWrapper<Text>] = [],
         oversupplyQuantity: SendableWrapper<Quantity>? = nil,
         orderLineReference: [SendableWrapper<OrderLineReference>] = [],
         documentReference: [SendableWrapper<DocumentReference>] = [],
         item: SendableWrapper<Item> = SendableWrapper(Item.empty()),
         shipment: [SendableWrapper<Shipment>] = []) {
        self.id = id
        self.uuid = uuid
        self.note = note
        self.lineStatusCode = lineStatusCode
        self.deliveredQuantity = deliveredQuantity
        self.backorderQuantity = backorderQuantity
        self.backorderReason = backorderReason
        self.outstandingQuantity = outstandingQuantity
        self.outstandingReason = outstandingReason
        self.oversupplyQuantity = oversupplyQuantity
        self.orderLineReference = orderLineReference
        self.documentReference = documentReference
        self.item = item
        self.shipment = shipment
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case uuid = "UUID"
        case note = "Note"
        case lineStatusCode = "LineStatusCode"
        case deliveredQuantity = "DeliveredQuantity"
        case backorderQuantity = "BackorderQuantity"
        case backorderReason = "BackorderReason"
        case outstandingQuantity = "OutstandingQuantity"
        case outstandingReason = "OutstandingReason"
        case oversupplyQuantity = "OversupplyQuantity"
        case orderLineReference = "OrderLineReference"
        case documentReference = "DocumentReference"
        case item = "Item"
        case shipment = "Shipment"
    }
}

extension DespatchLine: CreateEmpty {
    public nonisolated static func empty() -> DespatchLine {
        DespatchLine()
    }
}
