// 
// Dimension.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct Dimension: Codable, Sendable, Hashable  {
    public var attributeID: SendableWrapper<Identifier>
    public var measure: SendableWrapper<Measure>?
    public var description: [SendableWrapper<Text>] // This array should have at least one element
    public var minimumMeasure: SendableWrapper<Measure>?
    public var maximumMeasure: SendableWrapper<Measure>?

    public init(attributeID: SendableWrapper<Identifier> = SendableWrapper(Identifier.empty()),
         measure: SendableWrapper<Measure>? = nil,
         description: [SendableWrapper<Text>] = [],
         minimumMeasure: SendableWrapper<Measure>? = nil,
         maximumMeasure: SendableWrapper<Measure>? = nil) {
        self.attributeID = attributeID
        self.measure = measure
        self.description = description
        self.minimumMeasure = minimumMeasure
        self.maximumMeasure = maximumMeasure
    }
    
    public enum CodingKeys: String, CodingKey {
        case attributeID = "AttributeID"
        case measure = "Measure"
        case description = "Description"
        case minimumMeasure = "MinimumMeasure"
        case maximumMeasure = "MaximumMeasure"
    }
}

extension Dimension: CreateEmpty {
    public nonisolated static func empty() -> Dimension {
        Dimension()
    }
}
