// 
// EmissionCalculationMethod.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct EmissionCalculationMethod: Codable, Sendable, Hashable  {
    public var calculationMethodCode: SendableWrapper<Code>?
    public var fullnessIndicationCode: SendableWrapper<Code>?
    public var measurementFromLocation: SendableWrapper<Location>?
    public var measurementToLocation: SendableWrapper<Location>?

    public init(calculationMethodCode: SendableWrapper<Code>? = nil,
         fullnessIndicationCode: SendableWrapper<Code>? = nil,
         measurementFromLocation: SendableWrapper<Location>? = nil,
         measurementToLocation: SendableWrapper<Location>? = nil) {
        self.calculationMethodCode = calculationMethodCode
        self.fullnessIndicationCode = fullnessIndicationCode
        self.measurementFromLocation = measurementFromLocation
        self.measurementToLocation = measurementToLocation
    }
    
    public enum CodingKeys: String, CodingKey {
        case calculationMethodCode = "CalculationMethodCode"
        case fullnessIndicationCode = "FullnessIndicationCode"
        case measurementFromLocation = "MeasurementFromLocation"
        case measurementToLocation = "MeasurementToLocation"
    }
}

extension EmissionCalculationMethod: CreateEmpty {
    public nonisolated static func empty() -> EmissionCalculationMethod {
        EmissionCalculationMethod()
    }
}
