// 
// EnvironmentalEmission.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct EnvironmentalEmission: Codable, Sendable, Hashable  {
    public var environmentalEmissionTypeCode: SendableWrapper<Code>
    public var valueMeasure: SendableWrapper<Measure>
    public var description: [SendableWrapper<Text>] // This array should have at least one element
    public var emissionCalculationMethod: [SendableWrapper<EmissionCalculationMethod>] // This array should have at least one element

    public init(environmentalEmissionTypeCode: SendableWrapper<Code> = SendableWrapper(Code.empty()),
         valueMeasure: SendableWrapper<Measure> = SendableWrapper(Measure.empty()),
         description: [SendableWrapper<Text>] = [],
         emissionCalculationMethod: [SendableWrapper<EmissionCalculationMethod>] = []) {
        self.environmentalEmissionTypeCode = environmentalEmissionTypeCode
        self.valueMeasure = valueMeasure
        self.description = description
        self.emissionCalculationMethod = emissionCalculationMethod
    }
    
    public enum CodingKeys: String, CodingKey {
        case environmentalEmissionTypeCode = "EnvironmentalEmissionTypeCode"
        case valueMeasure = "ValueMeasure"
        case description = "Description"
        case emissionCalculationMethod = "EmissionCalculationMethod"
    }
}

extension EnvironmentalEmission: CreateEmpty {
    public nonisolated static func empty() -> EnvironmentalEmission {
        EnvironmentalEmission()
    }
}
