// 
// ExchangeRate.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct ExchangeRate: Codable, Sendable, Hashable  {
    public var sourceCurrencyCode: SendableWrapper<Code>
    public var sourceCurrencyBaseRate: SendableWrapper<Numeric>?
    public var targetCurrencyCode: SendableWrapper<Code>
    public var targetCurrencyBaseRate: SendableWrapper<Numeric>?
    public var exchangeMarketID: SendableWrapper<Identifier>?
    public var calculationRate: SendableWrapper<Numeric>?
    public var mathematicOperatorCode: SendableWrapper<Code>?
    public var date: XMLDate?
    public var foreignExchangeContract: SendableWrapper<Contract>?

    public init(sourceCurrencyCode: SendableWrapper<Code> = SendableWrapper(Code.empty()),
         sourceCurrencyBaseRate: SendableWrapper<Numeric>? = nil,
         targetCurrencyCode: SendableWrapper<Code> = SendableWrapper(Code.empty()),
         targetCurrencyBaseRate: SendableWrapper<Numeric>? = nil,
         exchangeMarketID: SendableWrapper<Identifier>? = nil,
         calculationRate: SendableWrapper<Numeric>? = nil,
         mathematicOperatorCode: SendableWrapper<Code>? = nil,
         date: XMLDate? = nil,
         foreignExchangeContract: SendableWrapper<Contract>? = nil) {
        self.sourceCurrencyCode = sourceCurrencyCode
        self.sourceCurrencyBaseRate = sourceCurrencyBaseRate
        self.targetCurrencyCode = targetCurrencyCode
        self.targetCurrencyBaseRate = targetCurrencyBaseRate
        self.exchangeMarketID = exchangeMarketID
        self.calculationRate = calculationRate
        self.mathematicOperatorCode = mathematicOperatorCode
        self.date = date
        self.foreignExchangeContract = foreignExchangeContract
    }
    
    public enum CodingKeys: String, CodingKey {
        case sourceCurrencyCode = "SourceCurrencyCode"
        case sourceCurrencyBaseRate = "SourceCurrencyBaseRate"
        case targetCurrencyCode = "TargetCurrencyCode"
        case targetCurrencyBaseRate = "TargetCurrencyBaseRate"
        case exchangeMarketID = "ExchangeMarketID"
        case calculationRate = "CalculationRate"
        case mathematicOperatorCode = "MathematicOperatorCode"
        case date = "Date"
        case foreignExchangeContract = "ForeignExchangeContract"
    }
}

extension ExchangeRate: CreateEmpty {
    public nonisolated static func empty() -> ExchangeRate {
        ExchangeRate()
    }
}
