// 
// ExternalReference.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct ExternalReference: Codable, Sendable, Hashable  {
    public var uri: SendableWrapper<Identifier>?
    public var documentHash: SendableWrapper<Text>?
    public var hashAlgorithmMethod: SendableWrapper<Text>?
    public var expiryDate: XMLDate?
    public var expiryTime: XMLDate?
    public var mimeCode: SendableWrapper<Code>?
    public var formatCode: SendableWrapper<Code>?
    public var encodingCode: SendableWrapper<Code>?
    public var characterSetCode: SendableWrapper<Code>?
    public var fileName: SendableWrapper<Text>?
    public var description: [SendableWrapper<Text>] // This array should have at least one element

    public init(uri: SendableWrapper<Identifier>? = nil,
         documentHash: SendableWrapper<Text>? = nil,
         hashAlgorithmMethod: SendableWrapper<Text>? = nil,
         expiryDate: XMLDate? = nil,
         expiryTime: XMLDate? = nil,
         mimeCode: SendableWrapper<Code>? = nil,
         formatCode: SendableWrapper<Code>? = nil,
         encodingCode: SendableWrapper<Code>? = nil,
         characterSetCode: SendableWrapper<Code>? = nil,
         fileName: SendableWrapper<Text>? = nil,
         description: [SendableWrapper<Text>] = []) {
        self.uri = uri
        self.documentHash = documentHash
        self.hashAlgorithmMethod = hashAlgorithmMethod
        self.expiryDate = expiryDate
        self.expiryTime = expiryTime
        self.mimeCode = mimeCode
        self.formatCode = formatCode
        self.encodingCode = encodingCode
        self.characterSetCode = characterSetCode
        self.fileName = fileName
        self.description = description
    }
    
    public enum CodingKeys: String, CodingKey {
        case uri = "URI"
        case documentHash = "DocumentHash"
        case hashAlgorithmMethod = "HashAlgorithmMethod"
        case expiryDate = "ExpiryDate"
        case expiryTime = "ExpiryTime"
        case mimeCode = "MimeCode"
        case formatCode = "FormatCode"
        case encodingCode = "EncodingCode"
        case characterSetCode = "CharacterSetCode"
        case fileName = "FileName"
        case description = "Description"
    }
}

extension ExternalReference: CreateEmpty {
    public nonisolated static func empty() -> ExternalReference {
        ExternalReference()
    }
}
