// 
// FinancialAccount.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct FinancialAccount: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>?
    public var name: SendableWrapper<Text>?
    public var aliasName: SendableWrapper<Text>?
    public var accountTypeCode: SendableWrapper<Code>?
    public var accountFormatCode: SendableWrapper<Code>?
    public var currencyCode: SendableWrapper<Code>?
    public var paymentNote: [SendableWrapper<Text>] // This array should have at least one element
    public var financialInstitutionBranch: SendableWrapper<Branch>?
    public var country: SendableWrapper<Country>?

    public init(id: SendableWrapper<Identifier>? = nil,
         name: SendableWrapper<Text>? = nil,
         aliasName: SendableWrapper<Text>? = nil,
         accountTypeCode: SendableWrapper<Code>? = nil,
         accountFormatCode: SendableWrapper<Code>? = nil,
         currencyCode: SendableWrapper<Code>? = nil,
         paymentNote: [SendableWrapper<Text>] = [],
         financialInstitutionBranch: SendableWrapper<Branch>? = nil,
         country: SendableWrapper<Country>? = nil) {
        self.id = id
        self.name = name
        self.aliasName = aliasName
        self.accountTypeCode = accountTypeCode
        self.accountFormatCode = accountFormatCode
        self.currencyCode = currencyCode
        self.paymentNote = paymentNote
        self.financialInstitutionBranch = financialInstitutionBranch
        self.country = country
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case name = "Name"
        case aliasName = "AliasName"
        case accountTypeCode = "AccountTypeCode"
        case accountFormatCode = "AccountFormatCode"
        case currencyCode = "CurrencyCode"
        case paymentNote = "PaymentNote"
        case financialInstitutionBranch = "FinancialInstitutionBranch"
        case country = "Country"
    }
}

extension FinancialAccount: CreateEmpty {
    public nonisolated static func empty() -> FinancialAccount {
        FinancialAccount()
    }
}
