// 
// GoodsItem.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct GoodsItem: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>?
    public var sequenceNumberID: SendableWrapper<Identifier>?
    public var description: [SendableWrapper<Text>] // This array should have at least one element
    public var hazardousRiskIndicator: SendableWrapper<Indicator>?
    public var declaredCustomsValueAmount: SendableWrapper<Amount>?
    public var declaredForCarriageValueAmount: SendableWrapper<Amount>?
    public var declaredStatisticsValueAmount: SendableWrapper<Amount>?
    public var freeOnBoardValueAmount: SendableWrapper<Amount>?
    public var insuranceValueAmount: SendableWrapper<Amount>?
    public var valueAmount: SendableWrapper<Amount>?
    public var grossWeightMeasure: SendableWrapper<Measure>?
    public var netWeightMeasure: SendableWrapper<Measure>?
    public var netNetWeightMeasure: SendableWrapper<Measure>?
    public var chargeableWeightMeasure: SendableWrapper<Measure>?
    public var grossVolumeMeasure: SendableWrapper<Measure>?
    public var netVolumeMeasure: SendableWrapper<Measure>?
    public var quantity: SendableWrapper<Quantity>?
    public var preferenceCriterionCode: SendableWrapper<Code>?
    public var requiredCustomsID: SendableWrapper<Identifier>?
    public var customsStatusCode: SendableWrapper<Code>?
    public var customsTariffQuantity: SendableWrapper<Quantity>?
    public var customsImportClassifiedIndicator: SendableWrapper<Indicator>?
    public var chargeableQuantity: SendableWrapper<Quantity>?
    public var returnableQuantity: SendableWrapper<Quantity>?
    public var traceID: SendableWrapper<Identifier>?
    public var item: [SendableWrapper<Item>] // This array should have at least one element
    public var goodsItemContainer: [SendableWrapper<GoodsItemContainer>] // This array should have at least one element
    public var freightAllowanceCharge: [SendableWrapper<AllowanceCharge>] // This array should have at least one element
    public var invoiceLine: [SendableWrapper<InvoiceLine>] // This array should have at least one element
    public var temperature: [SendableWrapper<Temperature>] // This array should have at least one element
    public var containedGoodsItem: [SendableWrapper<GoodsItem>] // This array should have at least one element
    public var originAddress: SendableWrapper<Address>?
    public var delivery: SendableWrapper<Delivery>?
    public var pickup: SendableWrapper<Pickup>?
    public var despatch: SendableWrapper<Despatch>?
    public var measurementDimension: [SendableWrapper<Dimension>] // This array should have at least one element
    public var containingPackage: [SendableWrapper<PackageType>] // This array should have at least one element
    public var shipmentDocumentReference: SendableWrapper<DocumentReference>?
    public var minimumTemperature: SendableWrapper<Temperature>?
    public var maximumTemperature: SendableWrapper<Temperature>?

    public init(id: SendableWrapper<Identifier>? = nil,
         sequenceNumberID: SendableWrapper<Identifier>? = nil,
         description: [SendableWrapper<Text>] = [],
         hazardousRiskIndicator: SendableWrapper<Indicator>? = nil,
         declaredCustomsValueAmount: SendableWrapper<Amount>? = nil,
         declaredForCarriageValueAmount: SendableWrapper<Amount>? = nil,
         declaredStatisticsValueAmount: SendableWrapper<Amount>? = nil,
         freeOnBoardValueAmount: SendableWrapper<Amount>? = nil,
         insuranceValueAmount: SendableWrapper<Amount>? = nil,
         valueAmount: SendableWrapper<Amount>? = nil,
         grossWeightMeasure: SendableWrapper<Measure>? = nil,
         netWeightMeasure: SendableWrapper<Measure>? = nil,
         netNetWeightMeasure: SendableWrapper<Measure>? = nil,
         chargeableWeightMeasure: SendableWrapper<Measure>? = nil,
         grossVolumeMeasure: SendableWrapper<Measure>? = nil,
         netVolumeMeasure: SendableWrapper<Measure>? = nil,
         quantity: SendableWrapper<Quantity>? = nil,
         preferenceCriterionCode: SendableWrapper<Code>? = nil,
         requiredCustomsID: SendableWrapper<Identifier>? = nil,
         customsStatusCode: SendableWrapper<Code>? = nil,
         customsTariffQuantity: SendableWrapper<Quantity>? = nil,
         customsImportClassifiedIndicator: SendableWrapper<Indicator>? = nil,
         chargeableQuantity: SendableWrapper<Quantity>? = nil,
         returnableQuantity: SendableWrapper<Quantity>? = nil,
         traceID: SendableWrapper<Identifier>? = nil,
         item: [SendableWrapper<Item>] = [],
         goodsItemContainer: [SendableWrapper<GoodsItemContainer>] = [],
         freightAllowanceCharge: [SendableWrapper<AllowanceCharge>] = [],
         invoiceLine: [SendableWrapper<InvoiceLine>] = [],
         temperature: [SendableWrapper<Temperature>] = [],
         containedGoodsItem: [SendableWrapper<GoodsItem>] = [],
         originAddress: SendableWrapper<Address>? = nil,
         delivery: SendableWrapper<Delivery>? = nil,
         pickup: SendableWrapper<Pickup>? = nil,
         despatch: SendableWrapper<Despatch>? = nil,
         measurementDimension: [SendableWrapper<Dimension>] = [],
         containingPackage: [SendableWrapper<PackageType>] = [],
         shipmentDocumentReference: SendableWrapper<DocumentReference>? = nil,
         minimumTemperature: SendableWrapper<Temperature>? = nil,
         maximumTemperature: SendableWrapper<Temperature>? = nil) {
        self.id = id
        self.sequenceNumberID = sequenceNumberID
        self.description = description
        self.hazardousRiskIndicator = hazardousRiskIndicator
        self.declaredCustomsValueAmount = declaredCustomsValueAmount
        self.declaredForCarriageValueAmount = declaredForCarriageValueAmount
        self.declaredStatisticsValueAmount = declaredStatisticsValueAmount
        self.freeOnBoardValueAmount = freeOnBoardValueAmount
        self.insuranceValueAmount = insuranceValueAmount
        self.valueAmount = valueAmount
        self.grossWeightMeasure = grossWeightMeasure
        self.netWeightMeasure = netWeightMeasure
        self.netNetWeightMeasure = netNetWeightMeasure
        self.chargeableWeightMeasure = chargeableWeightMeasure
        self.grossVolumeMeasure = grossVolumeMeasure
        self.netVolumeMeasure = netVolumeMeasure
        self.quantity = quantity
        self.preferenceCriterionCode = preferenceCriterionCode
        self.requiredCustomsID = requiredCustomsID
        self.customsStatusCode = customsStatusCode
        self.customsTariffQuantity = customsTariffQuantity
        self.customsImportClassifiedIndicator = customsImportClassifiedIndicator
        self.chargeableQuantity = chargeableQuantity
        self.returnableQuantity = returnableQuantity
        self.traceID = traceID
        self.item = item
        self.goodsItemContainer = goodsItemContainer
        self.freightAllowanceCharge = freightAllowanceCharge
        self.invoiceLine = invoiceLine
        self.temperature = temperature
        self.containedGoodsItem = containedGoodsItem
        self.originAddress = originAddress
        self.delivery = delivery
        self.pickup = pickup
        self.despatch = despatch
        self.measurementDimension = measurementDimension
        self.containingPackage = containingPackage
        self.shipmentDocumentReference = shipmentDocumentReference
        self.minimumTemperature = minimumTemperature
        self.maximumTemperature = maximumTemperature
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case sequenceNumberID = "SequenceNumberID"
        case description = "Description"
        case hazardousRiskIndicator = "HazardousRiskIndicator"
        case declaredCustomsValueAmount = "DeclaredCustomsValueAmount"
        case declaredForCarriageValueAmount = "DeclaredForCarriageValueAmount"
        case declaredStatisticsValueAmount = "DeclaredStatisticsValueAmount"
        case freeOnBoardValueAmount = "FreeOnBoardValueAmount"
        case insuranceValueAmount = "InsuranceValueAmount"
        case valueAmount = "ValueAmount"
        case grossWeightMeasure = "GrossWeightMeasure"
        case netWeightMeasure = "NetWeightMeasure"
        case netNetWeightMeasure = "NetNetWeightMeasure"
        case chargeableWeightMeasure = "ChargeableWeightMeasure"
        case grossVolumeMeasure = "GrossVolumeMeasure"
        case netVolumeMeasure = "NetVolumeMeasure"
        case quantity = "Quantity"
        case preferenceCriterionCode = "PreferenceCriterionCode"
        case requiredCustomsID = "RequiredCustomsID"
        case customsStatusCode = "CustomsStatusCode"
        case customsTariffQuantity = "CustomsTariffQuantity"
        case customsImportClassifiedIndicator = "CustomsImportClassifiedIndicator"
        case chargeableQuantity = "ChargeableQuantity"
        case returnableQuantity = "ReturnableQuantity"
        case traceID = "TraceID"
        case item = "Item"
        case goodsItemContainer = "GoodsItemContainer"
        case freightAllowanceCharge = "FreightAllowanceCharge"
        case invoiceLine = "InvoiceLine"
        case temperature = "Temperature"
        case containedGoodsItem = "ContainedGoodsItem"
        case originAddress = "OriginAddress"
        case delivery = "Delivery"
        case pickup = "Pickup"
        case despatch = "Despatch"
        case measurementDimension = "MeasurementDimension"
        case containingPackage = "ContainingPackage"
        case shipmentDocumentReference = "ShipmentDocumentReference"
        case minimumTemperature = "MinimumTemperature"
        case maximumTemperature = "MaximumTemperature"
    }
}

extension GoodsItem: CreateEmpty {
    public nonisolated static func empty() -> GoodsItem {
        GoodsItem()
    }
}
