// 
// GoodsItemContainer.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct GoodsItemContainer: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>
    public var quantity: SendableWrapper<Quantity>?
    public var transportEquipment: [SendableWrapper<TransportEquipment>] // This array should have at least one element

    public init(id: SendableWrapper<Identifier> = SendableWrapper(Identifier.empty()),
         quantity: SendableWrapper<Quantity>? = nil,
         transportEquipment: [SendableWrapper<TransportEquipment>] = []) {
        self.id = id
        self.quantity = quantity
        self.transportEquipment = transportEquipment
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case quantity = "Quantity"
        case transportEquipment = "TransportEquipment"
    }
}

extension GoodsItemContainer: CreateEmpty {
    public nonisolated static func empty() -> GoodsItemContainer {
        GoodsItemContainer()
    }
}
