// 
// HazardousGoodsTransit.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct HazardousGoodsTransit: Codable, Sendable, Hashable  {
    public var transportEmergencyCardCode: SendableWrapper<Code>?
    public var packingCriteriaCode: SendableWrapper<Code>?
    public var hazardousRegulationCode: SendableWrapper<Code>?
    public var inhalationToxicityZoneCode: SendableWrapper<Code>?
    public var transportAuthorizationCode: SendableWrapper<Code>?
    public var maximumTemperature: SendableWrapper<Temperature>?
    public var minimumTemperature: SendableWrapper<Temperature>?

    public init(transportEmergencyCardCode: SendableWrapper<Code>? = nil,
         packingCriteriaCode: SendableWrapper<Code>? = nil,
         hazardousRegulationCode: SendableWrapper<Code>? = nil,
         inhalationToxicityZoneCode: SendableWrapper<Code>? = nil,
         transportAuthorizationCode: SendableWrapper<Code>? = nil,
         maximumTemperature: SendableWrapper<Temperature>? = nil,
         minimumTemperature: SendableWrapper<Temperature>? = nil) {
        self.transportEmergencyCardCode = transportEmergencyCardCode
        self.packingCriteriaCode = packingCriteriaCode
        self.hazardousRegulationCode = hazardousRegulationCode
        self.inhalationToxicityZoneCode = inhalationToxicityZoneCode
        self.transportAuthorizationCode = transportAuthorizationCode
        self.maximumTemperature = maximumTemperature
        self.minimumTemperature = minimumTemperature
    }
    
    public enum CodingKeys: String, CodingKey {
        case transportEmergencyCardCode = "TransportEmergencyCardCode"
        case packingCriteriaCode = "PackingCriteriaCode"
        case hazardousRegulationCode = "HazardousRegulationCode"
        case inhalationToxicityZoneCode = "InhalationToxicityZoneCode"
        case transportAuthorizationCode = "TransportAuthorizationCode"
        case maximumTemperature = "MaximumTemperature"
        case minimumTemperature = "MinimumTemperature"
    }
}

extension HazardousGoodsTransit: CreateEmpty {
    public nonisolated static func empty() -> HazardousGoodsTransit {
        HazardousGoodsTransit()
    }
}
