// 
// HazardousItem.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct HazardousItem: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>?
    public var placardNotation: SendableWrapper<Text>?
    public var placardEndorsement: SendableWrapper<Text>?
    public var additionalInformation: [SendableWrapper<Text>] // This array should have at least one element
    public var undgCode: SendableWrapper<Code>?
    public var emergencyProceduresCode: SendableWrapper<Code>?
    public var medicalFirstAidGuideCode: SendableWrapper<Code>?
    public var technicalName: SendableWrapper<Text>?
    public var categoryName: SendableWrapper<Text>?
    public var hazardousCategoryCode: SendableWrapper<Code>?
    public var upperOrangeHazardPlacardID: SendableWrapper<Identifier>?
    public var lowerOrangeHazardPlacardID: SendableWrapper<Identifier>?
    public var markingID: SendableWrapper<Identifier>?
    public var hazardClassID: SendableWrapper<Identifier>?
    public var netWeightMeasure: SendableWrapper<Measure>?
    public var netVolumeMeasure: SendableWrapper<Measure>?
    public var quantity: SendableWrapper<Quantity>?
    public var contactParty: SendableWrapper<Party>?
    public var secondaryHazard: [SendableWrapper<SecondaryHazard>] // This array should have at least one element
    public var hazardousGoodsTransit: [SendableWrapper<HazardousGoodsTransit>] // This array should have at least one element
    public var emergencyTemperature: SendableWrapper<Temperature>?
    public var flashpointTemperature: SendableWrapper<Temperature>?
    public var additionalTemperature: [SendableWrapper<Temperature>] // This array should have at least one element

    public init(id: SendableWrapper<Identifier>? = nil,
         placardNotation: SendableWrapper<Text>? = nil,
         placardEndorsement: SendableWrapper<Text>? = nil,
         additionalInformation: [SendableWrapper<Text>] = [],
         undgCode: SendableWrapper<Code>? = nil,
         emergencyProceduresCode: SendableWrapper<Code>? = nil,
         medicalFirstAidGuideCode: SendableWrapper<Code>? = nil,
         technicalName: SendableWrapper<Text>? = nil,
         categoryName: SendableWrapper<Text>? = nil,
         hazardousCategoryCode: SendableWrapper<Code>? = nil,
         upperOrangeHazardPlacardID: SendableWrapper<Identifier>? = nil,
         lowerOrangeHazardPlacardID: SendableWrapper<Identifier>? = nil,
         markingID: SendableWrapper<Identifier>? = nil,
         hazardClassID: SendableWrapper<Identifier>? = nil,
         netWeightMeasure: SendableWrapper<Measure>? = nil,
         netVolumeMeasure: SendableWrapper<Measure>? = nil,
         quantity: SendableWrapper<Quantity>? = nil,
         contactParty: SendableWrapper<Party>? = nil,
         secondaryHazard: [SendableWrapper<SecondaryHazard>] = [],
         hazardousGoodsTransit: [SendableWrapper<HazardousGoodsTransit>] = [],
         emergencyTemperature: SendableWrapper<Temperature>? = nil,
         flashpointTemperature: SendableWrapper<Temperature>? = nil,
         additionalTemperature: [SendableWrapper<Temperature>] = []) {
        self.id = id
        self.placardNotation = placardNotation
        self.placardEndorsement = placardEndorsement
        self.additionalInformation = additionalInformation
        self.undgCode = undgCode
        self.emergencyProceduresCode = emergencyProceduresCode
        self.medicalFirstAidGuideCode = medicalFirstAidGuideCode
        self.technicalName = technicalName
        self.categoryName = categoryName
        self.hazardousCategoryCode = hazardousCategoryCode
        self.upperOrangeHazardPlacardID = upperOrangeHazardPlacardID
        self.lowerOrangeHazardPlacardID = lowerOrangeHazardPlacardID
        self.markingID = markingID
        self.hazardClassID = hazardClassID
        self.netWeightMeasure = netWeightMeasure
        self.netVolumeMeasure = netVolumeMeasure
        self.quantity = quantity
        self.contactParty = contactParty
        self.secondaryHazard = secondaryHazard
        self.hazardousGoodsTransit = hazardousGoodsTransit
        self.emergencyTemperature = emergencyTemperature
        self.flashpointTemperature = flashpointTemperature
        self.additionalTemperature = additionalTemperature
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case placardNotation = "PlacardNotation"
        case placardEndorsement = "PlacardEndorsement"
        case additionalInformation = "AdditionalInformation"
        case undgCode = "UNDGCode"
        case emergencyProceduresCode = "EmergencyProceduresCode"
        case medicalFirstAidGuideCode = "MedicalFirstAidGuideCode"
        case technicalName = "TechnicalName"
        case categoryName = "CategoryName"
        case hazardousCategoryCode = "HazardousCategoryCode"
        case upperOrangeHazardPlacardID = "UpperOrangeHazardPlacardID"
        case lowerOrangeHazardPlacardID = "LowerOrangeHazardPlacardID"
        case markingID = "MarkingID"
        case hazardClassID = "HazardClassID"
        case netWeightMeasure = "NetWeightMeasure"
        case netVolumeMeasure = "NetVolumeMeasure"
        case quantity = "Quantity"
        case contactParty = "ContactParty"
        case secondaryHazard = "SecondaryHazard"
        case hazardousGoodsTransit = "HazardousGoodsTransit"
        case emergencyTemperature = "EmergencyTemperature"
        case flashpointTemperature = "FlashpointTemperature"
        case additionalTemperature = "AdditionalTemperature"
    }
}

extension HazardousItem: CreateEmpty {
    public nonisolated static func empty() -> HazardousItem {
        HazardousItem()
    }
}
