// 
// Identifier.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct Identifier: Codable, Sendable, Hashable , DynamicNodeEncoding, DynamicNodeDecoding {
    public var value: String
    public var schemeID: String?
    public var schemeName: String?
    public var schemeAgencyID: String?
    public var schemeAgencyName: String?
    public var schemeVersionID: String?
    public var schemeDataURI: String?
    public var schemeURI: String?

    public init(value: String = "",
         schemeID: String? = nil,
         schemeName: String? = nil,
         schemeAgencyID: String? = nil,
         schemeAgencyName: String? = nil,
         schemeVersionID: String? = nil,
         schemeDataURI: String? = nil,
         schemeURI: String? = nil) {
        self.value = value
        self.schemeID = schemeID
        self.schemeName = schemeName
        self.schemeAgencyID = schemeAgencyID
        self.schemeAgencyName = schemeAgencyName
        self.schemeVersionID = schemeVersionID
        self.schemeDataURI = schemeDataURI
        self.schemeURI = schemeURI
    }
    
    public enum CodingKeys: String, CodingKey {
        case value = ""
        case schemeID = "schemeID"
        case schemeName = "schemeName"
        case schemeAgencyID = "schemeAgencyID"
        case schemeAgencyName = "schemeAgencyName"
        case schemeVersionID = "schemeVersionID"
        case schemeDataURI = "schemeDataURI"
        case schemeURI = "schemeURI"
    }

    nonisolated public static func nodeEncoding(for key: CodingKey) -> XMLEncoder.NodeEncoding {
        switch key {
        case CodingKeys.value:
           return .element
        default:
            return .attribute
        }
    }
    
    nonisolated public static func nodeDecoding(for key: CodingKey) -> XMLDecoder.NodeDecoding {
        switch key {
        case CodingKeys.value:
            return .element
        default:
            return .attribute
        }
    }}

extension Identifier: CreateEmpty {
    public nonisolated static func empty() -> Identifier {
        Identifier()
    }
}
