// 
// Indicator.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct Indicator: Codable, Sendable, Hashable , DynamicNodeEncoding, DynamicNodeDecoding {
    public var value: String
    public var format: String?

    public init(value: String = "",
         format: String? = nil) {
        self.value = value
        self.format = format
    }
    
    public enum CodingKeys: String, CodingKey {
        case value = ""
        case format = "format"
    }

    nonisolated public static func nodeEncoding(for key: CodingKey) -> XMLEncoder.NodeEncoding {
        switch key {
        case CodingKeys.value:
           return .element
        default:
            return .attribute
        }
    }
    
    nonisolated public static func nodeDecoding(for key: CodingKey) -> XMLDecoder.NodeDecoding {
        switch key {
        case CodingKeys.value:
            return .element
        default:
            return .attribute
        }
    }}

extension Indicator: CreateEmpty {
    public nonisolated static func empty() -> Indicator {
        Indicator()
    }
}
