// 
// Item.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct Item: Codable, Sendable, Hashable  {
    public var description: [SendableWrapper<Text>] // This array should have at least one element
    public var packQuantity: SendableWrapper<Quantity>?
    public var packSizeNumeric: SendableWrapper<Numeric>?
    public var catalogueIndicator: SendableWrapper<Indicator>?
    public var name: SendableWrapper<Text>?
    public var hazardousRiskIndicator: SendableWrapper<Indicator>?
    public var additionalInformation: [SendableWrapper<Text>] // This array should have at least one element
    public var keyword: [SendableWrapper<Text>] // This array should have at least one element
    public var brandName: [SendableWrapper<Text>] // This array should have at least one element
    public var modelName: [SendableWrapper<Text>] // This array should have at least one element
    public var buyersItemIdentification: SendableWrapper<ItemIdentification>?
    public var sellersItemIdentification: SendableWrapper<ItemIdentification>?
    public var manufacturersItemIdentification: [SendableWrapper<ItemIdentification>] // This array should have at least one element
    public var standardItemIdentification: SendableWrapper<ItemIdentification>?
    public var catalogueItemIdentification: SendableWrapper<ItemIdentification>?
    public var additionalItemIdentification: [SendableWrapper<ItemIdentification>] // This array should have at least one element
    public var catalogueDocumentReference: SendableWrapper<DocumentReference>?
    public var itemSpecificationDocumentReference: [SendableWrapper<DocumentReference>] // This array should have at least one element
    public var originCountry: SendableWrapper<Country>?
    public var commodityClassification: [SendableWrapper<CommodityClassification>] // This array should have at least one element
    public var transactionConditions: [SendableWrapper<TransactionConditions>] // This array should have at least one element
    public var hazardousItem: [SendableWrapper<HazardousItem>] // This array should have at least one element
    public var classifiedTaxCategory: [SendableWrapper<TaxCategory>] // This array should have at least one element
    public var additionalItemProperty: [SendableWrapper<ItemProperty>] // This array should have at least one element
    public var manufacturerParty: [SendableWrapper<Party>] // This array should have at least one element
    public var informationContentProviderParty: SendableWrapper<Party>?
    public var originAddress: [SendableWrapper<Address>] // This array should have at least one element
    public var itemInstance: [SendableWrapper<ItemInstance>] // This array should have at least one element
    public var certificate: [SendableWrapper<Certificate>] // This array should have at least one element
    public var dimension: [SendableWrapper<Dimension>] // This array should have at least one element

    public init(description: [SendableWrapper<Text>] = [],
         packQuantity: SendableWrapper<Quantity>? = nil,
         packSizeNumeric: SendableWrapper<Numeric>? = nil,
         catalogueIndicator: SendableWrapper<Indicator>? = nil,
         name: SendableWrapper<Text>? = nil,
         hazardousRiskIndicator: SendableWrapper<Indicator>? = nil,
         additionalInformation: [SendableWrapper<Text>] = [],
         keyword: [SendableWrapper<Text>] = [],
         brandName: [SendableWrapper<Text>] = [],
         modelName: [SendableWrapper<Text>] = [],
         buyersItemIdentification: SendableWrapper<ItemIdentification>? = nil,
         sellersItemIdentification: SendableWrapper<ItemIdentification>? = nil,
         manufacturersItemIdentification: [SendableWrapper<ItemIdentification>] = [],
         standardItemIdentification: SendableWrapper<ItemIdentification>? = nil,
         catalogueItemIdentification: SendableWrapper<ItemIdentification>? = nil,
         additionalItemIdentification: [SendableWrapper<ItemIdentification>] = [],
         catalogueDocumentReference: SendableWrapper<DocumentReference>? = nil,
         itemSpecificationDocumentReference: [SendableWrapper<DocumentReference>] = [],
         originCountry: SendableWrapper<Country>? = nil,
         commodityClassification: [SendableWrapper<CommodityClassification>] = [],
         transactionConditions: [SendableWrapper<TransactionConditions>] = [],
         hazardousItem: [SendableWrapper<HazardousItem>] = [],
         classifiedTaxCategory: [SendableWrapper<TaxCategory>] = [],
         additionalItemProperty: [SendableWrapper<ItemProperty>] = [],
         manufacturerParty: [SendableWrapper<Party>] = [],
         informationContentProviderParty: SendableWrapper<Party>? = nil,
         originAddress: [SendableWrapper<Address>] = [],
         itemInstance: [SendableWrapper<ItemInstance>] = [],
         certificate: [SendableWrapper<Certificate>] = [],
         dimension: [SendableWrapper<Dimension>] = []) {
        self.description = description
        self.packQuantity = packQuantity
        self.packSizeNumeric = packSizeNumeric
        self.catalogueIndicator = catalogueIndicator
        self.name = name
        self.hazardousRiskIndicator = hazardousRiskIndicator
        self.additionalInformation = additionalInformation
        self.keyword = keyword
        self.brandName = brandName
        self.modelName = modelName
        self.buyersItemIdentification = buyersItemIdentification
        self.sellersItemIdentification = sellersItemIdentification
        self.manufacturersItemIdentification = manufacturersItemIdentification
        self.standardItemIdentification = standardItemIdentification
        self.catalogueItemIdentification = catalogueItemIdentification
        self.additionalItemIdentification = additionalItemIdentification
        self.catalogueDocumentReference = catalogueDocumentReference
        self.itemSpecificationDocumentReference = itemSpecificationDocumentReference
        self.originCountry = originCountry
        self.commodityClassification = commodityClassification
        self.transactionConditions = transactionConditions
        self.hazardousItem = hazardousItem
        self.classifiedTaxCategory = classifiedTaxCategory
        self.additionalItemProperty = additionalItemProperty
        self.manufacturerParty = manufacturerParty
        self.informationContentProviderParty = informationContentProviderParty
        self.originAddress = originAddress
        self.itemInstance = itemInstance
        self.certificate = certificate
        self.dimension = dimension
    }
    
    public enum CodingKeys: String, CodingKey {
        case description = "Description"
        case packQuantity = "PackQuantity"
        case packSizeNumeric = "PackSizeNumeric"
        case catalogueIndicator = "CatalogueIndicator"
        case name = "Name"
        case hazardousRiskIndicator = "HazardousRiskIndicator"
        case additionalInformation = "AdditionalInformation"
        case keyword = "Keyword"
        case brandName = "BrandName"
        case modelName = "ModelName"
        case buyersItemIdentification = "BuyersItemIdentification"
        case sellersItemIdentification = "SellersItemIdentification"
        case manufacturersItemIdentification = "ManufacturersItemIdentification"
        case standardItemIdentification = "StandardItemIdentification"
        case catalogueItemIdentification = "CatalogueItemIdentification"
        case additionalItemIdentification = "AdditionalItemIdentification"
        case catalogueDocumentReference = "CatalogueDocumentReference"
        case itemSpecificationDocumentReference = "ItemSpecificationDocumentReference"
        case originCountry = "OriginCountry"
        case commodityClassification = "CommodityClassification"
        case transactionConditions = "TransactionConditions"
        case hazardousItem = "HazardousItem"
        case classifiedTaxCategory = "ClassifiedTaxCategory"
        case additionalItemProperty = "AdditionalItemProperty"
        case manufacturerParty = "ManufacturerParty"
        case informationContentProviderParty = "InformationContentProviderParty"
        case originAddress = "OriginAddress"
        case itemInstance = "ItemInstance"
        case certificate = "Certificate"
        case dimension = "Dimension"
    }
}

extension Item: CreateEmpty {
    public nonisolated static func empty() -> Item {
        Item()
    }
}
