// 
// ItemIdentification.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct ItemIdentification: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>
    public var extendedID: SendableWrapper<Identifier>?
    public var barcodeSymbologyID: SendableWrapper<Identifier>?
    public var physicalAttribute: [SendableWrapper<PhysicalAttribute>] // This array should have at least one element
    public var measurementDimension: [SendableWrapper<Dimension>] // This array should have at least one element
    public var issuerParty: SendableWrapper<Party>?

    public init(id: SendableWrapper<Identifier> = SendableWrapper(Identifier.empty()),
         extendedID: SendableWrapper<Identifier>? = nil,
         barcodeSymbologyID: SendableWrapper<Identifier>? = nil,
         physicalAttribute: [SendableWrapper<PhysicalAttribute>] = [],
         measurementDimension: [SendableWrapper<Dimension>] = [],
         issuerParty: SendableWrapper<Party>? = nil) {
        self.id = id
        self.extendedID = extendedID
        self.barcodeSymbologyID = barcodeSymbologyID
        self.physicalAttribute = physicalAttribute
        self.measurementDimension = measurementDimension
        self.issuerParty = issuerParty
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case extendedID = "ExtendedID"
        case barcodeSymbologyID = "BarcodeSymbologyID"
        case physicalAttribute = "PhysicalAttribute"
        case measurementDimension = "MeasurementDimension"
        case issuerParty = "IssuerParty"
    }
}

extension ItemIdentification: CreateEmpty {
    public nonisolated static func empty() -> ItemIdentification {
        ItemIdentification()
    }
}
