// 
// ItemInstance.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct ItemInstance: Codable, Sendable, Hashable  {
    public var productTraceID: SendableWrapper<Identifier>?
    public var manufactureDate: XMLDate?
    public var manufactureTime: XMLDate?
    public var bestBeforeDate: XMLDate?
    public var registrationID: SendableWrapper<Identifier>?
    public var serialID: SendableWrapper<Identifier>?
    public var additionalItemProperty: [SendableWrapper<ItemProperty>] // This array should have at least one element
    public var lotIdentification: SendableWrapper<LotIdentification>?

    public init(productTraceID: SendableWrapper<Identifier>? = nil,
         manufactureDate: XMLDate? = nil,
         manufactureTime: XMLDate? = nil,
         bestBeforeDate: XMLDate? = nil,
         registrationID: SendableWrapper<Identifier>? = nil,
         serialID: SendableWrapper<Identifier>? = nil,
         additionalItemProperty: [SendableWrapper<ItemProperty>] = [],
         lotIdentification: SendableWrapper<LotIdentification>? = nil) {
        self.productTraceID = productTraceID
        self.manufactureDate = manufactureDate
        self.manufactureTime = manufactureTime
        self.bestBeforeDate = bestBeforeDate
        self.registrationID = registrationID
        self.serialID = serialID
        self.additionalItemProperty = additionalItemProperty
        self.lotIdentification = lotIdentification
    }
    
    public enum CodingKeys: String, CodingKey {
        case productTraceID = "ProductTraceID"
        case manufactureDate = "ManufactureDate"
        case manufactureTime = "ManufactureTime"
        case bestBeforeDate = "BestBeforeDate"
        case registrationID = "RegistrationID"
        case serialID = "SerialID"
        case additionalItemProperty = "AdditionalItemProperty"
        case lotIdentification = "LotIdentification"
    }
}

extension ItemInstance: CreateEmpty {
    public nonisolated static func empty() -> ItemInstance {
        ItemInstance()
    }
}
