// 
// ItemLocationQuantity.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct ItemLocationQuantity: Codable, Sendable, Hashable  {
    public var leadTimeMeasure: SendableWrapper<Measure>?
    public var minimumQuantity: SendableWrapper<Quantity>?
    public var maximumQuantity: SendableWrapper<Quantity>?
    public var hazardousRiskIndicator: SendableWrapper<Indicator>?
    public var tradingRestrictions: [SendableWrapper<Text>] // This array should have at least one element
    public var applicableTerritoryAddress: [SendableWrapper<Address>] // This array should have at least one element
    public var price: SendableWrapper<Price>?
    public var deliveryUnit: [SendableWrapper<DeliveryUnit>] // This array should have at least one element
    public var applicableTaxCategory: [SendableWrapper<TaxCategory>] // This array should have at least one element
    public var package: SendableWrapper<PackageType>?
    public var allowanceCharge: [SendableWrapper<AllowanceCharge>] // This array should have at least one element
    public var dependentPriceReference: SendableWrapper<DependentPriceReference>?

    public init(leadTimeMeasure: SendableWrapper<Measure>? = nil,
         minimumQuantity: SendableWrapper<Quantity>? = nil,
         maximumQuantity: SendableWrapper<Quantity>? = nil,
         hazardousRiskIndicator: SendableWrapper<Indicator>? = nil,
         tradingRestrictions: [SendableWrapper<Text>] = [],
         applicableTerritoryAddress: [SendableWrapper<Address>] = [],
         price: SendableWrapper<Price>? = nil,
         deliveryUnit: [SendableWrapper<DeliveryUnit>] = [],
         applicableTaxCategory: [SendableWrapper<TaxCategory>] = [],
         package: SendableWrapper<PackageType>? = nil,
         allowanceCharge: [SendableWrapper<AllowanceCharge>] = [],
         dependentPriceReference: SendableWrapper<DependentPriceReference>? = nil) {
        self.leadTimeMeasure = leadTimeMeasure
        self.minimumQuantity = minimumQuantity
        self.maximumQuantity = maximumQuantity
        self.hazardousRiskIndicator = hazardousRiskIndicator
        self.tradingRestrictions = tradingRestrictions
        self.applicableTerritoryAddress = applicableTerritoryAddress
        self.price = price
        self.deliveryUnit = deliveryUnit
        self.applicableTaxCategory = applicableTaxCategory
        self.package = package
        self.allowanceCharge = allowanceCharge
        self.dependentPriceReference = dependentPriceReference
    }
    
    public enum CodingKeys: String, CodingKey {
        case leadTimeMeasure = "LeadTimeMeasure"
        case minimumQuantity = "MinimumQuantity"
        case maximumQuantity = "MaximumQuantity"
        case hazardousRiskIndicator = "HazardousRiskIndicator"
        case tradingRestrictions = "TradingRestrictions"
        case applicableTerritoryAddress = "ApplicableTerritoryAddress"
        case price = "Price"
        case deliveryUnit = "DeliveryUnit"
        case applicableTaxCategory = "ApplicableTaxCategory"
        case package = "Package"
        case allowanceCharge = "AllowanceCharge"
        case dependentPriceReference = "DependentPriceReference"
    }
}

extension ItemLocationQuantity: CreateEmpty {
    public nonisolated static func empty() -> ItemLocationQuantity {
        ItemLocationQuantity()
    }
}
