// 
// ItemProperty.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct ItemProperty: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>?
    public var name: SendableWrapper<Text>
    public var nameCode: SendableWrapper<Code>?
    public var testMethod: SendableWrapper<Text>?
    public var value: SendableWrapper<Text>?
    public var valueQuantity: SendableWrapper<Quantity>?
    public var valueQualifier: [SendableWrapper<Text>] // This array should have at least one element
    public var importanceCode: SendableWrapper<Code>?
    public var listValue: [SendableWrapper<Text>] // This array should have at least one element
    public var usabilityPeriod: SendableWrapper<Period>?
    public var itemPropertyGroup: [SendableWrapper<ItemPropertyGroup>] // This array should have at least one element
    public var rangeDimension: SendableWrapper<Dimension>?
    public var itemPropertyRange: SendableWrapper<ItemPropertyRange>?

    public init(id: SendableWrapper<Identifier>? = nil,
         name: SendableWrapper<Text> = SendableWrapper(Text.empty()),
         nameCode: SendableWrapper<Code>? = nil,
         testMethod: SendableWrapper<Text>? = nil,
         value: SendableWrapper<Text>? = nil,
         valueQuantity: SendableWrapper<Quantity>? = nil,
         valueQualifier: [SendableWrapper<Text>] = [],
         importanceCode: SendableWrapper<Code>? = nil,
         listValue: [SendableWrapper<Text>] = [],
         usabilityPeriod: SendableWrapper<Period>? = nil,
         itemPropertyGroup: [SendableWrapper<ItemPropertyGroup>] = [],
         rangeDimension: SendableWrapper<Dimension>? = nil,
         itemPropertyRange: SendableWrapper<ItemPropertyRange>? = nil) {
        self.id = id
        self.name = name
        self.nameCode = nameCode
        self.testMethod = testMethod
        self.value = value
        self.valueQuantity = valueQuantity
        self.valueQualifier = valueQualifier
        self.importanceCode = importanceCode
        self.listValue = listValue
        self.usabilityPeriod = usabilityPeriod
        self.itemPropertyGroup = itemPropertyGroup
        self.rangeDimension = rangeDimension
        self.itemPropertyRange = itemPropertyRange
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case name = "Name"
        case nameCode = "NameCode"
        case testMethod = "TestMethod"
        case value = ""
        case valueQuantity = "ValueQuantity"
        case valueQualifier = "ValueQualifier"
        case importanceCode = "ImportanceCode"
        case listValue = "ListValue"
        case usabilityPeriod = "UsabilityPeriod"
        case itemPropertyGroup = "ItemPropertyGroup"
        case rangeDimension = "RangeDimension"
        case itemPropertyRange = "ItemPropertyRange"
    }
}

extension ItemProperty: CreateEmpty {
    public nonisolated static func empty() -> ItemProperty {
        ItemProperty()
    }
}
