// 
// ItemPropertyGroup.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct ItemPropertyGroup: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>
    public var name: SendableWrapper<Text>?
    public var importanceCode: SendableWrapper<Code>?

    public init(id: SendableWrapper<Identifier> = SendableWrapper(Identifier.empty()),
         name: SendableWrapper<Text>? = nil,
         importanceCode: SendableWrapper<Code>? = nil) {
        self.id = id
        self.name = name
        self.importanceCode = importanceCode
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case name = "Name"
        case importanceCode = "ImportanceCode"
    }
}

extension ItemPropertyGroup: CreateEmpty {
    public nonisolated static func empty() -> ItemPropertyGroup {
        ItemPropertyGroup()
    }
}
