// 
// ItemPropertyRange.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct ItemPropertyRange: Codable, Sendable, Hashable  {
    public var minimumValue: SendableWrapper<Text>?
    public var maximumValue: SendableWrapper<Text>?

    public init(minimumValue: SendableWrapper<Text>? = nil,
         maximumValue: SendableWrapper<Text>? = nil) {
        self.minimumValue = minimumValue
        self.maximumValue = maximumValue
    }
    
    public enum CodingKeys: String, CodingKey {
        case minimumValue = "MinimumValue"
        case maximumValue = "MaximumValue"
    }
}

extension ItemPropertyRange: CreateEmpty {
    public nonisolated static func empty() -> ItemPropertyRange {
        ItemPropertyRange()
    }
}
