// 
// LineReference.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct LineReference: Codable, Sendable, Hashable  {
    public var lineID: SendableWrapper<Identifier>
    public var uuid: SendableWrapper<Identifier>?
    public var lineStatusCode: SendableWrapper<Code>?
    public var documentReference: SendableWrapper<DocumentReference>?

    public init(lineID: SendableWrapper<Identifier> = SendableWrapper(Identifier.empty()),
         uuid: SendableWrapper<Identifier>? = nil,
         lineStatusCode: SendableWrapper<Code>? = nil,
         documentReference: SendableWrapper<DocumentReference>? = nil) {
        self.lineID = lineID
        self.uuid = uuid
        self.lineStatusCode = lineStatusCode
        self.documentReference = documentReference
    }
    
    public enum CodingKeys: String, CodingKey {
        case lineID = "LineID"
        case uuid = "UUID"
        case lineStatusCode = "LineStatusCode"
        case documentReference = "DocumentReference"
    }
}

extension LineReference: CreateEmpty {
    public nonisolated static func empty() -> LineReference {
        LineReference()
    }
}
