// 
// Location.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct Location: Codable, Sendable, Hashable , DynamicNodeEncoding, DynamicNodeDecoding {
    public var id: SendableWrapper<Identifier>?
    public var description: [SendableWrapper<Text>] // This array should have at least one element
    public var conditions: [SendableWrapper<Text>] // This array should have at least one element
    public var countrySubentity: SendableWrapper<Text>?
    public var countrySubentityCode: SendableWrapper<Code>?
    public var locationTypeCode: SendableWrapper<Code>?
    public var informationURI: SendableWrapper<Identifier>?
    public var name: SendableWrapper<Text>?
    public var validityPeriod: [SendableWrapper<Period>] // This array should have at least one element
    public var address: SendableWrapper<Address>?
    public var subsidiaryLocation: [SendableWrapper<Location>] // This array should have at least one element
    public var locationCoordinate: [SendableWrapper<LocationCoordinate>] // This array should have at least one element
    public var value: String
    public var languageID: String?
    public var languageLocaleID: String?

    public init(id: SendableWrapper<Identifier>? = nil,
         description: [SendableWrapper<Text>] = [],
         conditions: [SendableWrapper<Text>] = [],
         countrySubentity: SendableWrapper<Text>? = nil,
         countrySubentityCode: SendableWrapper<Code>? = nil,
         locationTypeCode: SendableWrapper<Code>? = nil,
         informationURI: SendableWrapper<Identifier>? = nil,
         name: SendableWrapper<Text>? = nil,
         validityPeriod: [SendableWrapper<Period>] = [],
         address: SendableWrapper<Address>? = nil,
         subsidiaryLocation: [SendableWrapper<Location>] = [],
         locationCoordinate: [SendableWrapper<LocationCoordinate>] = [],
         value: String = "",
         languageID: String? = nil,
         languageLocaleID: String? = nil) {
        self.id = id
        self.description = description
        self.conditions = conditions
        self.countrySubentity = countrySubentity
        self.countrySubentityCode = countrySubentityCode
        self.locationTypeCode = locationTypeCode
        self.informationURI = informationURI
        self.name = name
        self.validityPeriod = validityPeriod
        self.address = address
        self.subsidiaryLocation = subsidiaryLocation
        self.locationCoordinate = locationCoordinate
        self.value = value
        self.languageID = languageID
        self.languageLocaleID = languageLocaleID
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case description = "Description"
        case conditions = "Conditions"
        case countrySubentity = "CountrySubentity"
        case countrySubentityCode = "CountrySubentityCode"
        case locationTypeCode = "LocationTypeCode"
        case informationURI = "InformationURI"
        case name = "Name"
        case validityPeriod = "ValidityPeriod"
        case address = "Address"
        case subsidiaryLocation = "SubsidiaryLocation"
        case locationCoordinate = "LocationCoordinate"
        case value = ""
        case languageID = "languageID"
        case languageLocaleID = "languageLocaleID"
    }

    nonisolated public static func nodeEncoding(for key: CodingKey) -> XMLEncoder.NodeEncoding {
        switch key {
        case CodingKeys.id, CodingKeys.description, CodingKeys.conditions, CodingKeys.countrySubentity, CodingKeys.countrySubentityCode, CodingKeys.locationTypeCode, CodingKeys.informationURI, CodingKeys.name, CodingKeys.validityPeriod, CodingKeys.address, CodingKeys.subsidiaryLocation, CodingKeys.locationCoordinate, CodingKeys.value:
           return .element
        default:
            return .attribute
        }
    }
    
    nonisolated public static func nodeDecoding(for key: CodingKey) -> XMLDecoder.NodeDecoding {
        switch key {
        case CodingKeys.id, CodingKeys.description, CodingKeys.conditions, CodingKeys.countrySubentity, CodingKeys.countrySubentityCode, CodingKeys.locationTypeCode, CodingKeys.informationURI, CodingKeys.name, CodingKeys.validityPeriod, CodingKeys.address, CodingKeys.subsidiaryLocation, CodingKeys.locationCoordinate, CodingKeys.value:
            return .element
        default:
            return .attribute
        }
    }}

extension Location: CreateEmpty {
    public nonisolated static func empty() -> Location {
        Location()
    }
}
