// 
// LocationCoordinate.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct LocationCoordinate: Codable, Sendable, Hashable  {
    public var coordinateSystemCode: SendableWrapper<Code>?
    public var latitudeDegreesMeasure: SendableWrapper<Measure>?
    public var latitudeMinutesMeasure: SendableWrapper<Measure>?
    public var latitudeDirectionCode: SendableWrapper<Code>?
    public var longitudeDegreesMeasure: SendableWrapper<Measure>?
    public var longitudeMinutesMeasure: SendableWrapper<Measure>?
    public var longitudeDirectionCode: SendableWrapper<Code>?
    public var altitudeMeasure: SendableWrapper<Measure>?

    public init(coordinateSystemCode: SendableWrapper<Code>? = nil,
         latitudeDegreesMeasure: SendableWrapper<Measure>? = nil,
         latitudeMinutesMeasure: SendableWrapper<Measure>? = nil,
         latitudeDirectionCode: SendableWrapper<Code>? = nil,
         longitudeDegreesMeasure: SendableWrapper<Measure>? = nil,
         longitudeMinutesMeasure: SendableWrapper<Measure>? = nil,
         longitudeDirectionCode: SendableWrapper<Code>? = nil,
         altitudeMeasure: SendableWrapper<Measure>? = nil) {
        self.coordinateSystemCode = coordinateSystemCode
        self.latitudeDegreesMeasure = latitudeDegreesMeasure
        self.latitudeMinutesMeasure = latitudeMinutesMeasure
        self.latitudeDirectionCode = latitudeDirectionCode
        self.longitudeDegreesMeasure = longitudeDegreesMeasure
        self.longitudeMinutesMeasure = longitudeMinutesMeasure
        self.longitudeDirectionCode = longitudeDirectionCode
        self.altitudeMeasure = altitudeMeasure
    }
    
    public enum CodingKeys: String, CodingKey {
        case coordinateSystemCode = "CoordinateSystemCode"
        case latitudeDegreesMeasure = "LatitudeDegreesMeasure"
        case latitudeMinutesMeasure = "LatitudeMinutesMeasure"
        case latitudeDirectionCode = "LatitudeDirectionCode"
        case longitudeDegreesMeasure = "LongitudeDegreesMeasure"
        case longitudeMinutesMeasure = "LongitudeMinutesMeasure"
        case longitudeDirectionCode = "LongitudeDirectionCode"
        case altitudeMeasure = "AltitudeMeasure"
    }
}

extension LocationCoordinate: CreateEmpty {
    public nonisolated static func empty() -> LocationCoordinate {
        LocationCoordinate()
    }
}
