// 
// LotIdentification.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct LotIdentification: Codable, Sendable, Hashable  {
    public var lotNumberID: SendableWrapper<Identifier>?
    public var expiryDate: XMLDate?
    public var additionalItemProperty: [SendableWrapper<ItemProperty>] // This array should have at least one element

    public init(lotNumberID: SendableWrapper<Identifier>? = nil,
         expiryDate: XMLDate? = nil,
         additionalItemProperty: [SendableWrapper<ItemProperty>] = []) {
        self.lotNumberID = lotNumberID
        self.expiryDate = expiryDate
        self.additionalItemProperty = additionalItemProperty
    }
    
    public enum CodingKeys: String, CodingKey {
        case lotNumberID = "LotNumberID"
        case expiryDate = "ExpiryDate"
        case additionalItemProperty = "AdditionalItemProperty"
    }
}

extension LotIdentification: CreateEmpty {
    public nonisolated static func empty() -> LotIdentification {
        LotIdentification()
    }
}
