// 
// MaritimeTransport.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct MaritimeTransport: Codable, Sendable, Hashable  {
    public var vesselID: SendableWrapper<Identifier>?
    public var vesselName: SendableWrapper<Text>?
    public var radioCallSignID: SendableWrapper<Identifier>?
    public var shipsRequirements: [SendableWrapper<Text>] // This array should have at least one element
    public var grossTonnageMeasure: SendableWrapper<Measure>?
    public var netTonnageMeasure: SendableWrapper<Measure>?
    public var registryCertificateDocumentReference: SendableWrapper<DocumentReference>?
    public var registryPortLocation: SendableWrapper<Location>?

    public init(vesselID: SendableWrapper<Identifier>? = nil,
         vesselName: SendableWrapper<Text>? = nil,
         radioCallSignID: SendableWrapper<Identifier>? = nil,
         shipsRequirements: [SendableWrapper<Text>] = [],
         grossTonnageMeasure: SendableWrapper<Measure>? = nil,
         netTonnageMeasure: SendableWrapper<Measure>? = nil,
         registryCertificateDocumentReference: SendableWrapper<DocumentReference>? = nil,
         registryPortLocation: SendableWrapper<Location>? = nil) {
        self.vesselID = vesselID
        self.vesselName = vesselName
        self.radioCallSignID = radioCallSignID
        self.shipsRequirements = shipsRequirements
        self.grossTonnageMeasure = grossTonnageMeasure
        self.netTonnageMeasure = netTonnageMeasure
        self.registryCertificateDocumentReference = registryCertificateDocumentReference
        self.registryPortLocation = registryPortLocation
    }
    
    public enum CodingKeys: String, CodingKey {
        case vesselID = "VesselID"
        case vesselName = "VesselName"
        case radioCallSignID = "RadioCallSignID"
        case shipsRequirements = "ShipsRequirements"
        case grossTonnageMeasure = "GrossTonnageMeasure"
        case netTonnageMeasure = "NetTonnageMeasure"
        case registryCertificateDocumentReference = "RegistryCertificateDocumentReference"
        case registryPortLocation = "RegistryPortLocation"
    }
}

extension MaritimeTransport: CreateEmpty {
    public nonisolated static func empty() -> MaritimeTransport {
        MaritimeTransport()
    }
}
