// 
// Measure.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct Measure: Codable, Sendable, Hashable , DynamicNodeEncoding, DynamicNodeDecoding {
    public var value: Decimal
    public var unitCode: String?
    public var unitCodeListVersionID: String?

    public init(value: Decimal = 0,
         unitCode: String? = nil,
         unitCodeListVersionID: String? = nil) {
        self.value = value
        self.unitCode = unitCode
        self.unitCodeListVersionID = unitCodeListVersionID
    }
    
    public enum CodingKeys: String, CodingKey {
        case value = ""
        case unitCode = "unitCode"
        case unitCodeListVersionID = "unitCodeListVersionID"
    }

    nonisolated public static func nodeEncoding(for key: CodingKey) -> XMLEncoder.NodeEncoding {
        switch key {
        case CodingKeys.value:
           return .element
        default:
            return .attribute
        }
    }
    
    nonisolated public static func nodeDecoding(for key: CodingKey) -> XMLDecoder.NodeDecoding {
        switch key {
        case CodingKeys.value:
            return .element
        default:
            return .attribute
        }
    }}

extension Measure: CreateEmpty {
    public nonisolated static func empty() -> Measure {
        Measure()
    }
}
