// 
// MonetaryTotal.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct MonetaryTotal: Codable, Sendable, Hashable  {
    public var lineExtensionAmount: SendableWrapper<Amount>?
    public var taxExclusiveAmount: SendableWrapper<Amount>?
    public var taxInclusiveAmount: SendableWrapper<Amount>?
    public var allowanceTotalAmount: SendableWrapper<Amount>?
    public var chargeTotalAmount: SendableWrapper<Amount>?
    public var prepaidAmount: SendableWrapper<Amount>?
    public var payableRoundingAmount: SendableWrapper<Amount>?
    public var payableAmount: SendableWrapper<Amount>
    public var payableAlternativeAmount: SendableWrapper<Amount>?

    public init(lineExtensionAmount: SendableWrapper<Amount>? = nil,
         taxExclusiveAmount: SendableWrapper<Amount>? = nil,
         taxInclusiveAmount: SendableWrapper<Amount>? = nil,
         allowanceTotalAmount: SendableWrapper<Amount>? = nil,
         chargeTotalAmount: SendableWrapper<Amount>? = nil,
         prepaidAmount: SendableWrapper<Amount>? = nil,
         payableRoundingAmount: SendableWrapper<Amount>? = nil,
         payableAmount: SendableWrapper<Amount> = SendableWrapper(Amount.empty()),
         payableAlternativeAmount: SendableWrapper<Amount>? = nil) {
        self.lineExtensionAmount = lineExtensionAmount
        self.taxExclusiveAmount = taxExclusiveAmount
        self.taxInclusiveAmount = taxInclusiveAmount
        self.allowanceTotalAmount = allowanceTotalAmount
        self.chargeTotalAmount = chargeTotalAmount
        self.prepaidAmount = prepaidAmount
        self.payableRoundingAmount = payableRoundingAmount
        self.payableAmount = payableAmount
        self.payableAlternativeAmount = payableAlternativeAmount
    }
    
    public enum CodingKeys: String, CodingKey {
        case lineExtensionAmount = "LineExtensionAmount"
        case taxExclusiveAmount = "TaxExclusiveAmount"
        case taxInclusiveAmount = "TaxInclusiveAmount"
        case allowanceTotalAmount = "AllowanceTotalAmount"
        case chargeTotalAmount = "ChargeTotalAmount"
        case prepaidAmount = "PrepaidAmount"
        case payableRoundingAmount = "PayableRoundingAmount"
        case payableAmount = "PayableAmount"
        case payableAlternativeAmount = "PayableAlternativeAmount"
    }
}

extension MonetaryTotal: CreateEmpty {
    public nonisolated static func empty() -> MonetaryTotal {
        MonetaryTotal()
    }
}
