// 
// OrderLineReference.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct OrderLineReference: Codable, Sendable, Hashable  {
    public var lineID: SendableWrapper<Identifier>
    public var salesOrderLineID: SendableWrapper<Identifier>?
    public var uuid: SendableWrapper<Identifier>?
    public var lineStatusCode: SendableWrapper<Code>?
    public var orderReference: SendableWrapper<OrderReference>?

    public init(lineID: SendableWrapper<Identifier> = SendableWrapper(Identifier.empty()),
         salesOrderLineID: SendableWrapper<Identifier>? = nil,
         uuid: SendableWrapper<Identifier>? = nil,
         lineStatusCode: SendableWrapper<Code>? = nil,
         orderReference: SendableWrapper<OrderReference>? = nil) {
        self.lineID = lineID
        self.salesOrderLineID = salesOrderLineID
        self.uuid = uuid
        self.lineStatusCode = lineStatusCode
        self.orderReference = orderReference
    }
    
    public enum CodingKeys: String, CodingKey {
        case lineID = "LineID"
        case salesOrderLineID = "SalesOrderLineID"
        case uuid = "UUID"
        case lineStatusCode = "LineStatusCode"
        case orderReference = "OrderReference"
    }
}

extension OrderLineReference: CreateEmpty {
    public nonisolated static func empty() -> OrderLineReference {
        OrderLineReference()
    }
}
