// 
// OrderReference.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct OrderReference: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>
    public var salesOrderID: SendableWrapper<Identifier>?
    public var copyIndicator: SendableWrapper<Indicator>?
    public var uuid: SendableWrapper<Identifier>?
    public var issueDate: XMLDate?
    public var issueTime: XMLDate?
    public var customerReference: SendableWrapper<Text>?
    public var orderTypeCode: SendableWrapper<Code>?
    public var documentReference: SendableWrapper<DocumentReference>?

    public init(id: SendableWrapper<Identifier> = SendableWrapper(Identifier.empty()),
         salesOrderID: SendableWrapper<Identifier>? = nil,
         copyIndicator: SendableWrapper<Indicator>? = nil,
         uuid: SendableWrapper<Identifier>? = nil,
         issueDate: XMLDate? = nil,
         issueTime: XMLDate? = nil,
         customerReference: SendableWrapper<Text>? = nil,
         orderTypeCode: SendableWrapper<Code>? = nil,
         documentReference: SendableWrapper<DocumentReference>? = nil) {
        self.id = id
        self.salesOrderID = salesOrderID
        self.copyIndicator = copyIndicator
        self.uuid = uuid
        self.issueDate = issueDate
        self.issueTime = issueTime
        self.customerReference = customerReference
        self.orderTypeCode = orderTypeCode
        self.documentReference = documentReference
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case salesOrderID = "SalesOrderID"
        case copyIndicator = "CopyIndicator"
        case uuid = "UUID"
        case issueDate = "IssueDate"
        case issueTime = "IssueTime"
        case customerReference = "CustomerReference"
        case orderTypeCode = "OrderTypeCode"
        case documentReference = "DocumentReference"
    }
}

extension OrderReference: CreateEmpty {
    public nonisolated static func empty() -> OrderReference {
        OrderReference()
    }
}
