// 
// PackageType.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct PackageType: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>?
    public var quantity: SendableWrapper<Quantity>?
    public var returnableMaterialIndicator: SendableWrapper<Indicator>?
    public var packageLevelCode: SendableWrapper<Code>?
    public var packagingTypeCode: SendableWrapper<Code>?
    public var packingMaterial: [SendableWrapper<Text>] // This array should have at least one element
    public var traceID: SendableWrapper<Identifier>?
    public var containedPackage: [SendableWrapper<PackageType>] // This array should have at least one element
    public var containingTransportEquipment: SendableWrapper<TransportEquipment>?
    public var goodsItem: [SendableWrapper<GoodsItem>] // This array should have at least one element
    public var measurementDimension: [SendableWrapper<Dimension>] // This array should have at least one element
    public var deliveryUnit: [SendableWrapper<DeliveryUnit>] // This array should have at least one element
    public var delivery: SendableWrapper<Delivery>?
    public var pickup: SendableWrapper<Pickup>?
    public var despatch: SendableWrapper<Despatch>?

    public init(id: SendableWrapper<Identifier>? = nil,
         quantity: SendableWrapper<Quantity>? = nil,
         returnableMaterialIndicator: SendableWrapper<Indicator>? = nil,
         packageLevelCode: SendableWrapper<Code>? = nil,
         packagingTypeCode: SendableWrapper<Code>? = nil,
         packingMaterial: [SendableWrapper<Text>] = [],
         traceID: SendableWrapper<Identifier>? = nil,
         containedPackage: [SendableWrapper<PackageType>] = [],
         containingTransportEquipment: SendableWrapper<TransportEquipment>? = nil,
         goodsItem: [SendableWrapper<GoodsItem>] = [],
         measurementDimension: [SendableWrapper<Dimension>] = [],
         deliveryUnit: [SendableWrapper<DeliveryUnit>] = [],
         delivery: SendableWrapper<Delivery>? = nil,
         pickup: SendableWrapper<Pickup>? = nil,
         despatch: SendableWrapper<Despatch>? = nil) {
        self.id = id
        self.quantity = quantity
        self.returnableMaterialIndicator = returnableMaterialIndicator
        self.packageLevelCode = packageLevelCode
        self.packagingTypeCode = packagingTypeCode
        self.packingMaterial = packingMaterial
        self.traceID = traceID
        self.containedPackage = containedPackage
        self.containingTransportEquipment = containingTransportEquipment
        self.goodsItem = goodsItem
        self.measurementDimension = measurementDimension
        self.deliveryUnit = deliveryUnit
        self.delivery = delivery
        self.pickup = pickup
        self.despatch = despatch
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case quantity = "Quantity"
        case returnableMaterialIndicator = "ReturnableMaterialIndicator"
        case packageLevelCode = "PackageLevelCode"
        case packagingTypeCode = "PackagingTypeCode"
        case packingMaterial = "PackingMaterial"
        case traceID = "TraceID"
        case containedPackage = "ContainedPackage"
        case containingTransportEquipment = "ContainingTransportEquipment"
        case goodsItem = "GoodsItem"
        case measurementDimension = "MeasurementDimension"
        case deliveryUnit = "DeliveryUnit"
        case delivery = "Delivery"
        case pickup = "Pickup"
        case despatch = "Despatch"
    }
}

extension PackageType: CreateEmpty {
    public nonisolated static func empty() -> PackageType {
        PackageType()
    }
}
