// 
// Party.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct Party: Codable, Sendable, Hashable  {
    public var markCareIndicator: SendableWrapper<Indicator>?
    public var markAttentionIndicator: SendableWrapper<Indicator>?
    public var websiteURI: SendableWrapper<Identifier>?
    public var logoReferenceID: SendableWrapper<Identifier>?
    public var endpointID: SendableWrapper<Identifier>?
    public var industryClassificationCode: SendableWrapper<Code>?
    public var partyIdentification: [SendableWrapper<PartyIdentification>] // This array should have at least one element
    public var partyName: [SendableWrapper<PartyName>] // This array should have at least one element
    public var language: SendableWrapper<Language>?
    public var postalAddress: SendableWrapper<Address>?
    public var physicalLocation: SendableWrapper<Location>?
    public var partyTaxScheme: [SendableWrapper<PartyTaxScheme>] // This array should have at least one element
    public var partyLegalEntity: [SendableWrapper<PartyLegalEntity>] // This array should have at least one element
    public var contact: SendableWrapper<Contact>?
    public var person: [SendableWrapper<Person>] // This array should have at least one element
    public var agentParty: SendableWrapper<Party>?
    public var serviceProviderParty: [SendableWrapper<ServiceProviderParty>] // This array should have at least one element
    public var powerOfAttorney: [SendableWrapper<PowerOfAttorney>] // This array should have at least one element
    public var financialAccount: SendableWrapper<FinancialAccount>?

    public init(markCareIndicator: SendableWrapper<Indicator>? = nil,
         markAttentionIndicator: SendableWrapper<Indicator>? = nil,
         websiteURI: SendableWrapper<Identifier>? = nil,
         logoReferenceID: SendableWrapper<Identifier>? = nil,
         endpointID: SendableWrapper<Identifier>? = nil,
         industryClassificationCode: SendableWrapper<Code>? = nil,
         partyIdentification: [SendableWrapper<PartyIdentification>] = [],
         partyName: [SendableWrapper<PartyName>] = [],
         language: SendableWrapper<Language>? = nil,
         postalAddress: SendableWrapper<Address>? = nil,
         physicalLocation: SendableWrapper<Location>? = nil,
         partyTaxScheme: [SendableWrapper<PartyTaxScheme>] = [],
         partyLegalEntity: [SendableWrapper<PartyLegalEntity>] = [],
         contact: SendableWrapper<Contact>? = nil,
         person: [SendableWrapper<Person>] = [],
         agentParty: SendableWrapper<Party>? = nil,
         serviceProviderParty: [SendableWrapper<ServiceProviderParty>] = [],
         powerOfAttorney: [SendableWrapper<PowerOfAttorney>] = [],
         financialAccount: SendableWrapper<FinancialAccount>? = nil) {
        self.markCareIndicator = markCareIndicator
        self.markAttentionIndicator = markAttentionIndicator
        self.websiteURI = websiteURI
        self.logoReferenceID = logoReferenceID
        self.endpointID = endpointID
        self.industryClassificationCode = industryClassificationCode
        self.partyIdentification = partyIdentification
        self.partyName = partyName
        self.language = language
        self.postalAddress = postalAddress
        self.physicalLocation = physicalLocation
        self.partyTaxScheme = partyTaxScheme
        self.partyLegalEntity = partyLegalEntity
        self.contact = contact
        self.person = person
        self.agentParty = agentParty
        self.serviceProviderParty = serviceProviderParty
        self.powerOfAttorney = powerOfAttorney
        self.financialAccount = financialAccount
    }
    
    public enum CodingKeys: String, CodingKey {
        case markCareIndicator = "MarkCareIndicator"
        case markAttentionIndicator = "MarkAttentionIndicator"
        case websiteURI = "WebsiteURI"
        case logoReferenceID = "LogoReferenceID"
        case endpointID = "EndpointID"
        case industryClassificationCode = "IndustryClassificationCode"
        case partyIdentification = "PartyIdentification"
        case partyName = "PartyName"
        case language = "Language"
        case postalAddress = "PostalAddress"
        case physicalLocation = "PhysicalLocation"
        case partyTaxScheme = "PartyTaxScheme"
        case partyLegalEntity = "PartyLegalEntity"
        case contact = "Contact"
        case person = "Person"
        case agentParty = "AgentParty"
        case serviceProviderParty = "ServiceProviderParty"
        case powerOfAttorney = "PowerOfAttorney"
        case financialAccount = "FinancialAccount"
    }
}

extension Party: CreateEmpty {
    public nonisolated static func empty() -> Party {
        Party()
    }
}
