// 
// PartyLegalEntity.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct PartyLegalEntity: Codable, Sendable, Hashable  {
    public var registrationName: SendableWrapper<Text>?
    public var companyID: SendableWrapper<Identifier>?
    public var registrationDate: XMLDate?
    public var registrationExpirationDate: XMLDate?
    public var companyLegalFormCode: SendableWrapper<Code>?
    public var companyLegalForm: SendableWrapper<Text>?
    public var soleProprietorshipIndicator: SendableWrapper<Indicator>?
    public var companyLiquidationStatusCode: SendableWrapper<Code>?
    public var corporateStockAmount: SendableWrapper<Amount>?
    public var fullyPaidSharesIndicator: SendableWrapper<Indicator>?
    public var registrationAddress: SendableWrapper<Address>?
    public var corporateRegistrationScheme: SendableWrapper<CorporateRegistrationScheme>?
    public var headOfficeParty: SendableWrapper<Party>?
    public var shareholderParty: [SendableWrapper<ShareholderParty>] // This array should have at least one element

    public init(registrationName: SendableWrapper<Text>? = nil,
         companyID: SendableWrapper<Identifier>? = nil,
         registrationDate: XMLDate? = nil,
         registrationExpirationDate: XMLDate? = nil,
         companyLegalFormCode: SendableWrapper<Code>? = nil,
         companyLegalForm: SendableWrapper<Text>? = nil,
         soleProprietorshipIndicator: SendableWrapper<Indicator>? = nil,
         companyLiquidationStatusCode: SendableWrapper<Code>? = nil,
         corporateStockAmount: SendableWrapper<Amount>? = nil,
         fullyPaidSharesIndicator: SendableWrapper<Indicator>? = nil,
         registrationAddress: SendableWrapper<Address>? = nil,
         corporateRegistrationScheme: SendableWrapper<CorporateRegistrationScheme>? = nil,
         headOfficeParty: SendableWrapper<Party>? = nil,
         shareholderParty: [SendableWrapper<ShareholderParty>] = []) {
        self.registrationName = registrationName
        self.companyID = companyID
        self.registrationDate = registrationDate
        self.registrationExpirationDate = registrationExpirationDate
        self.companyLegalFormCode = companyLegalFormCode
        self.companyLegalForm = companyLegalForm
        self.soleProprietorshipIndicator = soleProprietorshipIndicator
        self.companyLiquidationStatusCode = companyLiquidationStatusCode
        self.corporateStockAmount = corporateStockAmount
        self.fullyPaidSharesIndicator = fullyPaidSharesIndicator
        self.registrationAddress = registrationAddress
        self.corporateRegistrationScheme = corporateRegistrationScheme
        self.headOfficeParty = headOfficeParty
        self.shareholderParty = shareholderParty
    }
    
    public enum CodingKeys: String, CodingKey {
        case registrationName = "RegistrationName"
        case companyID = "CompanyID"
        case registrationDate = "RegistrationDate"
        case registrationExpirationDate = "RegistrationExpirationDate"
        case companyLegalFormCode = "CompanyLegalFormCode"
        case companyLegalForm = "CompanyLegalForm"
        case soleProprietorshipIndicator = "SoleProprietorshipIndicator"
        case companyLiquidationStatusCode = "CompanyLiquidationStatusCode"
        case corporateStockAmount = "CorporateStockAmount"
        case fullyPaidSharesIndicator = "FullyPaidSharesIndicator"
        case registrationAddress = "RegistrationAddress"
        case corporateRegistrationScheme = "CorporateRegistrationScheme"
        case headOfficeParty = "HeadOfficeParty"
        case shareholderParty = "ShareholderParty"
    }
}

extension PartyLegalEntity: CreateEmpty {
    public nonisolated static func empty() -> PartyLegalEntity {
        PartyLegalEntity()
    }
}
