// 
// PartyTaxScheme.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct PartyTaxScheme: Codable, Sendable, Hashable  {
    public var registrationName: SendableWrapper<Text>?
    public var companyID: SendableWrapper<Identifier>?
    public var taxLevelCode: SendableWrapper<Code>?
    public var exemptionReasonCode: SendableWrapper<Code>?
    public var exemptionReason: [SendableWrapper<Text>] // This array should have at least one element
    public var registrationAddress: SendableWrapper<Address>?
    public var taxScheme: SendableWrapper<TaxScheme>

    public init(registrationName: SendableWrapper<Text>? = nil,
         companyID: SendableWrapper<Identifier>? = nil,
         taxLevelCode: SendableWrapper<Code>? = nil,
         exemptionReasonCode: SendableWrapper<Code>? = nil,
         exemptionReason: [SendableWrapper<Text>] = [],
         registrationAddress: SendableWrapper<Address>? = nil,
         taxScheme: SendableWrapper<TaxScheme> = SendableWrapper(TaxScheme.empty())) {
        self.registrationName = registrationName
        self.companyID = companyID
        self.taxLevelCode = taxLevelCode
        self.exemptionReasonCode = exemptionReasonCode
        self.exemptionReason = exemptionReason
        self.registrationAddress = registrationAddress
        self.taxScheme = taxScheme
    }
    
    public enum CodingKeys: String, CodingKey {
        case registrationName = "RegistrationName"
        case companyID = "CompanyID"
        case taxLevelCode = "TaxLevelCode"
        case exemptionReasonCode = "ExemptionReasonCode"
        case exemptionReason = "ExemptionReason"
        case registrationAddress = "RegistrationAddress"
        case taxScheme = "TaxScheme"
    }
}

extension PartyTaxScheme: CreateEmpty {
    public nonisolated static func empty() -> PartyTaxScheme {
        PartyTaxScheme()
    }
}
