// 
// Payment.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct Payment: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>?
    public var paidAmount: SendableWrapper<Amount>?
    public var receivedDate: XMLDate?
    public var paidDate: XMLDate?
    public var paidTime: XMLDate?
    public var instructionID: SendableWrapper<Identifier>?

    public init(id: SendableWrapper<Identifier>? = nil,
         paidAmount: SendableWrapper<Amount>? = nil,
         receivedDate: XMLDate? = nil,
         paidDate: XMLDate? = nil,
         paidTime: XMLDate? = nil,
         instructionID: SendableWrapper<Identifier>? = nil) {
        self.id = id
        self.paidAmount = paidAmount
        self.receivedDate = receivedDate
        self.paidDate = paidDate
        self.paidTime = paidTime
        self.instructionID = instructionID
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case paidAmount = "PaidAmount"
        case receivedDate = "ReceivedDate"
        case paidDate = "PaidDate"
        case paidTime = "PaidTime"
        case instructionID = "InstructionID"
    }
}

extension Payment: CreateEmpty {
    public nonisolated static func empty() -> Payment {
        Payment()
    }
}
