// 
// PaymentMandate.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct PaymentMandate: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>?
    public var mandateTypeCode: SendableWrapper<Code>?
    public var maximumPaymentInstructionsNumeric: SendableWrapper<Numeric>?
    public var maximumPaidAmount: SendableWrapper<Amount>?
    public var signatureID: SendableWrapper<Identifier>?
    public var payerParty: SendableWrapper<Party>?
    public var payerFinancialAccount: SendableWrapper<FinancialAccount>?
    public var validityPeriod: SendableWrapper<Period>?
    public var paymentReversalPeriod: SendableWrapper<Period>?
    public var clause: [SendableWrapper<Clause>] // This array should have at least one element

    public init(id: SendableWrapper<Identifier>? = nil,
         mandateTypeCode: SendableWrapper<Code>? = nil,
         maximumPaymentInstructionsNumeric: SendableWrapper<Numeric>? = nil,
         maximumPaidAmount: SendableWrapper<Amount>? = nil,
         signatureID: SendableWrapper<Identifier>? = nil,
         payerParty: SendableWrapper<Party>? = nil,
         payerFinancialAccount: SendableWrapper<FinancialAccount>? = nil,
         validityPeriod: SendableWrapper<Period>? = nil,
         paymentReversalPeriod: SendableWrapper<Period>? = nil,
         clause: [SendableWrapper<Clause>] = []) {
        self.id = id
        self.mandateTypeCode = mandateTypeCode
        self.maximumPaymentInstructionsNumeric = maximumPaymentInstructionsNumeric
        self.maximumPaidAmount = maximumPaidAmount
        self.signatureID = signatureID
        self.payerParty = payerParty
        self.payerFinancialAccount = payerFinancialAccount
        self.validityPeriod = validityPeriod
        self.paymentReversalPeriod = paymentReversalPeriod
        self.clause = clause
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case mandateTypeCode = "MandateTypeCode"
        case maximumPaymentInstructionsNumeric = "MaximumPaymentInstructionsNumeric"
        case maximumPaidAmount = "MaximumPaidAmount"
        case signatureID = "SignatureID"
        case payerParty = "PayerParty"
        case payerFinancialAccount = "PayerFinancialAccount"
        case validityPeriod = "ValidityPeriod"
        case paymentReversalPeriod = "PaymentReversalPeriod"
        case clause = "Clause"
    }
}

extension PaymentMandate: CreateEmpty {
    public nonisolated static func empty() -> PaymentMandate {
        PaymentMandate()
    }
}
