// 
// PaymentMeans.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct PaymentMeans: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>?
    public var paymentMeansCode: SendableWrapper<Code>
    public var paymentDueDate: XMLDate?
    public var paymentChannelCode: SendableWrapper<Code>?
    public var instructionID: SendableWrapper<Identifier>?
    public var instructionNote: [SendableWrapper<Text>] // This array should have at least one element
    public var paymentID: [SendableWrapper<Identifier>] // This array should have at least one element
    public var cardAccount: SendableWrapper<CardAccount>?
    public var payerFinancialAccount: SendableWrapper<FinancialAccount>?
    public var payeeFinancialAccount: SendableWrapper<FinancialAccount>?
    public var creditAccount: SendableWrapper<CreditAccount>?
    public var paymentMandate: SendableWrapper<PaymentMandate>?
    public var tradeFinancing: SendableWrapper<TradeFinancing>?

    public init(id: SendableWrapper<Identifier>? = nil,
         paymentMeansCode: SendableWrapper<Code> = SendableWrapper(Code.empty()),
         paymentDueDate: XMLDate? = nil,
         paymentChannelCode: SendableWrapper<Code>? = nil,
         instructionID: SendableWrapper<Identifier>? = nil,
         instructionNote: [SendableWrapper<Text>] = [],
         paymentID: [SendableWrapper<Identifier>] = [],
         cardAccount: SendableWrapper<CardAccount>? = nil,
         payerFinancialAccount: SendableWrapper<FinancialAccount>? = nil,
         payeeFinancialAccount: SendableWrapper<FinancialAccount>? = nil,
         creditAccount: SendableWrapper<CreditAccount>? = nil,
         paymentMandate: SendableWrapper<PaymentMandate>? = nil,
         tradeFinancing: SendableWrapper<TradeFinancing>? = nil) {
        self.id = id
        self.paymentMeansCode = paymentMeansCode
        self.paymentDueDate = paymentDueDate
        self.paymentChannelCode = paymentChannelCode
        self.instructionID = instructionID
        self.instructionNote = instructionNote
        self.paymentID = paymentID
        self.cardAccount = cardAccount
        self.payerFinancialAccount = payerFinancialAccount
        self.payeeFinancialAccount = payeeFinancialAccount
        self.creditAccount = creditAccount
        self.paymentMandate = paymentMandate
        self.tradeFinancing = tradeFinancing
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case paymentMeansCode = "PaymentMeansCode"
        case paymentDueDate = "PaymentDueDate"
        case paymentChannelCode = "PaymentChannelCode"
        case instructionID = "InstructionID"
        case instructionNote = "InstructionNote"
        case paymentID = "PaymentID"
        case cardAccount = "CardAccount"
        case payerFinancialAccount = "PayerFinancialAccount"
        case payeeFinancialAccount = "PayeeFinancialAccount"
        case creditAccount = "CreditAccount"
        case paymentMandate = "PaymentMandate"
        case tradeFinancing = "TradeFinancing"
    }
}

extension PaymentMeans: CreateEmpty {
    public nonisolated static func empty() -> PaymentMeans {
        PaymentMeans()
    }
}
