// 
// PaymentTerms.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct PaymentTerms: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>?
    public var paymentMeansID: [SendableWrapper<Identifier>] // This array should have at least one element
    public var prepaidPaymentReferenceID: SendableWrapper<Identifier>?
    public var note: [SendableWrapper<Text>] // This array should have at least one element
    public var referenceEventCode: SendableWrapper<Code>?
    public var settlementDiscountPercent: SendableWrapper<Numeric>?
    public var penaltySurchargePercent: SendableWrapper<Numeric>?
    public var paymentPercent: SendableWrapper<Numeric>?
    public var amount: SendableWrapper<Amount>?
    public var settlementDiscountAmount: SendableWrapper<Amount>?
    public var penaltyAmount: SendableWrapper<Amount>?
    public var paymentTermsDetailsURI: SendableWrapper<Identifier>?
    public var paymentDueDate: XMLDate?
    public var installmentDueDate: XMLDate?
    public var invoicingPartyReference: SendableWrapper<Text>?
    public var settlementPeriod: SendableWrapper<Period>?
    public var penaltyPeriod: SendableWrapper<Period>?
    public var exchangeRate: SendableWrapper<ExchangeRate>?
    public var validityPeriod: SendableWrapper<Period>?

    public init(id: SendableWrapper<Identifier>? = nil,
         paymentMeansID: [SendableWrapper<Identifier>] = [],
         prepaidPaymentReferenceID: SendableWrapper<Identifier>? = nil,
         note: [SendableWrapper<Text>] = [],
         referenceEventCode: SendableWrapper<Code>? = nil,
         settlementDiscountPercent: SendableWrapper<Numeric>? = nil,
         penaltySurchargePercent: SendableWrapper<Numeric>? = nil,
         paymentPercent: SendableWrapper<Numeric>? = nil,
         amount: SendableWrapper<Amount>? = nil,
         settlementDiscountAmount: SendableWrapper<Amount>? = nil,
         penaltyAmount: SendableWrapper<Amount>? = nil,
         paymentTermsDetailsURI: SendableWrapper<Identifier>? = nil,
         paymentDueDate: XMLDate? = nil,
         installmentDueDate: XMLDate? = nil,
         invoicingPartyReference: SendableWrapper<Text>? = nil,
         settlementPeriod: SendableWrapper<Period>? = nil,
         penaltyPeriod: SendableWrapper<Period>? = nil,
         exchangeRate: SendableWrapper<ExchangeRate>? = nil,
         validityPeriod: SendableWrapper<Period>? = nil) {
        self.id = id
        self.paymentMeansID = paymentMeansID
        self.prepaidPaymentReferenceID = prepaidPaymentReferenceID
        self.note = note
        self.referenceEventCode = referenceEventCode
        self.settlementDiscountPercent = settlementDiscountPercent
        self.penaltySurchargePercent = penaltySurchargePercent
        self.paymentPercent = paymentPercent
        self.amount = amount
        self.settlementDiscountAmount = settlementDiscountAmount
        self.penaltyAmount = penaltyAmount
        self.paymentTermsDetailsURI = paymentTermsDetailsURI
        self.paymentDueDate = paymentDueDate
        self.installmentDueDate = installmentDueDate
        self.invoicingPartyReference = invoicingPartyReference
        self.settlementPeriod = settlementPeriod
        self.penaltyPeriod = penaltyPeriod
        self.exchangeRate = exchangeRate
        self.validityPeriod = validityPeriod
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case paymentMeansID = "PaymentMeansID"
        case prepaidPaymentReferenceID = "PrepaidPaymentReferenceID"
        case note = "Note"
        case referenceEventCode = "ReferenceEventCode"
        case settlementDiscountPercent = "SettlementDiscountPercent"
        case penaltySurchargePercent = "PenaltySurchargePercent"
        case paymentPercent = "PaymentPercent"
        case amount = "Amount"
        case settlementDiscountAmount = "SettlementDiscountAmount"
        case penaltyAmount = "PenaltyAmount"
        case paymentTermsDetailsURI = "PaymentTermsDetailsURI"
        case paymentDueDate = "PaymentDueDate"
        case installmentDueDate = "InstallmentDueDate"
        case invoicingPartyReference = "InvoicingPartyReference"
        case settlementPeriod = "SettlementPeriod"
        case penaltyPeriod = "PenaltyPeriod"
        case exchangeRate = "ExchangeRate"
        case validityPeriod = "ValidityPeriod"
    }
}

extension PaymentTerms: CreateEmpty {
    public nonisolated static func empty() -> PaymentTerms {
        PaymentTerms()
    }
}
