// 
// Period.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct Period: Codable, Sendable, Hashable  {
    public var startDate: XMLDate?
    public var startTime: XMLDate?
    public var endDate: XMLDate?
    public var endTime: XMLDate?
    public var durationMeasure: SendableWrapper<Measure>?
    public var descriptionCode: [SendableWrapper<Code>] // This array should have at least one element
    public var description: [SendableWrapper<Text>] // This array should have at least one element

    public init(startDate: XMLDate? = nil,
         startTime: XMLDate? = nil,
         endDate: XMLDate? = nil,
         endTime: XMLDate? = nil,
         durationMeasure: SendableWrapper<Measure>? = nil,
         descriptionCode: [SendableWrapper<Code>] = [],
         description: [SendableWrapper<Text>] = []) {
        self.startDate = startDate
        self.startTime = startTime
        self.endDate = endDate
        self.endTime = endTime
        self.durationMeasure = durationMeasure
        self.descriptionCode = descriptionCode
        self.description = description
    }
    
    public enum CodingKeys: String, CodingKey {
        case startDate = "StartDate"
        case startTime = "StartTime"
        case endDate = "EndDate"
        case endTime = "EndTime"
        case durationMeasure = "DurationMeasure"
        case descriptionCode = "DescriptionCode"
        case description = "Description"
    }
}

extension Period: CreateEmpty {
    public nonisolated static func empty() -> Period {
        Period()
    }
}
