// 
// Person.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct Person: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>?
    public var firstName: SendableWrapper<Text>?
    public var familyName: SendableWrapper<Text>?
    public var title: SendableWrapper<Text>?
    public var middleName: SendableWrapper<Text>?
    public var otherName: SendableWrapper<Text>?
    public var nameSuffix: SendableWrapper<Text>?
    public var jobTitle: SendableWrapper<Text>?
    public var nationalityID: SendableWrapper<Identifier>?
    public var genderCode: SendableWrapper<Code>?
    public var birthDate: XMLDate?
    public var birthplaceName: SendableWrapper<Text>?
    public var organizationDepartment: SendableWrapper<Text>?
    public var contact: SendableWrapper<Contact>?
    public var financialAccount: SendableWrapper<FinancialAccount>?
    public var identityDocumentReference: [SendableWrapper<DocumentReference>] // This array should have at least one element
    public var residenceAddress: SendableWrapper<Address>?

    public init(id: SendableWrapper<Identifier>? = nil,
         firstName: SendableWrapper<Text>? = nil,
         familyName: SendableWrapper<Text>? = nil,
         title: SendableWrapper<Text>? = nil,
         middleName: SendableWrapper<Text>? = nil,
         otherName: SendableWrapper<Text>? = nil,
         nameSuffix: SendableWrapper<Text>? = nil,
         jobTitle: SendableWrapper<Text>? = nil,
         nationalityID: SendableWrapper<Identifier>? = nil,
         genderCode: SendableWrapper<Code>? = nil,
         birthDate: XMLDate? = nil,
         birthplaceName: SendableWrapper<Text>? = nil,
         organizationDepartment: SendableWrapper<Text>? = nil,
         contact: SendableWrapper<Contact>? = nil,
         financialAccount: SendableWrapper<FinancialAccount>? = nil,
         identityDocumentReference: [SendableWrapper<DocumentReference>] = [],
         residenceAddress: SendableWrapper<Address>? = nil) {
        self.id = id
        self.firstName = firstName
        self.familyName = familyName
        self.title = title
        self.middleName = middleName
        self.otherName = otherName
        self.nameSuffix = nameSuffix
        self.jobTitle = jobTitle
        self.nationalityID = nationalityID
        self.genderCode = genderCode
        self.birthDate = birthDate
        self.birthplaceName = birthplaceName
        self.organizationDepartment = organizationDepartment
        self.contact = contact
        self.financialAccount = financialAccount
        self.identityDocumentReference = identityDocumentReference
        self.residenceAddress = residenceAddress
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case firstName = "FirstName"
        case familyName = "FamilyName"
        case title = "Title"
        case middleName = "MiddleName"
        case otherName = "OtherName"
        case nameSuffix = "NameSuffix"
        case jobTitle = "JobTitle"
        case nationalityID = "NationalityID"
        case genderCode = "GenderCode"
        case birthDate = "BirthDate"
        case birthplaceName = "BirthplaceName"
        case organizationDepartment = "OrganizationDepartment"
        case contact = "Contact"
        case financialAccount = "FinancialAccount"
        case identityDocumentReference = "IdentityDocumentReference"
        case residenceAddress = "ResidenceAddress"
    }
}

extension Person: CreateEmpty {
    public nonisolated static func empty() -> Person {
        Person()
    }
}
