// 
// PhysicalAttribute.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct PhysicalAttribute: Codable, Sendable, Hashable  {
    public var attributeID: SendableWrapper<Identifier>
    public var positionCode: SendableWrapper<Code>?
    public var descriptionCode: SendableWrapper<Code>?
    public var description: [SendableWrapper<Text>] // This array should have at least one element

    public init(attributeID: SendableWrapper<Identifier> = SendableWrapper(Identifier.empty()),
         positionCode: SendableWrapper<Code>? = nil,
         descriptionCode: SendableWrapper<Code>? = nil,
         description: [SendableWrapper<Text>] = []) {
        self.attributeID = attributeID
        self.positionCode = positionCode
        self.descriptionCode = descriptionCode
        self.description = description
    }
    
    public enum CodingKeys: String, CodingKey {
        case attributeID = "AttributeID"
        case positionCode = "PositionCode"
        case descriptionCode = "DescriptionCode"
        case description = "Description"
    }
}

extension PhysicalAttribute: CreateEmpty {
    public nonisolated static func empty() -> PhysicalAttribute {
        PhysicalAttribute()
    }
}
