// 
// Pickup.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct Pickup: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>?
    public var actualPickupDate: XMLDate?
    public var actualPickupTime: XMLDate?
    public var earliestPickupDate: XMLDate?
    public var earliestPickupTime: XMLDate?
    public var latestPickupDate: XMLDate?
    public var latestPickupTime: XMLDate?
    public var pickupLocation: SendableWrapper<Location>?
    public var pickupParty: SendableWrapper<Party>?

    public init(id: SendableWrapper<Identifier>? = nil,
         actualPickupDate: XMLDate? = nil,
         actualPickupTime: XMLDate? = nil,
         earliestPickupDate: XMLDate? = nil,
         earliestPickupTime: XMLDate? = nil,
         latestPickupDate: XMLDate? = nil,
         latestPickupTime: XMLDate? = nil,
         pickupLocation: SendableWrapper<Location>? = nil,
         pickupParty: SendableWrapper<Party>? = nil) {
        self.id = id
        self.actualPickupDate = actualPickupDate
        self.actualPickupTime = actualPickupTime
        self.earliestPickupDate = earliestPickupDate
        self.earliestPickupTime = earliestPickupTime
        self.latestPickupDate = latestPickupDate
        self.latestPickupTime = latestPickupTime
        self.pickupLocation = pickupLocation
        self.pickupParty = pickupParty
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case actualPickupDate = "ActualPickupDate"
        case actualPickupTime = "ActualPickupTime"
        case earliestPickupDate = "EarliestPickupDate"
        case earliestPickupTime = "EarliestPickupTime"
        case latestPickupDate = "LatestPickupDate"
        case latestPickupTime = "LatestPickupTime"
        case pickupLocation = "PickupLocation"
        case pickupParty = "PickupParty"
    }
}

extension Pickup: CreateEmpty {
    public nonisolated static func empty() -> Pickup {
        Pickup()
    }
}
