// 
// PowerOfAttorney.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct PowerOfAttorney: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>?
    public var issueDate: XMLDate?
    public var issueTime: XMLDate?
    public var description: [SendableWrapper<Text>] // This array should have at least one element
    public var notaryParty: SendableWrapper<Party>?
    public var agentParty: SendableWrapper<Party>
    public var witnessParty: [SendableWrapper<Party>] // This array should have at least one element
    public var mandateDocumentReference: [SendableWrapper<DocumentReference>] // This array should have at least one element

    public init(id: SendableWrapper<Identifier>? = nil,
         issueDate: XMLDate? = nil,
         issueTime: XMLDate? = nil,
         description: [SendableWrapper<Text>] = [],
         notaryParty: SendableWrapper<Party>? = nil,
         agentParty: SendableWrapper<Party> = SendableWrapper(Party.empty()),
         witnessParty: [SendableWrapper<Party>] = [],
         mandateDocumentReference: [SendableWrapper<DocumentReference>] = []) {
        self.id = id
        self.issueDate = issueDate
        self.issueTime = issueTime
        self.description = description
        self.notaryParty = notaryParty
        self.agentParty = agentParty
        self.witnessParty = witnessParty
        self.mandateDocumentReference = mandateDocumentReference
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case issueDate = "IssueDate"
        case issueTime = "IssueTime"
        case description = "Description"
        case notaryParty = "NotaryParty"
        case agentParty = "AgentParty"
        case witnessParty = "WitnessParty"
        case mandateDocumentReference = "MandateDocumentReference"
    }
}

extension PowerOfAttorney: CreateEmpty {
    public nonisolated static func empty() -> PowerOfAttorney {
        PowerOfAttorney()
    }
}
