// 
// Price.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct Price: Codable, Sendable, Hashable  {
    public var priceAmount: SendableWrapper<Amount>
    public var baseQuantity: SendableWrapper<Quantity>?
    public var priceChangeReason: [SendableWrapper<Text>] // This array should have at least one element
    public var priceTypeCode: SendableWrapper<Code>?
    public var priceType: SendableWrapper<Text>?
    public var orderableUnitFactorRate: SendableWrapper<Numeric>?
    public var validityPeriod: [SendableWrapper<Period>] // This array should have at least one element
    public var priceList: SendableWrapper<PriceList>?
    public var allowanceCharge: [SendableWrapper<AllowanceCharge>] // This array should have at least one element
    public var pricingExchangeRate: SendableWrapper<ExchangeRate>?

    public init(priceAmount: SendableWrapper<Amount> = SendableWrapper(Amount.empty()),
         baseQuantity: SendableWrapper<Quantity>? = nil,
         priceChangeReason: [SendableWrapper<Text>] = [],
         priceTypeCode: SendableWrapper<Code>? = nil,
         priceType: SendableWrapper<Text>? = nil,
         orderableUnitFactorRate: SendableWrapper<Numeric>? = nil,
         validityPeriod: [SendableWrapper<Period>] = [],
         priceList: SendableWrapper<PriceList>? = nil,
         allowanceCharge: [SendableWrapper<AllowanceCharge>] = [],
         pricingExchangeRate: SendableWrapper<ExchangeRate>? = nil) {
        self.priceAmount = priceAmount
        self.baseQuantity = baseQuantity
        self.priceChangeReason = priceChangeReason
        self.priceTypeCode = priceTypeCode
        self.priceType = priceType
        self.orderableUnitFactorRate = orderableUnitFactorRate
        self.validityPeriod = validityPeriod
        self.priceList = priceList
        self.allowanceCharge = allowanceCharge
        self.pricingExchangeRate = pricingExchangeRate
    }
    
    public enum CodingKeys: String, CodingKey {
        case priceAmount = "PriceAmount"
        case baseQuantity = "BaseQuantity"
        case priceChangeReason = "PriceChangeReason"
        case priceTypeCode = "PriceTypeCode"
        case priceType = "PriceType"
        case orderableUnitFactorRate = "OrderableUnitFactorRate"
        case validityPeriod = "ValidityPeriod"
        case priceList = "PriceList"
        case allowanceCharge = "AllowanceCharge"
        case pricingExchangeRate = "PricingExchangeRate"
    }
}

extension Price: CreateEmpty {
    public nonisolated static func empty() -> Price {
        Price()
    }
}
