// 
// PriceExtension.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct PriceExtension: Codable, Sendable, Hashable  {
    public var amount: SendableWrapper<Amount>
    public var taxTotal: [SendableWrapper<TaxTotal>] // This array should have at least one element

    public init(amount: SendableWrapper<Amount> = SendableWrapper(Amount.empty()),
         taxTotal: [SendableWrapper<TaxTotal>] = []) {
        self.amount = amount
        self.taxTotal = taxTotal
    }
    
    public enum CodingKeys: String, CodingKey {
        case amount = "Amount"
        case taxTotal = "TaxTotal"
    }
}

extension PriceExtension: CreateEmpty {
    public nonisolated static func empty() -> PriceExtension {
        PriceExtension()
    }
}
