// 
// PriceList.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct PriceList: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>?
    public var statusCode: SendableWrapper<Code>?
    public var validityPeriod: [SendableWrapper<Period>] // This array should have at least one element
    public var previousPriceList: SendableWrapper<PriceList>?

    public init(id: SendableWrapper<Identifier>? = nil,
         statusCode: SendableWrapper<Code>? = nil,
         validityPeriod: [SendableWrapper<Period>] = [],
         previousPriceList: SendableWrapper<PriceList>? = nil) {
        self.id = id
        self.statusCode = statusCode
        self.validityPeriod = validityPeriod
        self.previousPriceList = previousPriceList
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case statusCode = "StatusCode"
        case validityPeriod = "ValidityPeriod"
        case previousPriceList = "PreviousPriceList"
    }
}

extension PriceList: CreateEmpty {
    public nonisolated static func empty() -> PriceList {
        PriceList()
    }
}
