// 
// PricingReference.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct PricingReference: Codable, Sendable, Hashable  {
    public var originalItemLocationQuantity: SendableWrapper<ItemLocationQuantity>?
    public var alternativeConditionPrice: [SendableWrapper<Price>] // This array should have at least one element

    public init(originalItemLocationQuantity: SendableWrapper<ItemLocationQuantity>? = nil,
         alternativeConditionPrice: [SendableWrapper<Price>] = []) {
        self.originalItemLocationQuantity = originalItemLocationQuantity
        self.alternativeConditionPrice = alternativeConditionPrice
    }
    
    public enum CodingKeys: String, CodingKey {
        case originalItemLocationQuantity = "OriginalItemLocationQuantity"
        case alternativeConditionPrice = "AlternativeConditionPrice"
    }
}

extension PricingReference: CreateEmpty {
    public nonisolated static func empty() -> PricingReference {
        PricingReference()
    }
}
