// 
// ProjectReference.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct ProjectReference: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>
    public var uuid: SendableWrapper<Identifier>?
    public var issueDate: XMLDate?
    public var workPhaseReference: [SendableWrapper<WorkPhaseReference>] // This array should have at least one element

    public init(id: SendableWrapper<Identifier> = SendableWrapper(Identifier.empty()),
         uuid: SendableWrapper<Identifier>? = nil,
         issueDate: XMLDate? = nil,
         workPhaseReference: [SendableWrapper<WorkPhaseReference>] = []) {
        self.id = id
        self.uuid = uuid
        self.issueDate = issueDate
        self.workPhaseReference = workPhaseReference
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case uuid = "UUID"
        case issueDate = "IssueDate"
        case workPhaseReference = "WorkPhaseReference"
    }
}

extension ProjectReference: CreateEmpty {
    public nonisolated static func empty() -> ProjectReference {
        ProjectReference()
    }
}
