// 
// Quantity.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct Quantity: Codable, Sendable, Hashable , DynamicNodeEncoding, DynamicNodeDecoding {
    public var value: Decimal
    public var unitCode: String?
    public var unitCodeListID: String?
    public var unitCodeListAgencyID: String?
    public var unitCodeListAgencyName: String?

    public init(value: Decimal = 0,
         unitCode: String? = nil,
         unitCodeListID: String? = nil,
         unitCodeListAgencyID: String? = nil,
         unitCodeListAgencyName: String? = nil) {
        self.value = value
        self.unitCode = unitCode
        self.unitCodeListID = unitCodeListID
        self.unitCodeListAgencyID = unitCodeListAgencyID
        self.unitCodeListAgencyName = unitCodeListAgencyName
    }
    
    public enum CodingKeys: String, CodingKey {
        case value = ""
        case unitCode = "unitCode"
        case unitCodeListID = "unitCodeListID"
        case unitCodeListAgencyID = "unitCodeListAgencyID"
        case unitCodeListAgencyName = "unitCodeListAgencyName"
    }

    nonisolated public static func nodeEncoding(for key: CodingKey) -> XMLEncoder.NodeEncoding {
        switch key {
        case CodingKeys.value:
           return .element
        default:
            return .attribute
        }
    }
    
    nonisolated public static func nodeDecoding(for key: CodingKey) -> XMLDecoder.NodeDecoding {
        switch key {
        case CodingKeys.value:
            return .element
        default:
            return .attribute
        }
    }}

extension Quantity: CreateEmpty {
    public nonisolated static func empty() -> Quantity {
        Quantity()
    }
}
