// 
// RailTransport.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct RailTransport: Codable, Sendable, Hashable  {
    public var trainID: SendableWrapper<Identifier>
    public var railCarID: SendableWrapper<Identifier>?

    public init(trainID: SendableWrapper<Identifier> = SendableWrapper(Identifier.empty()),
         railCarID: SendableWrapper<Identifier>? = nil) {
        self.trainID = trainID
        self.railCarID = railCarID
    }
    
    public enum CodingKeys: String, CodingKey {
        case trainID = "TrainID"
        case railCarID = "RailCarID"
    }
}

extension RailTransport: CreateEmpty {
    public nonisolated static func empty() -> RailTransport {
        RailTransport()
    }
}
