// 
// ReceiptLine.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct ReceiptLine: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>
    public var uuid: SendableWrapper<Identifier>?
    public var note: [SendableWrapper<Text>] // This array should have at least one element
    public var receivedQuantity: SendableWrapper<Quantity>?
    public var shortQuantity: SendableWrapper<Quantity>?
    public var shortageActionCode: SendableWrapper<Code>?
    public var rejectedQuantity: SendableWrapper<Quantity>?
    public var rejectReasonCode: SendableWrapper<Code>?
    public var rejectReason: [SendableWrapper<Text>] // This array should have at least one element
    public var rejectActionCode: SendableWrapper<Code>?
    public var quantityDiscrepancyCode: SendableWrapper<Code>?
    public var oversupplyQuantity: SendableWrapper<Quantity>?
    public var receivedDate: XMLDate?
    public var timingComplaintCode: SendableWrapper<Code>?
    public var timingComplaint: SendableWrapper<Text>?
    public var orderLineReference: SendableWrapper<OrderLineReference>?
    public var despatchLineReference: [SendableWrapper<LineReference>] // This array should have at least one element
    public var documentReference: [SendableWrapper<DocumentReference>] // This array should have at least one element
    public var item: [SendableWrapper<Item>] // This array should have at least one element
    public var shipment: [SendableWrapper<Shipment>] // This array should have at least one element

    public init(id: SendableWrapper<Identifier> = SendableWrapper(Identifier.empty()),
         uuid: SendableWrapper<Identifier>? = nil,
         note: [SendableWrapper<Text>] = [],
         receivedQuantity: SendableWrapper<Quantity>? = nil,
         shortQuantity: SendableWrapper<Quantity>? = nil,
         shortageActionCode: SendableWrapper<Code>? = nil,
         rejectedQuantity: SendableWrapper<Quantity>? = nil,
         rejectReasonCode: SendableWrapper<Code>? = nil,
         rejectReason: [SendableWrapper<Text>] = [],
         rejectActionCode: SendableWrapper<Code>? = nil,
         quantityDiscrepancyCode: SendableWrapper<Code>? = nil,
         oversupplyQuantity: SendableWrapper<Quantity>? = nil,
         receivedDate: XMLDate? = nil,
         timingComplaintCode: SendableWrapper<Code>? = nil,
         timingComplaint: SendableWrapper<Text>? = nil,
         orderLineReference: SendableWrapper<OrderLineReference>? = nil,
         despatchLineReference: [SendableWrapper<LineReference>] = [],
         documentReference: [SendableWrapper<DocumentReference>] = [],
         item: [SendableWrapper<Item>] = [],
         shipment: [SendableWrapper<Shipment>] = []) {
        self.id = id
        self.uuid = uuid
        self.note = note
        self.receivedQuantity = receivedQuantity
        self.shortQuantity = shortQuantity
        self.shortageActionCode = shortageActionCode
        self.rejectedQuantity = rejectedQuantity
        self.rejectReasonCode = rejectReasonCode
        self.rejectReason = rejectReason
        self.rejectActionCode = rejectActionCode
        self.quantityDiscrepancyCode = quantityDiscrepancyCode
        self.oversupplyQuantity = oversupplyQuantity
        self.receivedDate = receivedDate
        self.timingComplaintCode = timingComplaintCode
        self.timingComplaint = timingComplaint
        self.orderLineReference = orderLineReference
        self.despatchLineReference = despatchLineReference
        self.documentReference = documentReference
        self.item = item
        self.shipment = shipment
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case uuid = "UUID"
        case note = "Note"
        case receivedQuantity = "ReceivedQuantity"
        case shortQuantity = "ShortQuantity"
        case shortageActionCode = "ShortageActionCode"
        case rejectedQuantity = "RejectedQuantity"
        case rejectReasonCode = "RejectReasonCode"
        case rejectReason = "RejectReason"
        case rejectActionCode = "RejectActionCode"
        case quantityDiscrepancyCode = "QuantityDiscrepancyCode"
        case oversupplyQuantity = "OversupplyQuantity"
        case receivedDate = "ReceivedDate"
        case timingComplaintCode = "TimingComplaintCode"
        case timingComplaint = "TimingComplaint"
        case orderLineReference = "OrderLineReference"
        case despatchLineReference = "DespatchLineReference"
        case documentReference = "DocumentReference"
        case item = "Item"
        case shipment = "Shipment"
    }
}

extension ReceiptLine: CreateEmpty {
    public nonisolated static func empty() -> ReceiptLine {
        ReceiptLine()
    }
}
