// 
// ResultOfVerification.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct ResultOfVerification: Codable, Sendable, Hashable  {
    public var validatorID: SendableWrapper<Identifier>?
    public var validationResultCode: SendableWrapper<Code>?
    public var validationDate: XMLDate?
    public var validationTime: XMLDate?
    public var validateProcess: SendableWrapper<Text>?
    public var validateTool: SendableWrapper<Text>?
    public var validateToolVersion: SendableWrapper<Text>?
    public var signatoryParty: SendableWrapper<Party>?

    public init(validatorID: SendableWrapper<Identifier>? = nil,
         validationResultCode: SendableWrapper<Code>? = nil,
         validationDate: XMLDate? = nil,
         validationTime: XMLDate? = nil,
         validateProcess: SendableWrapper<Text>? = nil,
         validateTool: SendableWrapper<Text>? = nil,
         validateToolVersion: SendableWrapper<Text>? = nil,
         signatoryParty: SendableWrapper<Party>? = nil) {
        self.validatorID = validatorID
        self.validationResultCode = validationResultCode
        self.validationDate = validationDate
        self.validationTime = validationTime
        self.validateProcess = validateProcess
        self.validateTool = validateTool
        self.validateToolVersion = validateToolVersion
        self.signatoryParty = signatoryParty
    }
    
    public enum CodingKeys: String, CodingKey {
        case validatorID = "ValidatorID"
        case validationResultCode = "ValidationResultCode"
        case validationDate = "ValidationDate"
        case validationTime = "ValidationTime"
        case validateProcess = "ValidateProcess"
        case validateTool = "ValidateTool"
        case validateToolVersion = "ValidateToolVersion"
        case signatoryParty = "SignatoryParty"
    }
}

extension ResultOfVerification: CreateEmpty {
    public nonisolated static func empty() -> ResultOfVerification {
        ResultOfVerification()
    }
}
