// 
// SecondaryHazard.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct SecondaryHazard: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>?
    public var placardNotation: SendableWrapper<Text>?
    public var placardEndorsement: SendableWrapper<Text>?
    public var emergencyProceduresCode: SendableWrapper<Code>?
    public var extensionVar: [SendableWrapper<Text>] // This array should have at least one element

    public init(id: SendableWrapper<Identifier>? = nil,
         placardNotation: SendableWrapper<Text>? = nil,
         placardEndorsement: SendableWrapper<Text>? = nil,
         emergencyProceduresCode: SendableWrapper<Code>? = nil,
         extensionVar: [SendableWrapper<Text>] = []) {
        self.id = id
        self.placardNotation = placardNotation
        self.placardEndorsement = placardEndorsement
        self.emergencyProceduresCode = emergencyProceduresCode
        self.extensionVar = extensionVar
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case placardNotation = "PlacardNotation"
        case placardEndorsement = "PlacardEndorsement"
        case emergencyProceduresCode = "EmergencyProceduresCode"
        case extensionVar = "Extension"
    }
}

extension SecondaryHazard: CreateEmpty {
    public nonisolated static func empty() -> SecondaryHazard {
        SecondaryHazard()
    }
}
