// 
// ServiceProviderParty.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct ServiceProviderParty: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>?
    public var serviceTypeCode: SendableWrapper<Code>?
    public var serviceType: [SendableWrapper<Text>] // This array should have at least one element
    public var party: SendableWrapper<Party>
    public var sellerContact: SendableWrapper<Contact>?

    public init(id: SendableWrapper<Identifier>? = nil,
         serviceTypeCode: SendableWrapper<Code>? = nil,
         serviceType: [SendableWrapper<Text>] = [],
         party: SendableWrapper<Party> = SendableWrapper(Party.empty()),
         sellerContact: SendableWrapper<Contact>? = nil) {
        self.id = id
        self.serviceTypeCode = serviceTypeCode
        self.serviceType = serviceType
        self.party = party
        self.sellerContact = sellerContact
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case serviceTypeCode = "ServiceTypeCode"
        case serviceType = "ServiceType"
        case party = "Party"
        case sellerContact = "SellerContact"
    }
}

extension ServiceProviderParty: CreateEmpty {
    public nonisolated static func empty() -> ServiceProviderParty {
        ServiceProviderParty()
    }
}
