// 
// Shipment.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct Shipment: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>
    public var shippingPriorityLevelCode: SendableWrapper<Code>?
    public var handlingCode: SendableWrapper<Code>?
    public var handlingInstructions: [SendableWrapper<Text>] // This array should have at least one element
    public var information: [SendableWrapper<Text>] // This array should have at least one element
    public var grossWeightMeasure: SendableWrapper<Measure>?
    public var netWeightMeasure: SendableWrapper<Measure>?
    public var netNetWeightMeasure: SendableWrapper<Measure>?
    public var grossVolumeMeasure: SendableWrapper<Measure>?
    public var netVolumeMeasure: SendableWrapper<Measure>?
    public var totalGoodsItemQuantity: SendableWrapper<Quantity>?
    public var totalTransportHandlingUnitQuantity: SendableWrapper<Quantity>?
    public var insuranceValueAmount: SendableWrapper<Amount>?
    public var declaredCustomsValueAmount: SendableWrapper<Amount>?
    public var declaredForCarriageValueAmount: SendableWrapper<Amount>?
    public var declaredStatisticsValueAmount: SendableWrapper<Amount>?
    public var freeOnBoardValueAmount: SendableWrapper<Amount>?
    public var specialInstructions: [SendableWrapper<Text>] // This array should have at least one element
    public var deliveryInstructions: [SendableWrapper<Text>] // This array should have at least one element
    public var splitConsignmentIndicator: SendableWrapper<Indicator>?
    public var consignmentQuantity: SendableWrapper<Quantity>?
    public var consignment: [SendableWrapper<Consignment>] // This array should have at least one element
    public var goodsItem: [SendableWrapper<GoodsItem>] // This array should have at least one element
    public var shipmentStage: [SendableWrapper<ShipmentStage>] // This array should have at least one element
    public var delivery: SendableWrapper<Delivery>?
    public var transportHandlingUnit: [SendableWrapper<TransportHandlingUnit>] // This array should have at least one element
    public var returnAddress: SendableWrapper<Address>?
    public var originAddress: SendableWrapper<Address>?
    public var firstArrivalPortLocation: SendableWrapper<Location>?
    public var lastExitPortLocation: SendableWrapper<Location>?
    public var exportCountry: SendableWrapper<Country>?
    public var freightAllowanceCharge: [SendableWrapper<AllowanceCharge>] // This array should have at least one element

    public init(id: SendableWrapper<Identifier> = SendableWrapper(Identifier.empty()),
         shippingPriorityLevelCode: SendableWrapper<Code>? = nil,
         handlingCode: SendableWrapper<Code>? = nil,
         handlingInstructions: [SendableWrapper<Text>] = [],
         information: [SendableWrapper<Text>] = [],
         grossWeightMeasure: SendableWrapper<Measure>? = nil,
         netWeightMeasure: SendableWrapper<Measure>? = nil,
         netNetWeightMeasure: SendableWrapper<Measure>? = nil,
         grossVolumeMeasure: SendableWrapper<Measure>? = nil,
         netVolumeMeasure: SendableWrapper<Measure>? = nil,
         totalGoodsItemQuantity: SendableWrapper<Quantity>? = nil,
         totalTransportHandlingUnitQuantity: SendableWrapper<Quantity>? = nil,
         insuranceValueAmount: SendableWrapper<Amount>? = nil,
         declaredCustomsValueAmount: SendableWrapper<Amount>? = nil,
         declaredForCarriageValueAmount: SendableWrapper<Amount>? = nil,
         declaredStatisticsValueAmount: SendableWrapper<Amount>? = nil,
         freeOnBoardValueAmount: SendableWrapper<Amount>? = nil,
         specialInstructions: [SendableWrapper<Text>] = [],
         deliveryInstructions: [SendableWrapper<Text>] = [],
         splitConsignmentIndicator: SendableWrapper<Indicator>? = nil,
         consignmentQuantity: SendableWrapper<Quantity>? = nil,
         consignment: [SendableWrapper<Consignment>] = [],
         goodsItem: [SendableWrapper<GoodsItem>] = [],
         shipmentStage: [SendableWrapper<ShipmentStage>] = [],
         delivery: SendableWrapper<Delivery>? = nil,
         transportHandlingUnit: [SendableWrapper<TransportHandlingUnit>] = [],
         returnAddress: SendableWrapper<Address>? = nil,
         originAddress: SendableWrapper<Address>? = nil,
         firstArrivalPortLocation: SendableWrapper<Location>? = nil,
         lastExitPortLocation: SendableWrapper<Location>? = nil,
         exportCountry: SendableWrapper<Country>? = nil,
         freightAllowanceCharge: [SendableWrapper<AllowanceCharge>] = []) {
        self.id = id
        self.shippingPriorityLevelCode = shippingPriorityLevelCode
        self.handlingCode = handlingCode
        self.handlingInstructions = handlingInstructions
        self.information = information
        self.grossWeightMeasure = grossWeightMeasure
        self.netWeightMeasure = netWeightMeasure
        self.netNetWeightMeasure = netNetWeightMeasure
        self.grossVolumeMeasure = grossVolumeMeasure
        self.netVolumeMeasure = netVolumeMeasure
        self.totalGoodsItemQuantity = totalGoodsItemQuantity
        self.totalTransportHandlingUnitQuantity = totalTransportHandlingUnitQuantity
        self.insuranceValueAmount = insuranceValueAmount
        self.declaredCustomsValueAmount = declaredCustomsValueAmount
        self.declaredForCarriageValueAmount = declaredForCarriageValueAmount
        self.declaredStatisticsValueAmount = declaredStatisticsValueAmount
        self.freeOnBoardValueAmount = freeOnBoardValueAmount
        self.specialInstructions = specialInstructions
        self.deliveryInstructions = deliveryInstructions
        self.splitConsignmentIndicator = splitConsignmentIndicator
        self.consignmentQuantity = consignmentQuantity
        self.consignment = consignment
        self.goodsItem = goodsItem
        self.shipmentStage = shipmentStage
        self.delivery = delivery
        self.transportHandlingUnit = transportHandlingUnit
        self.returnAddress = returnAddress
        self.originAddress = originAddress
        self.firstArrivalPortLocation = firstArrivalPortLocation
        self.lastExitPortLocation = lastExitPortLocation
        self.exportCountry = exportCountry
        self.freightAllowanceCharge = freightAllowanceCharge
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case shippingPriorityLevelCode = "ShippingPriorityLevelCode"
        case handlingCode = "HandlingCode"
        case handlingInstructions = "HandlingInstructions"
        case information = "Information"
        case grossWeightMeasure = "GrossWeightMeasure"
        case netWeightMeasure = "NetWeightMeasure"
        case netNetWeightMeasure = "NetNetWeightMeasure"
        case grossVolumeMeasure = "GrossVolumeMeasure"
        case netVolumeMeasure = "NetVolumeMeasure"
        case totalGoodsItemQuantity = "TotalGoodsItemQuantity"
        case totalTransportHandlingUnitQuantity = "TotalTransportHandlingUnitQuantity"
        case insuranceValueAmount = "InsuranceValueAmount"
        case declaredCustomsValueAmount = "DeclaredCustomsValueAmount"
        case declaredForCarriageValueAmount = "DeclaredForCarriageValueAmount"
        case declaredStatisticsValueAmount = "DeclaredStatisticsValueAmount"
        case freeOnBoardValueAmount = "FreeOnBoardValueAmount"
        case specialInstructions = "SpecialInstructions"
        case deliveryInstructions = "DeliveryInstructions"
        case splitConsignmentIndicator = "SplitConsignmentIndicator"
        case consignmentQuantity = "ConsignmentQuantity"
        case consignment = "Consignment"
        case goodsItem = "GoodsItem"
        case shipmentStage = "ShipmentStage"
        case delivery = "Delivery"
        case transportHandlingUnit = "TransportHandlingUnit"
        case returnAddress = "ReturnAddress"
        case originAddress = "OriginAddress"
        case firstArrivalPortLocation = "FirstArrivalPortLocation"
        case lastExitPortLocation = "LastExitPortLocation"
        case exportCountry = "ExportCountry"
        case freightAllowanceCharge = "FreightAllowanceCharge"
    }
}

extension Shipment: CreateEmpty {
    public nonisolated static func empty() -> Shipment {
        Shipment()
    }
}
