// 
// ShipmentStage.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct ShipmentStage: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>?
    public var transportModeCode: SendableWrapper<Code>?
    public var transportMeansTypeCode: SendableWrapper<Code>?
    public var transitDirectionCode: SendableWrapper<Code>?
    public var preCarriageIndicator: SendableWrapper<Indicator>?
    public var onCarriageIndicator: SendableWrapper<Indicator>?
    public var estimatedDeliveryDate: XMLDate?
    public var estimatedDeliveryTime: XMLDate?
    public var requiredDeliveryDate: XMLDate?
    public var requiredDeliveryTime: XMLDate?
    public var loadingSequenceID: SendableWrapper<Identifier>?
    public var successiveSequenceID: SendableWrapper<Identifier>?
    public var instructions: [SendableWrapper<Text>] // This array should have at least one element
    public var demurrageInstructions: [SendableWrapper<Text>] // This array should have at least one element
    public var crewQuantity: SendableWrapper<Quantity>?
    public var passengerQuantity: SendableWrapper<Quantity>?
    public var transitPeriod: SendableWrapper<Period>?
    public var carrierParty: [SendableWrapper<Party>] // This array should have at least one element
    public var transportMeans: SendableWrapper<TransportMeans>?
    public var loadingPortLocation: SendableWrapper<Location>?
    public var unloadingPortLocation: SendableWrapper<Location>?
    public var transshipPortLocation: SendableWrapper<Location>?
    public var loadingTransportEvent: SendableWrapper<TransportEvent>?
    public var examinationTransportEvent: SendableWrapper<TransportEvent>?
    public var availabilityTransportEvent: SendableWrapper<TransportEvent>?
    public var exportationTransportEvent: SendableWrapper<TransportEvent>?
    public var dischargeTransportEvent: SendableWrapper<TransportEvent>?
    public var warehousingTransportEvent: SendableWrapper<TransportEvent>?
    public var takeoverTransportEvent: SendableWrapper<TransportEvent>?
    public var optionalTakeoverTransportEvent: SendableWrapper<TransportEvent>?
    public var dropoffTransportEvent: SendableWrapper<TransportEvent>?
    public var actualPickupTransportEvent: SendableWrapper<TransportEvent>?
    public var deliveryTransportEvent: SendableWrapper<TransportEvent>?
    public var receiptTransportEvent: SendableWrapper<TransportEvent>?
    public var storageTransportEvent: SendableWrapper<TransportEvent>?
    public var acceptanceTransportEvent: SendableWrapper<TransportEvent>?
    public var terminalOperatorParty: SendableWrapper<Party>?
    public var customsAgentParty: SendableWrapper<Party>?
    public var estimatedTransitPeriod: SendableWrapper<Period>?
    public var freightAllowanceCharge: [SendableWrapper<AllowanceCharge>] // This array should have at least one element
    public var freightChargeLocation: SendableWrapper<Location>?
    public var detentionTransportEvent: [SendableWrapper<TransportEvent>] // This array should have at least one element
    public var requestedDepartureTransportEvent: SendableWrapper<TransportEvent>?
    public var requestedArrivalTransportEvent: SendableWrapper<TransportEvent>?
    public var requestedWaypointTransportEvent: [SendableWrapper<TransportEvent>] // This array should have at least one element
    public var plannedDepartureTransportEvent: SendableWrapper<TransportEvent>?
    public var plannedArrivalTransportEvent: SendableWrapper<TransportEvent>?
    public var plannedWaypointTransportEvent: [SendableWrapper<TransportEvent>] // This array should have at least one element
    public var actualDepartureTransportEvent: SendableWrapper<TransportEvent>?
    public var actualWaypointTransportEvent: SendableWrapper<TransportEvent>?
    public var actualArrivalTransportEvent: SendableWrapper<TransportEvent>?
    public var transportEvent: [SendableWrapper<TransportEvent>] // This array should have at least one element
    public var estimatedDepartureTransportEvent: SendableWrapper<TransportEvent>?
    public var estimatedArrivalTransportEvent: SendableWrapper<TransportEvent>?
    public var passengerPerson: [SendableWrapper<Person>] // This array should have at least one element
    public var driverPerson: [SendableWrapper<Person>] // This array should have at least one element
    public var reportingPerson: SendableWrapper<Person>?
    public var crewMemberPerson: [SendableWrapper<Person>] // This array should have at least one element
    public var securityOfficerPerson: SendableWrapper<Person>?
    public var masterPerson: SendableWrapper<Person>?
    public var shipsSurgeonPerson: SendableWrapper<Person>?

    public init(id: SendableWrapper<Identifier>? = nil,
         transportModeCode: SendableWrapper<Code>? = nil,
         transportMeansTypeCode: SendableWrapper<Code>? = nil,
         transitDirectionCode: SendableWrapper<Code>? = nil,
         preCarriageIndicator: SendableWrapper<Indicator>? = nil,
         onCarriageIndicator: SendableWrapper<Indicator>? = nil,
         estimatedDeliveryDate: XMLDate? = nil,
         estimatedDeliveryTime: XMLDate? = nil,
         requiredDeliveryDate: XMLDate? = nil,
         requiredDeliveryTime: XMLDate? = nil,
         loadingSequenceID: SendableWrapper<Identifier>? = nil,
         successiveSequenceID: SendableWrapper<Identifier>? = nil,
         instructions: [SendableWrapper<Text>] = [],
         demurrageInstructions: [SendableWrapper<Text>] = [],
         crewQuantity: SendableWrapper<Quantity>? = nil,
         passengerQuantity: SendableWrapper<Quantity>? = nil,
         transitPeriod: SendableWrapper<Period>? = nil,
         carrierParty: [SendableWrapper<Party>] = [],
         transportMeans: SendableWrapper<TransportMeans>? = nil,
         loadingPortLocation: SendableWrapper<Location>? = nil,
         unloadingPortLocation: SendableWrapper<Location>? = nil,
         transshipPortLocation: SendableWrapper<Location>? = nil,
         loadingTransportEvent: SendableWrapper<TransportEvent>? = nil,
         examinationTransportEvent: SendableWrapper<TransportEvent>? = nil,
         availabilityTransportEvent: SendableWrapper<TransportEvent>? = nil,
         exportationTransportEvent: SendableWrapper<TransportEvent>? = nil,
         dischargeTransportEvent: SendableWrapper<TransportEvent>? = nil,
         warehousingTransportEvent: SendableWrapper<TransportEvent>? = nil,
         takeoverTransportEvent: SendableWrapper<TransportEvent>? = nil,
         optionalTakeoverTransportEvent: SendableWrapper<TransportEvent>? = nil,
         dropoffTransportEvent: SendableWrapper<TransportEvent>? = nil,
         actualPickupTransportEvent: SendableWrapper<TransportEvent>? = nil,
         deliveryTransportEvent: SendableWrapper<TransportEvent>? = nil,
         receiptTransportEvent: SendableWrapper<TransportEvent>? = nil,
         storageTransportEvent: SendableWrapper<TransportEvent>? = nil,
         acceptanceTransportEvent: SendableWrapper<TransportEvent>? = nil,
         terminalOperatorParty: SendableWrapper<Party>? = nil,
         customsAgentParty: SendableWrapper<Party>? = nil,
         estimatedTransitPeriod: SendableWrapper<Period>? = nil,
         freightAllowanceCharge: [SendableWrapper<AllowanceCharge>] = [],
         freightChargeLocation: SendableWrapper<Location>? = nil,
         detentionTransportEvent: [SendableWrapper<TransportEvent>] = [],
         requestedDepartureTransportEvent: SendableWrapper<TransportEvent>? = nil,
         requestedArrivalTransportEvent: SendableWrapper<TransportEvent>? = nil,
         requestedWaypointTransportEvent: [SendableWrapper<TransportEvent>] = [],
         plannedDepartureTransportEvent: SendableWrapper<TransportEvent>? = nil,
         plannedArrivalTransportEvent: SendableWrapper<TransportEvent>? = nil,
         plannedWaypointTransportEvent: [SendableWrapper<TransportEvent>] = [],
         actualDepartureTransportEvent: SendableWrapper<TransportEvent>? = nil,
         actualWaypointTransportEvent: SendableWrapper<TransportEvent>? = nil,
         actualArrivalTransportEvent: SendableWrapper<TransportEvent>? = nil,
         transportEvent: [SendableWrapper<TransportEvent>] = [],
         estimatedDepartureTransportEvent: SendableWrapper<TransportEvent>? = nil,
         estimatedArrivalTransportEvent: SendableWrapper<TransportEvent>? = nil,
         passengerPerson: [SendableWrapper<Person>] = [],
         driverPerson: [SendableWrapper<Person>] = [],
         reportingPerson: SendableWrapper<Person>? = nil,
         crewMemberPerson: [SendableWrapper<Person>] = [],
         securityOfficerPerson: SendableWrapper<Person>? = nil,
         masterPerson: SendableWrapper<Person>? = nil,
         shipsSurgeonPerson: SendableWrapper<Person>? = nil) {
        self.id = id
        self.transportModeCode = transportModeCode
        self.transportMeansTypeCode = transportMeansTypeCode
        self.transitDirectionCode = transitDirectionCode
        self.preCarriageIndicator = preCarriageIndicator
        self.onCarriageIndicator = onCarriageIndicator
        self.estimatedDeliveryDate = estimatedDeliveryDate
        self.estimatedDeliveryTime = estimatedDeliveryTime
        self.requiredDeliveryDate = requiredDeliveryDate
        self.requiredDeliveryTime = requiredDeliveryTime
        self.loadingSequenceID = loadingSequenceID
        self.successiveSequenceID = successiveSequenceID
        self.instructions = instructions
        self.demurrageInstructions = demurrageInstructions
        self.crewQuantity = crewQuantity
        self.passengerQuantity = passengerQuantity
        self.transitPeriod = transitPeriod
        self.carrierParty = carrierParty
        self.transportMeans = transportMeans
        self.loadingPortLocation = loadingPortLocation
        self.unloadingPortLocation = unloadingPortLocation
        self.transshipPortLocation = transshipPortLocation
        self.loadingTransportEvent = loadingTransportEvent
        self.examinationTransportEvent = examinationTransportEvent
        self.availabilityTransportEvent = availabilityTransportEvent
        self.exportationTransportEvent = exportationTransportEvent
        self.dischargeTransportEvent = dischargeTransportEvent
        self.warehousingTransportEvent = warehousingTransportEvent
        self.takeoverTransportEvent = takeoverTransportEvent
        self.optionalTakeoverTransportEvent = optionalTakeoverTransportEvent
        self.dropoffTransportEvent = dropoffTransportEvent
        self.actualPickupTransportEvent = actualPickupTransportEvent
        self.deliveryTransportEvent = deliveryTransportEvent
        self.receiptTransportEvent = receiptTransportEvent
        self.storageTransportEvent = storageTransportEvent
        self.acceptanceTransportEvent = acceptanceTransportEvent
        self.terminalOperatorParty = terminalOperatorParty
        self.customsAgentParty = customsAgentParty
        self.estimatedTransitPeriod = estimatedTransitPeriod
        self.freightAllowanceCharge = freightAllowanceCharge
        self.freightChargeLocation = freightChargeLocation
        self.detentionTransportEvent = detentionTransportEvent
        self.requestedDepartureTransportEvent = requestedDepartureTransportEvent
        self.requestedArrivalTransportEvent = requestedArrivalTransportEvent
        self.requestedWaypointTransportEvent = requestedWaypointTransportEvent
        self.plannedDepartureTransportEvent = plannedDepartureTransportEvent
        self.plannedArrivalTransportEvent = plannedArrivalTransportEvent
        self.plannedWaypointTransportEvent = plannedWaypointTransportEvent
        self.actualDepartureTransportEvent = actualDepartureTransportEvent
        self.actualWaypointTransportEvent = actualWaypointTransportEvent
        self.actualArrivalTransportEvent = actualArrivalTransportEvent
        self.transportEvent = transportEvent
        self.estimatedDepartureTransportEvent = estimatedDepartureTransportEvent
        self.estimatedArrivalTransportEvent = estimatedArrivalTransportEvent
        self.passengerPerson = passengerPerson
        self.driverPerson = driverPerson
        self.reportingPerson = reportingPerson
        self.crewMemberPerson = crewMemberPerson
        self.securityOfficerPerson = securityOfficerPerson
        self.masterPerson = masterPerson
        self.shipsSurgeonPerson = shipsSurgeonPerson
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case transportModeCode = "TransportModeCode"
        case transportMeansTypeCode = "TransportMeansTypeCode"
        case transitDirectionCode = "TransitDirectionCode"
        case preCarriageIndicator = "PreCarriageIndicator"
        case onCarriageIndicator = "OnCarriageIndicator"
        case estimatedDeliveryDate = "EstimatedDeliveryDate"
        case estimatedDeliveryTime = "EstimatedDeliveryTime"
        case requiredDeliveryDate = "RequiredDeliveryDate"
        case requiredDeliveryTime = "RequiredDeliveryTime"
        case loadingSequenceID = "LoadingSequenceID"
        case successiveSequenceID = "SuccessiveSequenceID"
        case instructions = "Instructions"
        case demurrageInstructions = "DemurrageInstructions"
        case crewQuantity = "CrewQuantity"
        case passengerQuantity = "PassengerQuantity"
        case transitPeriod = "TransitPeriod"
        case carrierParty = "CarrierParty"
        case transportMeans = "TransportMeans"
        case loadingPortLocation = "LoadingPortLocation"
        case unloadingPortLocation = "UnloadingPortLocation"
        case transshipPortLocation = "TransshipPortLocation"
        case loadingTransportEvent = "LoadingTransportEvent"
        case examinationTransportEvent = "ExaminationTransportEvent"
        case availabilityTransportEvent = "AvailabilityTransportEvent"
        case exportationTransportEvent = "ExportationTransportEvent"
        case dischargeTransportEvent = "DischargeTransportEvent"
        case warehousingTransportEvent = "WarehousingTransportEvent"
        case takeoverTransportEvent = "TakeoverTransportEvent"
        case optionalTakeoverTransportEvent = "OptionalTakeoverTransportEvent"
        case dropoffTransportEvent = "DropoffTransportEvent"
        case actualPickupTransportEvent = "ActualPickupTransportEvent"
        case deliveryTransportEvent = "DeliveryTransportEvent"
        case receiptTransportEvent = "ReceiptTransportEvent"
        case storageTransportEvent = "StorageTransportEvent"
        case acceptanceTransportEvent = "AcceptanceTransportEvent"
        case terminalOperatorParty = "TerminalOperatorParty"
        case customsAgentParty = "CustomsAgentParty"
        case estimatedTransitPeriod = "EstimatedTransitPeriod"
        case freightAllowanceCharge = "FreightAllowanceCharge"
        case freightChargeLocation = "FreightChargeLocation"
        case detentionTransportEvent = "DetentionTransportEvent"
        case requestedDepartureTransportEvent = "RequestedDepartureTransportEvent"
        case requestedArrivalTransportEvent = "RequestedArrivalTransportEvent"
        case requestedWaypointTransportEvent = "RequestedWaypointTransportEvent"
        case plannedDepartureTransportEvent = "PlannedDepartureTransportEvent"
        case plannedArrivalTransportEvent = "PlannedArrivalTransportEvent"
        case plannedWaypointTransportEvent = "PlannedWaypointTransportEvent"
        case actualDepartureTransportEvent = "ActualDepartureTransportEvent"
        case actualWaypointTransportEvent = "ActualWaypointTransportEvent"
        case actualArrivalTransportEvent = "ActualArrivalTransportEvent"
        case transportEvent = "TransportEvent"
        case estimatedDepartureTransportEvent = "EstimatedDepartureTransportEvent"
        case estimatedArrivalTransportEvent = "EstimatedArrivalTransportEvent"
        case passengerPerson = "PassengerPerson"
        case driverPerson = "DriverPerson"
        case reportingPerson = "ReportingPerson"
        case crewMemberPerson = "CrewMemberPerson"
        case securityOfficerPerson = "SecurityOfficerPerson"
        case masterPerson = "MasterPerson"
        case shipsSurgeonPerson = "ShipsSurgeonPerson"
    }
}

extension ShipmentStage: CreateEmpty {
    public nonisolated static func empty() -> ShipmentStage {
        ShipmentStage()
    }
}
