// 
// Signature.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct Signature: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>
    public var note: [SendableWrapper<Text>] // This array should have at least one element
    public var validationDate: XMLDate?
    public var validationTime: XMLDate?
    public var validatorID: SendableWrapper<Identifier>?
    public var canonicalizationMethod: SendableWrapper<Text>?
    public var signatureMethod: SendableWrapper<Text>?
    public var signatoryParty: SendableWrapper<Party>?
    public var digitalSignatureAttachment: SendableWrapper<Attachment>?
    public var originalDocumentReference: SendableWrapper<DocumentReference>?

    public init(id: SendableWrapper<Identifier> = SendableWrapper(Identifier.empty()),
         note: [SendableWrapper<Text>] = [],
         validationDate: XMLDate? = nil,
         validationTime: XMLDate? = nil,
         validatorID: SendableWrapper<Identifier>? = nil,
         canonicalizationMethod: SendableWrapper<Text>? = nil,
         signatureMethod: SendableWrapper<Text>? = nil,
         signatoryParty: SendableWrapper<Party>? = nil,
         digitalSignatureAttachment: SendableWrapper<Attachment>? = nil,
         originalDocumentReference: SendableWrapper<DocumentReference>? = nil) {
        self.id = id
        self.note = note
        self.validationDate = validationDate
        self.validationTime = validationTime
        self.validatorID = validatorID
        self.canonicalizationMethod = canonicalizationMethod
        self.signatureMethod = signatureMethod
        self.signatoryParty = signatoryParty
        self.digitalSignatureAttachment = digitalSignatureAttachment
        self.originalDocumentReference = originalDocumentReference
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case note = "Note"
        case validationDate = "ValidationDate"
        case validationTime = "ValidationTime"
        case validatorID = "ValidatorID"
        case canonicalizationMethod = "CanonicalizationMethod"
        case signatureMethod = "SignatureMethod"
        case signatoryParty = "SignatoryParty"
        case digitalSignatureAttachment = "DigitalSignatureAttachment"
        case originalDocumentReference = "OriginalDocumentReference"
    }
}

extension Signature: CreateEmpty {
    public nonisolated static func empty() -> Signature {
        Signature()
    }
}
