// 
// Status.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct Status: Codable, Sendable, Hashable  {
    public var conditionCode: SendableWrapper<Code>?
    public var referenceDate: XMLDate?
    public var referenceTime: XMLDate?
    public var description: [SendableWrapper<Text>] // This array should have at least one element
    public var statusReasonCode: SendableWrapper<Code>?
    public var statusReason: [SendableWrapper<Text>] // This array should have at least one element
    public var sequenceID: SendableWrapper<Identifier>?
    public var text: [SendableWrapper<Text>] // This array should have at least one element
    public var indicationIndicator: SendableWrapper<Indicator>?
    public var percent: SendableWrapper<Numeric>?
    public var reliabilityPercent: SendableWrapper<Numeric>?
    public var condition: [SendableWrapper<Condition>] // This array should have at least one element

    public init(conditionCode: SendableWrapper<Code>? = nil,
         referenceDate: XMLDate? = nil,
         referenceTime: XMLDate? = nil,
         description: [SendableWrapper<Text>] = [],
         statusReasonCode: SendableWrapper<Code>? = nil,
         statusReason: [SendableWrapper<Text>] = [],
         sequenceID: SendableWrapper<Identifier>? = nil,
         text: [SendableWrapper<Text>] = [],
         indicationIndicator: SendableWrapper<Indicator>? = nil,
         percent: SendableWrapper<Numeric>? = nil,
         reliabilityPercent: SendableWrapper<Numeric>? = nil,
         condition: [SendableWrapper<Condition>] = []) {
        self.conditionCode = conditionCode
        self.referenceDate = referenceDate
        self.referenceTime = referenceTime
        self.description = description
        self.statusReasonCode = statusReasonCode
        self.statusReason = statusReason
        self.sequenceID = sequenceID
        self.text = text
        self.indicationIndicator = indicationIndicator
        self.percent = percent
        self.reliabilityPercent = reliabilityPercent
        self.condition = condition
    }
    
    public enum CodingKeys: String, CodingKey {
        case conditionCode = "ConditionCode"
        case referenceDate = "ReferenceDate"
        case referenceTime = "ReferenceTime"
        case description = "Description"
        case statusReasonCode = "StatusReasonCode"
        case statusReason = "StatusReason"
        case sequenceID = "SequenceID"
        case text = "Text"
        case indicationIndicator = "IndicationIndicator"
        case percent = "Percent"
        case reliabilityPercent = "ReliabilityPercent"
        case condition = "Condition"
    }
}

extension Status: CreateEmpty {
    public nonisolated static func empty() -> Status {
        Status()
    }
}
