// 
// Stowage.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct Stowage: Codable, Sendable, Hashable  {
    public var locationID: SendableWrapper<Identifier>?
    public var location: [SendableWrapper<Location>] // This array should have at least one element
    public var measurementDimension: [SendableWrapper<Dimension>] // This array should have at least one element

    public init(locationID: SendableWrapper<Identifier>? = nil,
         location: [SendableWrapper<Location>] = [],
         measurementDimension: [SendableWrapper<Dimension>] = []) {
        self.locationID = locationID
        self.location = location
        self.measurementDimension = measurementDimension
    }
    
    public enum CodingKeys: String, CodingKey {
        case locationID = "LocationID"
        case location = "Location"
        case measurementDimension = "MeasurementDimension"
    }
}

extension Stowage: CreateEmpty {
    public nonisolated static func empty() -> Stowage {
        Stowage()
    }
}
