// 
// SupplierParty.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct SupplierParty: Codable, Sendable, Hashable  {
    public var customerAssignedAccountID: SendableWrapper<Identifier>?
    public var additionalAccountID: [SendableWrapper<Identifier>] // This array should have at least one element
    public var dataSendingCapability: SendableWrapper<Text>?
    public var party: SendableWrapper<Party>?
    public var despatchContact: SendableWrapper<Contact>?
    public var accountingContact: SendableWrapper<Contact>?
    public var sellerContact: SendableWrapper<Contact>?

    public init(customerAssignedAccountID: SendableWrapper<Identifier>? = nil,
         additionalAccountID: [SendableWrapper<Identifier>] = [],
         dataSendingCapability: SendableWrapper<Text>? = nil,
         party: SendableWrapper<Party>? = nil,
         despatchContact: SendableWrapper<Contact>? = nil,
         accountingContact: SendableWrapper<Contact>? = nil,
         sellerContact: SendableWrapper<Contact>? = nil) {
        self.customerAssignedAccountID = customerAssignedAccountID
        self.additionalAccountID = additionalAccountID
        self.dataSendingCapability = dataSendingCapability
        self.party = party
        self.despatchContact = despatchContact
        self.accountingContact = accountingContact
        self.sellerContact = sellerContact
    }
    
    public enum CodingKeys: String, CodingKey {
        case customerAssignedAccountID = "CustomerAssignedAccountID"
        case additionalAccountID = "AdditionalAccountID"
        case dataSendingCapability = "DataSendingCapability"
        case party = "Party"
        case despatchContact = "DespatchContact"
        case accountingContact = "AccountingContact"
        case sellerContact = "SellerContact"
    }
}

extension SupplierParty: CreateEmpty {
    public nonisolated static func empty() -> SupplierParty {
        SupplierParty()
    }
}
