// 
// TaxCategory.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct TaxCategory: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>?
    public var name: SendableWrapper<Text>?
    public var percent: SendableWrapper<Numeric>?
    public var baseUnitMeasure: SendableWrapper<Measure>?
    public var perUnitAmount: SendableWrapper<Amount>?
    public var taxExemptionReasonCode: SendableWrapper<Code>?
    public var taxExemptionReason: [SendableWrapper<Text>] // This array should have at least one element
    public var tierRange: SendableWrapper<Text>?
    public var tierRatePercent: SendableWrapper<Numeric>?
    public var taxScheme: SendableWrapper<TaxScheme>

    public init(id: SendableWrapper<Identifier>? = nil,
         name: SendableWrapper<Text>? = nil,
         percent: SendableWrapper<Numeric>? = nil,
         baseUnitMeasure: SendableWrapper<Measure>? = nil,
         perUnitAmount: SendableWrapper<Amount>? = nil,
         taxExemptionReasonCode: SendableWrapper<Code>? = nil,
         taxExemptionReason: [SendableWrapper<Text>] = [],
         tierRange: SendableWrapper<Text>? = nil,
         tierRatePercent: SendableWrapper<Numeric>? = nil,
         taxScheme: SendableWrapper<TaxScheme> = SendableWrapper(TaxScheme.empty())) {
        self.id = id
        self.name = name
        self.percent = percent
        self.baseUnitMeasure = baseUnitMeasure
        self.perUnitAmount = perUnitAmount
        self.taxExemptionReasonCode = taxExemptionReasonCode
        self.taxExemptionReason = taxExemptionReason
        self.tierRange = tierRange
        self.tierRatePercent = tierRatePercent
        self.taxScheme = taxScheme
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case name = "Name"
        case percent = "Percent"
        case baseUnitMeasure = "BaseUnitMeasure"
        case perUnitAmount = "PerUnitAmount"
        case taxExemptionReasonCode = "TaxExemptionReasonCode"
        case taxExemptionReason = "TaxExemptionReason"
        case tierRange = "TierRange"
        case tierRatePercent = "TierRatePercent"
        case taxScheme = "TaxScheme"
    }
}

extension TaxCategory: CreateEmpty {
    public nonisolated static func empty() -> TaxCategory {
        TaxCategory()
    }
}
