// 
// TaxScheme.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct TaxScheme: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>?
    public var name: SendableWrapper<Text>?
    public var taxTypeCode: SendableWrapper<Code>?
    public var currencyCode: SendableWrapper<Code>?
    public var jurisdictionRegionAddress: [SendableWrapper<Address>] // This array should have at least one element

    public init(id: SendableWrapper<Identifier>? = nil,
         name: SendableWrapper<Text>? = nil,
         taxTypeCode: SendableWrapper<Code>? = nil,
         currencyCode: SendableWrapper<Code>? = nil,
         jurisdictionRegionAddress: [SendableWrapper<Address>] = []) {
        self.id = id
        self.name = name
        self.taxTypeCode = taxTypeCode
        self.currencyCode = currencyCode
        self.jurisdictionRegionAddress = jurisdictionRegionAddress
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case name = "Name"
        case taxTypeCode = "TaxTypeCode"
        case currencyCode = "CurrencyCode"
        case jurisdictionRegionAddress = "JurisdictionRegionAddress"
    }
}

extension TaxScheme: CreateEmpty {
    public nonisolated static func empty() -> TaxScheme {
        TaxScheme()
    }
}
