// 
// TaxSubtotal.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct TaxSubtotal: Codable, Sendable, Hashable  {
    public var taxableAmount: SendableWrapper<Amount>?
    public var taxAmount: SendableWrapper<Amount>
    public var calculationSequenceNumeric: SendableWrapper<Numeric>?
    public var transactionCurrencyTaxAmount: SendableWrapper<Amount>?
    public var percent: SendableWrapper<Numeric>?
    public var baseUnitMeasure: SendableWrapper<Measure>?
    public var perUnitAmount: SendableWrapper<Amount>?
    public var tierRange: SendableWrapper<Text>?
    public var tierRatePercent: SendableWrapper<Numeric>?
    public var taxCategory: SendableWrapper<TaxCategory>

    public init(taxableAmount: SendableWrapper<Amount>? = nil,
         taxAmount: SendableWrapper<Amount> = SendableWrapper(Amount.empty()),
         calculationSequenceNumeric: SendableWrapper<Numeric>? = nil,
         transactionCurrencyTaxAmount: SendableWrapper<Amount>? = nil,
         percent: SendableWrapper<Numeric>? = nil,
         baseUnitMeasure: SendableWrapper<Measure>? = nil,
         perUnitAmount: SendableWrapper<Amount>? = nil,
         tierRange: SendableWrapper<Text>? = nil,
         tierRatePercent: SendableWrapper<Numeric>? = nil,
         taxCategory: SendableWrapper<TaxCategory> = SendableWrapper(TaxCategory.empty())) {
        self.taxableAmount = taxableAmount
        self.taxAmount = taxAmount
        self.calculationSequenceNumeric = calculationSequenceNumeric
        self.transactionCurrencyTaxAmount = transactionCurrencyTaxAmount
        self.percent = percent
        self.baseUnitMeasure = baseUnitMeasure
        self.perUnitAmount = perUnitAmount
        self.tierRange = tierRange
        self.tierRatePercent = tierRatePercent
        self.taxCategory = taxCategory
    }
    
    public enum CodingKeys: String, CodingKey {
        case taxableAmount = "TaxableAmount"
        case taxAmount = "TaxAmount"
        case calculationSequenceNumeric = "CalculationSequenceNumeric"
        case transactionCurrencyTaxAmount = "TransactionCurrencyTaxAmount"
        case percent = "Percent"
        case baseUnitMeasure = "BaseUnitMeasure"
        case perUnitAmount = "PerUnitAmount"
        case tierRange = "TierRange"
        case tierRatePercent = "TierRatePercent"
        case taxCategory = "TaxCategory"
    }
}

extension TaxSubtotal: CreateEmpty {
    public nonisolated static func empty() -> TaxSubtotal {
        TaxSubtotal()
    }
}
