// 
// TaxTotal.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct TaxTotal: Codable, Sendable, Hashable  {
    public var taxAmount: SendableWrapper<Amount>
    public var roundingAmount: SendableWrapper<Amount>?
    public var taxEvidenceIndicator: SendableWrapper<Indicator>?
    public var taxIncludedIndicator: SendableWrapper<Indicator>?
    public var taxSubtotal: [SendableWrapper<TaxSubtotal>] // This array should have at least one element

    public init(taxAmount: SendableWrapper<Amount> = SendableWrapper(Amount.empty()),
         roundingAmount: SendableWrapper<Amount>? = nil,
         taxEvidenceIndicator: SendableWrapper<Indicator>? = nil,
         taxIncludedIndicator: SendableWrapper<Indicator>? = nil,
         taxSubtotal: [SendableWrapper<TaxSubtotal>] = []) {
        self.taxAmount = taxAmount
        self.roundingAmount = roundingAmount
        self.taxEvidenceIndicator = taxEvidenceIndicator
        self.taxIncludedIndicator = taxIncludedIndicator
        self.taxSubtotal = taxSubtotal
    }
    
    public enum CodingKeys: String, CodingKey {
        case taxAmount = "TaxAmount"
        case roundingAmount = "RoundingAmount"
        case taxEvidenceIndicator = "TaxEvidenceIndicator"
        case taxIncludedIndicator = "TaxIncludedIndicator"
        case taxSubtotal = "TaxSubtotal"
    }
}

extension TaxTotal: CreateEmpty {
    public nonisolated static func empty() -> TaxTotal {
        TaxTotal()
    }
}
