// 
// Temperature.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct Temperature: Codable, Sendable, Hashable  {
    public var attributeID: SendableWrapper<Identifier>
    public var measure: SendableWrapper<Measure>
    public var description: [SendableWrapper<Text>] // This array should have at least one element

    public init(attributeID: SendableWrapper<Identifier> = SendableWrapper(Identifier.empty()),
         measure: SendableWrapper<Measure> = SendableWrapper(Measure.empty()),
         description: [SendableWrapper<Text>] = []) {
        self.attributeID = attributeID
        self.measure = measure
        self.description = description
    }
    
    public enum CodingKeys: String, CodingKey {
        case attributeID = "AttributeID"
        case measure = "Measure"
        case description = "Description"
    }
}

extension Temperature: CreateEmpty {
    public nonisolated static func empty() -> Temperature {
        Temperature()
    }
}
