// 
// Text.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct Text: Codable, Sendable, Hashable , DynamicNodeEncoding, DynamicNodeDecoding {
    public var value: String
    public var languageID: String?
    public var languageLocaleID: String?

    public init(value: String = "",
         languageID: String? = nil,
         languageLocaleID: String? = nil) {
        self.value = value
        self.languageID = languageID
        self.languageLocaleID = languageLocaleID
    }
    
    public enum CodingKeys: String, CodingKey {
        case value = ""
        case languageID = "languageID"
        case languageLocaleID = "languageLocaleID"
    }

    nonisolated public static func nodeEncoding(for key: CodingKey) -> XMLEncoder.NodeEncoding {
        switch key {
        case CodingKeys.value:
           return .element
        default:
            return .attribute
        }
    }
    
    nonisolated public static func nodeDecoding(for key: CodingKey) -> XMLDecoder.NodeDecoding {
        switch key {
        case CodingKeys.value:
            return .element
        default:
            return .attribute
        }
    }}

extension Text: CreateEmpty {
    public nonisolated static func empty() -> Text {
        Text()
    }
}
