// 
// TradeFinancing.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct TradeFinancing: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>?
    public var financingInstrumentCode: SendableWrapper<Code>?
    public var contractDocumentReference: SendableWrapper<DocumentReference>?
    public var documentReference: [SendableWrapper<DocumentReference>] // This array should have at least one element
    public var financingParty: SendableWrapper<Party>
    public var financingFinancialAccount: SendableWrapper<FinancialAccount>?
    public var clause: [SendableWrapper<Clause>] // This array should have at least one element

    public init(id: SendableWrapper<Identifier>? = nil,
         financingInstrumentCode: SendableWrapper<Code>? = nil,
         contractDocumentReference: SendableWrapper<DocumentReference>? = nil,
         documentReference: [SendableWrapper<DocumentReference>] = [],
         financingParty: SendableWrapper<Party> = SendableWrapper(Party.empty()),
         financingFinancialAccount: SendableWrapper<FinancialAccount>? = nil,
         clause: [SendableWrapper<Clause>] = []) {
        self.id = id
        self.financingInstrumentCode = financingInstrumentCode
        self.contractDocumentReference = contractDocumentReference
        self.documentReference = documentReference
        self.financingParty = financingParty
        self.financingFinancialAccount = financingFinancialAccount
        self.clause = clause
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case financingInstrumentCode = "FinancingInstrumentCode"
        case contractDocumentReference = "ContractDocumentReference"
        case documentReference = "DocumentReference"
        case financingParty = "FinancingParty"
        case financingFinancialAccount = "FinancingFinancialAccount"
        case clause = "Clause"
    }
}

extension TradeFinancing: CreateEmpty {
    public nonisolated static func empty() -> TradeFinancing {
        TradeFinancing()
    }
}
