// 
// TradingTerms.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct TradingTerms: Codable, Sendable, Hashable  {
    public var information: [SendableWrapper<Text>] // This array should have at least one element
    public var reference: SendableWrapper<Text>?
    public var applicableAddress: SendableWrapper<Address>?

    public init(information: [SendableWrapper<Text>] = [],
         reference: SendableWrapper<Text>? = nil,
         applicableAddress: SendableWrapper<Address>? = nil) {
        self.information = information
        self.reference = reference
        self.applicableAddress = applicableAddress
    }
    
    public enum CodingKeys: String, CodingKey {
        case information = "Information"
        case reference = "Reference"
        case applicableAddress = "ApplicableAddress"
    }
}

extension TradingTerms: CreateEmpty {
    public nonisolated static func empty() -> TradingTerms {
        TradingTerms()
    }
}
