// 
// TransactionConditions.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct TransactionConditions: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>?
    public var actionCode: SendableWrapper<Code>?
    public var description: [SendableWrapper<Text>] // This array should have at least one element
    public var documentReference: [SendableWrapper<DocumentReference>] // This array should have at least one element

    public init(id: SendableWrapper<Identifier>? = nil,
         actionCode: SendableWrapper<Code>? = nil,
         description: [SendableWrapper<Text>] = [],
         documentReference: [SendableWrapper<DocumentReference>] = []) {
        self.id = id
        self.actionCode = actionCode
        self.description = description
        self.documentReference = documentReference
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case actionCode = "ActionCode"
        case description = "Description"
        case documentReference = "DocumentReference"
    }
}

extension TransactionConditions: CreateEmpty {
    public nonisolated static func empty() -> TransactionConditions {
        TransactionConditions()
    }
}
