// 
// TransportEquipment.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct TransportEquipment: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>?
    public var referencedConsignmentID: [SendableWrapper<Identifier>] // This array should have at least one element
    public var transportEquipmentTypeCode: SendableWrapper<Code>?
    public var providerTypeCode: SendableWrapper<Code>?
    public var ownerTypeCode: SendableWrapper<Code>?
    public var sizeTypeCode: SendableWrapper<Code>?
    public var dispositionCode: SendableWrapper<Code>?
    public var fullnessIndicationCode: SendableWrapper<Code>?
    public var refrigerationOnIndicator: SendableWrapper<Indicator>?
    public var information: [SendableWrapper<Text>] // This array should have at least one element
    public var returnabilityIndicator: SendableWrapper<Indicator>?
    public var legalStatusIndicator: SendableWrapper<Indicator>?
    public var airFlowPercent: SendableWrapper<Numeric>?
    public var humidityPercent: SendableWrapper<Numeric>?
    public var animalFoodApprovedIndicator: SendableWrapper<Indicator>?
    public var humanFoodApprovedIndicator: SendableWrapper<Indicator>?
    public var dangerousGoodsApprovedIndicator: SendableWrapper<Indicator>?
    public var refrigeratedIndicator: SendableWrapper<Indicator>?
    public var characteristics: SendableWrapper<Text>?
    public var damageRemarks: [SendableWrapper<Text>] // This array should have at least one element
    public var description: [SendableWrapper<Text>] // This array should have at least one element
    public var specialTransportRequirements: [SendableWrapper<Text>] // This array should have at least one element
    public var grossWeightMeasure: SendableWrapper<Measure>?
    public var grossVolumeMeasure: SendableWrapper<Measure>?
    public var tareWeightMeasure: SendableWrapper<Measure>?
    public var trackingDeviceCode: SendableWrapper<Code>?
    public var powerIndicator: SendableWrapper<Indicator>?
    public var traceID: SendableWrapper<Identifier>?
    public var measurementDimension: [SendableWrapper<Dimension>] // This array should have at least one element
    public var transportEquipmentSeal: [SendableWrapper<TransportEquipmentSeal>] // This array should have at least one element
    public var minimumTemperature: SendableWrapper<Temperature>?
    public var maximumTemperature: SendableWrapper<Temperature>?
    public var providerParty: SendableWrapper<Party>?
    public var loadingProofParty: SendableWrapper<Party>?
    public var supplierParty: SendableWrapper<SupplierParty>?
    public var ownerParty: SendableWrapper<Party>?
    public var operatingParty: SendableWrapper<Party>?
    public var loadingLocation: SendableWrapper<Location>?
    public var unloadingLocation: SendableWrapper<Location>?
    public var storageLocation: SendableWrapper<Location>?
    public var positioningTransportEvent: [SendableWrapper<TransportEvent>] // This array should have at least one element
    public var quarantineTransportEvent: [SendableWrapper<TransportEvent>] // This array should have at least one element
    public var deliveryTransportEvent: [SendableWrapper<TransportEvent>] // This array should have at least one element
    public var pickupTransportEvent: [SendableWrapper<TransportEvent>] // This array should have at least one element
    public var handlingTransportEvent: [SendableWrapper<TransportEvent>] // This array should have at least one element
    public var loadingTransportEvent: [SendableWrapper<TransportEvent>] // This array should have at least one element
    public var transportEvent: [SendableWrapper<TransportEvent>] // This array should have at least one element
    public var applicableTransportMeans: SendableWrapper<TransportMeans>?
    public var haulageTradingTerms: [SendableWrapper<TradingTerms>] // This array should have at least one element
    public var hazardousGoodsTransit: [SendableWrapper<HazardousGoodsTransit>] // This array should have at least one element
    public var packagedTransportHandlingUnit: [SendableWrapper<TransportHandlingUnit>] // This array should have at least one element
    public var serviceAllowanceCharge: [SendableWrapper<AllowanceCharge>] // This array should have at least one element
    public var freightAllowanceCharge: [SendableWrapper<AllowanceCharge>] // This array should have at least one element
    public var attachedTransportEquipment: [SendableWrapper<TransportEquipment>] // This array should have at least one element
    public var delivery: SendableWrapper<Delivery>?
    public var pickup: SendableWrapper<Pickup>?
    public var despatch: SendableWrapper<Despatch>?
    public var shipmentDocumentReference: [SendableWrapper<DocumentReference>] // This array should have at least one element
    public var containedInTransportEquipment: [SendableWrapper<TransportEquipment>] // This array should have at least one element
    public var package: [SendableWrapper<PackageType>] // This array should have at least one element
    public var goodsItem: [SendableWrapper<GoodsItem>] // This array should have at least one element

    public init(id: SendableWrapper<Identifier>? = nil,
         referencedConsignmentID: [SendableWrapper<Identifier>] = [],
         transportEquipmentTypeCode: SendableWrapper<Code>? = nil,
         providerTypeCode: SendableWrapper<Code>? = nil,
         ownerTypeCode: SendableWrapper<Code>? = nil,
         sizeTypeCode: SendableWrapper<Code>? = nil,
         dispositionCode: SendableWrapper<Code>? = nil,
         fullnessIndicationCode: SendableWrapper<Code>? = nil,
         refrigerationOnIndicator: SendableWrapper<Indicator>? = nil,
         information: [SendableWrapper<Text>] = [],
         returnabilityIndicator: SendableWrapper<Indicator>? = nil,
         legalStatusIndicator: SendableWrapper<Indicator>? = nil,
         airFlowPercent: SendableWrapper<Numeric>? = nil,
         humidityPercent: SendableWrapper<Numeric>? = nil,
         animalFoodApprovedIndicator: SendableWrapper<Indicator>? = nil,
         humanFoodApprovedIndicator: SendableWrapper<Indicator>? = nil,
         dangerousGoodsApprovedIndicator: SendableWrapper<Indicator>? = nil,
         refrigeratedIndicator: SendableWrapper<Indicator>? = nil,
         characteristics: SendableWrapper<Text>? = nil,
         damageRemarks: [SendableWrapper<Text>] = [],
         description: [SendableWrapper<Text>] = [],
         specialTransportRequirements: [SendableWrapper<Text>] = [],
         grossWeightMeasure: SendableWrapper<Measure>? = nil,
         grossVolumeMeasure: SendableWrapper<Measure>? = nil,
         tareWeightMeasure: SendableWrapper<Measure>? = nil,
         trackingDeviceCode: SendableWrapper<Code>? = nil,
         powerIndicator: SendableWrapper<Indicator>? = nil,
         traceID: SendableWrapper<Identifier>? = nil,
         measurementDimension: [SendableWrapper<Dimension>] = [],
         transportEquipmentSeal: [SendableWrapper<TransportEquipmentSeal>] = [],
         minimumTemperature: SendableWrapper<Temperature>? = nil,
         maximumTemperature: SendableWrapper<Temperature>? = nil,
         providerParty: SendableWrapper<Party>? = nil,
         loadingProofParty: SendableWrapper<Party>? = nil,
         supplierParty: SendableWrapper<SupplierParty>? = nil,
         ownerParty: SendableWrapper<Party>? = nil,
         operatingParty: SendableWrapper<Party>? = nil,
         loadingLocation: SendableWrapper<Location>? = nil,
         unloadingLocation: SendableWrapper<Location>? = nil,
         storageLocation: SendableWrapper<Location>? = nil,
         positioningTransportEvent: [SendableWrapper<TransportEvent>] = [],
         quarantineTransportEvent: [SendableWrapper<TransportEvent>] = [],
         deliveryTransportEvent: [SendableWrapper<TransportEvent>] = [],
         pickupTransportEvent: [SendableWrapper<TransportEvent>] = [],
         handlingTransportEvent: [SendableWrapper<TransportEvent>] = [],
         loadingTransportEvent: [SendableWrapper<TransportEvent>] = [],
         transportEvent: [SendableWrapper<TransportEvent>] = [],
         applicableTransportMeans: SendableWrapper<TransportMeans>? = nil,
         haulageTradingTerms: [SendableWrapper<TradingTerms>] = [],
         hazardousGoodsTransit: [SendableWrapper<HazardousGoodsTransit>] = [],
         packagedTransportHandlingUnit: [SendableWrapper<TransportHandlingUnit>] = [],
         serviceAllowanceCharge: [SendableWrapper<AllowanceCharge>] = [],
         freightAllowanceCharge: [SendableWrapper<AllowanceCharge>] = [],
         attachedTransportEquipment: [SendableWrapper<TransportEquipment>] = [],
         delivery: SendableWrapper<Delivery>? = nil,
         pickup: SendableWrapper<Pickup>? = nil,
         despatch: SendableWrapper<Despatch>? = nil,
         shipmentDocumentReference: [SendableWrapper<DocumentReference>] = [],
         containedInTransportEquipment: [SendableWrapper<TransportEquipment>] = [],
         package: [SendableWrapper<PackageType>] = [],
         goodsItem: [SendableWrapper<GoodsItem>] = []) {
        self.id = id
        self.referencedConsignmentID = referencedConsignmentID
        self.transportEquipmentTypeCode = transportEquipmentTypeCode
        self.providerTypeCode = providerTypeCode
        self.ownerTypeCode = ownerTypeCode
        self.sizeTypeCode = sizeTypeCode
        self.dispositionCode = dispositionCode
        self.fullnessIndicationCode = fullnessIndicationCode
        self.refrigerationOnIndicator = refrigerationOnIndicator
        self.information = information
        self.returnabilityIndicator = returnabilityIndicator
        self.legalStatusIndicator = legalStatusIndicator
        self.airFlowPercent = airFlowPercent
        self.humidityPercent = humidityPercent
        self.animalFoodApprovedIndicator = animalFoodApprovedIndicator
        self.humanFoodApprovedIndicator = humanFoodApprovedIndicator
        self.dangerousGoodsApprovedIndicator = dangerousGoodsApprovedIndicator
        self.refrigeratedIndicator = refrigeratedIndicator
        self.characteristics = characteristics
        self.damageRemarks = damageRemarks
        self.description = description
        self.specialTransportRequirements = specialTransportRequirements
        self.grossWeightMeasure = grossWeightMeasure
        self.grossVolumeMeasure = grossVolumeMeasure
        self.tareWeightMeasure = tareWeightMeasure
        self.trackingDeviceCode = trackingDeviceCode
        self.powerIndicator = powerIndicator
        self.traceID = traceID
        self.measurementDimension = measurementDimension
        self.transportEquipmentSeal = transportEquipmentSeal
        self.minimumTemperature = minimumTemperature
        self.maximumTemperature = maximumTemperature
        self.providerParty = providerParty
        self.loadingProofParty = loadingProofParty
        self.supplierParty = supplierParty
        self.ownerParty = ownerParty
        self.operatingParty = operatingParty
        self.loadingLocation = loadingLocation
        self.unloadingLocation = unloadingLocation
        self.storageLocation = storageLocation
        self.positioningTransportEvent = positioningTransportEvent
        self.quarantineTransportEvent = quarantineTransportEvent
        self.deliveryTransportEvent = deliveryTransportEvent
        self.pickupTransportEvent = pickupTransportEvent
        self.handlingTransportEvent = handlingTransportEvent
        self.loadingTransportEvent = loadingTransportEvent
        self.transportEvent = transportEvent
        self.applicableTransportMeans = applicableTransportMeans
        self.haulageTradingTerms = haulageTradingTerms
        self.hazardousGoodsTransit = hazardousGoodsTransit
        self.packagedTransportHandlingUnit = packagedTransportHandlingUnit
        self.serviceAllowanceCharge = serviceAllowanceCharge
        self.freightAllowanceCharge = freightAllowanceCharge
        self.attachedTransportEquipment = attachedTransportEquipment
        self.delivery = delivery
        self.pickup = pickup
        self.despatch = despatch
        self.shipmentDocumentReference = shipmentDocumentReference
        self.containedInTransportEquipment = containedInTransportEquipment
        self.package = package
        self.goodsItem = goodsItem
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case referencedConsignmentID = "ReferencedConsignmentID"
        case transportEquipmentTypeCode = "TransportEquipmentTypeCode"
        case providerTypeCode = "ProviderTypeCode"
        case ownerTypeCode = "OwnerTypeCode"
        case sizeTypeCode = "SizeTypeCode"
        case dispositionCode = "DispositionCode"
        case fullnessIndicationCode = "FullnessIndicationCode"
        case refrigerationOnIndicator = "RefrigerationOnIndicator"
        case information = "Information"
        case returnabilityIndicator = "ReturnabilityIndicator"
        case legalStatusIndicator = "LegalStatusIndicator"
        case airFlowPercent = "AirFlowPercent"
        case humidityPercent = "HumidityPercent"
        case animalFoodApprovedIndicator = "AnimalFoodApprovedIndicator"
        case humanFoodApprovedIndicator = "HumanFoodApprovedIndicator"
        case dangerousGoodsApprovedIndicator = "DangerousGoodsApprovedIndicator"
        case refrigeratedIndicator = "RefrigeratedIndicator"
        case characteristics = "Characteristics"
        case damageRemarks = "DamageRemarks"
        case description = "Description"
        case specialTransportRequirements = "SpecialTransportRequirements"
        case grossWeightMeasure = "GrossWeightMeasure"
        case grossVolumeMeasure = "GrossVolumeMeasure"
        case tareWeightMeasure = "TareWeightMeasure"
        case trackingDeviceCode = "TrackingDeviceCode"
        case powerIndicator = "PowerIndicator"
        case traceID = "TraceID"
        case measurementDimension = "MeasurementDimension"
        case transportEquipmentSeal = "TransportEquipmentSeal"
        case minimumTemperature = "MinimumTemperature"
        case maximumTemperature = "MaximumTemperature"
        case providerParty = "ProviderParty"
        case loadingProofParty = "LoadingProofParty"
        case supplierParty = "SupplierParty"
        case ownerParty = "OwnerParty"
        case operatingParty = "OperatingParty"
        case loadingLocation = "LoadingLocation"
        case unloadingLocation = "UnloadingLocation"
        case storageLocation = "StorageLocation"
        case positioningTransportEvent = "PositioningTransportEvent"
        case quarantineTransportEvent = "QuarantineTransportEvent"
        case deliveryTransportEvent = "DeliveryTransportEvent"
        case pickupTransportEvent = "PickupTransportEvent"
        case handlingTransportEvent = "HandlingTransportEvent"
        case loadingTransportEvent = "LoadingTransportEvent"
        case transportEvent = "TransportEvent"
        case applicableTransportMeans = "ApplicableTransportMeans"
        case haulageTradingTerms = "HaulageTradingTerms"
        case hazardousGoodsTransit = "HazardousGoodsTransit"
        case packagedTransportHandlingUnit = "PackagedTransportHandlingUnit"
        case serviceAllowanceCharge = "ServiceAllowanceCharge"
        case freightAllowanceCharge = "FreightAllowanceCharge"
        case attachedTransportEquipment = "AttachedTransportEquipment"
        case delivery = "Delivery"
        case pickup = "Pickup"
        case despatch = "Despatch"
        case shipmentDocumentReference = "ShipmentDocumentReference"
        case containedInTransportEquipment = "ContainedInTransportEquipment"
        case package = "Package"
        case goodsItem = "GoodsItem"
    }
}

extension TransportEquipment: CreateEmpty {
    public nonisolated static func empty() -> TransportEquipment {
        TransportEquipment()
    }
}
