// 
// TransportEquipmentSeal.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct TransportEquipmentSeal: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>
    public var sealIssuerTypeCode: SendableWrapper<Code>?
    public var condition: SendableWrapper<Condition>?
    public var sealStatusCode: SendableWrapper<Code>?
    public var sealingPartyType: SendableWrapper<Text>?

    public init(id: SendableWrapper<Identifier> = SendableWrapper(Identifier.empty()),
         sealIssuerTypeCode: SendableWrapper<Code>? = nil,
         condition: SendableWrapper<Condition>? = nil,
         sealStatusCode: SendableWrapper<Code>? = nil,
         sealingPartyType: SendableWrapper<Text>? = nil) {
        self.id = id
        self.sealIssuerTypeCode = sealIssuerTypeCode
        self.condition = condition
        self.sealStatusCode = sealStatusCode
        self.sealingPartyType = sealingPartyType
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case sealIssuerTypeCode = "SealIssuerTypeCode"
        case condition = "Condition"
        case sealStatusCode = "SealStatusCode"
        case sealingPartyType = "SealingPartyType"
    }
}

extension TransportEquipmentSeal: CreateEmpty {
    public nonisolated static func empty() -> TransportEquipmentSeal {
        TransportEquipmentSeal()
    }
}
