// 
// TransportEvent.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct TransportEvent: Codable, Sendable, Hashable  {
    public var identificationID: SendableWrapper<Identifier>?
    public var occurrenceDate: XMLDate?
    public var occurrenceTime: XMLDate?
    public var transportEventTypeCode: SendableWrapper<Code>?
    public var description: [SendableWrapper<Text>] // This array should have at least one element
    public var completionIndicator: SendableWrapper<Indicator>?
    public var reportedShipment: SendableWrapper<Shipment>?
    public var currentStatus: [SendableWrapper<Status>] // This array should have at least one element
    public var contact: [SendableWrapper<Contact>] // This array should have at least one element
    public var location: SendableWrapper<Location>?
    public var signature: SendableWrapper<Signature>?
    public var period: [SendableWrapper<Period>] // This array should have at least one element

    public init(identificationID: SendableWrapper<Identifier>? = nil,
         occurrenceDate: XMLDate? = nil,
         occurrenceTime: XMLDate? = nil,
         transportEventTypeCode: SendableWrapper<Code>? = nil,
         description: [SendableWrapper<Text>] = [],
         completionIndicator: SendableWrapper<Indicator>? = nil,
         reportedShipment: SendableWrapper<Shipment>? = nil,
         currentStatus: [SendableWrapper<Status>] = [],
         contact: [SendableWrapper<Contact>] = [],
         location: SendableWrapper<Location>? = nil,
         signature: SendableWrapper<Signature>? = nil,
         period: [SendableWrapper<Period>] = []) {
        self.identificationID = identificationID
        self.occurrenceDate = occurrenceDate
        self.occurrenceTime = occurrenceTime
        self.transportEventTypeCode = transportEventTypeCode
        self.description = description
        self.completionIndicator = completionIndicator
        self.reportedShipment = reportedShipment
        self.currentStatus = currentStatus
        self.contact = contact
        self.location = location
        self.signature = signature
        self.period = period
    }
    
    public enum CodingKeys: String, CodingKey {
        case identificationID = "IdentificationID"
        case occurrenceDate = "OccurrenceDate"
        case occurrenceTime = "OccurrenceTime"
        case transportEventTypeCode = "TransportEventTypeCode"
        case description = "Description"
        case completionIndicator = "CompletionIndicator"
        case reportedShipment = "ReportedShipment"
        case currentStatus = "CurrentStatus"
        case contact = "Contact"
        case location = "Location"
        case signature = "Signature"
        case period = "Period"
    }
}

extension TransportEvent: CreateEmpty {
    public nonisolated static func empty() -> TransportEvent {
        TransportEvent()
    }
}
