// 
// TransportHandlingUnit.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct TransportHandlingUnit: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>?
    public var transportHandlingUnitTypeCode: SendableWrapper<Code>?
    public var handlingCode: SendableWrapper<Code>?
    public var handlingInstructions: [SendableWrapper<Text>] // This array should have at least one element
    public var hazardousRiskIndicator: SendableWrapper<Indicator>?
    public var totalGoodsItemQuantity: SendableWrapper<Quantity>?
    public var totalPackageQuantity: SendableWrapper<Quantity>?
    public var damageRemarks: [SendableWrapper<Text>] // This array should have at least one element
    public var shippingMarks: [SendableWrapper<Text>] // This array should have at least one element
    public var traceID: SendableWrapper<Identifier>?
    public var handlingUnitDespatchLine: [SendableWrapper<DespatchLine>] // This array should have at least one element
    public var actualPackage: [SendableWrapper<PackageType>] // This array should have at least one element
    public var receivedHandlingUnitReceiptLine: [SendableWrapper<ReceiptLine>] // This array should have at least one element
    public var transportEquipment: [SendableWrapper<TransportEquipment>] // This array should have at least one element
    public var transportMeans: [SendableWrapper<TransportMeans>] // This array should have at least one element
    public var hazardousGoodsTransit: [SendableWrapper<HazardousGoodsTransit>] // This array should have at least one element
    public var measurementDimension: [SendableWrapper<Dimension>] // This array should have at least one element
    public var minimumTemperature: SendableWrapper<Temperature>?
    public var maximumTemperature: SendableWrapper<Temperature>?
    public var goodsItem: [SendableWrapper<GoodsItem>] // This array should have at least one element
    public var floorSpaceMeasurementDimension: SendableWrapper<Dimension>?
    public var palletSpaceMeasurementDimension: SendableWrapper<Dimension>?
    public var shipmentDocumentReference: [SendableWrapper<DocumentReference>] // This array should have at least one element
    public var status: [SendableWrapper<Status>] // This array should have at least one element
    public var customsDeclaration: [SendableWrapper<CustomsDeclaration>] // This array should have at least one element
    public var referencedShipment: [SendableWrapper<Shipment>] // This array should have at least one element
    public var package: [SendableWrapper<PackageType>] // This array should have at least one element

    public init(id: SendableWrapper<Identifier>? = nil,
         transportHandlingUnitTypeCode: SendableWrapper<Code>? = nil,
         handlingCode: SendableWrapper<Code>? = nil,
         handlingInstructions: [SendableWrapper<Text>] = [],
         hazardousRiskIndicator: SendableWrapper<Indicator>? = nil,
         totalGoodsItemQuantity: SendableWrapper<Quantity>? = nil,
         totalPackageQuantity: SendableWrapper<Quantity>? = nil,
         damageRemarks: [SendableWrapper<Text>] = [],
         shippingMarks: [SendableWrapper<Text>] = [],
         traceID: SendableWrapper<Identifier>? = nil,
         handlingUnitDespatchLine: [SendableWrapper<DespatchLine>] = [],
         actualPackage: [SendableWrapper<PackageType>] = [],
         receivedHandlingUnitReceiptLine: [SendableWrapper<ReceiptLine>] = [],
         transportEquipment: [SendableWrapper<TransportEquipment>] = [],
         transportMeans: [SendableWrapper<TransportMeans>] = [],
         hazardousGoodsTransit: [SendableWrapper<HazardousGoodsTransit>] = [],
         measurementDimension: [SendableWrapper<Dimension>] = [],
         minimumTemperature: SendableWrapper<Temperature>? = nil,
         maximumTemperature: SendableWrapper<Temperature>? = nil,
         goodsItem: [SendableWrapper<GoodsItem>] = [],
         floorSpaceMeasurementDimension: SendableWrapper<Dimension>? = nil,
         palletSpaceMeasurementDimension: SendableWrapper<Dimension>? = nil,
         shipmentDocumentReference: [SendableWrapper<DocumentReference>] = [],
         status: [SendableWrapper<Status>] = [],
         customsDeclaration: [SendableWrapper<CustomsDeclaration>] = [],
         referencedShipment: [SendableWrapper<Shipment>] = [],
         package: [SendableWrapper<PackageType>] = []) {
        self.id = id
        self.transportHandlingUnitTypeCode = transportHandlingUnitTypeCode
        self.handlingCode = handlingCode
        self.handlingInstructions = handlingInstructions
        self.hazardousRiskIndicator = hazardousRiskIndicator
        self.totalGoodsItemQuantity = totalGoodsItemQuantity
        self.totalPackageQuantity = totalPackageQuantity
        self.damageRemarks = damageRemarks
        self.shippingMarks = shippingMarks
        self.traceID = traceID
        self.handlingUnitDespatchLine = handlingUnitDespatchLine
        self.actualPackage = actualPackage
        self.receivedHandlingUnitReceiptLine = receivedHandlingUnitReceiptLine
        self.transportEquipment = transportEquipment
        self.transportMeans = transportMeans
        self.hazardousGoodsTransit = hazardousGoodsTransit
        self.measurementDimension = measurementDimension
        self.minimumTemperature = minimumTemperature
        self.maximumTemperature = maximumTemperature
        self.goodsItem = goodsItem
        self.floorSpaceMeasurementDimension = floorSpaceMeasurementDimension
        self.palletSpaceMeasurementDimension = palletSpaceMeasurementDimension
        self.shipmentDocumentReference = shipmentDocumentReference
        self.status = status
        self.customsDeclaration = customsDeclaration
        self.referencedShipment = referencedShipment
        self.package = package
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case transportHandlingUnitTypeCode = "TransportHandlingUnitTypeCode"
        case handlingCode = "HandlingCode"
        case handlingInstructions = "HandlingInstructions"
        case hazardousRiskIndicator = "HazardousRiskIndicator"
        case totalGoodsItemQuantity = "TotalGoodsItemQuantity"
        case totalPackageQuantity = "TotalPackageQuantity"
        case damageRemarks = "DamageRemarks"
        case shippingMarks = "ShippingMarks"
        case traceID = "TraceID"
        case handlingUnitDespatchLine = "HandlingUnitDespatchLine"
        case actualPackage = "ActualPackage"
        case receivedHandlingUnitReceiptLine = "ReceivedHandlingUnitReceiptLine"
        case transportEquipment = "TransportEquipment"
        case transportMeans = "TransportMeans"
        case hazardousGoodsTransit = "HazardousGoodsTransit"
        case measurementDimension = "MeasurementDimension"
        case minimumTemperature = "MinimumTemperature"
        case maximumTemperature = "MaximumTemperature"
        case goodsItem = "GoodsItem"
        case floorSpaceMeasurementDimension = "FloorSpaceMeasurementDimension"
        case palletSpaceMeasurementDimension = "PalletSpaceMeasurementDimension"
        case shipmentDocumentReference = "ShipmentDocumentReference"
        case status = "Status"
        case customsDeclaration = "CustomsDeclaration"
        case referencedShipment = "ReferencedShipment"
        case package = "Package"
    }
}

extension TransportHandlingUnit: CreateEmpty {
    public nonisolated static func empty() -> TransportHandlingUnit {
        TransportHandlingUnit()
    }
}
