// 
// TransportMeans.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct TransportMeans: Codable, Sendable, Hashable  {
    public var journeyID: SendableWrapper<Identifier>?
    public var registrationNationalityID: SendableWrapper<Identifier>?
    public var registrationNationality: [SendableWrapper<Text>] // This array should have at least one element
    public var directionCode: SendableWrapper<Code>?
    public var transportMeansTypeCode: SendableWrapper<Code>?
    public var tradeServiceCode: SendableWrapper<Code>?
    public var stowage: SendableWrapper<Stowage>?
    public var airTransport: SendableWrapper<AirTransport>?
    public var roadTransport: SendableWrapper<RoadTransport>?
    public var railTransport: SendableWrapper<RailTransport>?
    public var maritimeTransport: SendableWrapper<MaritimeTransport>?
    public var ownerParty: SendableWrapper<Party>?
    public var measurementDimension: [SendableWrapper<Dimension>] // This array should have at least one element

    public init(journeyID: SendableWrapper<Identifier>? = nil,
         registrationNationalityID: SendableWrapper<Identifier>? = nil,
         registrationNationality: [SendableWrapper<Text>] = [],
         directionCode: SendableWrapper<Code>? = nil,
         transportMeansTypeCode: SendableWrapper<Code>? = nil,
         tradeServiceCode: SendableWrapper<Code>? = nil,
         stowage: SendableWrapper<Stowage>? = nil,
         airTransport: SendableWrapper<AirTransport>? = nil,
         roadTransport: SendableWrapper<RoadTransport>? = nil,
         railTransport: SendableWrapper<RailTransport>? = nil,
         maritimeTransport: SendableWrapper<MaritimeTransport>? = nil,
         ownerParty: SendableWrapper<Party>? = nil,
         measurementDimension: [SendableWrapper<Dimension>] = []) {
        self.journeyID = journeyID
        self.registrationNationalityID = registrationNationalityID
        self.registrationNationality = registrationNationality
        self.directionCode = directionCode
        self.transportMeansTypeCode = transportMeansTypeCode
        self.tradeServiceCode = tradeServiceCode
        self.stowage = stowage
        self.airTransport = airTransport
        self.roadTransport = roadTransport
        self.railTransport = railTransport
        self.maritimeTransport = maritimeTransport
        self.ownerParty = ownerParty
        self.measurementDimension = measurementDimension
    }
    
    public enum CodingKeys: String, CodingKey {
        case journeyID = "JourneyID"
        case registrationNationalityID = "RegistrationNationalityID"
        case registrationNationality = "RegistrationNationality"
        case directionCode = "DirectionCode"
        case transportMeansTypeCode = "TransportMeansTypeCode"
        case tradeServiceCode = "TradeServiceCode"
        case stowage = "Stowage"
        case airTransport = "AirTransport"
        case roadTransport = "RoadTransport"
        case railTransport = "RailTransport"
        case maritimeTransport = "MaritimeTransport"
        case ownerParty = "OwnerParty"
        case measurementDimension = "MeasurementDimension"
    }
}

extension TransportMeans: CreateEmpty {
    public nonisolated static func empty() -> TransportMeans {
        TransportMeans()
    }
}
