// 
// WorkPhaseReference.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import XMLCoder
import ViewPresentable

public struct WorkPhaseReference: Codable, Sendable, Hashable  {
    public var id: SendableWrapper<Identifier>?
    public var workPhaseCode: SendableWrapper<Code>?
    public var workPhase: [SendableWrapper<Text>] // This array should have at least one element
    public var progressPercent: SendableWrapper<Numeric>?
    public var startDate: XMLDate?
    public var endDate: XMLDate?
    public var workOrderDocumentReference: [SendableWrapper<DocumentReference>] // This array should have at least one element

    public init(id: SendableWrapper<Identifier>? = nil,
         workPhaseCode: SendableWrapper<Code>? = nil,
         workPhase: [SendableWrapper<Text>] = [],
         progressPercent: SendableWrapper<Numeric>? = nil,
         startDate: XMLDate? = nil,
         endDate: XMLDate? = nil,
         workOrderDocumentReference: [SendableWrapper<DocumentReference>] = []) {
        self.id = id
        self.workPhaseCode = workPhaseCode
        self.workPhase = workPhase
        self.progressPercent = progressPercent
        self.startDate = startDate
        self.endDate = endDate
        self.workOrderDocumentReference = workOrderDocumentReference
    }
    
    public enum CodingKeys: String, CodingKey {
        case id = "ID"
        case workPhaseCode = "WorkPhaseCode"
        case workPhase = "WorkPhase"
        case progressPercent = "ProgressPercent"
        case startDate = "StartDate"
        case endDate = "EndDate"
        case workOrderDocumentReference = "WorkOrderDocumentReference"
    }
}

extension WorkPhaseReference: CreateEmpty {
    public nonisolated static func empty() -> WorkPhaseReference {
        WorkPhaseReference()
    }
}
