// 
// Amount.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import SwiftUI
import ViewPresentable
import UBLInvoice

extension UBLInvoice.Amount: KeyViewPresentable {
    public static let elementKeys: [CodingKeys] = [
        .value,
        .currencyID,
        .currencyCodeListVersionID
]
    public var hasNilValue: Bool {(currencyID == nil)
        || (currencyCodeListVersionID == nil)
    }
    
    public func title(for key: CodingKeys) -> String {
        switch key {
            case .value: return "Value"
            case .currencyID: return "Currency Id"
            case .currencyCodeListVersionID: return "Currency Code List Version Id"
        }
    }

    public func details(for key: CodingKeys) -> String? {
        switch key {
            case .value: return nil
            case .currencyID: return nil
            case .currencyCodeListVersionID: return nil
        }
    }
    func skipView(title _title: String, key: CodingKeys, search _search: String?) -> Bool {
        if let _search,
            (_title.search(_search) == nil) {
            let result: SearchResult?
            switch key {
                case .value: result = value.search(_search)
                case .currencyID: result = currencyID?.search(_search)
                case .currencyCodeListVersionID: result = currencyCodeListVersionID?.search(_search)
            }
            return (result == nil)
        }
        return false
    }

    @MainActor @ViewBuilder public func view(for key: CodingKeys, show: Bool = false, search _search: String? = nil) -> some View {
        let _title = title(for: key)
        if !skipView(title: _title, key: key, search: _search) {
        let _details = details(for: key)
            switch key {
                case .value: anyView(for: value, title: _title, details: _details, show: show, search: _search)
                case .currencyID: anyView(for: currencyID, title: _title, details: _details, show: show, search: _search)
                case .currencyCodeListVersionID: anyView(for: currencyCodeListVersionID, title: _title, details: _details, show: show, search: _search)
            }
        }
    }
}

extension UBLInvoice.Amount: Searchable {
    public func search(_ string: String) -> SearchResult? {
        for codingKey in Self.elementKeys {
            let _title = self.title(for: codingKey) 
            if _title.contains(string) {
                return .title(_title)
            }
        }
        if let result = value.search(string) { return result }
        if let result = currencyID?.search(string) { return result }
        if let result = currencyCodeListVersionID?.search(string) { return result }
        return nil
    }
}
