// 
// Code.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import SwiftUI
import ViewPresentable
import UBLInvoice

extension UBLInvoice.Code: KeyViewPresentable {
    public static let elementKeys: [CodingKeys] = [
        .value,
        .listID,
        .listAgencyID,
        .listAgencyName,
        .listName,
        .listVersionID,
        .name,
        .languageID,
        .listURI,
        .listSchemeURI
]
    public var hasNilValue: Bool {(listID == nil)
        || (listAgencyID == nil)
        || (listAgencyName == nil)
        || (listName == nil)
        || (listVersionID == nil)
        || (name == nil)
        || (languageID == nil)
        || (listURI == nil)
        || (listSchemeURI == nil)
    }
    
    public func title(for key: CodingKeys) -> String {
        switch key {
            case .value: return "Value"
            case .listID: return "List Id"
            case .listAgencyID: return "List Agency Id"
            case .listAgencyName: return "List Agency Name"
            case .listName: return "List Name"
            case .listVersionID: return "List Version Id"
            case .name: return "Name"
            case .languageID: return "Language Id"
            case .listURI: return "List Uri"
            case .listSchemeURI: return "List Scheme Uri"
        }
    }

    public func details(for key: CodingKeys) -> String? {
        switch key {
            case .value: return nil
            case .listID: return nil
            case .listAgencyID: return nil
            case .listAgencyName: return nil
            case .listName: return nil
            case .listVersionID: return nil
            case .name: return nil
            case .languageID: return nil
            case .listURI: return nil
            case .listSchemeURI: return nil
        }
    }
    func skipView(title _title: String, key: CodingKeys, search _search: String?) -> Bool {
        if let _search,
            (_title.search(_search) == nil) {
            let result: SearchResult?
            switch key {
                case .value: result = value.search(_search)
                case .listID: result = listID?.search(_search)
                case .listAgencyID: result = listAgencyID?.search(_search)
                case .listAgencyName: result = listAgencyName?.search(_search)
                case .listName: result = listName?.search(_search)
                case .listVersionID: result = listVersionID?.search(_search)
                case .name: result = name?.search(_search)
                case .languageID: result = languageID?.search(_search)
                case .listURI: result = listURI?.search(_search)
                case .listSchemeURI: result = listSchemeURI?.search(_search)
            }
            return (result == nil)
        }
        return false
    }

    @MainActor @ViewBuilder public func view(for key: CodingKeys, show: Bool = false, search _search: String? = nil) -> some View {
        let _title = title(for: key)
        if !skipView(title: _title, key: key, search: _search) {
        let _details = details(for: key)
            switch key {
                case .value: anyView(for: value, title: _title, details: _details, show: show, search: _search)
                case .listID: anyView(for: listID, title: _title, details: _details, show: show, search: _search)
                case .listAgencyID: anyView(for: listAgencyID, title: _title, details: _details, show: show, search: _search)
                case .listAgencyName: anyView(for: listAgencyName, title: _title, details: _details, show: show, search: _search)
                case .listName: anyView(for: listName, title: _title, details: _details, show: show, search: _search)
                case .listVersionID: anyView(for: listVersionID, title: _title, details: _details, show: show, search: _search)
                case .name: anyView(for: name, title: _title, details: _details, show: show, search: _search)
                case .languageID: anyView(for: languageID, title: _title, details: _details, show: show, search: _search)
                case .listURI: anyView(for: listURI, title: _title, details: _details, show: show, search: _search)
                case .listSchemeURI: anyView(for: listSchemeURI, title: _title, details: _details, show: show, search: _search)
            }
        }
    }
}

extension UBLInvoice.Code: Searchable {
    public func search(_ string: String) -> SearchResult? {
        for codingKey in Self.elementKeys {
            let _title = self.title(for: codingKey) 
            if _title.contains(string) {
                return .title(_title)
            }
        }
        if let result = value.search(string) { return result }
        if let result = listID?.search(string) { return result }
        if let result = listAgencyID?.search(string) { return result }
        if let result = listAgencyName?.search(string) { return result }
        if let result = listName?.search(string) { return result }
        if let result = listVersionID?.search(string) { return result }
        if let result = name?.search(string) { return result }
        if let result = languageID?.search(string) { return result }
        if let result = listURI?.search(string) { return result }
        if let result = listSchemeURI?.search(string) { return result }
        return nil
    }
}
