// 
// Consignment.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import SwiftUI
import ViewPresentable
import UBLInvoice

extension UBLInvoice.Consignment: KeyViewPresentable {
    public static let elementKeys: [CodingKeys] = [
        .id,
        .carrierAssignedID,
        .consigneeAssignedID,
        .consignorAssignedID,
        .freightForwarderAssignedID,
        .brokerAssignedID,
        .contractedCarrierAssignedID,
        .performingCarrierAssignedID,
        .summaryDescription,
        .totalInvoiceAmount,
        .declaredCustomsValueAmount,
        .tariffDescription,
        .tariffCode,
        .insurancePremiumAmount,
        .grossWeightMeasure,
        .netWeightMeasure,
        .netNetWeightMeasure,
        .chargeableWeightMeasure,
        .grossVolumeMeasure,
        .netVolumeMeasure,
        .loadingLengthMeasure,
        .remarks,
        .hazardousRiskIndicator,
        .animalFoodIndicator,
        .humanFoodIndicator,
        .livestockIndicator,
        .bulkCargoIndicator,
        .containerizedIndicator,
        .generalCargoIndicator,
        .specialSecurityIndicator,
        .thirdPartyPayerIndicator,
        .carrierServiceInstructions,
        .customsClearanceServiceInstructions,
        .forwarderServiceInstructions,
        .specialServiceInstructions,
        .sequenceID,
        .shippingPriorityLevelCode,
        .handlingCode,
        .handlingInstructions,
        .information,
        .totalGoodsItemQuantity,
        .totalTransportHandlingUnitQuantity,
        .insuranceValueAmount,
        .declaredForCarriageValueAmount,
        .declaredStatisticsValueAmount,
        .freeOnBoardValueAmount,
        .specialInstructions,
        .splitConsignmentIndicator,
        .deliveryInstructions,
        .consignmentQuantity,
        .consolidatableIndicator,
        .haulageInstructions,
        .loadingSequenceID,
        .childConsignmentQuantity,
        .totalPackagesQuantity,
        .consolidatedShipment,
        .customsDeclaration,
        .requestedPickupTransportEvent,
        .requestedDeliveryTransportEvent,
        .plannedPickupTransportEvent,
        .plannedDeliveryTransportEvent,
        .status,
        .childConsignment,
        .consigneeParty,
        .exporterParty,
        .consignorParty,
        .importerParty,
        .carrierParty,
        .freightForwarderParty,
        .notifyParty,
        .originalDespatchParty,
        .finalDeliveryParty,
        .performingCarrierParty,
        .substituteCarrierParty,
        .logisticsOperatorParty,
        .transportAdvisorParty,
        .hazardousItemNotificationParty,
        .insuranceParty,
        .mortgageHolderParty,
        .billOfLadingHolderParty,
        .originalDepartureCountry,
        .finalDestinationCountry,
        .transitCountry,
        .transportContract,
        .transportEvent,
        .originalDespatchTransportationService,
        .finalDeliveryTransportationService,
        .deliveryTerms,
        .paymentTerms,
        .collectPaymentTerms,
        .disbursementPaymentTerms,
        .prepaidPaymentTerms,
        .freightAllowanceCharge,
        .extraAllowanceCharge,
        .mainCarriageShipmentStage,
        .preCarriageShipmentStage,
        .onCarriageShipmentStage,
        .transportHandlingUnit,
        .firstArrivalPortLocation,
        .lastExitPortLocation
]
    public var hasNilValue: Bool {(carrierAssignedID == nil)
        || (consigneeAssignedID == nil)
        || (consignorAssignedID == nil)
        || (freightForwarderAssignedID == nil)
        || (brokerAssignedID == nil)
        || (contractedCarrierAssignedID == nil)
        || (performingCarrierAssignedID == nil)
        || (totalInvoiceAmount == nil)
        || (declaredCustomsValueAmount == nil)
        || (tariffCode == nil)
        || (insurancePremiumAmount == nil)
        || (grossWeightMeasure == nil)
        || (netWeightMeasure == nil)
        || (netNetWeightMeasure == nil)
        || (chargeableWeightMeasure == nil)
        || (grossVolumeMeasure == nil)
        || (netVolumeMeasure == nil)
        || (loadingLengthMeasure == nil)
        || (hazardousRiskIndicator == nil)
        || (animalFoodIndicator == nil)
        || (humanFoodIndicator == nil)
        || (livestockIndicator == nil)
        || (bulkCargoIndicator == nil)
        || (containerizedIndicator == nil)
        || (generalCargoIndicator == nil)
        || (specialSecurityIndicator == nil)
        || (thirdPartyPayerIndicator == nil)
        || (sequenceID == nil)
        || (shippingPriorityLevelCode == nil)
        || (handlingCode == nil)
        || (totalGoodsItemQuantity == nil)
        || (totalTransportHandlingUnitQuantity == nil)
        || (insuranceValueAmount == nil)
        || (declaredForCarriageValueAmount == nil)
        || (declaredStatisticsValueAmount == nil)
        || (freeOnBoardValueAmount == nil)
        || (splitConsignmentIndicator == nil)
        || (consignmentQuantity == nil)
        || (consolidatableIndicator == nil)
        || (loadingSequenceID == nil)
        || (childConsignmentQuantity == nil)
        || (totalPackagesQuantity == nil)
        || (requestedPickupTransportEvent == nil)
        || (requestedDeliveryTransportEvent == nil)
        || (plannedPickupTransportEvent == nil)
        || (plannedDeliveryTransportEvent == nil)
        || (consigneeParty == nil)
        || (exporterParty == nil)
        || (consignorParty == nil)
        || (importerParty == nil)
        || (carrierParty == nil)
        || (freightForwarderParty == nil)
        || (notifyParty == nil)
        || (originalDespatchParty == nil)
        || (finalDeliveryParty == nil)
        || (performingCarrierParty == nil)
        || (substituteCarrierParty == nil)
        || (logisticsOperatorParty == nil)
        || (transportAdvisorParty == nil)
        || (hazardousItemNotificationParty == nil)
        || (insuranceParty == nil)
        || (mortgageHolderParty == nil)
        || (billOfLadingHolderParty == nil)
        || (originalDepartureCountry == nil)
        || (finalDestinationCountry == nil)
        || (transportContract == nil)
        || (originalDespatchTransportationService == nil)
        || (finalDeliveryTransportationService == nil)
        || (deliveryTerms == nil)
        || (paymentTerms == nil)
        || (collectPaymentTerms == nil)
        || (disbursementPaymentTerms == nil)
        || (prepaidPaymentTerms == nil)
        || (firstArrivalPortLocation == nil)
        || (lastExitPortLocation == nil)
    }
    
    public func title(for key: CodingKeys) -> String {
        switch key {
            case .id: return "Identifier"
            case .carrierAssignedID: return "Carrier Assigned Identifier"
            case .consigneeAssignedID: return "Consignee Assigned Identifier"
            case .consignorAssignedID: return "Consignor Assigned Identifier"
            case .freightForwarderAssignedID: return "Freight Forwarder Assigned Identifier"
            case .brokerAssignedID: return "Broker Assigned Identifier"
            case .contractedCarrierAssignedID: return "Contracted Carrier Assigned Identifier"
            case .performingCarrierAssignedID: return "Performing Carrier Assigned Identifier"
            case .summaryDescription: return "Summary Description"
            case .totalInvoiceAmount: return "Total Invoice Amount"
            case .declaredCustomsValueAmount: return "Declared Customs Value"
            case .tariffDescription: return "Tariff Description"
            case .tariffCode: return "Tariff Code"
            case .insurancePremiumAmount: return "Insurance Premium Amount"
            case .grossWeightMeasure: return "Gross Weight"
            case .netWeightMeasure: return "Net Weight"
            case .netNetWeightMeasure: return "Net Net Weight"
            case .chargeableWeightMeasure: return "Chargeable Weight"
            case .grossVolumeMeasure: return "Gross Volume"
            case .netVolumeMeasure: return "Net Volume"
            case .loadingLengthMeasure: return "Loading Length"
            case .remarks: return "Remarks"
            case .hazardousRiskIndicator: return "Hazardous Risk Indicator"
            case .animalFoodIndicator: return "Animal Food Indicator"
            case .humanFoodIndicator: return "Human Food Indicator"
            case .livestockIndicator: return "Livestock Indicator"
            case .bulkCargoIndicator: return "Bulk Cargo Indicator"
            case .containerizedIndicator: return "Containerized Indicator"
            case .generalCargoIndicator: return "General Cargo Indicator"
            case .specialSecurityIndicator: return "Special Security Indicator"
            case .thirdPartyPayerIndicator: return "Third Party Payer Indicator"
            case .carrierServiceInstructions: return "Carrier Service Instructions"
            case .customsClearanceServiceInstructions: return "Customs Clearance Service Instructions"
            case .forwarderServiceInstructions: return "Forwarder Service Instructions"
            case .specialServiceInstructions: return "Special Service Instructions"
            case .sequenceID: return "Sequence Identifier"
            case .shippingPriorityLevelCode: return "Shipping Priority Level Code"
            case .handlingCode: return "Handling Code"
            case .handlingInstructions: return "Handling Instructions"
            case .information: return "Information"
            case .totalGoodsItemQuantity: return "Total Goods Item Quantity"
            case .totalTransportHandlingUnitQuantity: return "Total Transport Handling Unit Quantity"
            case .insuranceValueAmount: return "Insurance Value"
            case .declaredForCarriageValueAmount: return "Declared For Carriage Value"
            case .declaredStatisticsValueAmount: return "Declared Statistics Value"
            case .freeOnBoardValueAmount: return "Free On Board Value"
            case .specialInstructions: return "Special Instructions"
            case .splitConsignmentIndicator: return "Split Consignment Indicator"
            case .deliveryInstructions: return "Delivery Instructions"
            case .consignmentQuantity: return "Consignment Quantity"
            case .consolidatableIndicator: return "Consolidatable Indicator"
            case .haulageInstructions: return "Haulage Instructions"
            case .loadingSequenceID: return "Loading Sequence Identifier"
            case .childConsignmentQuantity: return "Child Consignment Quantity"
            case .totalPackagesQuantity: return "Total Packages Quantity"
            case .consolidatedShipment: return "Consolidated Shipment"
            case .customsDeclaration: return "Customs Declaration"
            case .requestedPickupTransportEvent: return "Requested Pickup Transport Event"
            case .requestedDeliveryTransportEvent: return "Requested Delivery Transport Event"
            case .plannedPickupTransportEvent: return "Planned Pickup Transport Event"
            case .plannedDeliveryTransportEvent: return "Planned Delivery Transport Event"
            case .status: return "Status"
            case .childConsignment: return "Child Consignment"
            case .consigneeParty: return "Consignee Party"
            case .exporterParty: return "Exporter Party"
            case .consignorParty: return "Consignor Party"
            case .importerParty: return "Importer Party"
            case .carrierParty: return "Carrier Party"
            case .freightForwarderParty: return "Freight Forwarder Party"
            case .notifyParty: return "Notify Party"
            case .originalDespatchParty: return "Original Despatch Party"
            case .finalDeliveryParty: return "Final Delivery Party"
            case .performingCarrierParty: return "Performing Carrier Party"
            case .substituteCarrierParty: return "Substitute Carrier Party"
            case .logisticsOperatorParty: return "Logistics Operator Party"
            case .transportAdvisorParty: return "Transport Advisor Party"
            case .hazardousItemNotificationParty: return "Hazardous Item Notification Party"
            case .insuranceParty: return "Insurance Party"
            case .mortgageHolderParty: return "Mortgage Holder Party"
            case .billOfLadingHolderParty: return "Bill Of Lading Holder Party"
            case .originalDepartureCountry: return "Original Departure Country"
            case .finalDestinationCountry: return "Final Destination Country"
            case .transitCountry: return "Transit Country"
            case .transportContract: return "Transport Contract"
            case .transportEvent: return "Transport Event"
            case .originalDespatchTransportationService: return "Original Despatch Transportation Service"
            case .finalDeliveryTransportationService: return "Final Delivery Transportation Service"
            case .deliveryTerms: return "Delivery Terms"
            case .paymentTerms: return "Payment Terms"
            case .collectPaymentTerms: return "Collect Payment Terms"
            case .disbursementPaymentTerms: return "Disbursement Payment Terms"
            case .prepaidPaymentTerms: return "Prepaid Payment Terms"
            case .freightAllowanceCharge: return "Freight Allowance Charge"
            case .extraAllowanceCharge: return "Extra Allowance Charge"
            case .mainCarriageShipmentStage: return "Main Carriage Shipment Stage"
            case .preCarriageShipmentStage: return "Pre Carriage Shipment Stage"
            case .onCarriageShipmentStage: return "On Carriage Shipment Stage"
            case .transportHandlingUnit: return "Transport Handling Unit"
            case .firstArrivalPortLocation: return "First Arrival Port Location"
            case .lastExitPortLocation: return "Last Exit Port Location"
        }
    }

    public func details(for key: CodingKeys) -> String? {
        switch key {
            case .id: return "An identifier assigned to a collection of goods for both import and export."
            case .carrierAssignedID: return "An identifier for this consignment, assigned by the carrier."
            case .consigneeAssignedID: return "An identifier for this consignment, assigned by the consignee."
            case .consignorAssignedID: return "An identifier for this consignment, assigned by the consignor."
            case .freightForwarderAssignedID: return "An identifier for this consignment, assigned by the freight forwarder."
            case .brokerAssignedID: return "An identifier for this consignment, assigned by the broker."
            case .contractedCarrierAssignedID: return "An identifier for this consignment, assigned by the contracted carrier."
            case .performingCarrierAssignedID: return "An identifier for this consignment, assigned by the performing carrier."
            case .summaryDescription: return "A textual summary description of the consignment."
            case .totalInvoiceAmount: return "The total of all invoice amounts declared in this consignment."
            case .declaredCustomsValueAmount: return "The total declared value for customs purposes of all the goods in this consignment, regardless of whether they are subject to the same customs procedure, tariff/statistical categorization, country information, or duty regime."
            case .tariffDescription: return "Text describing the tariff applied to this consignment."
            case .tariffCode: return "A code signifying the tariff applied to this consignment."
            case .insurancePremiumAmount: return "The amount of the premium payable to an insurance company for insuring the goods contained in this consignment."
            case .grossWeightMeasure: return "The total declared weight of the goods in this consignment, including packaging but excluding the carrier's equipment."
            case .netWeightMeasure: return "The total net weight of all the goods items referred to as one consignment."
            case .netNetWeightMeasure: return "The total net weight of the goods in this consignment, exclusive of packaging."
            case .chargeableWeightMeasure: return "The weight upon which a charge is to be based."
            case .grossVolumeMeasure: return "The total volume of the goods referred to as one consignment."
            case .netVolumeMeasure: return "The total net volume of all goods items referred to as one consignment."
            case .loadingLengthMeasure: return "The total length in a means of transport or a piece of transport equipment which, given the width and height of the transport means, will accommodate all of the consignments in a single consolidation."
            case .remarks: return "Remarks concerning the complete consignment, to be printed on the transport document."
            case .hazardousRiskIndicator: return "An indication that the transported goods in this consignment are subject to an international regulation concerning the carriage of dangerous goods (true) or not (false)."
            case .animalFoodIndicator: return "An indication that the transported goods in this consignment are animal foodstuffs (true) or not (false)."
            case .humanFoodIndicator: return "An indication that the transported goods in this consignment are for human consumption (true) or not (false)."
            case .livestockIndicator: return "An indication that the transported goods are livestock (true) or not (false)."
            case .bulkCargoIndicator: return "An indication that the transported goods in this consignment are bulk cargoes (true) or not (false)."
            case .containerizedIndicator: return "An indication that the transported goods in this consignment are containerized cargoes (true) or not (false)."
            case .generalCargoIndicator: return "An indication that the transported goods in this consignment are general cargoes (true) or not (false)."
            case .specialSecurityIndicator: return "An indication that the transported goods in this consignment require special security (true) or not (false)."
            case .thirdPartyPayerIndicator: return "An indication that this consignment will be paid for by a third party (true) or not (false)."
            case .carrierServiceInstructions: return "Service instructions to the carrier, expressed as text."
            case .customsClearanceServiceInstructions: return "Service instructions for customs clearance, expressed as text."
            case .forwarderServiceInstructions: return "Service instructions for the forwarder, expressed as text."
            case .specialServiceInstructions: return "Special service instructions, expressed as text."
            case .sequenceID: return "A sequence identifier for this consignment."
            case .shippingPriorityLevelCode: return "A code signifying the priority or level of service required for this consignment."
            case .handlingCode: return "The handling required for this consignment, expressed as a code."
            case .handlingInstructions: return "The handling required for this consignment, expressed as text."
            case .information: return "Free-form text pertinent to this consignment, conveying information that is not contained explicitly in other structures."
            case .totalGoodsItemQuantity: return "The total number of goods items in this consignment."
            case .totalTransportHandlingUnitQuantity: return "The number of pieces of transport handling equipment (pallets, boxes, cases, etc.) in this consignment."
            case .insuranceValueAmount: return "The amount covered by insurance for this consignment."
            case .declaredForCarriageValueAmount: return "The value of this consignment, declared by the shipper or his agent solely for the purpose of varying the carrier's level of liability from that provided in the contract of carriage, in case of loss or damage to goods or delayed delivery."
            case .declaredStatisticsValueAmount: return "The value, declared for statistical purposes, of those goods in this consignment that have the same statistical heading."
            case .freeOnBoardValueAmount: return "The monetary amount that has to be or has been paid as calculated under the applicable trade delivery."
            case .specialInstructions: return "Special instructions relating to this consignment."
            case .splitConsignmentIndicator: return "An indicator that this consignment has been split in transit (true) or not (false)."
            case .deliveryInstructions: return "A set of delivery instructions relating to this consignment."
            case .consignmentQuantity: return "The count in this consignment considering goods items, child consignments, shipments"
            case .consolidatableIndicator: return "An indicator that this consignment can be consolidated (true) or not (false)."
            case .haulageInstructions: return "Instructions regarding haulage of this consignment, expressed as text."
            case .loadingSequenceID: return "An identifier for the loading sequence of this consignment."
            case .childConsignmentQuantity: return "The quantity of (consolidated) child consignments"
            case .totalPackagesQuantity: return "The total number of packages associated with a Consignment."
            case .consolidatedShipment: return "A consolidated shipment (a shipment created by an act of consolidation)."
            case .customsDeclaration: return "A class describing identifiers or references relating to customs procedures."
            case .requestedPickupTransportEvent: return "The pickup of this consignment requested by the party requesting a transportation service (the transport user)."
            case .requestedDeliveryTransportEvent: return "The delivery of this consignment requested by the party requesting a transportation service (the transport user)."
            case .plannedPickupTransportEvent: return "The pickup of this consignment planned by the party responsible for providing the transportation service (the transport service provider)."
            case .plannedDeliveryTransportEvent: return "The delivery of this consignment planned by the party responsible for providing the transportation service (the transport service provider)."
            case .status: return "The status of a particular condition associated with this consignment."
            case .childConsignment: return "One of the child consignments of which a consolidated consignment is composed."
            case .consigneeParty: return "A party to which goods are consigned."
            case .exporterParty: return "The party that makes the export declaration, or on behalf of which the export declaration is made, and that is the owner of the goods in this consignment or has similar right of disposal over them at the time when the declaration is accepted."
            case .consignorParty: return "The party consigning goods, as stipulated in the transport contract by the party ordering transport."
            case .importerParty: return "The party that makes an import declaration regarding this consignment, or on behalf of which a customs clearing agent or other authorized person makes an import declaration regarding this consignment. This may include a person who has possession of the goods or to whom the goods are consigned."
            case .carrierParty: return "The party providing the transport of goods in this consignment between named points."
            case .freightForwarderParty: return "The party combining individual smaller consignments into a single larger shipment (the consolidated shipment), which is sent to a counterpart that mirrors the consolidator's activity by dividing the consolidated consignment into its original components."
            case .notifyParty: return "The party to be notified upon arrival of goods and when special occurrences (usually pre-defined) take place during a transportation service."
            case .originalDespatchParty: return "The original despatch (sender) party for this consignment."
            case .finalDeliveryParty: return "The final delivery party for this consignment."
            case .performingCarrierParty: return "The party performing the carriage of this consignment."
            case .substituteCarrierParty: return "A substitute party performing the carriage of this consignment."
            case .logisticsOperatorParty: return "The logistics operator party for this consignment."
            case .transportAdvisorParty: return "The party providing transport advice this consignment."
            case .hazardousItemNotificationParty: return "The party that would be notified of a hazardous item in this consignment."
            case .insuranceParty: return "The party holding the insurance for this consignment."
            case .mortgageHolderParty: return "The party holding the mortgage for this consignment."
            case .billOfLadingHolderParty: return "The party holding the bill of lading for this consignment."
            case .originalDepartureCountry: return "The country from which the goods in this consignment were originally exported, without any commercial transaction taking place in intermediate countries."
            case .finalDestinationCountry: return "The country in which the goods in this consignment are to be delivered to the final consignee or buyer."
            case .transitCountry: return "One of the countries through which goods or passengers in this consignment are routed between the country of original departure and the country of final destination."
            case .transportContract: return "A transport contract relating to this consignment."
            case .transportEvent: return "A class describing a significant occurrence or happening related to the transportation of goods."
            case .originalDespatchTransportationService: return "The service for pickup from the consignor under the transport contract for this consignment."
            case .finalDeliveryTransportationService: return "The service for delivery to the consignee under the transport contract for this consignment."
            case .deliveryTerms: return "The conditions agreed upon between a seller and a buyer with regard to the delivery of goods and/or services (e.g., CIF, FOB, or EXW from the INCOTERMS Terms of Delivery)."
            case .paymentTerms: return "The terms of payment between the parties (such as logistics service client, logistics service provider) in a transaction."
            case .collectPaymentTerms: return "The terms of payment that apply to the collection of this consignment."
            case .disbursementPaymentTerms: return "The terms of payment for disbursement."
            case .prepaidPaymentTerms: return "The terms of payment for prepayment."
            case .freightAllowanceCharge: return "A cost incurred by the shipper in moving goods, by whatever means, from one place to another under the terms of the contract of carriage for this consignment. In addition to transport costs, this may include such elements as packing, documentation, loading, unloading, and insurance to the extent that they relate to the freight costs."
            case .extraAllowanceCharge: return "A charge for extra allowance."
            case .mainCarriageShipmentStage: return "A shipment stage during main carriage."
            case .preCarriageShipmentStage: return "A shipment stage during precarriage (usually refers to movement activity that takes place prior to the container being loaded at a port of loading)."
            case .onCarriageShipmentStage: return "A shipment stage during on-carriage (usually refers to movement activity that takes place after the container is discharged at a port of discharge)."
            case .transportHandlingUnit: return "A transport handling unit used for loose and containerized goods."
            case .firstArrivalPortLocation: return "The first arrival location in a transport. This would be a port for sea, an airport for air, a terminal for rail, or a border post for land crossing."
            case .lastExitPortLocation: return "The final exporting location in a transport. This would be a port for sea, an airport for air, a terminal for rail, or a border post for land crossing."
        }
    }
    func skipView(title _title: String, key: CodingKeys, search _search: String?) -> Bool {
        if let _search,
            (_title.search(_search) == nil) {
            let result: SearchResult?
            switch key {
                case .id: result = id.search(_search)
                case .carrierAssignedID: result = carrierAssignedID?.search(_search)
                case .consigneeAssignedID: result = consigneeAssignedID?.search(_search)
                case .consignorAssignedID: result = consignorAssignedID?.search(_search)
                case .freightForwarderAssignedID: result = freightForwarderAssignedID?.search(_search)
                case .brokerAssignedID: result = brokerAssignedID?.search(_search)
                case .contractedCarrierAssignedID: result = contractedCarrierAssignedID?.search(_search)
                case .performingCarrierAssignedID: result = performingCarrierAssignedID?.search(_search)
                case .summaryDescription: result = summaryDescription.compactMap({ $0.search(_search) }).first
                case .totalInvoiceAmount: result = totalInvoiceAmount?.search(_search)
                case .declaredCustomsValueAmount: result = declaredCustomsValueAmount?.search(_search)
                case .tariffDescription: result = tariffDescription.compactMap({ $0.search(_search) }).first
                case .tariffCode: result = tariffCode?.search(_search)
                case .insurancePremiumAmount: result = insurancePremiumAmount?.search(_search)
                case .grossWeightMeasure: result = grossWeightMeasure?.search(_search)
                case .netWeightMeasure: result = netWeightMeasure?.search(_search)
                case .netNetWeightMeasure: result = netNetWeightMeasure?.search(_search)
                case .chargeableWeightMeasure: result = chargeableWeightMeasure?.search(_search)
                case .grossVolumeMeasure: result = grossVolumeMeasure?.search(_search)
                case .netVolumeMeasure: result = netVolumeMeasure?.search(_search)
                case .loadingLengthMeasure: result = loadingLengthMeasure?.search(_search)
                case .remarks: result = remarks.compactMap({ $0.search(_search) }).first
                case .hazardousRiskIndicator: result = hazardousRiskIndicator?.search(_search)
                case .animalFoodIndicator: result = animalFoodIndicator?.search(_search)
                case .humanFoodIndicator: result = humanFoodIndicator?.search(_search)
                case .livestockIndicator: result = livestockIndicator?.search(_search)
                case .bulkCargoIndicator: result = bulkCargoIndicator?.search(_search)
                case .containerizedIndicator: result = containerizedIndicator?.search(_search)
                case .generalCargoIndicator: result = generalCargoIndicator?.search(_search)
                case .specialSecurityIndicator: result = specialSecurityIndicator?.search(_search)
                case .thirdPartyPayerIndicator: result = thirdPartyPayerIndicator?.search(_search)
                case .carrierServiceInstructions: result = carrierServiceInstructions.compactMap({ $0.search(_search) }).first
                case .customsClearanceServiceInstructions: result = customsClearanceServiceInstructions.compactMap({ $0.search(_search) }).first
                case .forwarderServiceInstructions: result = forwarderServiceInstructions.compactMap({ $0.search(_search) }).first
                case .specialServiceInstructions: result = specialServiceInstructions.compactMap({ $0.search(_search) }).first
                case .sequenceID: result = sequenceID?.search(_search)
                case .shippingPriorityLevelCode: result = shippingPriorityLevelCode?.search(_search)
                case .handlingCode: result = handlingCode?.search(_search)
                case .handlingInstructions: result = handlingInstructions.compactMap({ $0.search(_search) }).first
                case .information: result = information.compactMap({ $0.search(_search) }).first
                case .totalGoodsItemQuantity: result = totalGoodsItemQuantity?.search(_search)
                case .totalTransportHandlingUnitQuantity: result = totalTransportHandlingUnitQuantity?.search(_search)
                case .insuranceValueAmount: result = insuranceValueAmount?.search(_search)
                case .declaredForCarriageValueAmount: result = declaredForCarriageValueAmount?.search(_search)
                case .declaredStatisticsValueAmount: result = declaredStatisticsValueAmount?.search(_search)
                case .freeOnBoardValueAmount: result = freeOnBoardValueAmount?.search(_search)
                case .specialInstructions: result = specialInstructions.compactMap({ $0.search(_search) }).first
                case .splitConsignmentIndicator: result = splitConsignmentIndicator?.search(_search)
                case .deliveryInstructions: result = deliveryInstructions.compactMap({ $0.search(_search) }).first
                case .consignmentQuantity: result = consignmentQuantity?.search(_search)
                case .consolidatableIndicator: result = consolidatableIndicator?.search(_search)
                case .haulageInstructions: result = haulageInstructions.compactMap({ $0.search(_search) }).first
                case .loadingSequenceID: result = loadingSequenceID?.search(_search)
                case .childConsignmentQuantity: result = childConsignmentQuantity?.search(_search)
                case .totalPackagesQuantity: result = totalPackagesQuantity?.search(_search)
                case .consolidatedShipment: result = consolidatedShipment.compactMap({ $0.search(_search) }).first
                case .customsDeclaration: result = customsDeclaration.compactMap({ $0.search(_search) }).first
                case .requestedPickupTransportEvent: result = requestedPickupTransportEvent?.search(_search)
                case .requestedDeliveryTransportEvent: result = requestedDeliveryTransportEvent?.search(_search)
                case .plannedPickupTransportEvent: result = plannedPickupTransportEvent?.search(_search)
                case .plannedDeliveryTransportEvent: result = plannedDeliveryTransportEvent?.search(_search)
                case .status: result = status.compactMap({ $0.search(_search) }).first
                case .childConsignment: result = childConsignment.compactMap({ $0.search(_search) }).first
                case .consigneeParty: result = consigneeParty?.search(_search)
                case .exporterParty: result = exporterParty?.search(_search)
                case .consignorParty: result = consignorParty?.search(_search)
                case .importerParty: result = importerParty?.search(_search)
                case .carrierParty: result = carrierParty?.search(_search)
                case .freightForwarderParty: result = freightForwarderParty?.search(_search)
                case .notifyParty: result = notifyParty?.search(_search)
                case .originalDespatchParty: result = originalDespatchParty?.search(_search)
                case .finalDeliveryParty: result = finalDeliveryParty?.search(_search)
                case .performingCarrierParty: result = performingCarrierParty?.search(_search)
                case .substituteCarrierParty: result = substituteCarrierParty?.search(_search)
                case .logisticsOperatorParty: result = logisticsOperatorParty?.search(_search)
                case .transportAdvisorParty: result = transportAdvisorParty?.search(_search)
                case .hazardousItemNotificationParty: result = hazardousItemNotificationParty?.search(_search)
                case .insuranceParty: result = insuranceParty?.search(_search)
                case .mortgageHolderParty: result = mortgageHolderParty?.search(_search)
                case .billOfLadingHolderParty: result = billOfLadingHolderParty?.search(_search)
                case .originalDepartureCountry: result = originalDepartureCountry?.search(_search)
                case .finalDestinationCountry: result = finalDestinationCountry?.search(_search)
                case .transitCountry: result = transitCountry.compactMap({ $0.search(_search) }).first
                case .transportContract: result = transportContract?.search(_search)
                case .transportEvent: result = transportEvent.compactMap({ $0.search(_search) }).first
                case .originalDespatchTransportationService: result = originalDespatchTransportationService?.search(_search)
                case .finalDeliveryTransportationService: result = finalDeliveryTransportationService?.search(_search)
                case .deliveryTerms: result = deliveryTerms?.search(_search)
                case .paymentTerms: result = paymentTerms?.search(_search)
                case .collectPaymentTerms: result = collectPaymentTerms?.search(_search)
                case .disbursementPaymentTerms: result = disbursementPaymentTerms?.search(_search)
                case .prepaidPaymentTerms: result = prepaidPaymentTerms?.search(_search)
                case .freightAllowanceCharge: result = freightAllowanceCharge.compactMap({ $0.search(_search) }).first
                case .extraAllowanceCharge: result = extraAllowanceCharge.compactMap({ $0.search(_search) }).first
                case .mainCarriageShipmentStage: result = mainCarriageShipmentStage.compactMap({ $0.search(_search) }).first
                case .preCarriageShipmentStage: result = preCarriageShipmentStage.compactMap({ $0.search(_search) }).first
                case .onCarriageShipmentStage: result = onCarriageShipmentStage.compactMap({ $0.search(_search) }).first
                case .transportHandlingUnit: result = transportHandlingUnit.compactMap({ $0.search(_search) }).first
                case .firstArrivalPortLocation: result = firstArrivalPortLocation?.search(_search)
                case .lastExitPortLocation: result = lastExitPortLocation?.search(_search)
            }
            return (result == nil)
        }
        return false
    }

    @MainActor @ViewBuilder public func view(for key: CodingKeys, show: Bool = false, search _search: String? = nil) -> some View {
        let _title = title(for: key)
        if !skipView(title: _title, key: key, search: _search) {
        let _details = details(for: key)
            switch key {
                case .id: presentableView(for: id, title: _title, details: _details, show: show, search: _search)
                case .carrierAssignedID: presentableView(for: carrierAssignedID, title: _title, details: _details, show: show, search: _search)
                case .consigneeAssignedID: presentableView(for: consigneeAssignedID, title: _title, details: _details, show: show, search: _search)
                case .consignorAssignedID: presentableView(for: consignorAssignedID, title: _title, details: _details, show: show, search: _search)
                case .freightForwarderAssignedID: presentableView(for: freightForwarderAssignedID, title: _title, details: _details, show: show, search: _search)
                case .brokerAssignedID: presentableView(for: brokerAssignedID, title: _title, details: _details, show: show, search: _search)
                case .contractedCarrierAssignedID: presentableView(for: contractedCarrierAssignedID, title: _title, details: _details, show: show, search: _search)
                case .performingCarrierAssignedID: presentableView(for: performingCarrierAssignedID, title: _title, details: _details, show: show, search: _search)
                case .summaryDescription: presentableView(for: summaryDescription.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .totalInvoiceAmount: presentableView(for: totalInvoiceAmount, title: _title, details: _details, show: show, search: _search)
                case .declaredCustomsValueAmount: presentableView(for: declaredCustomsValueAmount, title: _title, details: _details, show: show, search: _search)
                case .tariffDescription: presentableView(for: tariffDescription.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .tariffCode: presentableView(for: tariffCode, title: _title, details: _details, show: show, search: _search)
                case .insurancePremiumAmount: presentableView(for: insurancePremiumAmount, title: _title, details: _details, show: show, search: _search)
                case .grossWeightMeasure: presentableView(for: grossWeightMeasure, title: _title, details: _details, show: show, search: _search)
                case .netWeightMeasure: presentableView(for: netWeightMeasure, title: _title, details: _details, show: show, search: _search)
                case .netNetWeightMeasure: presentableView(for: netNetWeightMeasure, title: _title, details: _details, show: show, search: _search)
                case .chargeableWeightMeasure: presentableView(for: chargeableWeightMeasure, title: _title, details: _details, show: show, search: _search)
                case .grossVolumeMeasure: presentableView(for: grossVolumeMeasure, title: _title, details: _details, show: show, search: _search)
                case .netVolumeMeasure: presentableView(for: netVolumeMeasure, title: _title, details: _details, show: show, search: _search)
                case .loadingLengthMeasure: presentableView(for: loadingLengthMeasure, title: _title, details: _details, show: show, search: _search)
                case .remarks: presentableView(for: remarks.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .hazardousRiskIndicator: presentableView(for: hazardousRiskIndicator, title: _title, details: _details, show: show, search: _search)
                case .animalFoodIndicator: presentableView(for: animalFoodIndicator, title: _title, details: _details, show: show, search: _search)
                case .humanFoodIndicator: presentableView(for: humanFoodIndicator, title: _title, details: _details, show: show, search: _search)
                case .livestockIndicator: presentableView(for: livestockIndicator, title: _title, details: _details, show: show, search: _search)
                case .bulkCargoIndicator: presentableView(for: bulkCargoIndicator, title: _title, details: _details, show: show, search: _search)
                case .containerizedIndicator: presentableView(for: containerizedIndicator, title: _title, details: _details, show: show, search: _search)
                case .generalCargoIndicator: presentableView(for: generalCargoIndicator, title: _title, details: _details, show: show, search: _search)
                case .specialSecurityIndicator: presentableView(for: specialSecurityIndicator, title: _title, details: _details, show: show, search: _search)
                case .thirdPartyPayerIndicator: presentableView(for: thirdPartyPayerIndicator, title: _title, details: _details, show: show, search: _search)
                case .carrierServiceInstructions: presentableView(for: carrierServiceInstructions.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .customsClearanceServiceInstructions: presentableView(for: customsClearanceServiceInstructions.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .forwarderServiceInstructions: presentableView(for: forwarderServiceInstructions.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .specialServiceInstructions: presentableView(for: specialServiceInstructions.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .sequenceID: presentableView(for: sequenceID, title: _title, details: _details, show: show, search: _search)
                case .shippingPriorityLevelCode: presentableView(for: shippingPriorityLevelCode, title: _title, details: _details, show: show, search: _search)
                case .handlingCode: presentableView(for: handlingCode, title: _title, details: _details, show: show, search: _search)
                case .handlingInstructions: presentableView(for: handlingInstructions.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .information: presentableView(for: information.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .totalGoodsItemQuantity: presentableView(for: totalGoodsItemQuantity, title: _title, details: _details, show: show, search: _search)
                case .totalTransportHandlingUnitQuantity: presentableView(for: totalTransportHandlingUnitQuantity, title: _title, details: _details, show: show, search: _search)
                case .insuranceValueAmount: presentableView(for: insuranceValueAmount, title: _title, details: _details, show: show, search: _search)
                case .declaredForCarriageValueAmount: presentableView(for: declaredForCarriageValueAmount, title: _title, details: _details, show: show, search: _search)
                case .declaredStatisticsValueAmount: presentableView(for: declaredStatisticsValueAmount, title: _title, details: _details, show: show, search: _search)
                case .freeOnBoardValueAmount: presentableView(for: freeOnBoardValueAmount, title: _title, details: _details, show: show, search: _search)
                case .specialInstructions: presentableView(for: specialInstructions.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .splitConsignmentIndicator: presentableView(for: splitConsignmentIndicator, title: _title, details: _details, show: show, search: _search)
                case .deliveryInstructions: presentableView(for: deliveryInstructions.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .consignmentQuantity: presentableView(for: consignmentQuantity, title: _title, details: _details, show: show, search: _search)
                case .consolidatableIndicator: presentableView(for: consolidatableIndicator, title: _title, details: _details, show: show, search: _search)
                case .haulageInstructions: presentableView(for: haulageInstructions.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .loadingSequenceID: presentableView(for: loadingSequenceID, title: _title, details: _details, show: show, search: _search)
                case .childConsignmentQuantity: presentableView(for: childConsignmentQuantity, title: _title, details: _details, show: show, search: _search)
                case .totalPackagesQuantity: presentableView(for: totalPackagesQuantity, title: _title, details: _details, show: show, search: _search)
                case .consolidatedShipment: presentableView(for: consolidatedShipment.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .customsDeclaration: presentableView(for: customsDeclaration.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .requestedPickupTransportEvent: presentableView(for: requestedPickupTransportEvent, title: _title, details: _details, show: show, search: _search)
                case .requestedDeliveryTransportEvent: presentableView(for: requestedDeliveryTransportEvent, title: _title, details: _details, show: show, search: _search)
                case .plannedPickupTransportEvent: presentableView(for: plannedPickupTransportEvent, title: _title, details: _details, show: show, search: _search)
                case .plannedDeliveryTransportEvent: presentableView(for: plannedDeliveryTransportEvent, title: _title, details: _details, show: show, search: _search)
                case .status: presentableView(for: status.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .childConsignment: presentableView(for: childConsignment.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .consigneeParty: presentableView(for: consigneeParty, title: _title, details: _details, show: show, search: _search)
                case .exporterParty: presentableView(for: exporterParty, title: _title, details: _details, show: show, search: _search)
                case .consignorParty: presentableView(for: consignorParty, title: _title, details: _details, show: show, search: _search)
                case .importerParty: presentableView(for: importerParty, title: _title, details: _details, show: show, search: _search)
                case .carrierParty: presentableView(for: carrierParty, title: _title, details: _details, show: show, search: _search)
                case .freightForwarderParty: presentableView(for: freightForwarderParty, title: _title, details: _details, show: show, search: _search)
                case .notifyParty: presentableView(for: notifyParty, title: _title, details: _details, show: show, search: _search)
                case .originalDespatchParty: presentableView(for: originalDespatchParty, title: _title, details: _details, show: show, search: _search)
                case .finalDeliveryParty: presentableView(for: finalDeliveryParty, title: _title, details: _details, show: show, search: _search)
                case .performingCarrierParty: presentableView(for: performingCarrierParty, title: _title, details: _details, show: show, search: _search)
                case .substituteCarrierParty: presentableView(for: substituteCarrierParty, title: _title, details: _details, show: show, search: _search)
                case .logisticsOperatorParty: presentableView(for: logisticsOperatorParty, title: _title, details: _details, show: show, search: _search)
                case .transportAdvisorParty: presentableView(for: transportAdvisorParty, title: _title, details: _details, show: show, search: _search)
                case .hazardousItemNotificationParty: presentableView(for: hazardousItemNotificationParty, title: _title, details: _details, show: show, search: _search)
                case .insuranceParty: presentableView(for: insuranceParty, title: _title, details: _details, show: show, search: _search)
                case .mortgageHolderParty: presentableView(for: mortgageHolderParty, title: _title, details: _details, show: show, search: _search)
                case .billOfLadingHolderParty: presentableView(for: billOfLadingHolderParty, title: _title, details: _details, show: show, search: _search)
                case .originalDepartureCountry: presentableView(for: originalDepartureCountry, title: _title, details: _details, show: show, search: _search)
                case .finalDestinationCountry: presentableView(for: finalDestinationCountry, title: _title, details: _details, show: show, search: _search)
                case .transitCountry: presentableView(for: transitCountry.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .transportContract: presentableView(for: transportContract, title: _title, details: _details, show: show, search: _search)
                case .transportEvent: presentableView(for: transportEvent.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .originalDespatchTransportationService: presentableView(for: originalDespatchTransportationService, title: _title, details: _details, show: show, search: _search)
                case .finalDeliveryTransportationService: presentableView(for: finalDeliveryTransportationService, title: _title, details: _details, show: show, search: _search)
                case .deliveryTerms: presentableView(for: deliveryTerms, title: _title, details: _details, show: show, search: _search)
                case .paymentTerms: presentableView(for: paymentTerms, title: _title, details: _details, show: show, search: _search)
                case .collectPaymentTerms: presentableView(for: collectPaymentTerms, title: _title, details: _details, show: show, search: _search)
                case .disbursementPaymentTerms: presentableView(for: disbursementPaymentTerms, title: _title, details: _details, show: show, search: _search)
                case .prepaidPaymentTerms: presentableView(for: prepaidPaymentTerms, title: _title, details: _details, show: show, search: _search)
                case .freightAllowanceCharge: presentableView(for: freightAllowanceCharge.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .extraAllowanceCharge: presentableView(for: extraAllowanceCharge.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .mainCarriageShipmentStage: presentableView(for: mainCarriageShipmentStage.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .preCarriageShipmentStage: presentableView(for: preCarriageShipmentStage.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .onCarriageShipmentStage: presentableView(for: onCarriageShipmentStage.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .transportHandlingUnit: presentableView(for: transportHandlingUnit.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .firstArrivalPortLocation: presentableView(for: firstArrivalPortLocation, title: _title, details: _details, show: show, search: _search)
                case .lastExitPortLocation: presentableView(for: lastExitPortLocation, title: _title, details: _details, show: show, search: _search)
            }
        }
    }
}

extension UBLInvoice.Consignment: Searchable {
    public func search(_ string: String) -> SearchResult? {
        for codingKey in Self.elementKeys {
            let _title = self.title(for: codingKey) 
            if _title.contains(string) {
                return .title(_title)
            }
        }
        if let result = id.search(string) { return result }
        if let result = carrierAssignedID?.search(string) { return result }
        if let result = consigneeAssignedID?.search(string) { return result }
        if let result = consignorAssignedID?.search(string) { return result }
        if let result = freightForwarderAssignedID?.search(string) { return result }
        if let result = brokerAssignedID?.search(string) { return result }
        if let result = contractedCarrierAssignedID?.search(string) { return result }
        if let result = performingCarrierAssignedID?.search(string) { return result }
        if let result = summaryDescription.compactMap({ $0.search(string)  }).first { return result }
        if let result = totalInvoiceAmount?.search(string) { return result }
        if let result = declaredCustomsValueAmount?.search(string) { return result }
        if let result = tariffDescription.compactMap({ $0.search(string)  }).first { return result }
        if let result = tariffCode?.search(string) { return result }
        if let result = insurancePremiumAmount?.search(string) { return result }
        if let result = grossWeightMeasure?.search(string) { return result }
        if let result = netWeightMeasure?.search(string) { return result }
        if let result = netNetWeightMeasure?.search(string) { return result }
        if let result = chargeableWeightMeasure?.search(string) { return result }
        if let result = grossVolumeMeasure?.search(string) { return result }
        if let result = netVolumeMeasure?.search(string) { return result }
        if let result = loadingLengthMeasure?.search(string) { return result }
        if let result = remarks.compactMap({ $0.search(string)  }).first { return result }
        if let result = hazardousRiskIndicator?.search(string) { return result }
        if let result = animalFoodIndicator?.search(string) { return result }
        if let result = humanFoodIndicator?.search(string) { return result }
        if let result = livestockIndicator?.search(string) { return result }
        if let result = bulkCargoIndicator?.search(string) { return result }
        if let result = containerizedIndicator?.search(string) { return result }
        if let result = generalCargoIndicator?.search(string) { return result }
        if let result = specialSecurityIndicator?.search(string) { return result }
        if let result = thirdPartyPayerIndicator?.search(string) { return result }
        if let result = carrierServiceInstructions.compactMap({ $0.search(string)  }).first { return result }
        if let result = customsClearanceServiceInstructions.compactMap({ $0.search(string)  }).first { return result }
        if let result = forwarderServiceInstructions.compactMap({ $0.search(string)  }).first { return result }
        if let result = specialServiceInstructions.compactMap({ $0.search(string)  }).first { return result }
        if let result = sequenceID?.search(string) { return result }
        if let result = shippingPriorityLevelCode?.search(string) { return result }
        if let result = handlingCode?.search(string) { return result }
        if let result = handlingInstructions.compactMap({ $0.search(string)  }).first { return result }
        if let result = information.compactMap({ $0.search(string)  }).first { return result }
        if let result = totalGoodsItemQuantity?.search(string) { return result }
        if let result = totalTransportHandlingUnitQuantity?.search(string) { return result }
        if let result = insuranceValueAmount?.search(string) { return result }
        if let result = declaredForCarriageValueAmount?.search(string) { return result }
        if let result = declaredStatisticsValueAmount?.search(string) { return result }
        if let result = freeOnBoardValueAmount?.search(string) { return result }
        if let result = specialInstructions.compactMap({ $0.search(string)  }).first { return result }
        if let result = splitConsignmentIndicator?.search(string) { return result }
        if let result = deliveryInstructions.compactMap({ $0.search(string)  }).first { return result }
        if let result = consignmentQuantity?.search(string) { return result }
        if let result = consolidatableIndicator?.search(string) { return result }
        if let result = haulageInstructions.compactMap({ $0.search(string)  }).first { return result }
        if let result = loadingSequenceID?.search(string) { return result }
        if let result = childConsignmentQuantity?.search(string) { return result }
        if let result = totalPackagesQuantity?.search(string) { return result }
        if let result = consolidatedShipment.compactMap({ $0.search(string)  }).first { return result }
        if let result = customsDeclaration.compactMap({ $0.search(string)  }).first { return result }
        if let result = requestedPickupTransportEvent?.search(string) { return result }
        if let result = requestedDeliveryTransportEvent?.search(string) { return result }
        if let result = plannedPickupTransportEvent?.search(string) { return result }
        if let result = plannedDeliveryTransportEvent?.search(string) { return result }
        if let result = status.compactMap({ $0.search(string)  }).first { return result }
        if let result = childConsignment.compactMap({ $0.search(string)  }).first { return result }
        if let result = consigneeParty?.search(string) { return result }
        if let result = exporterParty?.search(string) { return result }
        if let result = consignorParty?.search(string) { return result }
        if let result = importerParty?.search(string) { return result }
        if let result = carrierParty?.search(string) { return result }
        if let result = freightForwarderParty?.search(string) { return result }
        if let result = notifyParty?.search(string) { return result }
        if let result = originalDespatchParty?.search(string) { return result }
        if let result = finalDeliveryParty?.search(string) { return result }
        if let result = performingCarrierParty?.search(string) { return result }
        if let result = substituteCarrierParty?.search(string) { return result }
        if let result = logisticsOperatorParty?.search(string) { return result }
        if let result = transportAdvisorParty?.search(string) { return result }
        if let result = hazardousItemNotificationParty?.search(string) { return result }
        if let result = insuranceParty?.search(string) { return result }
        if let result = mortgageHolderParty?.search(string) { return result }
        if let result = billOfLadingHolderParty?.search(string) { return result }
        if let result = originalDepartureCountry?.search(string) { return result }
        if let result = finalDestinationCountry?.search(string) { return result }
        if let result = transitCountry.compactMap({ $0.search(string)  }).first { return result }
        if let result = transportContract?.search(string) { return result }
        if let result = transportEvent.compactMap({ $0.search(string)  }).first { return result }
        if let result = originalDespatchTransportationService?.search(string) { return result }
        if let result = finalDeliveryTransportationService?.search(string) { return result }
        if let result = deliveryTerms?.search(string) { return result }
        if let result = paymentTerms?.search(string) { return result }
        if let result = collectPaymentTerms?.search(string) { return result }
        if let result = disbursementPaymentTerms?.search(string) { return result }
        if let result = prepaidPaymentTerms?.search(string) { return result }
        if let result = freightAllowanceCharge.compactMap({ $0.search(string)  }).first { return result }
        if let result = extraAllowanceCharge.compactMap({ $0.search(string)  }).first { return result }
        if let result = mainCarriageShipmentStage.compactMap({ $0.search(string)  }).first { return result }
        if let result = preCarriageShipmentStage.compactMap({ $0.search(string)  }).first { return result }
        if let result = onCarriageShipmentStage.compactMap({ $0.search(string)  }).first { return result }
        if let result = transportHandlingUnit.compactMap({ $0.search(string)  }).first { return result }
        if let result = firstArrivalPortLocation?.search(string) { return result }
        if let result = lastExitPortLocation?.search(string) { return result }
        return nil
    }
}
