// 
// CustomsDeclaration.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import SwiftUI
import ViewPresentable
import UBLInvoice

extension UBLInvoice.CustomsDeclaration: KeyViewPresentable {
    public static let elementKeys: [CodingKeys] = [
        .id,
        .issuerParty
]
    public var hasNilValue: Bool {(issuerParty == nil)
    }
    
    public func title(for key: CodingKeys) -> String {
        switch key {
            case .id: return "Identifier"
            case .issuerParty: return "Issuer Party"
        }
    }

    public func details(for key: CodingKeys) -> String? {
        switch key {
            case .id: return "An identifier associated with customs related procedures."
            case .issuerParty: return "Describes the party issuing the customs declaration."
        }
    }
    func skipView(title _title: String, key: CodingKeys, search _search: String?) -> Bool {
        if let _search,
            (_title.search(_search) == nil) {
            let result: SearchResult?
            switch key {
                case .id: result = id.search(_search)
                case .issuerParty: result = issuerParty?.search(_search)
            }
            return (result == nil)
        }
        return false
    }

    @MainActor @ViewBuilder public func view(for key: CodingKeys, show: Bool = false, search _search: String? = nil) -> some View {
        let _title = title(for: key)
        if !skipView(title: _title, key: key, search: _search) {
        let _details = details(for: key)
            switch key {
                case .id: presentableView(for: id, title: _title, details: _details, show: show, search: _search)
                case .issuerParty: presentableView(for: issuerParty, title: _title, details: _details, show: show, search: _search)
            }
        }
    }
}

extension UBLInvoice.CustomsDeclaration: Searchable {
    public func search(_ string: String) -> SearchResult? {
        for codingKey in Self.elementKeys {
            let _title = self.title(for: codingKey) 
            if _title.contains(string) {
                return .title(_title)
            }
        }
        if let result = id.search(string) { return result }
        if let result = issuerParty?.search(string) { return result }
        return nil
    }
}
