// 
// EnvironmentalEmission.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import SwiftUI
import ViewPresentable
import UBLInvoice

extension UBLInvoice.EnvironmentalEmission: KeyViewPresentable {
    public static let elementKeys: [CodingKeys] = [
        .environmentalEmissionTypeCode,
        .valueMeasure,
        .description,
        .emissionCalculationMethod
]
    public var hasNilValue: Bool {
        false
    }
    
    public func title(for key: CodingKeys) -> String {
        switch key {
            case .environmentalEmissionTypeCode: return "Environmental Emission Type Code"
            case .valueMeasure: return "Value"
            case .description: return "Description"
            case .emissionCalculationMethod: return "Emission Calculation Method"
        }
    }

    public func details(for key: CodingKeys) -> String? {
        switch key {
            case .environmentalEmissionTypeCode: return "A code specifying the type of environmental emission."
            case .valueMeasure: return "A value measurement for the environmental emission."
            case .description: return "Text describing this environmental emission."
            case .emissionCalculationMethod: return "A method used to calculate the amount of this emission."
        }
    }
    func skipView(title _title: String, key: CodingKeys, search _search: String?) -> Bool {
        if let _search,
            (_title.search(_search) == nil) {
            let result: SearchResult?
            switch key {
                case .environmentalEmissionTypeCode: result = environmentalEmissionTypeCode.search(_search)
                case .valueMeasure: result = valueMeasure.search(_search)
                case .description: result = description.compactMap({ $0.search(_search) }).first
                case .emissionCalculationMethod: result = emissionCalculationMethod.compactMap({ $0.search(_search) }).first
            }
            return (result == nil)
        }
        return false
    }

    @MainActor @ViewBuilder public func view(for key: CodingKeys, show: Bool = false, search _search: String? = nil) -> some View {
        let _title = title(for: key)
        if !skipView(title: _title, key: key, search: _search) {
        let _details = details(for: key)
            switch key {
                case .environmentalEmissionTypeCode: presentableView(for: environmentalEmissionTypeCode, title: _title, details: _details, show: show, search: _search)
                case .valueMeasure: presentableView(for: valueMeasure, title: _title, details: _details, show: show, search: _search)
                case .description: presentableView(for: description.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .emissionCalculationMethod: presentableView(for: emissionCalculationMethod.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
            }
        }
    }
}

extension UBLInvoice.EnvironmentalEmission: Searchable {
    public func search(_ string: String) -> SearchResult? {
        for codingKey in Self.elementKeys {
            let _title = self.title(for: codingKey) 
            if _title.contains(string) {
                return .title(_title)
            }
        }
        if let result = environmentalEmissionTypeCode.search(string) { return result }
        if let result = valueMeasure.search(string) { return result }
        if let result = description.compactMap({ $0.search(string)  }).first { return result }
        if let result = emissionCalculationMethod.compactMap({ $0.search(string)  }).first { return result }
        return nil
    }
}
