// 
// GoodsItem.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import SwiftUI
import ViewPresentable
import UBLInvoice

extension UBLInvoice.GoodsItem: KeyViewPresentable {
    public static let elementKeys: [CodingKeys] = [
        .id,
        .sequenceNumberID,
        .description,
        .hazardousRiskIndicator,
        .declaredCustomsValueAmount,
        .declaredForCarriageValueAmount,
        .declaredStatisticsValueAmount,
        .freeOnBoardValueAmount,
        .insuranceValueAmount,
        .valueAmount,
        .grossWeightMeasure,
        .netWeightMeasure,
        .netNetWeightMeasure,
        .chargeableWeightMeasure,
        .grossVolumeMeasure,
        .netVolumeMeasure,
        .quantity,
        .preferenceCriterionCode,
        .requiredCustomsID,
        .customsStatusCode,
        .customsTariffQuantity,
        .customsImportClassifiedIndicator,
        .chargeableQuantity,
        .returnableQuantity,
        .traceID,
        .item,
        .goodsItemContainer,
        .freightAllowanceCharge,
        .invoiceLine,
        .temperature,
        .containedGoodsItem,
        .originAddress,
        .delivery,
        .pickup,
        .despatch,
        .measurementDimension,
        .containingPackage,
        .shipmentDocumentReference,
        .minimumTemperature,
        .maximumTemperature
]
    public var hasNilValue: Bool {(id == nil)
        || (sequenceNumberID == nil)
        || (hazardousRiskIndicator == nil)
        || (declaredCustomsValueAmount == nil)
        || (declaredForCarriageValueAmount == nil)
        || (declaredStatisticsValueAmount == nil)
        || (freeOnBoardValueAmount == nil)
        || (insuranceValueAmount == nil)
        || (valueAmount == nil)
        || (grossWeightMeasure == nil)
        || (netWeightMeasure == nil)
        || (netNetWeightMeasure == nil)
        || (chargeableWeightMeasure == nil)
        || (grossVolumeMeasure == nil)
        || (netVolumeMeasure == nil)
        || (quantity == nil)
        || (preferenceCriterionCode == nil)
        || (requiredCustomsID == nil)
        || (customsStatusCode == nil)
        || (customsTariffQuantity == nil)
        || (customsImportClassifiedIndicator == nil)
        || (chargeableQuantity == nil)
        || (returnableQuantity == nil)
        || (traceID == nil)
        || (originAddress == nil)
        || (delivery == nil)
        || (pickup == nil)
        || (despatch == nil)
        || (shipmentDocumentReference == nil)
        || (minimumTemperature == nil)
        || (maximumTemperature == nil)
    }
    
    public func title(for key: CodingKeys) -> String {
        switch key {
            case .id: return "Identifier"
            case .sequenceNumberID: return "Sequence Number"
            case .description: return "Description"
            case .hazardousRiskIndicator: return "Hazardous Risk Indicator"
            case .declaredCustomsValueAmount: return "Declared Customs Value"
            case .declaredForCarriageValueAmount: return "Declared For Carriage Value"
            case .declaredStatisticsValueAmount: return "Declared Statistics Value"
            case .freeOnBoardValueAmount: return "Free On Board Value"
            case .insuranceValueAmount: return "Insurance Value"
            case .valueAmount: return "Value"
            case .grossWeightMeasure: return "Gross Weight"
            case .netWeightMeasure: return "Net Weight"
            case .netNetWeightMeasure: return "Net Net Weight"
            case .chargeableWeightMeasure: return "Chargeable Weight"
            case .grossVolumeMeasure: return "Gross Volume"
            case .netVolumeMeasure: return "Net Volume"
            case .quantity: return "Quantity"
            case .preferenceCriterionCode: return "Preference Criterion Code"
            case .requiredCustomsID: return "Required Customs Identifier"
            case .customsStatusCode: return "Customs Status Code"
            case .customsTariffQuantity: return "Customs Tariff Quantity"
            case .customsImportClassifiedIndicator: return "Customs Import Classified Indicator"
            case .chargeableQuantity: return "Chargeable Quantity"
            case .returnableQuantity: return "Returnable Quantity"
            case .traceID: return "Trace Identifier"
            case .item: return "Item"
            case .goodsItemContainer: return "Goods Item Container"
            case .freightAllowanceCharge: return "Freight Allowance Charge"
            case .invoiceLine: return "Invoice Line"
            case .temperature: return "Temperature"
            case .containedGoodsItem: return "Contained Goods Item"
            case .originAddress: return "Origin Address"
            case .delivery: return "Delivery"
            case .pickup: return "Pickup"
            case .despatch: return "Despatch"
            case .measurementDimension: return "Measurement Dimension"
            case .containingPackage: return "Containing Package"
            case .shipmentDocumentReference: return "Shipment Document Reference"
            case .minimumTemperature: return "Minimum Temperature"
            case .maximumTemperature: return "Maximum Temperature"
        }
    }

    public func details(for key: CodingKeys) -> String? {
        switch key {
            case .id: return "An identifier for this goods item."
            case .sequenceNumberID: return "A sequence number differentiating a specific goods item within a consignment."
            case .description: return "Text describing this goods item to identify it for customs, statistical, or transport purposes."
            case .hazardousRiskIndicator: return "An indication that the transported goods item is subject to an international regulation concerning the carriage of dangerous goods (true) or not (false)."
            case .declaredCustomsValueAmount: return "The total declared value for customs purposes of the goods item."
            case .declaredForCarriageValueAmount: return "The value of this goods item, declared by the shipper or his agent solely for the purpose of varying the carrier's level of liability from that provided in the contract of carriage, in case of loss or damage to goods or delayed delivery."
            case .declaredStatisticsValueAmount: return "The total declared value of all the goods items in the same consignment with this goods item that have the same statistical heading."
            case .freeOnBoardValueAmount: return "The monetary amount that has to be or has been paid as calculated under the applicable trade delivery."
            case .insuranceValueAmount: return "The amount covered by insurance for this goods item."
            case .valueAmount: return "The amount on which a duty, tax, or fee will be assessed."
            case .grossWeightMeasure: return "The weight of this goods item, including packing and packaging but excluding the carrier's equipment."
            case .netWeightMeasure: return "The weight of this goods item, excluding packing but including packaging that normally accompanies the goods."
            case .netNetWeightMeasure: return "The total weight of this goods item, excluding all packing and packaging."
            case .chargeableWeightMeasure: return "The weight on which a charge is to be based."
            case .grossVolumeMeasure: return "The volume of this goods item, normally calculated by multiplying its maximum length, width, and height."
            case .netVolumeMeasure: return "The volume contained by a goods item, excluding the volume of any packaging material."
            case .quantity: return "The number of units making up this goods item."
            case .preferenceCriterionCode: return "A code signifying the treatment preference for this goods item according to international trading agreements."
            case .requiredCustomsID: return "An identifier for a set of tariff codes required to specify a type of goods for customs, transport, statistical, or other regulatory purposes."
            case .customsStatusCode: return "A code assigned by customs to signify the status of this goods item."
            case .customsTariffQuantity: return "Quantity of the units in this goods item as required by customs for tariff, statistical, or fiscal purposes."
            case .customsImportClassifiedIndicator: return "An indicator that this goods item has been classified for import by customs (true) or not (false)."
            case .chargeableQuantity: return "The number of units in the goods item to which charges apply."
            case .returnableQuantity: return "The number of units in the goods item that may be returned."
            case .traceID: return "An identifier for use in tracing this goods item, such as the EPC number used in RFID."
            case .item: return "Product information relating to a goods item."
            case .goodsItemContainer: return "The transporting of a goods item in a unit of transport equipment (e.g., container)."
            case .freightAllowanceCharge: return "A cost incurred by the shipper in moving goods, by whatever means, from one place to another under the terms of the contract of carriage. In addition to transport costs, this may include such elements as packing, documentation, loading, unloading, and insurance to the extent that they relate to the freight costs."
            case .invoiceLine: return "Information about an invoice line relating to this goods item."
            case .temperature: return "The temperature of the goods item."
            case .containedGoodsItem: return "A goods item contained in this goods item."
            case .originAddress: return "The region in which the goods have been produced or manufactured, according to criteria laid down for the purposes of application of the customs tariff, or of quantitative restrictions, or of any other measure related to trade."
            case .delivery: return "The delivery of this goods item."
            case .pickup: return "The pickup of this goods item."
            case .despatch: return "The despatch of this goods item."
            case .measurementDimension: return "A measurable dimension (length, mass, weight, or volume) of this goods item."
            case .containingPackage: return "A package containing this goods item."
            case .shipmentDocumentReference: return "A reference to a shipping document associated with this goods item."
            case .minimumTemperature: return "Information about minimum temperature."
            case .maximumTemperature: return "Information about maximum temperature."
        }
    }
    func skipView(title _title: String, key: CodingKeys, search _search: String?) -> Bool {
        if let _search,
            (_title.search(_search) == nil) {
            let result: SearchResult?
            switch key {
                case .id: result = id?.search(_search)
                case .sequenceNumberID: result = sequenceNumberID?.search(_search)
                case .description: result = description.compactMap({ $0.search(_search) }).first
                case .hazardousRiskIndicator: result = hazardousRiskIndicator?.search(_search)
                case .declaredCustomsValueAmount: result = declaredCustomsValueAmount?.search(_search)
                case .declaredForCarriageValueAmount: result = declaredForCarriageValueAmount?.search(_search)
                case .declaredStatisticsValueAmount: result = declaredStatisticsValueAmount?.search(_search)
                case .freeOnBoardValueAmount: result = freeOnBoardValueAmount?.search(_search)
                case .insuranceValueAmount: result = insuranceValueAmount?.search(_search)
                case .valueAmount: result = valueAmount?.search(_search)
                case .grossWeightMeasure: result = grossWeightMeasure?.search(_search)
                case .netWeightMeasure: result = netWeightMeasure?.search(_search)
                case .netNetWeightMeasure: result = netNetWeightMeasure?.search(_search)
                case .chargeableWeightMeasure: result = chargeableWeightMeasure?.search(_search)
                case .grossVolumeMeasure: result = grossVolumeMeasure?.search(_search)
                case .netVolumeMeasure: result = netVolumeMeasure?.search(_search)
                case .quantity: result = quantity?.search(_search)
                case .preferenceCriterionCode: result = preferenceCriterionCode?.search(_search)
                case .requiredCustomsID: result = requiredCustomsID?.search(_search)
                case .customsStatusCode: result = customsStatusCode?.search(_search)
                case .customsTariffQuantity: result = customsTariffQuantity?.search(_search)
                case .customsImportClassifiedIndicator: result = customsImportClassifiedIndicator?.search(_search)
                case .chargeableQuantity: result = chargeableQuantity?.search(_search)
                case .returnableQuantity: result = returnableQuantity?.search(_search)
                case .traceID: result = traceID?.search(_search)
                case .item: result = item.compactMap({ $0.search(_search) }).first
                case .goodsItemContainer: result = goodsItemContainer.compactMap({ $0.search(_search) }).first
                case .freightAllowanceCharge: result = freightAllowanceCharge.compactMap({ $0.search(_search) }).first
                case .invoiceLine: result = invoiceLine.compactMap({ $0.search(_search) }).first
                case .temperature: result = temperature.compactMap({ $0.search(_search) }).first
                case .containedGoodsItem: result = containedGoodsItem.compactMap({ $0.search(_search) }).first
                case .originAddress: result = originAddress?.search(_search)
                case .delivery: result = delivery?.search(_search)
                case .pickup: result = pickup?.search(_search)
                case .despatch: result = despatch?.search(_search)
                case .measurementDimension: result = measurementDimension.compactMap({ $0.search(_search) }).first
                case .containingPackage: result = containingPackage.compactMap({ $0.search(_search) }).first
                case .shipmentDocumentReference: result = shipmentDocumentReference?.search(_search)
                case .minimumTemperature: result = minimumTemperature?.search(_search)
                case .maximumTemperature: result = maximumTemperature?.search(_search)
            }
            return (result == nil)
        }
        return false
    }

    @MainActor @ViewBuilder public func view(for key: CodingKeys, show: Bool = false, search _search: String? = nil) -> some View {
        let _title = title(for: key)
        if !skipView(title: _title, key: key, search: _search) {
        let _details = details(for: key)
            switch key {
                case .id: presentableView(for: id, title: _title, details: _details, show: show, search: _search)
                case .sequenceNumberID: presentableView(for: sequenceNumberID, title: _title, details: _details, show: show, search: _search)
                case .description: presentableView(for: description.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .hazardousRiskIndicator: presentableView(for: hazardousRiskIndicator, title: _title, details: _details, show: show, search: _search)
                case .declaredCustomsValueAmount: presentableView(for: declaredCustomsValueAmount, title: _title, details: _details, show: show, search: _search)
                case .declaredForCarriageValueAmount: presentableView(for: declaredForCarriageValueAmount, title: _title, details: _details, show: show, search: _search)
                case .declaredStatisticsValueAmount: presentableView(for: declaredStatisticsValueAmount, title: _title, details: _details, show: show, search: _search)
                case .freeOnBoardValueAmount: presentableView(for: freeOnBoardValueAmount, title: _title, details: _details, show: show, search: _search)
                case .insuranceValueAmount: presentableView(for: insuranceValueAmount, title: _title, details: _details, show: show, search: _search)
                case .valueAmount: presentableView(for: valueAmount, title: _title, details: _details, show: show, search: _search)
                case .grossWeightMeasure: presentableView(for: grossWeightMeasure, title: _title, details: _details, show: show, search: _search)
                case .netWeightMeasure: presentableView(for: netWeightMeasure, title: _title, details: _details, show: show, search: _search)
                case .netNetWeightMeasure: presentableView(for: netNetWeightMeasure, title: _title, details: _details, show: show, search: _search)
                case .chargeableWeightMeasure: presentableView(for: chargeableWeightMeasure, title: _title, details: _details, show: show, search: _search)
                case .grossVolumeMeasure: presentableView(for: grossVolumeMeasure, title: _title, details: _details, show: show, search: _search)
                case .netVolumeMeasure: presentableView(for: netVolumeMeasure, title: _title, details: _details, show: show, search: _search)
                case .quantity: presentableView(for: quantity, title: _title, details: _details, show: show, search: _search)
                case .preferenceCriterionCode: presentableView(for: preferenceCriterionCode, title: _title, details: _details, show: show, search: _search)
                case .requiredCustomsID: presentableView(for: requiredCustomsID, title: _title, details: _details, show: show, search: _search)
                case .customsStatusCode: presentableView(for: customsStatusCode, title: _title, details: _details, show: show, search: _search)
                case .customsTariffQuantity: presentableView(for: customsTariffQuantity, title: _title, details: _details, show: show, search: _search)
                case .customsImportClassifiedIndicator: presentableView(for: customsImportClassifiedIndicator, title: _title, details: _details, show: show, search: _search)
                case .chargeableQuantity: presentableView(for: chargeableQuantity, title: _title, details: _details, show: show, search: _search)
                case .returnableQuantity: presentableView(for: returnableQuantity, title: _title, details: _details, show: show, search: _search)
                case .traceID: presentableView(for: traceID, title: _title, details: _details, show: show, search: _search)
                case .item: presentableView(for: item.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .goodsItemContainer: presentableView(for: goodsItemContainer.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .freightAllowanceCharge: presentableView(for: freightAllowanceCharge.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .invoiceLine: presentableView(for: invoiceLine.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .temperature: presentableView(for: temperature.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .containedGoodsItem: presentableView(for: containedGoodsItem.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .originAddress: presentableView(for: originAddress, title: _title, details: _details, show: show, search: _search)
                case .delivery: presentableView(for: delivery, title: _title, details: _details, show: show, search: _search)
                case .pickup: presentableView(for: pickup, title: _title, details: _details, show: show, search: _search)
                case .despatch: presentableView(for: despatch, title: _title, details: _details, show: show, search: _search)
                case .measurementDimension: presentableView(for: measurementDimension.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .containingPackage: presentableView(for: containingPackage.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .shipmentDocumentReference: presentableView(for: shipmentDocumentReference, title: _title, details: _details, show: show, search: _search)
                case .minimumTemperature: presentableView(for: minimumTemperature, title: _title, details: _details, show: show, search: _search)
                case .maximumTemperature: presentableView(for: maximumTemperature, title: _title, details: _details, show: show, search: _search)
            }
        }
    }
}

extension UBLInvoice.GoodsItem: Searchable {
    public func search(_ string: String) -> SearchResult? {
        for codingKey in Self.elementKeys {
            let _title = self.title(for: codingKey) 
            if _title.contains(string) {
                return .title(_title)
            }
        }
        if let result = id?.search(string) { return result }
        if let result = sequenceNumberID?.search(string) { return result }
        if let result = description.compactMap({ $0.search(string)  }).first { return result }
        if let result = hazardousRiskIndicator?.search(string) { return result }
        if let result = declaredCustomsValueAmount?.search(string) { return result }
        if let result = declaredForCarriageValueAmount?.search(string) { return result }
        if let result = declaredStatisticsValueAmount?.search(string) { return result }
        if let result = freeOnBoardValueAmount?.search(string) { return result }
        if let result = insuranceValueAmount?.search(string) { return result }
        if let result = valueAmount?.search(string) { return result }
        if let result = grossWeightMeasure?.search(string) { return result }
        if let result = netWeightMeasure?.search(string) { return result }
        if let result = netNetWeightMeasure?.search(string) { return result }
        if let result = chargeableWeightMeasure?.search(string) { return result }
        if let result = grossVolumeMeasure?.search(string) { return result }
        if let result = netVolumeMeasure?.search(string) { return result }
        if let result = quantity?.search(string) { return result }
        if let result = preferenceCriterionCode?.search(string) { return result }
        if let result = requiredCustomsID?.search(string) { return result }
        if let result = customsStatusCode?.search(string) { return result }
        if let result = customsTariffQuantity?.search(string) { return result }
        if let result = customsImportClassifiedIndicator?.search(string) { return result }
        if let result = chargeableQuantity?.search(string) { return result }
        if let result = returnableQuantity?.search(string) { return result }
        if let result = traceID?.search(string) { return result }
        if let result = item.compactMap({ $0.search(string)  }).first { return result }
        if let result = goodsItemContainer.compactMap({ $0.search(string)  }).first { return result }
        if let result = freightAllowanceCharge.compactMap({ $0.search(string)  }).first { return result }
        if let result = invoiceLine.compactMap({ $0.search(string)  }).first { return result }
        if let result = temperature.compactMap({ $0.search(string)  }).first { return result }
        if let result = containedGoodsItem.compactMap({ $0.search(string)  }).first { return result }
        if let result = originAddress?.search(string) { return result }
        if let result = delivery?.search(string) { return result }
        if let result = pickup?.search(string) { return result }
        if let result = despatch?.search(string) { return result }
        if let result = measurementDimension.compactMap({ $0.search(string)  }).first { return result }
        if let result = containingPackage.compactMap({ $0.search(string)  }).first { return result }
        if let result = shipmentDocumentReference?.search(string) { return result }
        if let result = minimumTemperature?.search(string) { return result }
        if let result = maximumTemperature?.search(string) { return result }
        return nil
    }
}
