// 
// Measure.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import SwiftUI
import ViewPresentable
import UBLInvoice

extension UBLInvoice.Measure: KeyViewPresentable {
    public static let elementKeys: [CodingKeys] = [
        .value,
        .unitCode,
        .unitCodeListVersionID
]
    public var hasNilValue: Bool {(unitCode == nil)
        || (unitCodeListVersionID == nil)
    }
    
    public func title(for key: CodingKeys) -> String {
        switch key {
            case .value: return "Value"
            case .unitCode: return "Unit Code"
            case .unitCodeListVersionID: return "Unit Code List Version Id"
        }
    }

    public func details(for key: CodingKeys) -> String? {
        switch key {
            case .value: return nil
            case .unitCode: return nil
            case .unitCodeListVersionID: return nil
        }
    }
    func skipView(title _title: String, key: CodingKeys, search _search: String?) -> Bool {
        if let _search,
            (_title.search(_search) == nil) {
            let result: SearchResult?
            switch key {
                case .value: result = value.search(_search)
                case .unitCode: result = unitCode?.search(_search)
                case .unitCodeListVersionID: result = unitCodeListVersionID?.search(_search)
            }
            return (result == nil)
        }
        return false
    }

    @MainActor @ViewBuilder public func view(for key: CodingKeys, show: Bool = false, search _search: String? = nil) -> some View {
        let _title = title(for: key)
        if !skipView(title: _title, key: key, search: _search) {
        let _details = details(for: key)
            switch key {
                case .value: anyView(for: value, title: _title, details: _details, show: show, search: _search)
                case .unitCode: anyView(for: unitCode, title: _title, details: _details, show: show, search: _search)
                case .unitCodeListVersionID: anyView(for: unitCodeListVersionID, title: _title, details: _details, show: show, search: _search)
            }
        }
    }
}

extension UBLInvoice.Measure: Searchable {
    public func search(_ string: String) -> SearchResult? {
        for codingKey in Self.elementKeys {
            let _title = self.title(for: codingKey) 
            if _title.contains(string) {
                return .title(_title)
            }
        }
        if let result = value.search(string) { return result }
        if let result = unitCode?.search(string) { return result }
        if let result = unitCodeListVersionID?.search(string) { return result }
        return nil
    }
}
