// 
// Pickup.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import SwiftUI
import ViewPresentable
import UBLInvoice

extension UBLInvoice.Pickup: KeyViewPresentable {
    public static let elementKeys: [CodingKeys] = [
        .id,
        .actualPickupDate,
        .actualPickupTime,
        .earliestPickupDate,
        .earliestPickupTime,
        .latestPickupDate,
        .latestPickupTime,
        .pickupLocation,
        .pickupParty
]
    public var hasNilValue: Bool {(id == nil)
        || (actualPickupDate == nil)
        || (actualPickupTime == nil)
        || (earliestPickupDate == nil)
        || (earliestPickupTime == nil)
        || (latestPickupDate == nil)
        || (latestPickupTime == nil)
        || (pickupLocation == nil)
        || (pickupParty == nil)
    }
    
    public func title(for key: CodingKeys) -> String {
        switch key {
            case .id: return "Identifier"
            case .actualPickupDate: return "Actual Pickup Date"
            case .actualPickupTime: return "Actual Pickup Time"
            case .earliestPickupDate: return "Earliest Pickup Date"
            case .earliestPickupTime: return "Earliest Pickup Time"
            case .latestPickupDate: return "Latest Pickup Date"
            case .latestPickupTime: return "Latest Pickup Time"
            case .pickupLocation: return "Pickup Location"
            case .pickupParty: return "Pickup Party"
        }
    }

    public func details(for key: CodingKeys) -> String? {
        switch key {
            case .id: return "An identifier for this pickup."
            case .actualPickupDate: return "The actual pickup date."
            case .actualPickupTime: return "The actual pickup time."
            case .earliestPickupDate: return "The earliest pickup date."
            case .earliestPickupTime: return "The earliest pickup time."
            case .latestPickupDate: return "The latest pickup date."
            case .latestPickupTime: return "The latest pickup time."
            case .pickupLocation: return "The pickup location."
            case .pickupParty: return "The party responsible for picking up a delivery."
        }
    }
    func skipView(title _title: String, key: CodingKeys, search _search: String?) -> Bool {
        if let _search,
            (_title.search(_search) == nil) {
            let result: SearchResult?
            switch key {
                case .id: result = id?.search(_search)
                case .actualPickupDate: result = actualPickupDate?.search(_search)
                case .actualPickupTime: result = actualPickupTime?.search(_search)
                case .earliestPickupDate: result = earliestPickupDate?.search(_search)
                case .earliestPickupTime: result = earliestPickupTime?.search(_search)
                case .latestPickupDate: result = latestPickupDate?.search(_search)
                case .latestPickupTime: result = latestPickupTime?.search(_search)
                case .pickupLocation: result = pickupLocation?.search(_search)
                case .pickupParty: result = pickupParty?.search(_search)
            }
            return (result == nil)
        }
        return false
    }

    @MainActor @ViewBuilder public func view(for key: CodingKeys, show: Bool = false, search _search: String? = nil) -> some View {
        let _title = title(for: key)
        if !skipView(title: _title, key: key, search: _search) {
        let _details = details(for: key)
            switch key {
                case .id: presentableView(for: id, title: _title, details: _details, show: show, search: _search)
                case .actualPickupDate: anyView(for: actualPickupDate, title: _title, details: _details, show: show, search: _search)
                case .actualPickupTime: anyView(for: actualPickupTime, title: _title, details: _details, show: show, search: _search)
                case .earliestPickupDate: anyView(for: earliestPickupDate, title: _title, details: _details, show: show, search: _search)
                case .earliestPickupTime: anyView(for: earliestPickupTime, title: _title, details: _details, show: show, search: _search)
                case .latestPickupDate: anyView(for: latestPickupDate, title: _title, details: _details, show: show, search: _search)
                case .latestPickupTime: anyView(for: latestPickupTime, title: _title, details: _details, show: show, search: _search)
                case .pickupLocation: presentableView(for: pickupLocation, title: _title, details: _details, show: show, search: _search)
                case .pickupParty: presentableView(for: pickupParty, title: _title, details: _details, show: show, search: _search)
            }
        }
    }
}

extension UBLInvoice.Pickup: Searchable {
    public func search(_ string: String) -> SearchResult? {
        for codingKey in Self.elementKeys {
            let _title = self.title(for: codingKey) 
            if _title.contains(string) {
                return .title(_title)
            }
        }
        if let result = actualPickupDate?.search(string) { return result }
        if let result = actualPickupTime?.search(string) { return result }
        if let result = earliestPickupDate?.search(string) { return result }
        if let result = earliestPickupTime?.search(string) { return result }
        if let result = latestPickupDate?.search(string) { return result }
        if let result = latestPickupTime?.search(string) { return result }
        if let result = id?.search(string) { return result }
        if let result = pickupLocation?.search(string) { return result }
        if let result = pickupParty?.search(string) { return result }
        return nil
    }
}
