// 
// RailTransport.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import SwiftUI
import ViewPresentable
import UBLInvoice

extension UBLInvoice.RailTransport: KeyViewPresentable {
    public static let elementKeys: [CodingKeys] = [
        .trainID,
        .railCarID
]
    public var hasNilValue: Bool {(railCarID == nil)
    }
    
    public func title(for key: CodingKeys) -> String {
        switch key {
            case .trainID: return "Train Identifier"
            case .railCarID: return "Rail Car Identifier"
        }
    }

    public func details(for key: CodingKeys) -> String? {
        switch key {
            case .trainID: return "An identifier for the train used as the means of transport."
            case .railCarID: return "An identifier for the rail car on the train used as the means of transport."
        }
    }
    func skipView(title _title: String, key: CodingKeys, search _search: String?) -> Bool {
        if let _search,
            (_title.search(_search) == nil) {
            let result: SearchResult?
            switch key {
                case .trainID: result = trainID.search(_search)
                case .railCarID: result = railCarID?.search(_search)
            }
            return (result == nil)
        }
        return false
    }

    @MainActor @ViewBuilder public func view(for key: CodingKeys, show: Bool = false, search _search: String? = nil) -> some View {
        let _title = title(for: key)
        if !skipView(title: _title, key: key, search: _search) {
        let _details = details(for: key)
            switch key {
                case .trainID: presentableView(for: trainID, title: _title, details: _details, show: show, search: _search)
                case .railCarID: presentableView(for: railCarID, title: _title, details: _details, show: show, search: _search)
            }
        }
    }
}

extension UBLInvoice.RailTransport: Searchable {
    public func search(_ string: String) -> SearchResult? {
        for codingKey in Self.elementKeys {
            let _title = self.title(for: codingKey) 
            if _title.contains(string) {
                return .title(_title)
            }
        }
        if let result = trainID.search(string) { return result }
        if let result = railCarID?.search(string) { return result }
        return nil
    }
}
