// 
// RoadTransport.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import SwiftUI
import ViewPresentable
import UBLInvoice

extension UBLInvoice.RoadTransport: KeyViewPresentable {
    public static let elementKeys: [CodingKeys] = [
        .licensePlateID
]
    public var hasNilValue: Bool {
        false
    }
    
    public func title(for key: CodingKeys) -> String {
        switch key {
            case .licensePlateID: return "License Plate Identifier"
        }
    }

    public func details(for key: CodingKeys) -> String? {
        switch key {
            case .licensePlateID: return "The license plate identifier of this vehicle."
        }
    }
    func skipView(title _title: String, key: CodingKeys, search _search: String?) -> Bool {
        if let _search,
            (_title.search(_search) == nil) {
            let result: SearchResult?
            switch key {
                case .licensePlateID: result = licensePlateID.search(_search)
            }
            return (result == nil)
        }
        return false
    }

    @MainActor @ViewBuilder public func view(for key: CodingKeys, show: Bool = false, search _search: String? = nil) -> some View {
        let _title = title(for: key)
        if !skipView(title: _title, key: key, search: _search) {
        let _details = details(for: key)
            switch key {
                case .licensePlateID: presentableView(for: licensePlateID, title: _title, details: _details, show: show, search: _search)
            }
        }
    }
}

extension UBLInvoice.RoadTransport: Searchable {
    public func search(_ string: String) -> SearchResult? {
        for codingKey in Self.elementKeys {
            let _title = self.title(for: codingKey) 
            if _title.contains(string) {
                return .title(_title)
            }
        }
        if let result = licensePlateID.search(string) { return result }
        return nil
    }
}
