// 
// ShareholderParty.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import SwiftUI
import ViewPresentable
import UBLInvoice

extension UBLInvoice.ShareholderParty: KeyViewPresentable {
    public static let elementKeys: [CodingKeys] = [
        .partecipationPercent,
        .party
]
    public var hasNilValue: Bool {(partecipationPercent == nil)
        || (party == nil)
    }
    
    public func title(for key: CodingKeys) -> String {
        switch key {
            case .partecipationPercent: return "Partecipation"
            case .party: return "Party"
        }
    }

    public func details(for key: CodingKeys) -> String? {
        switch key {
            case .partecipationPercent: return "The shareholder participation, expressed as a percentage."
            case .party: return "The shareholder party."
        }
    }
    func skipView(title _title: String, key: CodingKeys, search _search: String?) -> Bool {
        if let _search,
            (_title.search(_search) == nil) {
            let result: SearchResult?
            switch key {
                case .partecipationPercent: result = partecipationPercent?.search(_search)
                case .party: result = party?.search(_search)
            }
            return (result == nil)
        }
        return false
    }

    @MainActor @ViewBuilder public func view(for key: CodingKeys, show: Bool = false, search _search: String? = nil) -> some View {
        let _title = title(for: key)
        if !skipView(title: _title, key: key, search: _search) {
        let _details = details(for: key)
            switch key {
                case .partecipationPercent: presentableView(for: partecipationPercent, title: _title, details: _details, show: show, search: _search)
                case .party: presentableView(for: party, title: _title, details: _details, show: show, search: _search)
            }
        }
    }
}

extension UBLInvoice.ShareholderParty: Searchable {
    public func search(_ string: String) -> SearchResult? {
        for codingKey in Self.elementKeys {
            let _title = self.title(for: codingKey) 
            if _title.contains(string) {
                return .title(_title)
            }
        }
        if let result = partecipationPercent?.search(string) { return result }
        if let result = party?.search(string) { return result }
        return nil
    }
}
