// 
// ShipmentStage.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import SwiftUI
import ViewPresentable
import UBLInvoice

extension UBLInvoice.ShipmentStage: KeyViewPresentable {
    public static let elementKeys: [CodingKeys] = [
        .id,
        .transportModeCode,
        .transportMeansTypeCode,
        .transitDirectionCode,
        .preCarriageIndicator,
        .onCarriageIndicator,
        .estimatedDeliveryDate,
        .estimatedDeliveryTime,
        .requiredDeliveryDate,
        .requiredDeliveryTime,
        .loadingSequenceID,
        .successiveSequenceID,
        .instructions,
        .demurrageInstructions,
        .crewQuantity,
        .passengerQuantity,
        .transitPeriod,
        .carrierParty,
        .transportMeans,
        .loadingPortLocation,
        .unloadingPortLocation,
        .transshipPortLocation,
        .loadingTransportEvent,
        .examinationTransportEvent,
        .availabilityTransportEvent,
        .exportationTransportEvent,
        .dischargeTransportEvent,
        .warehousingTransportEvent,
        .takeoverTransportEvent,
        .optionalTakeoverTransportEvent,
        .dropoffTransportEvent,
        .actualPickupTransportEvent,
        .deliveryTransportEvent,
        .receiptTransportEvent,
        .storageTransportEvent,
        .acceptanceTransportEvent,
        .terminalOperatorParty,
        .customsAgentParty,
        .estimatedTransitPeriod,
        .freightAllowanceCharge,
        .freightChargeLocation,
        .detentionTransportEvent,
        .requestedDepartureTransportEvent,
        .requestedArrivalTransportEvent,
        .requestedWaypointTransportEvent,
        .plannedDepartureTransportEvent,
        .plannedArrivalTransportEvent,
        .plannedWaypointTransportEvent,
        .actualDepartureTransportEvent,
        .actualWaypointTransportEvent,
        .actualArrivalTransportEvent,
        .transportEvent,
        .estimatedDepartureTransportEvent,
        .estimatedArrivalTransportEvent,
        .passengerPerson,
        .driverPerson,
        .reportingPerson,
        .crewMemberPerson,
        .securityOfficerPerson,
        .masterPerson,
        .shipsSurgeonPerson
]
    public var hasNilValue: Bool {(id == nil)
        || (transportModeCode == nil)
        || (transportMeansTypeCode == nil)
        || (transitDirectionCode == nil)
        || (preCarriageIndicator == nil)
        || (onCarriageIndicator == nil)
        || (estimatedDeliveryDate == nil)
        || (estimatedDeliveryTime == nil)
        || (requiredDeliveryDate == nil)
        || (requiredDeliveryTime == nil)
        || (loadingSequenceID == nil)
        || (successiveSequenceID == nil)
        || (crewQuantity == nil)
        || (passengerQuantity == nil)
        || (transitPeriod == nil)
        || (transportMeans == nil)
        || (loadingPortLocation == nil)
        || (unloadingPortLocation == nil)
        || (transshipPortLocation == nil)
        || (loadingTransportEvent == nil)
        || (examinationTransportEvent == nil)
        || (availabilityTransportEvent == nil)
        || (exportationTransportEvent == nil)
        || (dischargeTransportEvent == nil)
        || (warehousingTransportEvent == nil)
        || (takeoverTransportEvent == nil)
        || (optionalTakeoverTransportEvent == nil)
        || (dropoffTransportEvent == nil)
        || (actualPickupTransportEvent == nil)
        || (deliveryTransportEvent == nil)
        || (receiptTransportEvent == nil)
        || (storageTransportEvent == nil)
        || (acceptanceTransportEvent == nil)
        || (terminalOperatorParty == nil)
        || (customsAgentParty == nil)
        || (estimatedTransitPeriod == nil)
        || (freightChargeLocation == nil)
        || (requestedDepartureTransportEvent == nil)
        || (requestedArrivalTransportEvent == nil)
        || (plannedDepartureTransportEvent == nil)
        || (plannedArrivalTransportEvent == nil)
        || (actualDepartureTransportEvent == nil)
        || (actualWaypointTransportEvent == nil)
        || (actualArrivalTransportEvent == nil)
        || (estimatedDepartureTransportEvent == nil)
        || (estimatedArrivalTransportEvent == nil)
        || (reportingPerson == nil)
        || (securityOfficerPerson == nil)
        || (masterPerson == nil)
        || (shipsSurgeonPerson == nil)
    }
    
    public func title(for key: CodingKeys) -> String {
        switch key {
            case .id: return "Identifier"
            case .transportModeCode: return "Transport Mode Code"
            case .transportMeansTypeCode: return "Transport Means Type Code"
            case .transitDirectionCode: return "Transit Direction Code"
            case .preCarriageIndicator: return "Pre Carriage Indicator"
            case .onCarriageIndicator: return "On Carriage Indicator"
            case .estimatedDeliveryDate: return "Estimated Delivery Date"
            case .estimatedDeliveryTime: return "Estimated Delivery Time"
            case .requiredDeliveryDate: return "Required Delivery Date"
            case .requiredDeliveryTime: return "Required Delivery Time"
            case .loadingSequenceID: return "Loading Sequence Identifier"
            case .successiveSequenceID: return "Successive Sequence Identifier"
            case .instructions: return "Instructions"
            case .demurrageInstructions: return "Demurrage Instructions"
            case .crewQuantity: return "Crew Quantity"
            case .passengerQuantity: return "Passenger Quantity"
            case .transitPeriod: return "Transit Period"
            case .carrierParty: return "Carrier Party"
            case .transportMeans: return "Transport Means"
            case .loadingPortLocation: return "Loading Port Location"
            case .unloadingPortLocation: return "Unloading Port Location"
            case .transshipPortLocation: return "Transship Port Location"
            case .loadingTransportEvent: return "Loading Transport Event"
            case .examinationTransportEvent: return "Examination Transport Event"
            case .availabilityTransportEvent: return "Availability Transport Event"
            case .exportationTransportEvent: return "Exportation Transport Event"
            case .dischargeTransportEvent: return "Discharge Transport Event"
            case .warehousingTransportEvent: return "Warehousing Transport Event"
            case .takeoverTransportEvent: return "Takeover Transport Event"
            case .optionalTakeoverTransportEvent: return "Optional Takeover Transport Event"
            case .dropoffTransportEvent: return "Dropoff Transport Event"
            case .actualPickupTransportEvent: return "Actual Pickup Transport Event"
            case .deliveryTransportEvent: return "Delivery Transport Event"
            case .receiptTransportEvent: return "Receipt Transport Event"
            case .storageTransportEvent: return "Storage Transport Event"
            case .acceptanceTransportEvent: return "Acceptance Transport Event"
            case .terminalOperatorParty: return "Terminal Operator Party"
            case .customsAgentParty: return "Customs Agent Party"
            case .estimatedTransitPeriod: return "Estimated Transit Period"
            case .freightAllowanceCharge: return "Freight Allowance Charge"
            case .freightChargeLocation: return "Freight Charge Location"
            case .detentionTransportEvent: return "Detention Transport Event"
            case .requestedDepartureTransportEvent: return "Requested Departure Transport Event"
            case .requestedArrivalTransportEvent: return "Requested Arrival Transport Event"
            case .requestedWaypointTransportEvent: return "Requested Waypoint Transport Event"
            case .plannedDepartureTransportEvent: return "Planned Departure Transport Event"
            case .plannedArrivalTransportEvent: return "Planned Arrival Transport Event"
            case .plannedWaypointTransportEvent: return "Planned Waypoint Transport Event"
            case .actualDepartureTransportEvent: return "Actual Departure Transport Event"
            case .actualWaypointTransportEvent: return "Actual Waypoint Transport Event"
            case .actualArrivalTransportEvent: return "Actual Arrival Transport Event"
            case .transportEvent: return "Transport Event"
            case .estimatedDepartureTransportEvent: return "Estimated Departure Transport Event"
            case .estimatedArrivalTransportEvent: return "Estimated Arrival Transport Event"
            case .passengerPerson: return "Passenger Person"
            case .driverPerson: return "Driver Person"
            case .reportingPerson: return "Reporting Person"
            case .crewMemberPerson: return "Crew Member Person"
            case .securityOfficerPerson: return "Security Officer Person"
            case .masterPerson: return "Master Person"
            case .shipsSurgeonPerson: return "Ships Surgeon Person"
        }
    }

    public func details(for key: CodingKeys) -> String? {
        switch key {
            case .id: return "An identifier for this shipment stage."
            case .transportModeCode: return "A code signifying the method of transport used for this shipment stage."
            case .transportMeansTypeCode: return "A code signifying the kind of transport means (truck, vessel, etc.) used for this shipment stage."
            case .transitDirectionCode: return "A code signifying the direction of transit in this shipment stage."
            case .preCarriageIndicator: return "An indicator that this stage takes place before the main carriage of the shipment (true) or not (false)."
            case .onCarriageIndicator: return "An indicator that this stage takes place after the main carriage of the shipment (true) or not (false)."
            case .estimatedDeliveryDate: return "The estimated date of delivery in this shipment stage."
            case .estimatedDeliveryTime: return "The estimated time of delivery in this shipment stage."
            case .requiredDeliveryDate: return "The delivery date required by the buyer in this shipment stage."
            case .requiredDeliveryTime: return "The delivery time required by the buyer in this shipment stage."
            case .loadingSequenceID: return "An identifier for the loading sequence (of consignments) associated with this shipment stage."
            case .successiveSequenceID: return "Identifies the successive loading sequence (of consignments) associated with a shipment stage."
            case .instructions: return "Text of instructions applicable to a shipment stage."
            case .demurrageInstructions: return "Text of instructions relating to demurrage (the case in which a vessel is prevented from loading or discharging cargo within the stipulated laytime)."
            case .crewQuantity: return "The total number of crew aboard a transport means."
            case .passengerQuantity: return "The total number of passengers aboard a transport means."
            case .transitPeriod: return "The period during which this shipment stage actually took place."
            case .carrierParty: return "A carrier party responsible for this shipment stage."
            case .transportMeans: return "The means of transport used in this shipment stage."
            case .loadingPortLocation: return "The location of loading for a shipment stage."
            case .unloadingPortLocation: return "The location of unloading for a shipment stage."
            case .transshipPortLocation: return "The location of transshipment relating to a shipment stage."
            case .loadingTransportEvent: return "The loading of goods in this shipment stage."
            case .examinationTransportEvent: return "The examination of shipments in this shipment stage."
            case .availabilityTransportEvent: return "The making available of shipments in this shipment stage."
            case .exportationTransportEvent: return "The export event associated with this shipment stage."
            case .dischargeTransportEvent: return "The discharge event associated with this shipment stage."
            case .warehousingTransportEvent: return "The warehousing event associated with this shipment stage."
            case .takeoverTransportEvent: return "The receiver's takeover of the goods in this shipment stage."
            case .optionalTakeoverTransportEvent: return "The optional takeover of the goods in this shipment stage."
            case .dropoffTransportEvent: return "The dropping off of goods in this shipment stage."
            case .actualPickupTransportEvent: return "The pickup of goods in this shipment stage."
            case .deliveryTransportEvent: return "The delivery of goods in this shipment stage."
            case .receiptTransportEvent: return "The receipt of goods in this shipment stage."
            case .storageTransportEvent: return "The storage of goods in this shipment stage."
            case .acceptanceTransportEvent: return "The acceptance of goods in this shipment stage."
            case .terminalOperatorParty: return "A terminal operator associated with this shipment stage."
            case .customsAgentParty: return "A customs agent associated with this shipment stage."
            case .estimatedTransitPeriod: return "The estimated transit period of this shipment stage."
            case .freightAllowanceCharge: return "A freight allowance charge for this shipment stage."
            case .freightChargeLocation: return "The location associated with a freight charge related to this shipment stage."
            case .detentionTransportEvent: return "The detention of a transport means during loading and unloading operations."
            case .requestedDepartureTransportEvent: return "The departure requested by the party requesting a transportation service."
            case .requestedArrivalTransportEvent: return "The arrival requested by the party requesting a transportation service."
            case .requestedWaypointTransportEvent: return "A waypoint requested by the party requesting a transportation service."
            case .plannedDepartureTransportEvent: return "The departure planned by the party providing a transportation service."
            case .plannedArrivalTransportEvent: return "The arrival planned by the party providing a transportation service."
            case .plannedWaypointTransportEvent: return "A waypoint planned by the party providing a transportation service."
            case .actualDepartureTransportEvent: return "The actual departure from a specific location during a transportation service."
            case .actualWaypointTransportEvent: return "The location of an actual waypoint during a transportation service."
            case .actualArrivalTransportEvent: return "The actual arrival at a specific location during a transportation service."
            case .transportEvent: return "A significant occurrence in the course of this shipment of goods."
            case .estimatedDepartureTransportEvent: return "Describes an estimated departure at a location during a transport service."
            case .estimatedArrivalTransportEvent: return "Describes an estimated arrival at a location during a transport service."
            case .passengerPerson: return "A person who travels in a conveyance without participating in its operation."
            case .driverPerson: return "Describes a person responsible for driving the transport means."
            case .reportingPerson: return "Describes a person being responsible for providing the required administrative reporting relating to a transport."
            case .crewMemberPerson: return "A person operating or serving aboard a transport means."
            case .securityOfficerPerson: return "The person on board the vessel, accountable to the master, designated by the company as responsible for the security of the ship, including implementation and maintenance of the ship security plan and for the liaison with the company security officer and the port facility security officers."
            case .masterPerson: return "The person responsible for the ship's safe and efficient operation, including cargo operations, navigation, crew management and for ensuring that the vessel complies with local and international laws, as well as company and flag state policies."
            case .shipsSurgeonPerson: return "The person responsible for the health of the people aboard a ship at sea."
        }
    }
    func skipView(title _title: String, key: CodingKeys, search _search: String?) -> Bool {
        if let _search,
            (_title.search(_search) == nil) {
            let result: SearchResult?
            switch key {
                case .id: result = id?.search(_search)
                case .transportModeCode: result = transportModeCode?.search(_search)
                case .transportMeansTypeCode: result = transportMeansTypeCode?.search(_search)
                case .transitDirectionCode: result = transitDirectionCode?.search(_search)
                case .preCarriageIndicator: result = preCarriageIndicator?.search(_search)
                case .onCarriageIndicator: result = onCarriageIndicator?.search(_search)
                case .estimatedDeliveryDate: result = estimatedDeliveryDate?.search(_search)
                case .estimatedDeliveryTime: result = estimatedDeliveryTime?.search(_search)
                case .requiredDeliveryDate: result = requiredDeliveryDate?.search(_search)
                case .requiredDeliveryTime: result = requiredDeliveryTime?.search(_search)
                case .loadingSequenceID: result = loadingSequenceID?.search(_search)
                case .successiveSequenceID: result = successiveSequenceID?.search(_search)
                case .instructions: result = instructions.compactMap({ $0.search(_search) }).first
                case .demurrageInstructions: result = demurrageInstructions.compactMap({ $0.search(_search) }).first
                case .crewQuantity: result = crewQuantity?.search(_search)
                case .passengerQuantity: result = passengerQuantity?.search(_search)
                case .transitPeriod: result = transitPeriod?.search(_search)
                case .carrierParty: result = carrierParty.compactMap({ $0.search(_search) }).first
                case .transportMeans: result = transportMeans?.search(_search)
                case .loadingPortLocation: result = loadingPortLocation?.search(_search)
                case .unloadingPortLocation: result = unloadingPortLocation?.search(_search)
                case .transshipPortLocation: result = transshipPortLocation?.search(_search)
                case .loadingTransportEvent: result = loadingTransportEvent?.search(_search)
                case .examinationTransportEvent: result = examinationTransportEvent?.search(_search)
                case .availabilityTransportEvent: result = availabilityTransportEvent?.search(_search)
                case .exportationTransportEvent: result = exportationTransportEvent?.search(_search)
                case .dischargeTransportEvent: result = dischargeTransportEvent?.search(_search)
                case .warehousingTransportEvent: result = warehousingTransportEvent?.search(_search)
                case .takeoverTransportEvent: result = takeoverTransportEvent?.search(_search)
                case .optionalTakeoverTransportEvent: result = optionalTakeoverTransportEvent?.search(_search)
                case .dropoffTransportEvent: result = dropoffTransportEvent?.search(_search)
                case .actualPickupTransportEvent: result = actualPickupTransportEvent?.search(_search)
                case .deliveryTransportEvent: result = deliveryTransportEvent?.search(_search)
                case .receiptTransportEvent: result = receiptTransportEvent?.search(_search)
                case .storageTransportEvent: result = storageTransportEvent?.search(_search)
                case .acceptanceTransportEvent: result = acceptanceTransportEvent?.search(_search)
                case .terminalOperatorParty: result = terminalOperatorParty?.search(_search)
                case .customsAgentParty: result = customsAgentParty?.search(_search)
                case .estimatedTransitPeriod: result = estimatedTransitPeriod?.search(_search)
                case .freightAllowanceCharge: result = freightAllowanceCharge.compactMap({ $0.search(_search) }).first
                case .freightChargeLocation: result = freightChargeLocation?.search(_search)
                case .detentionTransportEvent: result = detentionTransportEvent.compactMap({ $0.search(_search) }).first
                case .requestedDepartureTransportEvent: result = requestedDepartureTransportEvent?.search(_search)
                case .requestedArrivalTransportEvent: result = requestedArrivalTransportEvent?.search(_search)
                case .requestedWaypointTransportEvent: result = requestedWaypointTransportEvent.compactMap({ $0.search(_search) }).first
                case .plannedDepartureTransportEvent: result = plannedDepartureTransportEvent?.search(_search)
                case .plannedArrivalTransportEvent: result = plannedArrivalTransportEvent?.search(_search)
                case .plannedWaypointTransportEvent: result = plannedWaypointTransportEvent.compactMap({ $0.search(_search) }).first
                case .actualDepartureTransportEvent: result = actualDepartureTransportEvent?.search(_search)
                case .actualWaypointTransportEvent: result = actualWaypointTransportEvent?.search(_search)
                case .actualArrivalTransportEvent: result = actualArrivalTransportEvent?.search(_search)
                case .transportEvent: result = transportEvent.compactMap({ $0.search(_search) }).first
                case .estimatedDepartureTransportEvent: result = estimatedDepartureTransportEvent?.search(_search)
                case .estimatedArrivalTransportEvent: result = estimatedArrivalTransportEvent?.search(_search)
                case .passengerPerson: result = passengerPerson.compactMap({ $0.search(_search) }).first
                case .driverPerson: result = driverPerson.compactMap({ $0.search(_search) }).first
                case .reportingPerson: result = reportingPerson?.search(_search)
                case .crewMemberPerson: result = crewMemberPerson.compactMap({ $0.search(_search) }).first
                case .securityOfficerPerson: result = securityOfficerPerson?.search(_search)
                case .masterPerson: result = masterPerson?.search(_search)
                case .shipsSurgeonPerson: result = shipsSurgeonPerson?.search(_search)
            }
            return (result == nil)
        }
        return false
    }

    @MainActor @ViewBuilder public func view(for key: CodingKeys, show: Bool = false, search _search: String? = nil) -> some View {
        let _title = title(for: key)
        if !skipView(title: _title, key: key, search: _search) {
        let _details = details(for: key)
            switch key {
                case .id: presentableView(for: id, title: _title, details: _details, show: show, search: _search)
                case .transportModeCode: presentableView(for: transportModeCode, title: _title, details: _details, show: show, search: _search)
                case .transportMeansTypeCode: presentableView(for: transportMeansTypeCode, title: _title, details: _details, show: show, search: _search)
                case .transitDirectionCode: presentableView(for: transitDirectionCode, title: _title, details: _details, show: show, search: _search)
                case .preCarriageIndicator: presentableView(for: preCarriageIndicator, title: _title, details: _details, show: show, search: _search)
                case .onCarriageIndicator: presentableView(for: onCarriageIndicator, title: _title, details: _details, show: show, search: _search)
                case .estimatedDeliveryDate: anyView(for: estimatedDeliveryDate, title: _title, details: _details, show: show, search: _search)
                case .estimatedDeliveryTime: anyView(for: estimatedDeliveryTime, title: _title, details: _details, show: show, search: _search)
                case .requiredDeliveryDate: anyView(for: requiredDeliveryDate, title: _title, details: _details, show: show, search: _search)
                case .requiredDeliveryTime: anyView(for: requiredDeliveryTime, title: _title, details: _details, show: show, search: _search)
                case .loadingSequenceID: presentableView(for: loadingSequenceID, title: _title, details: _details, show: show, search: _search)
                case .successiveSequenceID: presentableView(for: successiveSequenceID, title: _title, details: _details, show: show, search: _search)
                case .instructions: presentableView(for: instructions.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .demurrageInstructions: presentableView(for: demurrageInstructions.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .crewQuantity: presentableView(for: crewQuantity, title: _title, details: _details, show: show, search: _search)
                case .passengerQuantity: presentableView(for: passengerQuantity, title: _title, details: _details, show: show, search: _search)
                case .transitPeriod: presentableView(for: transitPeriod, title: _title, details: _details, show: show, search: _search)
                case .carrierParty: presentableView(for: carrierParty.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .transportMeans: presentableView(for: transportMeans, title: _title, details: _details, show: show, search: _search)
                case .loadingPortLocation: presentableView(for: loadingPortLocation, title: _title, details: _details, show: show, search: _search)
                case .unloadingPortLocation: presentableView(for: unloadingPortLocation, title: _title, details: _details, show: show, search: _search)
                case .transshipPortLocation: presentableView(for: transshipPortLocation, title: _title, details: _details, show: show, search: _search)
                case .loadingTransportEvent: presentableView(for: loadingTransportEvent, title: _title, details: _details, show: show, search: _search)
                case .examinationTransportEvent: presentableView(for: examinationTransportEvent, title: _title, details: _details, show: show, search: _search)
                case .availabilityTransportEvent: presentableView(for: availabilityTransportEvent, title: _title, details: _details, show: show, search: _search)
                case .exportationTransportEvent: presentableView(for: exportationTransportEvent, title: _title, details: _details, show: show, search: _search)
                case .dischargeTransportEvent: presentableView(for: dischargeTransportEvent, title: _title, details: _details, show: show, search: _search)
                case .warehousingTransportEvent: presentableView(for: warehousingTransportEvent, title: _title, details: _details, show: show, search: _search)
                case .takeoverTransportEvent: presentableView(for: takeoverTransportEvent, title: _title, details: _details, show: show, search: _search)
                case .optionalTakeoverTransportEvent: presentableView(for: optionalTakeoverTransportEvent, title: _title, details: _details, show: show, search: _search)
                case .dropoffTransportEvent: presentableView(for: dropoffTransportEvent, title: _title, details: _details, show: show, search: _search)
                case .actualPickupTransportEvent: presentableView(for: actualPickupTransportEvent, title: _title, details: _details, show: show, search: _search)
                case .deliveryTransportEvent: presentableView(for: deliveryTransportEvent, title: _title, details: _details, show: show, search: _search)
                case .receiptTransportEvent: presentableView(for: receiptTransportEvent, title: _title, details: _details, show: show, search: _search)
                case .storageTransportEvent: presentableView(for: storageTransportEvent, title: _title, details: _details, show: show, search: _search)
                case .acceptanceTransportEvent: presentableView(for: acceptanceTransportEvent, title: _title, details: _details, show: show, search: _search)
                case .terminalOperatorParty: presentableView(for: terminalOperatorParty, title: _title, details: _details, show: show, search: _search)
                case .customsAgentParty: presentableView(for: customsAgentParty, title: _title, details: _details, show: show, search: _search)
                case .estimatedTransitPeriod: presentableView(for: estimatedTransitPeriod, title: _title, details: _details, show: show, search: _search)
                case .freightAllowanceCharge: presentableView(for: freightAllowanceCharge.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .freightChargeLocation: presentableView(for: freightChargeLocation, title: _title, details: _details, show: show, search: _search)
                case .detentionTransportEvent: presentableView(for: detentionTransportEvent.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .requestedDepartureTransportEvent: presentableView(for: requestedDepartureTransportEvent, title: _title, details: _details, show: show, search: _search)
                case .requestedArrivalTransportEvent: presentableView(for: requestedArrivalTransportEvent, title: _title, details: _details, show: show, search: _search)
                case .requestedWaypointTransportEvent: presentableView(for: requestedWaypointTransportEvent.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .plannedDepartureTransportEvent: presentableView(for: plannedDepartureTransportEvent, title: _title, details: _details, show: show, search: _search)
                case .plannedArrivalTransportEvent: presentableView(for: plannedArrivalTransportEvent, title: _title, details: _details, show: show, search: _search)
                case .plannedWaypointTransportEvent: presentableView(for: plannedWaypointTransportEvent.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .actualDepartureTransportEvent: presentableView(for: actualDepartureTransportEvent, title: _title, details: _details, show: show, search: _search)
                case .actualWaypointTransportEvent: presentableView(for: actualWaypointTransportEvent, title: _title, details: _details, show: show, search: _search)
                case .actualArrivalTransportEvent: presentableView(for: actualArrivalTransportEvent, title: _title, details: _details, show: show, search: _search)
                case .transportEvent: presentableView(for: transportEvent.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .estimatedDepartureTransportEvent: presentableView(for: estimatedDepartureTransportEvent, title: _title, details: _details, show: show, search: _search)
                case .estimatedArrivalTransportEvent: presentableView(for: estimatedArrivalTransportEvent, title: _title, details: _details, show: show, search: _search)
                case .passengerPerson: presentableView(for: passengerPerson.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .driverPerson: presentableView(for: driverPerson.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .reportingPerson: presentableView(for: reportingPerson, title: _title, details: _details, show: show, search: _search)
                case .crewMemberPerson: presentableView(for: crewMemberPerson.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .securityOfficerPerson: presentableView(for: securityOfficerPerson, title: _title, details: _details, show: show, search: _search)
                case .masterPerson: presentableView(for: masterPerson, title: _title, details: _details, show: show, search: _search)
                case .shipsSurgeonPerson: presentableView(for: shipsSurgeonPerson, title: _title, details: _details, show: show, search: _search)
            }
        }
    }
}

extension UBLInvoice.ShipmentStage: Searchable {
    public func search(_ string: String) -> SearchResult? {
        for codingKey in Self.elementKeys {
            let _title = self.title(for: codingKey) 
            if _title.contains(string) {
                return .title(_title)
            }
        }
        if let result = estimatedDeliveryDate?.search(string) { return result }
        if let result = estimatedDeliveryTime?.search(string) { return result }
        if let result = requiredDeliveryDate?.search(string) { return result }
        if let result = requiredDeliveryTime?.search(string) { return result }
        if let result = id?.search(string) { return result }
        if let result = transportModeCode?.search(string) { return result }
        if let result = transportMeansTypeCode?.search(string) { return result }
        if let result = transitDirectionCode?.search(string) { return result }
        if let result = preCarriageIndicator?.search(string) { return result }
        if let result = onCarriageIndicator?.search(string) { return result }
        if let result = loadingSequenceID?.search(string) { return result }
        if let result = successiveSequenceID?.search(string) { return result }
        if let result = instructions.compactMap({ $0.search(string)  }).first { return result }
        if let result = demurrageInstructions.compactMap({ $0.search(string)  }).first { return result }
        if let result = crewQuantity?.search(string) { return result }
        if let result = passengerQuantity?.search(string) { return result }
        if let result = transitPeriod?.search(string) { return result }
        if let result = carrierParty.compactMap({ $0.search(string)  }).first { return result }
        if let result = transportMeans?.search(string) { return result }
        if let result = loadingPortLocation?.search(string) { return result }
        if let result = unloadingPortLocation?.search(string) { return result }
        if let result = transshipPortLocation?.search(string) { return result }
        if let result = loadingTransportEvent?.search(string) { return result }
        if let result = examinationTransportEvent?.search(string) { return result }
        if let result = availabilityTransportEvent?.search(string) { return result }
        if let result = exportationTransportEvent?.search(string) { return result }
        if let result = dischargeTransportEvent?.search(string) { return result }
        if let result = warehousingTransportEvent?.search(string) { return result }
        if let result = takeoverTransportEvent?.search(string) { return result }
        if let result = optionalTakeoverTransportEvent?.search(string) { return result }
        if let result = dropoffTransportEvent?.search(string) { return result }
        if let result = actualPickupTransportEvent?.search(string) { return result }
        if let result = deliveryTransportEvent?.search(string) { return result }
        if let result = receiptTransportEvent?.search(string) { return result }
        if let result = storageTransportEvent?.search(string) { return result }
        if let result = acceptanceTransportEvent?.search(string) { return result }
        if let result = terminalOperatorParty?.search(string) { return result }
        if let result = customsAgentParty?.search(string) { return result }
        if let result = estimatedTransitPeriod?.search(string) { return result }
        if let result = freightAllowanceCharge.compactMap({ $0.search(string)  }).first { return result }
        if let result = freightChargeLocation?.search(string) { return result }
        if let result = detentionTransportEvent.compactMap({ $0.search(string)  }).first { return result }
        if let result = requestedDepartureTransportEvent?.search(string) { return result }
        if let result = requestedArrivalTransportEvent?.search(string) { return result }
        if let result = requestedWaypointTransportEvent.compactMap({ $0.search(string)  }).first { return result }
        if let result = plannedDepartureTransportEvent?.search(string) { return result }
        if let result = plannedArrivalTransportEvent?.search(string) { return result }
        if let result = plannedWaypointTransportEvent.compactMap({ $0.search(string)  }).first { return result }
        if let result = actualDepartureTransportEvent?.search(string) { return result }
        if let result = actualWaypointTransportEvent?.search(string) { return result }
        if let result = actualArrivalTransportEvent?.search(string) { return result }
        if let result = transportEvent.compactMap({ $0.search(string)  }).first { return result }
        if let result = estimatedDepartureTransportEvent?.search(string) { return result }
        if let result = estimatedArrivalTransportEvent?.search(string) { return result }
        if let result = passengerPerson.compactMap({ $0.search(string)  }).first { return result }
        if let result = driverPerson.compactMap({ $0.search(string)  }).first { return result }
        if let result = reportingPerson?.search(string) { return result }
        if let result = crewMemberPerson.compactMap({ $0.search(string)  }).first { return result }
        if let result = securityOfficerPerson?.search(string) { return result }
        if let result = masterPerson?.search(string) { return result }
        if let result = shipsSurgeonPerson?.search(string) { return result }
        return nil
    }
}
