// 
// TransportEquipment.swift
// 
// 
// Generated by Christoph Vogelbusch on 26. Nov 2024
//

import Foundation
import SwiftUI
import ViewPresentable
import UBLInvoice

extension UBLInvoice.TransportEquipment: KeyViewPresentable {
    public static let elementKeys: [CodingKeys] = [
        .id,
        .referencedConsignmentID,
        .transportEquipmentTypeCode,
        .providerTypeCode,
        .ownerTypeCode,
        .sizeTypeCode,
        .dispositionCode,
        .fullnessIndicationCode,
        .refrigerationOnIndicator,
        .information,
        .returnabilityIndicator,
        .legalStatusIndicator,
        .airFlowPercent,
        .humidityPercent,
        .animalFoodApprovedIndicator,
        .humanFoodApprovedIndicator,
        .dangerousGoodsApprovedIndicator,
        .refrigeratedIndicator,
        .characteristics,
        .damageRemarks,
        .description,
        .specialTransportRequirements,
        .grossWeightMeasure,
        .grossVolumeMeasure,
        .tareWeightMeasure,
        .trackingDeviceCode,
        .powerIndicator,
        .traceID,
        .measurementDimension,
        .transportEquipmentSeal,
        .minimumTemperature,
        .maximumTemperature,
        .providerParty,
        .loadingProofParty,
        .supplierParty,
        .ownerParty,
        .operatingParty,
        .loadingLocation,
        .unloadingLocation,
        .storageLocation,
        .positioningTransportEvent,
        .quarantineTransportEvent,
        .deliveryTransportEvent,
        .pickupTransportEvent,
        .handlingTransportEvent,
        .loadingTransportEvent,
        .transportEvent,
        .applicableTransportMeans,
        .haulageTradingTerms,
        .hazardousGoodsTransit,
        .packagedTransportHandlingUnit,
        .serviceAllowanceCharge,
        .freightAllowanceCharge,
        .attachedTransportEquipment,
        .delivery,
        .pickup,
        .despatch,
        .shipmentDocumentReference,
        .containedInTransportEquipment,
        .package,
        .goodsItem
]
    public var hasNilValue: Bool {(id == nil)
        || (transportEquipmentTypeCode == nil)
        || (providerTypeCode == nil)
        || (ownerTypeCode == nil)
        || (sizeTypeCode == nil)
        || (dispositionCode == nil)
        || (fullnessIndicationCode == nil)
        || (refrigerationOnIndicator == nil)
        || (returnabilityIndicator == nil)
        || (legalStatusIndicator == nil)
        || (airFlowPercent == nil)
        || (humidityPercent == nil)
        || (animalFoodApprovedIndicator == nil)
        || (humanFoodApprovedIndicator == nil)
        || (dangerousGoodsApprovedIndicator == nil)
        || (refrigeratedIndicator == nil)
        || (characteristics == nil)
        || (grossWeightMeasure == nil)
        || (grossVolumeMeasure == nil)
        || (tareWeightMeasure == nil)
        || (trackingDeviceCode == nil)
        || (powerIndicator == nil)
        || (traceID == nil)
        || (minimumTemperature == nil)
        || (maximumTemperature == nil)
        || (providerParty == nil)
        || (loadingProofParty == nil)
        || (supplierParty == nil)
        || (ownerParty == nil)
        || (operatingParty == nil)
        || (loadingLocation == nil)
        || (unloadingLocation == nil)
        || (storageLocation == nil)
        || (applicableTransportMeans == nil)
        || (delivery == nil)
        || (pickup == nil)
        || (despatch == nil)
    }
    
    public func title(for key: CodingKeys) -> String {
        switch key {
            case .id: return "Identifier"
            case .referencedConsignmentID: return "Referenced Consignment Identifier"
            case .transportEquipmentTypeCode: return "Transport Equipment Type Code"
            case .providerTypeCode: return "Provider Type Code"
            case .ownerTypeCode: return "Owner Type Code"
            case .sizeTypeCode: return "Size Type Code"
            case .dispositionCode: return "Disposition Code"
            case .fullnessIndicationCode: return "Fullness Indication Code"
            case .refrigerationOnIndicator: return "Refrigeration On Indicator"
            case .information: return "Information"
            case .returnabilityIndicator: return "Returnability Indicator"
            case .legalStatusIndicator: return "Legal Status Indicator"
            case .airFlowPercent: return "Air Flow Percent"
            case .humidityPercent: return "Humidity Percent"
            case .animalFoodApprovedIndicator: return "Animal Food Approved Indicator"
            case .humanFoodApprovedIndicator: return "Human Food Approved Indicator"
            case .dangerousGoodsApprovedIndicator: return "Dangerous Goods Approved Indicator"
            case .refrigeratedIndicator: return "Refrigerated Indicator"
            case .characteristics: return "Characteristics"
            case .damageRemarks: return "Damage Remarks"
            case .description: return "Description"
            case .specialTransportRequirements: return "Special Transport Requirements"
            case .grossWeightMeasure: return "Gross Weight"
            case .grossVolumeMeasure: return "Gross Volume"
            case .tareWeightMeasure: return "Tare Weight"
            case .trackingDeviceCode: return "Tracking Device Code"
            case .powerIndicator: return "Power"
            case .traceID: return "Trace Identifier"
            case .measurementDimension: return "Measurement Dimension"
            case .transportEquipmentSeal: return "Transport Equipment Seal"
            case .minimumTemperature: return "Minimum Temperature"
            case .maximumTemperature: return "Maximum Temperature"
            case .providerParty: return "Provider Party"
            case .loadingProofParty: return "Loading Proof Party"
            case .supplierParty: return "Supplier Party"
            case .ownerParty: return "Owner Party"
            case .operatingParty: return "Operating Party"
            case .loadingLocation: return "Loading Location"
            case .unloadingLocation: return "Unloading Location"
            case .storageLocation: return "Storage Location"
            case .positioningTransportEvent: return "Positioning Transport Event"
            case .quarantineTransportEvent: return "Quarantine Transport Event"
            case .deliveryTransportEvent: return "Delivery Transport Event"
            case .pickupTransportEvent: return "Pickup Transport Event"
            case .handlingTransportEvent: return "Handling Transport Event"
            case .loadingTransportEvent: return "Loading Transport Event"
            case .transportEvent: return "Transport Event"
            case .applicableTransportMeans: return "Applicable Transport Means"
            case .haulageTradingTerms: return "Haulage Trading Terms"
            case .hazardousGoodsTransit: return "Hazardous Goods Transit"
            case .packagedTransportHandlingUnit: return "Packaged Transport Handling Unit"
            case .serviceAllowanceCharge: return "Service Allowance Charge"
            case .freightAllowanceCharge: return "Freight Allowance Charge"
            case .attachedTransportEquipment: return "Attached Transport Equipment"
            case .delivery: return "Delivery"
            case .pickup: return "Pickup"
            case .despatch: return "Despatch"
            case .shipmentDocumentReference: return "Shipment Document Reference"
            case .containedInTransportEquipment: return "Contained In Transport Equipment"
            case .package: return "Package"
            case .goodsItem: return "Goods Item"
        }
    }

    public func details(for key: CodingKeys) -> String? {
        switch key {
            case .id: return "An identifier for this piece of transport equipment."
            case .referencedConsignmentID: return "An identifier for the consignment contained by this piece of transport equipment."
            case .transportEquipmentTypeCode: return "A code signifying the type of this piece of transport equipment."
            case .providerTypeCode: return "A code signifying the type of provider of this piece of transport equipment."
            case .ownerTypeCode: return "A code signifying the type of owner of this piece of transport equipment."
            case .sizeTypeCode: return "A code signifying the size and type of this piece of piece of transport equipment. When the piece of transport equipment is a shipping container, it is recommended to use ContainerSizeTypeCode for validation."
            case .dispositionCode: return "A code signifying the current disposition of this piece of transport equipment."
            case .fullnessIndicationCode: return "A code signifying whether this piece of transport equipment is full, partially full, or empty."
            case .refrigerationOnIndicator: return "An indicator that this piece of transport equipment's refrigeration is on (true) or off (false)."
            case .information: return "Additional information about this piece of transport equipment."
            case .returnabilityIndicator: return "An indicator that this piece of transport equipment is returnable (true) or not (false)."
            case .legalStatusIndicator: return "An indication of the legal status of this piece of transport equipment with respect to the Container Convention Code."
            case .airFlowPercent: return "The percent of the airflow within this piece of transport equipment."
            case .humidityPercent: return "The percent humidity within this piece of transport equipment."
            case .animalFoodApprovedIndicator: return "An indicator that this piece of transport equipment is approved for animal food (true) or not (false)."
            case .humanFoodApprovedIndicator: return "An indicator that this piece of transport equipment is approved for human food (true) or not (false)."
            case .dangerousGoodsApprovedIndicator: return "An indicator that this piece of transport equipment is approved for dangerous goods (true) or not (false)."
            case .refrigeratedIndicator: return "An indicator that this piece of transport equipment is refrigerated (true) or not (false)."
            case .characteristics: return "Characteristics of this piece of transport equipment."
            case .damageRemarks: return "Damage associated with this piece of transport equipment."
            case .description: return "Text describing this piece of transport equipment."
            case .specialTransportRequirements: return "Special transport requirements expressed as text."
            case .grossWeightMeasure: return "The gross weight of this piece of transport equipment."
            case .grossVolumeMeasure: return "The gross volume of this piece of transport equipment."
            case .tareWeightMeasure: return "The weight of this piece of transport equipment when empty."
            case .trackingDeviceCode: return "A code signifying the tracking device for this piece of transport equipment."
            case .powerIndicator: return "An indicator that this piece of transport equipment can supply power (true) or not (false)."
            case .traceID: return "An identifier for use in tracing this piece of transport equipment, such as the EPC number used in RFID."
            case .measurementDimension: return "A measurable dimension (length, mass, weight, or volume) of this piece of transport equipment."
            case .transportEquipmentSeal: return "A seal securing the door of a piece of transport equipment."
            case .minimumTemperature: return "In the case of a refrigeration unit, the minimum allowable operating temperature for this container."
            case .maximumTemperature: return "In the case of a refrigeration unit, the maximum allowable operating temperature for this container."
            case .providerParty: return "The party providing this piece of transport equipment."
            case .loadingProofParty: return "The authorized party responsible for certifying that the goods were loaded into this piece of transport equipment."
            case .supplierParty: return "The party that supplies this piece of transport equipment."
            case .ownerParty: return "The party that owns this piece of transport equipment."
            case .operatingParty: return "The party that operates this piece of transport equipment."
            case .loadingLocation: return "The location where this piece of transport equipment is loaded."
            case .unloadingLocation: return "The location where this piece of transport equipment is unloaded."
            case .storageLocation: return "The location where this piece of transport equipment is being stored."
            case .positioningTransportEvent: return "A positioning of this piece of transport equipment."
            case .quarantineTransportEvent: return "A quarantine of this piece of transport equipment."
            case .deliveryTransportEvent: return "A delivery of this piece of transport equipment."
            case .pickupTransportEvent: return "A pickup of this piece of transport equipment."
            case .handlingTransportEvent: return "A handling of this piece of transport equipment."
            case .loadingTransportEvent: return "A loading of this piece of transport equipment."
            case .transportEvent: return "A transport event associated with this piece of transport equipment."
            case .applicableTransportMeans: return "The applicable transport means associated with this piece of transport equipment."
            case .haulageTradingTerms: return "A set of haulage trading terms associated with this piece of transport equipment."
            case .hazardousGoodsTransit: return "Transit-related information regarding a type of hazardous goods contained in this piece of transport equipment."
            case .packagedTransportHandlingUnit: return "A packaged transport handling unit associated with this piece of transport equipment."
            case .serviceAllowanceCharge: return "A service allowance charge associated with this piece of transport equipment."
            case .freightAllowanceCharge: return "A freight allowance charge associated with this piece of transport equipment."
            case .attachedTransportEquipment: return "A piece of transport equipment attached to this piece of transport equipment."
            case .delivery: return "The delivery of this piece of transport equipment."
            case .pickup: return "The pickup of this piece of transport equipment."
            case .despatch: return "The despatch of this piece of transport equipment."
            case .shipmentDocumentReference: return "A reference to a shipping document associated with this piece of transport equipment."
            case .containedInTransportEquipment: return "A piece of transport equipment contained in this piece of transport equipment."
            case .package: return "A package contained in this piece of transport equipment."
            case .goodsItem: return "A goods item contained in this piece of transport equipment."
        }
    }
    func skipView(title _title: String, key: CodingKeys, search _search: String?) -> Bool {
        if let _search,
            (_title.search(_search) == nil) {
            let result: SearchResult?
            switch key {
                case .id: result = id?.search(_search)
                case .referencedConsignmentID: result = referencedConsignmentID.compactMap({ $0.search(_search) }).first
                case .transportEquipmentTypeCode: result = transportEquipmentTypeCode?.search(_search)
                case .providerTypeCode: result = providerTypeCode?.search(_search)
                case .ownerTypeCode: result = ownerTypeCode?.search(_search)
                case .sizeTypeCode: result = sizeTypeCode?.search(_search)
                case .dispositionCode: result = dispositionCode?.search(_search)
                case .fullnessIndicationCode: result = fullnessIndicationCode?.search(_search)
                case .refrigerationOnIndicator: result = refrigerationOnIndicator?.search(_search)
                case .information: result = information.compactMap({ $0.search(_search) }).first
                case .returnabilityIndicator: result = returnabilityIndicator?.search(_search)
                case .legalStatusIndicator: result = legalStatusIndicator?.search(_search)
                case .airFlowPercent: result = airFlowPercent?.search(_search)
                case .humidityPercent: result = humidityPercent?.search(_search)
                case .animalFoodApprovedIndicator: result = animalFoodApprovedIndicator?.search(_search)
                case .humanFoodApprovedIndicator: result = humanFoodApprovedIndicator?.search(_search)
                case .dangerousGoodsApprovedIndicator: result = dangerousGoodsApprovedIndicator?.search(_search)
                case .refrigeratedIndicator: result = refrigeratedIndicator?.search(_search)
                case .characteristics: result = characteristics?.search(_search)
                case .damageRemarks: result = damageRemarks.compactMap({ $0.search(_search) }).first
                case .description: result = description.compactMap({ $0.search(_search) }).first
                case .specialTransportRequirements: result = specialTransportRequirements.compactMap({ $0.search(_search) }).first
                case .grossWeightMeasure: result = grossWeightMeasure?.search(_search)
                case .grossVolumeMeasure: result = grossVolumeMeasure?.search(_search)
                case .tareWeightMeasure: result = tareWeightMeasure?.search(_search)
                case .trackingDeviceCode: result = trackingDeviceCode?.search(_search)
                case .powerIndicator: result = powerIndicator?.search(_search)
                case .traceID: result = traceID?.search(_search)
                case .measurementDimension: result = measurementDimension.compactMap({ $0.search(_search) }).first
                case .transportEquipmentSeal: result = transportEquipmentSeal.compactMap({ $0.search(_search) }).first
                case .minimumTemperature: result = minimumTemperature?.search(_search)
                case .maximumTemperature: result = maximumTemperature?.search(_search)
                case .providerParty: result = providerParty?.search(_search)
                case .loadingProofParty: result = loadingProofParty?.search(_search)
                case .supplierParty: result = supplierParty?.search(_search)
                case .ownerParty: result = ownerParty?.search(_search)
                case .operatingParty: result = operatingParty?.search(_search)
                case .loadingLocation: result = loadingLocation?.search(_search)
                case .unloadingLocation: result = unloadingLocation?.search(_search)
                case .storageLocation: result = storageLocation?.search(_search)
                case .positioningTransportEvent: result = positioningTransportEvent.compactMap({ $0.search(_search) }).first
                case .quarantineTransportEvent: result = quarantineTransportEvent.compactMap({ $0.search(_search) }).first
                case .deliveryTransportEvent: result = deliveryTransportEvent.compactMap({ $0.search(_search) }).first
                case .pickupTransportEvent: result = pickupTransportEvent.compactMap({ $0.search(_search) }).first
                case .handlingTransportEvent: result = handlingTransportEvent.compactMap({ $0.search(_search) }).first
                case .loadingTransportEvent: result = loadingTransportEvent.compactMap({ $0.search(_search) }).first
                case .transportEvent: result = transportEvent.compactMap({ $0.search(_search) }).first
                case .applicableTransportMeans: result = applicableTransportMeans?.search(_search)
                case .haulageTradingTerms: result = haulageTradingTerms.compactMap({ $0.search(_search) }).first
                case .hazardousGoodsTransit: result = hazardousGoodsTransit.compactMap({ $0.search(_search) }).first
                case .packagedTransportHandlingUnit: result = packagedTransportHandlingUnit.compactMap({ $0.search(_search) }).first
                case .serviceAllowanceCharge: result = serviceAllowanceCharge.compactMap({ $0.search(_search) }).first
                case .freightAllowanceCharge: result = freightAllowanceCharge.compactMap({ $0.search(_search) }).first
                case .attachedTransportEquipment: result = attachedTransportEquipment.compactMap({ $0.search(_search) }).first
                case .delivery: result = delivery?.search(_search)
                case .pickup: result = pickup?.search(_search)
                case .despatch: result = despatch?.search(_search)
                case .shipmentDocumentReference: result = shipmentDocumentReference.compactMap({ $0.search(_search) }).first
                case .containedInTransportEquipment: result = containedInTransportEquipment.compactMap({ $0.search(_search) }).first
                case .package: result = package.compactMap({ $0.search(_search) }).first
                case .goodsItem: result = goodsItem.compactMap({ $0.search(_search) }).first
            }
            return (result == nil)
        }
        return false
    }

    @MainActor @ViewBuilder public func view(for key: CodingKeys, show: Bool = false, search _search: String? = nil) -> some View {
        let _title = title(for: key)
        if !skipView(title: _title, key: key, search: _search) {
        let _details = details(for: key)
            switch key {
                case .id: presentableView(for: id, title: _title, details: _details, show: show, search: _search)
                case .referencedConsignmentID: presentableView(for: referencedConsignmentID.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .transportEquipmentTypeCode: presentableView(for: transportEquipmentTypeCode, title: _title, details: _details, show: show, search: _search)
                case .providerTypeCode: presentableView(for: providerTypeCode, title: _title, details: _details, show: show, search: _search)
                case .ownerTypeCode: presentableView(for: ownerTypeCode, title: _title, details: _details, show: show, search: _search)
                case .sizeTypeCode: presentableView(for: sizeTypeCode, title: _title, details: _details, show: show, search: _search)
                case .dispositionCode: presentableView(for: dispositionCode, title: _title, details: _details, show: show, search: _search)
                case .fullnessIndicationCode: presentableView(for: fullnessIndicationCode, title: _title, details: _details, show: show, search: _search)
                case .refrigerationOnIndicator: presentableView(for: refrigerationOnIndicator, title: _title, details: _details, show: show, search: _search)
                case .information: presentableView(for: information.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .returnabilityIndicator: presentableView(for: returnabilityIndicator, title: _title, details: _details, show: show, search: _search)
                case .legalStatusIndicator: presentableView(for: legalStatusIndicator, title: _title, details: _details, show: show, search: _search)
                case .airFlowPercent: presentableView(for: airFlowPercent, title: _title, details: _details, show: show, search: _search)
                case .humidityPercent: presentableView(for: humidityPercent, title: _title, details: _details, show: show, search: _search)
                case .animalFoodApprovedIndicator: presentableView(for: animalFoodApprovedIndicator, title: _title, details: _details, show: show, search: _search)
                case .humanFoodApprovedIndicator: presentableView(for: humanFoodApprovedIndicator, title: _title, details: _details, show: show, search: _search)
                case .dangerousGoodsApprovedIndicator: presentableView(for: dangerousGoodsApprovedIndicator, title: _title, details: _details, show: show, search: _search)
                case .refrigeratedIndicator: presentableView(for: refrigeratedIndicator, title: _title, details: _details, show: show, search: _search)
                case .characteristics: presentableView(for: characteristics, title: _title, details: _details, show: show, search: _search)
                case .damageRemarks: presentableView(for: damageRemarks.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .description: presentableView(for: description.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .specialTransportRequirements: presentableView(for: specialTransportRequirements.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .grossWeightMeasure: presentableView(for: grossWeightMeasure, title: _title, details: _details, show: show, search: _search)
                case .grossVolumeMeasure: presentableView(for: grossVolumeMeasure, title: _title, details: _details, show: show, search: _search)
                case .tareWeightMeasure: presentableView(for: tareWeightMeasure, title: _title, details: _details, show: show, search: _search)
                case .trackingDeviceCode: presentableView(for: trackingDeviceCode, title: _title, details: _details, show: show, search: _search)
                case .powerIndicator: presentableView(for: powerIndicator, title: _title, details: _details, show: show, search: _search)
                case .traceID: presentableView(for: traceID, title: _title, details: _details, show: show, search: _search)
                case .measurementDimension: presentableView(for: measurementDimension.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .transportEquipmentSeal: presentableView(for: transportEquipmentSeal.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .minimumTemperature: presentableView(for: minimumTemperature, title: _title, details: _details, show: show, search: _search)
                case .maximumTemperature: presentableView(for: maximumTemperature, title: _title, details: _details, show: show, search: _search)
                case .providerParty: presentableView(for: providerParty, title: _title, details: _details, show: show, search: _search)
                case .loadingProofParty: presentableView(for: loadingProofParty, title: _title, details: _details, show: show, search: _search)
                case .supplierParty: presentableView(for: supplierParty, title: _title, details: _details, show: show, search: _search)
                case .ownerParty: presentableView(for: ownerParty, title: _title, details: _details, show: show, search: _search)
                case .operatingParty: presentableView(for: operatingParty, title: _title, details: _details, show: show, search: _search)
                case .loadingLocation: presentableView(for: loadingLocation, title: _title, details: _details, show: show, search: _search)
                case .unloadingLocation: presentableView(for: unloadingLocation, title: _title, details: _details, show: show, search: _search)
                case .storageLocation: presentableView(for: storageLocation, title: _title, details: _details, show: show, search: _search)
                case .positioningTransportEvent: presentableView(for: positioningTransportEvent.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .quarantineTransportEvent: presentableView(for: quarantineTransportEvent.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .deliveryTransportEvent: presentableView(for: deliveryTransportEvent.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .pickupTransportEvent: presentableView(for: pickupTransportEvent.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .handlingTransportEvent: presentableView(for: handlingTransportEvent.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .loadingTransportEvent: presentableView(for: loadingTransportEvent.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .transportEvent: presentableView(for: transportEvent.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .applicableTransportMeans: presentableView(for: applicableTransportMeans, title: _title, details: _details, show: show, search: _search)
                case .haulageTradingTerms: presentableView(for: haulageTradingTerms.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .hazardousGoodsTransit: presentableView(for: hazardousGoodsTransit.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .packagedTransportHandlingUnit: presentableView(for: packagedTransportHandlingUnit.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .serviceAllowanceCharge: presentableView(for: serviceAllowanceCharge.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .freightAllowanceCharge: presentableView(for: freightAllowanceCharge.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .attachedTransportEquipment: presentableView(for: attachedTransportEquipment.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .delivery: presentableView(for: delivery, title: _title, details: _details, show: show, search: _search)
                case .pickup: presentableView(for: pickup, title: _title, details: _details, show: show, search: _search)
                case .despatch: presentableView(for: despatch, title: _title, details: _details, show: show, search: _search)
                case .shipmentDocumentReference: presentableView(for: shipmentDocumentReference.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .containedInTransportEquipment: presentableView(for: containedInTransportEquipment.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .package: presentableView(for: package.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
                case .goodsItem: presentableView(for: goodsItem.filter({ if let _search { return ($0.search(_search) != nil) } else { return true } }), title: _title, details: _details, show: show, search: _search)
            }
        }
    }
}

extension UBLInvoice.TransportEquipment: Searchable {
    public func search(_ string: String) -> SearchResult? {
        for codingKey in Self.elementKeys {
            let _title = self.title(for: codingKey) 
            if _title.contains(string) {
                return .title(_title)
            }
        }
        if let result = id?.search(string) { return result }
        if let result = referencedConsignmentID.compactMap({ $0.search(string)  }).first { return result }
        if let result = transportEquipmentTypeCode?.search(string) { return result }
        if let result = providerTypeCode?.search(string) { return result }
        if let result = ownerTypeCode?.search(string) { return result }
        if let result = sizeTypeCode?.search(string) { return result }
        if let result = dispositionCode?.search(string) { return result }
        if let result = fullnessIndicationCode?.search(string) { return result }
        if let result = refrigerationOnIndicator?.search(string) { return result }
        if let result = information.compactMap({ $0.search(string)  }).first { return result }
        if let result = returnabilityIndicator?.search(string) { return result }
        if let result = legalStatusIndicator?.search(string) { return result }
        if let result = airFlowPercent?.search(string) { return result }
        if let result = humidityPercent?.search(string) { return result }
        if let result = animalFoodApprovedIndicator?.search(string) { return result }
        if let result = humanFoodApprovedIndicator?.search(string) { return result }
        if let result = dangerousGoodsApprovedIndicator?.search(string) { return result }
        if let result = refrigeratedIndicator?.search(string) { return result }
        if let result = characteristics?.search(string) { return result }
        if let result = damageRemarks.compactMap({ $0.search(string)  }).first { return result }
        if let result = description.compactMap({ $0.search(string)  }).first { return result }
        if let result = specialTransportRequirements.compactMap({ $0.search(string)  }).first { return result }
        if let result = grossWeightMeasure?.search(string) { return result }
        if let result = grossVolumeMeasure?.search(string) { return result }
        if let result = tareWeightMeasure?.search(string) { return result }
        if let result = trackingDeviceCode?.search(string) { return result }
        if let result = powerIndicator?.search(string) { return result }
        if let result = traceID?.search(string) { return result }
        if let result = measurementDimension.compactMap({ $0.search(string)  }).first { return result }
        if let result = transportEquipmentSeal.compactMap({ $0.search(string)  }).first { return result }
        if let result = minimumTemperature?.search(string) { return result }
        if let result = maximumTemperature?.search(string) { return result }
        if let result = providerParty?.search(string) { return result }
        if let result = loadingProofParty?.search(string) { return result }
        if let result = supplierParty?.search(string) { return result }
        if let result = ownerParty?.search(string) { return result }
        if let result = operatingParty?.search(string) { return result }
        if let result = loadingLocation?.search(string) { return result }
        if let result = unloadingLocation?.search(string) { return result }
        if let result = storageLocation?.search(string) { return result }
        if let result = positioningTransportEvent.compactMap({ $0.search(string)  }).first { return result }
        if let result = quarantineTransportEvent.compactMap({ $0.search(string)  }).first { return result }
        if let result = deliveryTransportEvent.compactMap({ $0.search(string)  }).first { return result }
        if let result = pickupTransportEvent.compactMap({ $0.search(string)  }).first { return result }
        if let result = handlingTransportEvent.compactMap({ $0.search(string)  }).first { return result }
        if let result = loadingTransportEvent.compactMap({ $0.search(string)  }).first { return result }
        if let result = transportEvent.compactMap({ $0.search(string)  }).first { return result }
        if let result = applicableTransportMeans?.search(string) { return result }
        if let result = haulageTradingTerms.compactMap({ $0.search(string)  }).first { return result }
        if let result = hazardousGoodsTransit.compactMap({ $0.search(string)  }).first { return result }
        if let result = packagedTransportHandlingUnit.compactMap({ $0.search(string)  }).first { return result }
        if let result = serviceAllowanceCharge.compactMap({ $0.search(string)  }).first { return result }
        if let result = freightAllowanceCharge.compactMap({ $0.search(string)  }).first { return result }
        if let result = attachedTransportEquipment.compactMap({ $0.search(string)  }).first { return result }
        if let result = delivery?.search(string) { return result }
        if let result = pickup?.search(string) { return result }
        if let result = despatch?.search(string) { return result }
        if let result = shipmentDocumentReference.compactMap({ $0.search(string)  }).first { return result }
        if let result = containedInTransportEquipment.compactMap({ $0.search(string)  }).first { return result }
        if let result = package.compactMap({ $0.search(string)  }).first { return result }
        if let result = goodsItem.compactMap({ $0.search(string)  }).first { return result }
        return nil
    }
}
